<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' ); 
jimport('joomla.application.component.controller');

class rseventsController extends JController
{
	var $_db;
	
	function __construct()
	{
		parent::__construct();
		$this->_db=& JFactory::getDBO();
	}
	
	function gcalendar()
	{
		$app =& JFactory::getApplication();
		$config = RSEventsHelper::getConfig();
		$username = $config['google.username'];
		$password = $config['google.password'];
		
		if (empty($username) || empty($password)) $app->redirect('index.php?option=com_rsevents&task=editsettings',JText::_('RSE_EMPTY_DETAILS'));
		
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'google.calendar.php');
		$googleCalendar = new RSEGoogleCalendar($username,$password);
		$response = $googleCalendar->parse();
		$errors = $googleCalendar->getErrors();
		
		if (!empty($errors)) $app->redirect('index.php?option=com_rsevents&task=editsettings',implode("<br/>",$errors),'error');
		
		$message = $response ? JText::sprintf('RSE_GOOGLE_ADDED_EVENTS',$response) : JText::_('RSE_GOOGLE_NO_EVENTS');
		$app->redirect('index.php?option=com_rsevents',$message);
		
	}
	
	function facebook()
	{
		$db =& JFactory::getDBO();
		$app =& JFactory::getApplication();
		$juser =& JFactory::getUser();
		$config = RSEventsHelper::getConfig();
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'facebook'.DS.'facebook.php');
		
		if (empty($config['facebook_token']))
			$app->redirect('index.php?option=com_rsevents&task=editsettings',JText::_('RSE_NO_FACEBOOK_CONNECTION'));
		
		$idcategory = $config['facebook.category'];
		
		if (empty($idcategory))
		{
			$db->setQuery("INSERT INTO #__rsevents_categories SET CategoryName = 'Facebook events' , CategoryAlias = 'facebook-events' ");
			$db->query();
			$idcategory = $db->insertid();
		}
		
		$facebook = new RSEFacebook(array('appId'  => $config['facebook_appid'], 'secret' => $config['facebook_secret'], 'cookie' => true));
		$attachment =  array('access_token' => $config['facebook_token'],'limit' => 100);
		
		$container = array();
		
		try
		{
			$user	= $facebook->api('/me', 'GET', $attachment);
			$uid 	= $user['id'];
			$events	= $facebook->api('/me/events', 'GET', $attachment);
			
			if (!empty($events) && !empty($events['data']))
			{
				foreach ($events['data'] as $event)
				{
					$eobj = $facebook->api($event['id'], 'GET', $attachment);
					if (empty($eobj)) continue;					
					$picture = $facebook->api(array('method' => 'fql.query','query' => 'SELECT pic_big FROM event WHERE eid = '.$event['id'].' ')); 
					
					$image = '';
					if (!empty($picture) && !empty($picture[0]))
						$image = isset($picture[0]['pic_big']) ? $picture[0]['pic_big'] : '';
					
					if (!empty($eobj) && !empty($eobj['owner']) && !empty($eobj['owner']['id']))
						if ($eobj['owner']['id'] != $uid)
							continue;
					
					$ev = new stdClass();
					$ev->id = @$eobj['id'];
					$ev->EventName = @$eobj['name'];
					$ev->EventDescription = @$eobj['description'];
					$ev->EventStartDate = isset($eobj['start_time']) ? strtotime($eobj['start_time']) : time();
					$ev->EventEndDate = isset($eobj['end_time']) ? strtotime($eobj['end_time']) : time() + 7200;
					$ev->EventHost = isset($eobj['owner']['name']) ? $eobj['owner']['name'] : @$user['name'];
					$ev->Location = isset($eobj['location']) ? $eobj['location'] : 'Facebook Location';
					$ev->LocationStreet = isset($eobj['venue']['street']) ? $eobj['venue']['street'] : '';
					$ev->LocationCity = isset($eobj['venue']['city']) ? $eobj['venue']['city'] : '';
					$ev->LocationState = isset($eobj['venue']['state']) ? $eobj['venue']['state'] : '';
					$ev->LocationCountry = isset($eobj['venue']['country']) ? $eobj['venue']['country'] : '';
					$ev->LocationLat = isset($eobj['venue']['latitude']) ? $eobj['venue']['latitude'] : '';
					$ev->LocationLon = isset($eobj['venue']['longitude']) ? $eobj['venue']['longitude'] : '';
					$ev->image = $image;
					
					$container[] = $ev; 
				}
			}
			
		} catch (Exception $e)
		{
			$app->redirect('index.php?option=com_rsevents&task=editsettings',$e->getMessage());
		}
		
		$i = 0;
		if (!empty($container))
			foreach ($container as $event)
			{
				$idlocation = $config['facebook.location'];
				
				//check if the current event was already added
				$db->setQuery("SELECT COUNT(id) FROM #__rsevents_sync WHERE id = '".$event->id."' AND `from` = 'facebook' ");
				$indb = $db->loadResult();
				
				if(!empty($indb)) continue;
				
				$db->setQuery("SELECT IdDesign FROM #__rsevents_designs WHERE DesignDefault = 1 AND designtype = 0 ");
				$iddesign = (int) $db->loadResult();
				
				$db->setQuery("SELECT id FROM #__rsevents_themes WHERE `default` = 1");
				$idtheme = (int) $db->loadResult();
				
				if (empty($idlocation))
				{
					$db->setQuery("INSERT INTO #__rsevents_locations SET LocationName = '".$db->getEscaped($event->Location)."' , LocationAddress = '".$db->getEscaped($event->Location)."' , LocationAlias = '".$db->getEscaped(JFilterOutput::stringURLSafe($event->Location))."' , LocationCity = '".$db->getEscaped($event->LocationCity)."' , LocationState = '".$db->getEscaped($event->LocationState)."' , LocationCountry = '".$db->getEscaped($event->LocationCountry)."' , LocationLat = '".$db->getEscaped($event->LocationLat)."' , LocationLon = '".$db->getEscaped($event->LocationLon)."' , published = 1 ");
					$db->query();
					$idlocation = $db->insertid();
				}
				
				$db->setQuery("INSERT INTO #__rsevents_events SET IdLocation = '".$idlocation."' , IdNewDesign = '".$iddesign."' , IdTheme = '".$idtheme."' , IdUser = '".$juser->id."' , EventName = '".$db->getEscaped($event->EventName)."' , EventAlias = '".$db->getEscaped(JFilterOutput::stringURLSafe($event->EventName))."', EventHost = '".$db->getEscaped($event->EventHost)."' , EventDescription = '".$db->getEscaped($event->EventDescription)."' , EventType = 1 , EventStartDate = '".$db->getEscaped($event->EventStartDate)."' , EventEndDate = '".$db->getEscaped($event->EventEndDate)."' , published = 1 ");
				$db->query();
				
				$idevent = $db->insertid();
				
				$db->setQuery("INSERT INTO  #__rsevents_events_cat SET IdEvent = '".$idevent."' , IdCategory = '".$idcategory."' ");
				$db->query();
				
				$db->setQuery("INSERT INTO #__rsevents_sync SET id = '".$event->id."' , IdEvent = '".$idevent."' , `from` = 'facebook' ");
				$db->query();
				
				//create the thumb
				if (!empty($event->image))
				{
					jimport('joomla.filesystem.file');
					$pathToThumbs 	= JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS;
					
					rseventsHelper::createIcon($event->image , $pathToThumbs , $config['event.icon.small'] , $idevent,1,1);
					rseventsHelper::createIcon($event->image , $pathToThumbs , $config['event.icon.big'] , $idevent,1,1);
				}
				
				$i++;
			}
		
		$message = $i ? JText::sprintf('RSE_FACEBOOK_ADDED_EVENTS',$i) : JText::_('RSE_FACEBOOK_NO_EVENTS');
		$app->redirect('index.php?option=com_rsevents',$message);	
	}
	
	
	function saveRegistration()
	{
		$code = JRequest::getVar('global_register_code');
		$code = $this->_db->getEscaped(trim($code));
		
		if (!empty($code))
		{
			$this->_db->setQuery("UPDATE #__rsevents_config SET `ConfigValue`='".$code."' WHERE `ConfigName`='global.register.code'");
			$this->_db->query();
			$this->setRedirect('index.php?option=com_rsevents&task=update', JText::_('RSE_REGISTRATION_SAVED'));
		}
		else
			$this->setRedirect('index.php?option=com_rsevents&task=editsettings');
	}
	
	function savetoken()
	{
		$db		=& JFactory::getDBO();
		$token	= JRequest::getVar('access_token');
		if (!empty($token))
		{
			$db->setQuery("UPDATE `#__rsevents_config` SET `ConfigValue` = '".$db->getEscaped($token)."' WHERE `ConfigName` = 'facebook_token' ");
			$db->query();
			$this->setRedirect('index.php?option=com_rsevents&task=editsettings',JText::_('RSE_FACEBOOK_CONNECTION_OK'));
		} else $this->setRedirect('index.php?option=com_rsevents&task=editsettings',JText::_('RSE_FACEBOOK_NO_CONNECTION'));
	}
	
	function saveposition()
	{
		JRequest::setVar('tmpl','component');
		$db			=& JFactory::getDBO();
		$column		= JRequest::getVar('column');
		$modules	= JRequest::getVar('module');
		
		foreach ($modules as $position => $module)
		{
			$db->setQuery("UPDATE #__rsevents_modules SET `column` = '".$db->getEscaped($column)."' , `position` = '".$db->getEscaped($position)."' WHERE `module` = 'module".$db->getEscaped($module)."' ");
			$db->query();
		}
		exit();
		
	}
	
	function main()
	{

		JRequest::setVar('view','main');
		JRequest::setVar('layout','default');
		
		parent::display();
	}
// Events
	
	function listevents()
	{
		JRequest::setVar('view','events');
		JRequest::setVar('layout','default');
		parent::display();
	}
	
	function editevent()
	{
		JRequest::setVar('view','events');
		JRequest::setVar('layout','edit');
		parent::display();
	}
	function eventrepeat()
	{
		$view =& $this->getView('repeat', 'html');
		$model = $this->getModel('events');
		$view->setLayout('default');
		$view->setModel($model);
		$view->display();
	}
	
	function listcategories()
	{
		JRequest::setVar('view','categories');
		JRequest::setVar('layout','default');
		parent::display();
		
	}
	
	function editcategories()
	{
		JRequest::setVar('view','categories');
		JRequest::setVar('layout','edit');
		parent::display();
		
	}
	
	function listlocations()
	{
		JRequest::setVar('view','locations');
		JRequest::setVar('layout','default');
		parent::display();
		
	}
	
	function editlocation()
	{
		JRequest::setVar('view','locations');
		JRequest::setVar('layout','edit');
		parent::display();
		
	}

	function import()
	{
		JRequest::setVar('view','import');
		JRequest::setVar('layout','default');
		parent::display();
		
	}
	
	function archive()
	{
		JRequest::setVar('view','archive');
		JRequest::setVar('layout','default');
		parent::display();
		
	}

	/*Designs*/
	
	function listdesigns()
	{
		JRequest::setVar('view','designs');
		JRequest::setVar('layout','default');
		parent::display();
	}
	
	function upload()
	{
		JRequest::setVar('view','designs');
		JRequest::setVar('layout','upload');
		parent::display();
	}
	
	/*Settings*/
	
	function editsettings()
	{
		JRequest::setVar('view','settings');
		JRequest::setVar('layout','default');
		parent::display();
	}
	
	function listgroups()
	{
		JRequest::setVar('view','groups');
		JRequest::setVar('layout','default');
		parent::display();
	}
	
	function editgroups()
	{
		JRequest::setVar('view','groups');
		JRequest::setVar('layout','edit');
		parent::display();
	}
	
	function editfile()
	{
		$view =& $this->getView('files', 'html');
		$model = $this->getModel('events');
		$view->setLayout('default');
		$view->setModel($model);
		JRequest::setVar('tmpl','component');
		$view->display();
	}
	
	function listsubscriptions()
	{
		JRequest::setVar('view','subscriptions');
		JRequest::setVar('layout','default');
		parent::display();
	}
	
	function editsubscription()
	{
		JRequest::setVar('view','subscriptions');
		JRequest::setVar('layout','edit');
		parent::display();
	}
	
	function showtransaction()
	{
		JRequest::setVar('view','subscriptions');
		JRequest::setVar('layout','transaction');
		parent::display();
	}
	
	function listtickets()
	{
		JRequest::setVar('view','tickets');
		JRequest::setVar('layout','default');
		parent::display();
	}
	
	function editticket()
	{
		JRequest::setVar('view','tickets');
		JRequest::setVar('layout','edit');
		parent::display();
	}
	
	function edityoutube()
	{
		JRequest::setVar('view','events');
		JRequest::setVar('layout','youtube');
		parent::display();
	}
	
	function editflash()
	{
		JRequest::setVar('view','events');
		JRequest::setVar('layout','flash');
		parent::display();
	}
	
	function editmp3()
	{
		JRequest::setVar('view','events');
		JRequest::setVar('layout','mp3');
		parent::display();
	}
	
	function editmeebo()
	{
		JRequest::setVar('view','events');
		JRequest::setVar('layout','chat');
		parent::display();
	}
	
	function categorieselement()
	{
		JRequest::setVar('view','categorieselement');
		JRequest::setVar('layout','default');
		parent::display();
	}
	
	function eventelement()
	{
		JRequest::setVar('view','eventelement');
		JRequest::setVar('layout','default');
		parent::display();
	}
	
	function locationselement()
	{
		JRequest::setVar('view','locationselement');
		JRequest::setVar('layout','default');
		parent::display();
	}
	
	function update()
	{
		JRequest::setVar('view','main');
		JRequest::setVar('layout','update');
		parent::display();
	}
	
	function editflickr()
	{
		JRequest::setVar('view','events');
		JRequest::setVar('layout','flickr');
		parent::display();
	}

	function map()
	{
		JRequest::setVar('view','settings');
		JRequest::setVar('layout','map');
		parent::display();
	}
	
	function rsform()
	{
		JRequest::setVar('view','events');
		parent::display();
		exit();
	}
	
	function location_filter()
	{
		$db = &JFactory::getDBO();
		$string = JRequest::getVar('string');
		$return = '';
		
		
		$db->setQuery("SELECT IdLocation,LocationName FROM #__rsevents_locations WHERE LocationName LIKE '%".$db->getEscaped($string)."%' ");
		$locations = $db->loadObjectList();
		$return .= '<select id="IdLocation" class="inputbox" size="1" name="IdLocation">'; 
		$return .= '<option value="0">'.JText::_('RSE_EVENT_SELECT_LOCATION').'</option>';
		foreach($locations as $location)
			$return .= '<option value="'.$location->IdLocation.'">'.$location->LocationName.'</option>'; 
		$return .= '</select>';
		
		echo $return;
		exit();
	}
	
	function cupons()
	{
		JRequest::setVar('view','tickets');
		JRequest::setVar('layout','cupons');
		parent::display();
	}

	function editcupon()
	{
		JRequest::setVar('view','tickets');
		JRequest::setVar('layout','editcupon');
		parent::display();
	}
	
	function users()
	{
		JRequest::setVar('view','users');
		JRequest::setVar('layout','default');
		JRequest::setVar('tmpl','component');
		parent::display();
	}

	function themes()
	{
		JRequest::setVar('view','themes');
		JRequest::setVar('layout','default');
		parent::display();
	}
	
	function edittheme()
	{
		JRequest::setVar('view','themes');
		JRequest::setVar('layout','edit');
		parent::display();
	}
	
	function payments()
	{
		JRequest::setVar('view','payments');
		JRequest::setVar('layout','default');
		parent::display();
	}
	
	function editpayment()
	{
		JRequest::setVar('view','payments');
		JRequest::setVar('layout','edit');
		parent::display();
	}
	
	function log()
	{
		JRequest::setVar('view','subscriptions');
		JRequest::setVar('layout','log');
		parent::display();
	}
	
	function cleanup()
	{
		$db = JFactory::getDBO();
		
		$db->setQuery("DELETE FROM #__menu WHERE type = 'component' AND path LIKE '%rsevents%'");
		$db->query();
		$db->setQuery("DELETE FROM #__extensions WHERE type = 'component' AND element = 'com_rsevents'");
		$db->query();
		$db->setQuery("DELETE FROM #__assets WHERE name LIKE '%rsevents%'");
		$db->query();
		
		$this->setRedirect('index.php?option=com_installer',JText::_('RSE_ADMIN_MENUS_INFO'));
	}
}
?>