<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


class rseventsControllerPayments extends rseventsController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();

		// Register Extra tasks
		$this->registerTask('apply' ,  'save');
		$this->registerTask( 'unpublish' , 'publish');
	}

	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function save()
	{
		$model = $this->getModel('payments');
		$row = $model->save();
		
		if ($row)
			$msg = JText::_('RSE_PAYMENT_SAVED' );
		else
			$msg = JText::_('RSE_PAYMENT_SAVE_ERROR' );
		
		switch(JRequest::getCmd('task'))
		{
			case 'apply' :
				$link = 'index.php?option=com_rsevents&task=editpayment&cid='.$row->id;
			break;
			case 'save' :
				$link = 'index.php?option=com_rsevents&task=payments';
			break;
		}
		
		$this->setRedirect($link, $msg);
	}

	/**
	 * remove record(s)
	 * @return void
	 */
	function remove()
	{
		$model = $this->getModel('payments');
		if ($model->remove())
			$this->setRedirect( 'index.php?option=com_rsevents&task=payments', JText::_('RSE_PAYMENT_DELETED'));
	}

	/**
	 * cancel editing a record
	 * @return void
	 */
	function cancel()
	{
		$this->setRedirect( 'index.php?option=com_rsevents&task=payments');
	}
	
	//publish/unpublish
	function publish()
	{
		$model = $this->getModel('payments');
		if ($model->publish())
			$this->setRedirect('index.php?option=com_rsevents&task=payments');
	}
}