<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


class rseventsControllerRepeat extends rseventsController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();

		// Register Extra tasks
		$this->registerTask( 'apply' , 'save');
	}


	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function save()
	{
		jimport('joomla.filesystem.file');
		
		$db 	= &JFactory::getDBO();
		$model 	= $this->getModel('events');
		$post	= JRequest::get('post',JREQUEST_ALLOWRAW);
		$cid 	= JRequest::getInt('cid','0','request');
		$row	=& JTable::getInstance('Rsevents_Events','Table');
		$config	= rseventsHelper::getConfig();
		
		//load parent event
		$row->load($cid);
		if(!$row->bind($post)) return JError::raiseWarning(500, $row->getError()); 
		
		//prepare values
		
		if (!empty($row->EventRepeatDays))
		$row->EventRepeatDays = serialize($row->EventRepeatDays);
		if(!isset($post['EventRepeatDays'])) $row->EventRepeatDays = '';
		$row->EventRepeatUntil = strtotime($row->EventRepeatUntil);
		if (is_array($row->EventRepeatAlso))
		{
			$dates = array_unique($row->EventRepeatAlso);
			$dates = array_merge($dates,array());
			foreach($dates as $i => $date)
			{
				$datetounix = strtotime($date);
				$datetounix = $datetounix + (((date('H',$row->EventStartDate) * 60) + date('i',$row->EventStartDate)) * 60);
				$dates[$i] = $datetounix;
			}
			
			$row->EventRepeatAlso = serialize($dates);
		}
		if (!isset($post['EventRepeatAlso'])) $row->EventRepeatAlso = '';
		
		//save details
		$row->store();
		
		if ($row->EventEnableRepeat == 1)
		{
			//create a clone of the parent
			$new = clone($row);
			
			//get the parent id
			$parentid = $row->IdEvent;
			
			//get categories
			$db->setQuery("SELECT IdCategory FROM #__rsevents_events_cat WHERE IdEvent = '".$parentid."'");
			$categories = $db->loadResultArray();
			
			//get tickets
			$db->setQuery("SELECT * FROM #__rsevents_tickets WHERE IdEvent = '".$parentid."'");
			$tickets = $db->loadObjectList();
			
			//get coupons
			$db->setQuery("SELECT * FROM #__rsevents_cupons WHERE IdEvent = '".$parentid."'");
			$coupons = $db->loadObjectList();
			
			//get extras
			$db->setQuery("SELECT ExtraName,ExtraValue FROM #__rsevents_extras WHERE IdEvent = '".$parentid."'");
			$extras = $db->loadObjectList();
			
			//get files
			$db->setQuery("SELECT FileName,FileDescription,FileLocation,FilePermission FROM #__rsevents_files WHERE IdEvent='".$parentid."'");
			$dbfiles = $db->loadObjectList();
			
			//load icon extension
			$extension = JFile::getExt($row->EventIcon);
			
			//delete data first
			$db->setQuery("SELECT IdEvent FROM #__rsevents_events WHERE IdParent = '".$parentid."'");
			$ids = $db->loadResultArray();
			
			if (!empty($ids))
				foreach ($ids as $id)
				{
					//delete categories
					$db->setQuery("DELETE FROM #__rsevents_events_cat WHERE IdEvent = '".$id."'");
					$db->query();
					
					//delete tickets 
					$db->setQuery("DELETE FROM #__rsevents_tickets WHERE IdEvent = '".$id."'");
					$db->query();
					
					//delete coupons
					$db->setQuery("DELETE FROM #__rsevents_cupons WHERE IdEvent = '".$id."'");
					$db->query();
					
					//delete extras
					$db->setQuery("DELETE FROM #__rsevents_extras WHERE IdEvent = '".$id."'");
					$db->query();
					
					//delete subscription tickets
					$db->setQuery("SELECT IdSubscription FROM #__rsevents_subscriptions WHERE IdEvent = '".$id."'");
					$subscriptions = $db->loadObjectList();
					
					foreach($subscriptions as $sid)
					{
						$db->setQuery("DELETE FROM #__rsevents_subscription_tickets WHERE IdSubscription='".$sid->IdSubscription."'");
						$db->query();
					}
					
					//delete subscriptions
					$db->setQuery("DELETE FROM #__rsevents_subscriptions WHERE IdEvent='".$id."'");
					$db->query();
					
					//delete files
					$db->setQuery("SELECT FileLocation FROM #__rsevents_files WHERE IdEvent='".$id."'");
					$files = $db->loadObjectList();
					
					if (!empty($files))
					foreach ($files as $file)
						JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'files'.DS.$file->FileLocation);
					
					$db->setQuery("DELETE FROM #__rsevents_files WHERE IdEvent='".$id."'");
					$db->query();
					
					//delete icon if exists					
					if ($row->EventIcon != '')
					{
						$ext = JFile::getExt($row->EventIcon);
						$name = JFile::getName(JFile::stripExt($row->EventIcon));
						$big = $name.'_'.$config['event.icon.big'].'.'.$ext;
						$small = $name.'_'.$config['event.icon.small'].'.'.$ext;
						JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$big);
						JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$small);
					}
					
					//delete event 
					$db->setQuery("DELETE FROM #__rsevents_events WHERE IdEvent = '".$id."'");
					$db->query();
				}
			
			//get dates
			$startdates = array();
			$startdate 	= $row->EventStartDate;
			$repeatnr 	= $row->EventRepeatNumber;
			$duration 	= $row->EventEndDate - $row->EventStartDate;
			$repeatalso = unserialize($row->EventRepeatAlso);
			$days		= unserialize($row->EventRepeatDays);
			$repeatnr	= empty($repeatnr) ? 0 : $repeatnr;
			
			//switch on the type of the repetition
			if ($repeatnr > 0)
			switch($row->EventRepeatType)
			{
				//Days
				case 1:
					while ($startdate <= $row->EventRepeatUntil)
					{
						$startdate = strtotime('+'.$repeatnr.' days',  $startdate);
						if (!in_array(date('w',$startdate),$days)) continue;
						if($startdate > $row->EventRepeatUntil) break;
						$startdates[] = $startdate;
						
					}
				break;
				
				//Weeks
				case 2:
					while ($startdate <= $row->EventRepeatUntil)
					{
						$startdate = strtotime('+'.$repeatnr.' weeks',  $startdate);
						if (!in_array(date('w',$startdate),$days)) continue;
						if($startdate > $row->EventRepeatUntil) break;
						$startdates[] = $startdate;
						
					}
				break;
				
				//Months
				case 3:
					while ($startdate <= $row->EventRepeatUntil)
					{
						$startdate = strtotime('+'.$repeatnr.' months',  $startdate);
						if($startdate > $row->EventRepeatUntil) break;
						$startdates[] = $startdate;
						
					}
				break;
				
				//Years
				case 4:
					while ($startdate <= $row->EventRepeatUntil)
					{
						$startdate = strtotime('+'.$repeatnr.' year',  $startdate);
						if($startdate > $row->EventRepeatUntil) break;
						$startdates[] = $startdate;
						
					}
				break;
			}
			
			
			if (!empty($repeatalso))
				$startdates = array_merge($startdates,$repeatalso);
			
			$i = 0;
			//create new events
			if (!empty($startdates))
			foreach ($startdates as $newdate)
			{
				$new->EventStartDate = $newdate;
				$new->EventEndDate = $newdate + $duration;
				$new->IdParent = $parentid;
				$new->IdEvent = null;
				$new->EventEnableRepeat = 0;
				$new->EventRepeatAlso = '';
				$new->EventRepeatDays = '';
				$new->EventRepeatNumber = '';
				$new->EventRepeatType = '';
				$new->EventRepeatUntil = '';
				$new->EventIcon = '';
				$new->EventArchive = 0;
				$new->store();
				$i++;
				
				//load categories
				foreach ($categories as $category)
				{
					$db->setQuery("INSERT INTO #__rsevents_events_cat SET IdEvent = '".$new->IdEvent."' , IdCategory = '".$category."' ");
					$db->query();
				}
				
				//load tickets
				if (!empty($tickets))
					foreach ($tickets as $ticket)
					{
						$db->setQuery("INSERT INTO #__rsevents_tickets SET IdEvent = '".$new->IdEvent."' , TicketName = '".$db->getEscaped($ticket->TicketName)."' , TicketPrice = '".$ticket->TicketPrice."' ,TicketMaxAudience = '".$ticket->TicketMaxAudience."' , TicketsPerUser = '".$ticket->TicketsPerUser."' ,TicketDescription = '".$db->getEscaped($ticket->TicketDescription)."' , ordering = '".$ticket->ordering."' ");
						$db->query();
					}
				
				//load coupons
				if (!empty($coupons))
					foreach ($coupons as $coupon)
					{
						$db->setQuery("INSERT INTO #__rsevents_cupons SET IdEvent = '".$new->IdEvent."', CuponName = '".$coupon->CuponName."', CuponCode = '".$coupon->CuponCode."', CuponType = '".$coupon->CuponType."', CuponValue = '".$coupon->CuponValue."' ");
						$db->query();
					}
				
				//load extras
				if (!empty($extras))
					foreach ($extras as $extra)
					{
						$db->setQuery("INSERT INTO #__rsevents_extras SET IdEvent = '".$new->IdEvent."', ExtraName = '".$extra->ExtraName."' , ExtraValue = '".$extra->ExtraValue."' ");
						$db->query();
					}
				
				//load files
				if (!empty($dbfiles))
					foreach ($dbfiles as $file)
					{
						$fileext = JFile::getExt($file->FileLocation);
						$newfile = uniqid('',false).'.'.$fileext;
						JFile::copy(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'files'.DS.$file->FileLocation , JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'files'.DS.$newfile);
						$db->setQuery("INSERT INTO #__rsevents_files SET FileName = '".$file->FileName."' , FileDescription = '".$file->FileDescription."' , FileLocation = '".$newfile."' , FilePermission = '".$file->FilePermission."' , IdEvent = '".$new->IdEvent."' ");
						$db->query();
					}
				
				//load the icon
				if ($row->EventIcon != '')
				{
					$db->setQuery("UPDATE #__rsevents_events SET EventIcon = '".$new->IdEvent.'.'.$extension."' WHERE IdEvent = '".$new->IdEvent."' ");
					$db->query();
					
					JFile::copy(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$parentid.'_'.$config['event.icon.small'].'.'.$extension , JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$new->IdEvent.'_'.$config['event.icon.small'].'.'.$extension);
				JFile::copy(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$parentid.'_'.$config['event.icon.big'].'.'.$extension , JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$new->IdEvent.'_'.$config['event.icon.big'].'.'.$extension);
				}
			}
			
		}
		
		switch(JRequest::getCmd('task'))
		{
			case 'apply' :
				$link = 'index.php?option=com_rsevents&task=eventrepeat&cid='.$parentid;
			break;
			
			case 'save' :
				$link = 'index.php?option=com_rsevents&task=listevents';
			break;
		}
		
		$this->setRedirect($link, JText::sprintf('RSE_REPEAT_SAVED',$i));
	}
	
	function cancel()
	{
		$this->setRedirect( 'index.php?option=com_rsevents&task=listevents');
	}
}