<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class rseventsControllerThemes extends rseventsController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();
		$this->registerTask('apply' ,  'save');
	}
	
	function edittheme()
	{
		$model = $this->getModel('themes');
		$model->edit();
	}
	
	/**
	 * remove record(s)
	 * @return void
	 */
	function remove()
	{
		$model = $this->getModel('themes');
		$model->remove();
	}

	/**
	 * cancel editing a record
	 * @return void
	 */
	function cancel()
	{
		$this->setRedirect( 'index.php?option=com_rsevents&task=themes');
	}
	
	//set the default theme
	function makeDefault()
	{
		$model = $this->getModel('themes');
		$model->makedefault();
	}
	
	function save()
	{
		$model = $this->getModel('themes');
		$model->save();
	}
	
	function saveposition()
	{
		JRequest::setVar('tmpl','component');
		$db =& JFactory::getDBO();
		$placeholders = JRequest::getVar('pla');
		$column = JRequest::getVar('column');
		$blocks = JRequest::getVar('block',array(),'request','none',JREQUEST_ALLOWRAW);
		$id = JRequest::getInt('id');
		
		
		//delete all occurrences
		$db->setQuery("DELETE FROM `#__rsevents_themes_position` WHERE `id` = '".$id."' AND `column` = '".$db->getEscaped($column)."' ");
		$db->query();
		
		if (!empty($placeholders))
		foreach ($placeholders as $position => $placeholder)
		{
			$db->setQuery("INSERT INTO `#__rsevents_themes_position` SET `id` = '".$id."' , `position` = '".$db->getEscaped($position)."' , `column` = '".$db->getEscaped($column)."' , placeholder = '".$db->getEscaped($placeholder)."' , `block` = '".$db->getEscaped($blocks[$position])."' ");
			$db->query();
		}
		
		$db->setQuery("SELECT * FROM `#__rsevents_themes_position` WHERE `id` = '".$id."' AND `column` = '".$db->getEscaped($column)."' ORDER BY `position` ASC ");
		$placeh =$db->loadObjectList();
		
		$html = '';
		
		if (!empty($placeh))
		foreach ($placeh as $object)
			$html.= rseventsHelper::showPlaceholder($object->placeholder, $object->column, $object->position, htmlspecialchars($object->block,ENT_COMPAT,'UTF-8'));
		
		echo $html;
		exit();
	}
	
	
	function rempos()
	{
		JRequest::setVar('tmpl','component');
		$db =& JFactory::getDBO();
		$placeholder = JRequest::getVar('placeholder');
		$column = JRequest::getVar('column');
		$position = JRequest::getInt('position');
		$from = JRequest::getVar('from','');
		$id = JRequest::getInt('id');
		
		$placeholder = str_replace('pla_','',$placeholder);
		
		$db->setQuery("DELETE FROM `#__rsevents_themes_position` WHERE id = '".$id."' AND `column` = '".$db->getEscaped($column)."' AND `placeholder` = '".$db->getEscaped($placeholder)."' AND `position` = '".$db->getEscaped($position)."' ");
		$db->query();
		
		if ($from == 'delete')
		{
			$db->setQuery("SELECT * FROM `#__rsevents_themes_position` WHERE `id` = '".$id."' AND `column` = '".$db->getEscaped($column)."' ORDER BY `position` ASC ");
			$placeh =$db->loadObjectList();
			$html = '';
			
			if (!empty($placeh))
			foreach ($placeh as $object)
				$html.= rseventsHelper::showPlaceholder($object->placeholder, $object->column, $object->position, htmlspecialchars($object->block,ENT_COMPAT,'UTF-8'));
			
			echo $html;
		}
		
		exit();
	}
	
	function block()
	{
		JRequest::setVar('tmpl','component');
		$db =& JFactory::getDBO();
		$placeholder = JRequest::getVar('placeholder');
		$column = JRequest::getVar('column');
		$position = JRequest::getInt('position');
		$id = JRequest::getInt('id');
		
		$db->setQuery("SELECT `block` FROM `#__rsevents_themes_position` WHERE `id` = '".$id."' AND `column` = '".$db->getEscaped($column)."' AND `placeholder` = '".$db->getEscaped($placeholder)."' AND `position` = '".$db->getEscaped($position)."' ");		
		$content = $db->loadResult();
		
		echo '<div>'.JText::sprintf('RSE_THEME_EDIT_PLA',rseventsHelper::getPlaceholder($placeholder)).'</div>
				<textarea name="'.$column.$placeholder.$position.'" id="'.$column.$placeholder.$position.'" cols="40" rows="5">'.$content.'</textarea>
				<br />
				<button type="button" onclick="rse_save_block(\''.$placeholder.'\',\''.$column.'\',\''.$position.'\');">'.JText::_('RSE_SAVE_BTN').'</button>
				<button type="button" onclick="rse_cancel_block();">'.JText::_('RSE_CANCEL_BTN').'</button>
				<p>
					<div class="pla_info">
						<img src="'.JURI::root().'administrator/components/com_rsevents/assets/images/icons/warning.png" style="vertical-align:middle;" />
					</div>
					'.JText::sprintf('RSE_PLA_INFO',rseventsHelper::getPlaceholder($placeholder)).' 
				</p>
				';
		
		exit();
	}
	
	function saveblock()
	{
		JRequest::setVar('tmpl','component');
		$db =& JFactory::getDBO();
		$placeholder = JRequest::getVar('placeholder');
		$column = JRequest::getVar('column');
		$block = JRequest::getVar('block','','request','none',JREQUEST_ALLOWRAW);
		$position = JRequest::getInt('position');
		$id = JRequest::getInt('id');
		
		$db->setQuery("UPDATE `#__rsevents_themes_position` SET `block` = '".$db->getEscaped($block)."' WHERE `id` = '".$id."' AND `column` = '".$db->getEscaped($column)."' AND `placeholder` = '".$db->getEscaped($placeholder)."' AND `position` = '".$db->getEscaped($position)."' ");
		$db->query();
		
		$db->setQuery("SELECT * FROM `#__rsevents_themes_position` WHERE `id` = '".$id."' AND `column` = '".$db->getEscaped($column)."' ORDER BY `position` ASC ");
		$placeh = $db->loadObjectList();
		$html = '';
		
		if (!empty($placeh))
		foreach ($placeh as $object)
			$html.= rseventsHelper::showPlaceholder($object->placeholder, $object->column, $object->position, htmlspecialchars($object->block,ENT_COMPAT,'UTF-8'));
		
		echo $html;
		exit();
	}
	
}