<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('JPATH_BASE') or die;

jimport('joomla.form.formfield');

/**
 * Supports a modal article picker.
 *
 * @package		RSEvents!
 * @subpackage	com_rsevents
 * @since		1.6
 */
class JFormFieldDesignsField extends JFormField
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'DesignsField';

	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	protected function getInput()
	{		
		$fieldName	= $this->name;
		
		$layouts = array();
		$layouts[] = JHTML::_('select.option', 'none', JText::_( 'RSE_SELECT_DESIGN' ) );
		$layouts[] = JHTML::_('select.option', '0', JText::_( 'RSE_DEFAULT_LAYOUT' ) );
		$layouts[] = JHTML::_('select.option', '1', JText::_( 'RSE_DEFAULT_CUSTOM_LAYOUT' ) );
		$layouts[] = JHTML::_('select.option', '2', JText::_( 'RSE_TABLE_LAYOUT' ) );
		$layouts[] = JHTML::_('select.option', '3', JText::_( 'RSE_TABLE_CUSTOM_LAYOUT' ) );
		
		jimport('joomla.filesystem.folder');
		jimport('joomla.utilities.simplexml');
		$files = JFolder::folders(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'designs','intro');
		
		if (!empty($files))
			foreach ($files as $file)
			{						
				$file = str_replace('intro_','',$file);
				
				$xml = new JSimpleXML;
				$xml->loadFile(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'designs'.DS.'intro_'.$file.DS.$file.'.xml');
				$name = $xml->document->attributes('name');
				$type = $xml->document->attributes('type');
				
				$layouts[] = JHTML::_('select.option', $file , $name. ' ('.$type.')' );
			}
		
		return JHTML::_('select.genericlist', $layouts, $this->name, 'class="inputbox"', 'value', 'text', $this->value );
	}
}