CREATE TABLE IF NOT EXISTS `#__rsevents_categories` (
  `IdCategory` int(11) NOT NULL AUTO_INCREMENT,
  `parent` int(10) NOT NULL DEFAULT '0',
  `CategoryName` varchar(255) NOT NULL,
  `CategoryColor` varchar(20) NOT NULL,
  `CategoryDescription` text NOT NULL,
  `published` tinyint(1) NOT NULL,
  `ordering` int(11) NOT NULL,
  `CategoryAlias` varchar(255) NOT NULL,
  PRIMARY KEY (`IdCategory`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;



CREATE TABLE IF NOT EXISTS `#__rsevents_config` (
  `ConfigName` varchar(255) NOT NULL,
  `ConfigValue` text NOT NULL,
  PRIMARY KEY (`ConfigName`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



CREATE TABLE IF NOT EXISTS `#__rsevents_cupons` (
  `IdCupon` int(4) NOT NULL AUTO_INCREMENT,
  `IdEvent` int(4) NOT NULL,
  `CuponName` varchar(255) NOT NULL,
  `CuponCode` varchar(255) NOT NULL,
  `CuponType` int(1) NOT NULL,
  `CuponValue` float NOT NULL,
  `CouponStart` int(15) NOT NULL,
  `CouponEnd` int(15) NOT NULL,
  `CouponLimit` int(5) NOT NULL,
  `CouponUsed` int(5) NOT NULL,
  `CouponAction` int(2) NOT NULL,
  PRIMARY KEY (`IdCupon`),
  KEY `IdEvent` (`IdEvent`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;



CREATE TABLE IF NOT EXISTS `#__rsevents_designs` (
  `IdDesign` int(11) NOT NULL AUTO_INCREMENT,
  `DesignName` varchar(255) NOT NULL,
  `DesignDefault` tinyint(1) NOT NULL,
  `designtype` int(1) NOT NULL,
  PRIMARY KEY (`IdDesign`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;



CREATE TABLE IF NOT EXISTS `#__rsevents_events` (
  `IdEvent` int(11) NOT NULL AUTO_INCREMENT,
  `IdLocation` int(11) NOT NULL,
  `IdDesign` int(11) NOT NULL,
  `IdNewDesign` int(10) NOT NULL,
  `IdTheme` int(10) NOT NULL,
  `IdUser` int(11) NOT NULL,
  `IdParent` tinyint(2) NOT NULL,
  `EventName` varchar(255) NOT NULL,
  `EventAlias` char(255) NOT NULL,
  `EventSubtitle` varchar(255) NOT NULL,
  `EventHost` varchar(255) NOT NULL,
  `EventURL` varchar(255) NOT NULL,
  `EventPhone` varchar(255) NOT NULL,
  `EventEmail` varchar(255) NOT NULL,
  `EventDescription` text NOT NULL,
  `EventType` tinyint(1) NOT NULL DEFAULT '1',
  `EventOverbooking` tinyint(2) NOT NULL,
  `EventStartDate` int(11) NOT NULL,
  `EventEndDate` int(11) NOT NULL,
  `EventEnableRegistration` tinyint(1) NOT NULL,
  `EventShowGuest` tinyint(1) NOT NULL,
  `EventEnableComments` tinyint(1) NOT NULL,
  `EventPostReminder` tinyint(1) NOT NULL,
  `published` tinyint(1) NOT NULL,
  `EventPrivateUrl` varchar(255) NOT NULL,
  `EventEnableRepeat` tinyint(2) NOT NULL,
  `EventRepeatType` tinyint(2) NOT NULL,
  `EventRepeatNumber` int(10) NOT NULL,
  `EventRepeatDays` text NOT NULL,
  `EventRepeatUntil` int(11) NOT NULL,
  `EventRepeatAlso` text NOT NULL,
  `EventRegistrationForm` int(5) NOT NULL,
  `EventArchive` tinyint(2) NOT NULL,
  `EventAutoApprove` tinyint(2) NOT NULL,
  `EventPaypalEmail` varchar(255) NOT NULL,
  `EventIcon` text NOT NULL,
  `EventReturnUrl` varchar(255) NOT NULL,
  `EventKeywords` varchar(255) NOT NULL,
  `EventMetaDescription` varchar(255) NOT NULL,
  `EventAmPm1` int(1) NOT NULL,
  `EventAmPm2` int(1) NOT NULL,
  `EventCreation` int(15) NOT NULL,
  `EventPageTitle` varchar(255) NOT NULL,
  `EventStartRegistration` int(15) NOT NULL,
  `EventEndRegistration` int(15) NOT NULL,
  `designtype` int(1) NOT NULL,
  `SubscriptionNotification` tinyint(1) NOT NULL,
  `payments` varchar(255) NOT NULL,
  `early_discount_type` tinyint(1) NOT NULL,
  `early_discount_value` float NOT NULL,
  `early_discount_deadline` int(11) NOT NULL,
  `late_fee_type` tinyint(1) NOT NULL,
  `late_fee_value` float NOT NULL,
  `late_fee_date` int(11) NOT NULL,
  `ticket_pdf` tinyint(1) NOT NULL,
  `ticket_pdf_layout` text NOT NULL,
  PRIMARY KEY (`IdEvent`),
  KEY `EventPeriod` (`EventStartDate`,`EventEndDate`),
  KEY `IdLocation` (`IdLocation`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;



CREATE TABLE IF NOT EXISTS `#__rsevents_events_cat` (
  `IdEventCategory` int(11) NOT NULL AUTO_INCREMENT,
  `IdEvent` int(11) NOT NULL,
  `IdCategory` int(11) NOT NULL,
  PRIMARY KEY (`IdEventCategory`),
  KEY `IdEvent` (`IdEvent`,`IdCategory`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;



CREATE TABLE IF NOT EXISTS `#__rsevents_events_reminders` (
  `IdEvent` int(11) NOT NULL,
  `Sent` tinyint(1) NOT NULL,
  UNIQUE KEY `IdEvent` (`IdEvent`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



CREATE TABLE IF NOT EXISTS `#__rsevents_extras` (
  `IdExtra` int(11) NOT NULL AUTO_INCREMENT,
  `IdEvent` int(11) NOT NULL,
  `ExtraName` varchar(255) NOT NULL,
  `ExtraValue` text NOT NULL,
  PRIMARY KEY (`IdExtra`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;



CREATE TABLE IF NOT EXISTS `#__rsevents_files` (
  `IdFile` int(11) NOT NULL AUTO_INCREMENT,
  `IdEvent` int(11) NOT NULL,
  `FileName` text NOT NULL,
  `FileDescription` text NOT NULL,
  `FileLocation` text NOT NULL,
  `FilePermission` varchar(30) NOT NULL,
  PRIMARY KEY (`IdFile`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;



CREATE TABLE IF NOT EXISTS `#__rsevents_groups` (
  `IdGroup` int(11) NOT NULL AUTO_INCREMENT,
  `GroupName` varchar(255) NOT NULL,
  PRIMARY KEY (`IdGroup`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;



CREATE TABLE IF NOT EXISTS `#__rsevents_groups_acl` (
  `IdGroupAcl` int(11) NOT NULL AUTO_INCREMENT,
  `IdGroup` int(11) NOT NULL,
  `GroupAcl` int(11) NOT NULL,
  PRIMARY KEY (`IdGroupAcl`),
  KEY `IdGroup` (`IdGroup`,`GroupAcl`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;



CREATE TABLE IF NOT EXISTS `#__rsevents_group_permissions` (
  `IdGroupPermission` int(11) NOT NULL AUTO_INCREMENT,
  `IdGroup` int(11) NOT NULL,
  `PermissionName` varchar(255) NOT NULL,
  `PermissionValue` text NOT NULL,
  PRIMARY KEY (`IdGroupPermission`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;



CREATE TABLE IF NOT EXISTS `#__rsevents_locations` (
  `IdLocation` int(11) NOT NULL AUTO_INCREMENT,
  `LocationName` varchar(255) NOT NULL,
  `LocationDescription` text NOT NULL,
  `LocationAlias` varchar(255) NOT NULL,
  `LocationURL` varchar(255) NOT NULL,
  `LocationCity` varchar(255) NOT NULL,
  `LocationAddress` varchar(255) NOT NULL,
  `LocationZip` varchar(255) NOT NULL,
  `LocationState` varchar(255) NOT NULL,
  `LocationCountry` varchar(255) NOT NULL,
  `LocationLat` varchar(255) NOT NULL,
  `LocationLon` varchar(255) NOT NULL,
  `published` tinyint(1) NOT NULL,
  `ordering` int(10) NOT NULL,
  PRIMARY KEY (`IdLocation`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;



CREATE TABLE IF NOT EXISTS `#__rsevents_rating` (
  `id` int(5) NOT NULL AUTO_INCREMENT,
  `IdEvent` int(5) NOT NULL,
  `rating` int(2) NOT NULL,
  `ip` varchar(15) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `IdEvent` (`IdEvent`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;



CREATE TABLE IF NOT EXISTS `#__rsevents_subscriptions` (
  `IdSubscription` int(11) NOT NULL AUTO_INCREMENT,
  `IdEvent` int(11) NOT NULL,
  `IdUser` int(11) NOT NULL,
  `FirstName` varchar(255) NOT NULL,
  `LastName` varchar(255) NOT NULL,
  `Email` varchar(255) NOT NULL,
  `SubscriptionState` tinyint(4) NOT NULL,
  `SubscriptionDate` int(11) NOT NULL,
  `SubscriptionVerification` varchar(32) NOT NULL,
  `TransactionGateway` varchar(20) NOT NULL,
  `TransactionParams` text NOT NULL,
  `SubscriptionFormId` int(3) NOT NULL,
  `UserIp` varchar(15) NOT NULL,
  `PaymentUrl` text NOT NULL,
  `Discount` float NOT NULL,
  `early_fee` float NOT NULL,
  `late_fee` float NOT NULL,
  `tax` float NOT NULL,
  `log` text NOT NULL,
  PRIMARY KEY (`IdSubscription`),
  KEY `IdEvent` (`IdEvent`),
  KEY `Email` (`Email`),
  KEY `IdUser` (`IdUser`),
  KEY `EventSubscriptionState` (`IdEvent`,`SubscriptionState`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `#__rsevents_subscription_tickets` (
  `IdSubscriptionTickets` int(11) NOT NULL AUTO_INCREMENT,
  `IdSubscription` int(11) NOT NULL,
  `IdTicket` int(11) NOT NULL,
  `TicketsSubscribed` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`IdSubscriptionTickets`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;



CREATE TABLE IF NOT EXISTS `#__rsevents_tickets` (
  `IdTicket` int(11) NOT NULL AUTO_INCREMENT,
  `IdEvent` int(11) NOT NULL,
  `TicketName` varchar(255) NOT NULL,
  `TicketPrice` double NOT NULL,
  `TicketMaxAudience` int(11) NOT NULL,
  `TicketsPerUser` int(5) NOT NULL,
  `TicketDescription` text NOT NULL,
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`IdTicket`),
  KEY `IdEvent` (`IdEvent`),
  KEY `EventFeeNameUnique` (`IdEvent`,`TicketName`),
  KEY `IdEvent_2` (`IdEvent`,`TicketName`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `#__rsevents_countries` (
  `name` varchar(255) NOT NULL,
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__rsevents_modules` (
  `position` int(11) NOT NULL,
  `column` varchar(255) NOT NULL,
  `module` varchar(255) NOT NULL,
  PRIMARY KEY (`module`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `#__rsevents_sync` (
  `id` varchar(255) NOT NULL,
  `IdEvent` int(11) NOT NULL,
  `from` varchar(255) NOT NULL,
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `#__rsevents_themes` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `default` int(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `#__rsevents_themes_position` (
  `id` int(10) NOT NULL,
  `position` int(10) NOT NULL,
  `column` varchar(10) NOT NULL,
  `placeholder` int(5) NOT NULL,
  `block` text NOT NULL,
  PRIMARY KEY (`id`,`position`,`column`,`placeholder`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__rsevents_cards` (
`id` INT NOT NULL AUTO_INCREMENT ,
`ids` INT NOT NULL ,
`card_number` TEXT NOT NULL ,
`card_csc` TEXT NOT NULL ,
`card_exp` VARCHAR( 10 ) NOT NULL ,
`card_fname` VARCHAR( 255 ) NOT NULL ,
`card_lname` VARCHAR( 255 ) NOT NULL ,
PRIMARY KEY ( `id` )
) ENGINE = MYISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__rsevents_payments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `details` text NOT NULL,
  `tax_type` tinyint(1) NOT NULL,
  `tax_value` int(11) NOT NULL,
  `redirect` text NOT NULL,
  `published` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

INSERT IGNORE INTO `#__rsevents_payments` (`id`, `name`, `details`, `tax_type`, `tax_value`, `published`) VALUES(1, 'Wire Transfer', '<p><strong>Bank name:</strong> Your bank name <strong></strong></p>\r\n<p><strong>Bank Address:</strong> your bank address <strong></strong></p>\r\n<p><strong>Bank Account Number:</strong></p>\r\n<p><strong>Swift BIC Number:</strong> <strong>Beneficiary:</strong></p>', 0, 0, 1);


INSERT IGNORE INTO `#__rsevents_countries` (`name`) VALUES
('Afghanistan'),
('Akrotiri'),
('Albania'),
('Algeria'),
('American Samoa'),
('Andorra'),
('Angola'),
('Anguilla'),
('Antarctica'),
('Antigua and Barbuda'),
('Argentina'),
('Armenia'),
('Aruba'),
('Ashmore and Cartier Islands'),
('Australia'),
('Austria'),
('Azerbaijan'),
('Bahamas, The'),
('Bahrain'),
('Bangladesh'),
('Barbados'),
('Bassas da India'),
('Belarus'),
('Belgium'),
('Belize'),
('Benin'),
('Bermuda'),
('Bhutan'),
('Bolivia'),
('Bosnia and Herzegovina'),
('Botswana'),
('Bouvet Island'),
('Brazil'),
('British Indian Ocean Territory'),
('British Virgin Islands'),
('Brunei'),
('Bulgaria'),
('Burkina Faso'),
('Burma'),
('Burundi'),
('Cambodia'),
('Cameroon'),
('Canada'),
('Cape Verde'),
('Cayman Islands'),
('Central African Republic'),
('Chad'),
('Chile'),
('China'),
('Christmas Island'),
('Clipperton Island'),
('Cocos (Keeling) Islands'),
('Colombia'),
('Comoros'),
('Congo, Democratic Republic of the'),
('Congo, Republic of the'),
('Cook Islands'),
('Coral Sea Islands'),
('Costa Rica'),
('Cote d''Ivoire'),
('Croatia'),
('Cuba'),
('Cyprus'),
('Czech Republic'),
('Denmark'),
('Dhekelia'),
('Djibouti'),
('Dominica'),
('Dominican Republic'),
('Ecuador'),
('Egypt'),
('El Salvador'),
('Equatorial Guinea'),
('Eritrea'),
('Estonia'),
('Ethiopia'),
('Europa Island'),
('Falkland Islands (Islas Malvinas)'),
('Faroe Islands'),
('Fiji'),
('Finland'),
('France'),
('French Guiana'),
('French Polynesia'),
('French Southern and Antarctic Lands'),
('Gabon'),
('Gambia, The'),
('Gaza Strip'),
('Georgia'),
('Germany'),
('Ghana'),
('Gibraltar'),
('Glorioso Islands'),
('Greece'),
('Greenland'),
('Grenada'),
('Guadeloupe'),
('Guam'),
('Guatemala'),
('Guernsey'),
('Guinea'),
('Guinea-Bissau'),
('Guyana'),
('Haiti'),
('Heard Island and McDonald Islands'),
('Holy See (Vatican City)'),
('Honduras'),
('Hong Kong'),
('Hungary'),
('Iceland'),
('India'),
('Indonesia'),
('Iran'),
('Iraq'),
('Ireland'),
('Isle of Man'),
('Israel'),
('Italy'),
('Jamaica'),
('Jan Mayen'),
('Japan'),
('Jersey'),
('Jordan'),
('Juan de Nova Island'),
('Kazakhstan'),
('Kenya'),
('Kiribati'),
('Korea, North'),
('Korea, South'),
('Kuwait'),
('Kyrgyzstan'),
('Laos'),
('Latvia'),
('Lebanon'),
('Lesotho'),
('Liberia'),
('Libya'),
('Liechtenstein'),
('Lithuania'),
('Luxembourg'),
('Macau'),
('Macedonia'),
('Madagascar'),
('Malawi'),
('Malaysia'),
('Maldives'),
('Mali'),
('Malta'),
('Marshall Islands'),
('Martinique'),
('Mauritania'),
('Mauritius'),
('Mayotte'),
('Mexico'),
('Micronesia, Federated States of'),
('Moldova'),
('Monaco'),
('Mongolia'),
('Montserrat'),
('Morocco'),
('Mozambique'),
('Namibia'),
('Nauru'),
('Navassa Island'),
('Nepal'),
('Netherlands'),
('Netherlands Antilles'),
('New Caledonia'),
('New Zealand'),
('Nicaragua'),
('Niger'),
('Nigeria'),
('Niue'),
('Norfolk Island'),
('Northern Mariana Islands'),
('Norway'),
('Oman'),
('Pakistan'),
('Palau'),
('Panama'),
('Papua New Guinea'),
('Paracel Islands'),
('Paraguay'),
('Peru'),
('Philippines'),
('Pitcairn Islands'),
('Poland'),
('Portugal'),
('Puerto Rico'),
('Qatar'),
('Reunion'),
('Romania'),
('Russia'),
('Rwanda'),
('Saint Helena'),
('Saint Kitts and Nevis'),
('Saint Lucia'),
('Saint Pierre and Miquelon'),
('Saint Vincent and the Grenadines'),
('Samoa'),
('San Marino'),
('Sao Tome and Principe'),
('Saudi Arabia'),
('Senegal'),
('Serbia and Montenegro'),
('Seychelles'),
('Sierra Leone'),
('Singapore'),
('Slovakia'),
('Slovenia'),
('Solomon Islands'),
('Somalia'),
('South Africa'),
('South Georgia and the South Sandwich Islands'),
('Spain'),
('Spratly Islands'),
('Sri Lanka'),
('Sudan'),
('Suriname'),
('Svalbard'),
('Swaziland'),
('Sweden'),
('Switzerland'),
('Syria'),
('Taiwan'),
('Tajikistan'),
('Tanzania'),
('Thailand'),
('Timor-Leste'),
('Togo'),
('Tokelau'),
('Tonga'),
('Trinidad and Tobago'),
('Tromelin Island'),
('Tunisia'),
('Turkey'),
('Turkmenistan'),
('Turks and Caicos Islands'),
('Tuvalu'),
('Uganda'),
('Ukraine'),
('United Arab Emirates'),
('United Kingdom'),
('United States'),
('Uruguay'),
('Uzbekistan'),
('Vanuatu'),
('Venezuela'),
('Vietnam'),
('Virgin Islands'),
('Wake Island'),
('Wallis and Futuna'),
('West Bank'),
('Western Sahara'),
('Yemen'),
('Zambia'),
('Zimbabwe');


INSERT IGNORE INTO `#__rsevents_modules` (`position`, `column`, `module`) VALUES(0, 'col1', 'module1');
INSERT IGNORE INTO `#__rsevents_modules` (`position`, `column`, `module`) VALUES(1, 'col2', 'module2');
INSERT IGNORE INTO `#__rsevents_modules` (`position`, `column`, `module`) VALUES(0, 'col3', 'module3');
INSERT IGNORE INTO `#__rsevents_modules` (`position`, `column`, `module`) VALUES(1, 'col3', 'module4');
INSERT IGNORE INTO `#__rsevents_modules` (`position`, `column`, `module`) VALUES(3, 'col3', 'module5');
INSERT IGNORE INTO `#__rsevents_modules` (`position`, `column`, `module`) VALUES(2, 'col3', 'module6');


INSERT IGNORE INTO `#__rsevents_themes` (`id`, `name`, `default`) VALUES(1, 'Default', 1);
INSERT IGNORE INTO `#__rsevents_themes` (`id`, `name`, `default`) VALUES(2, 'Single column', 0);
INSERT IGNORE INTO `#__rsevents_themes` (`id`, `name`, `default`) VALUES(3, 'Two columns', 0);
INSERT IGNORE INTO `#__rsevents_themes` (`id`, `name`, `default`) VALUES(4, 'Three columns', 0);

INSERT IGNORE INTO `#__rsevents_categories` (`IdCategory`,`CategoryName`, `CategoryColor`, `CategoryDescription`, `published`, `ordering`, `CategoryAlias`) VALUES
(1, 'Events', '', 'My first category.', 1, 1, 'events');
INSERT IGNORE INTO `#__rsevents_locations` (`IdLocation`, `LocationName`, `LocationDescription`, `LocationAlias`, `LocationURL`, `LocationCity`, `LocationAddress`, `LocationZip`, `LocationState`, `LocationCountry`, `LocationLat`, `LocationLon`, `published`, `ordering`) VALUES
(1, 'My first location', 'My First Location.', 'my-first-location', 'http://myfirstlocation.com', 'My first city', 'My address', 'My zip code', '', 'My Country', '', '', 1, 1);
INSERT IGNORE INTO `#__rsevents_groups` (`IdGroup`, `GroupName`) VALUES (1, 'Public');
INSERT IGNORE INTO `#__rsevents_groups_acl` (`IdGroupAcl`, `IdGroup`, `GroupAcl`) VALUES (1, 1, 29);
INSERT IGNORE INTO `#__rsevents_group_permissions` (`IdGroupPermission`, `IdGroup`, `PermissionName`, `PermissionValue`) VALUES(1, 1, 'allowDownload', '1');
INSERT IGNORE INTO `#__rsevents_group_permissions` (`IdGroupPermission`, `IdGroup`, `PermissionName`, `PermissionValue`) VALUES(2, 1, 'allowRegistrationCancel', '0');
INSERT IGNORE INTO `#__rsevents_group_permissions` (`IdGroupPermission`, `IdGroup`, `PermissionName`, `PermissionValue`) VALUES(3, 1, 'allowRegistration', '1');
INSERT IGNORE INTO `#__rsevents_group_permissions` (`IdGroupPermission`, `IdGroup`, `PermissionName`, `PermissionValue`) VALUES(4, 1, 'canEdit', '0');
INSERT IGNORE INTO `#__rsevents_group_permissions` (`IdGroupPermission`, `IdGroup`, `PermissionName`, `PermissionValue`) VALUES(5, 1, 'enableModeration', '1');
INSERT IGNORE INTO `#__rsevents_group_permissions` (`IdGroupPermission`, `IdGroup`, `PermissionName`, `PermissionValue`) VALUES(6, 1, 'enablePosts', '0');
INSERT IGNORE INTO `#__rsevents_group_permissions` (`IdGroupPermission`, `IdGroup`, `PermissionName`, `PermissionValue`) VALUES(7, 1, 'enableLocationModeration', '1');
INSERT IGNORE INTO `#__rsevents_group_permissions` (`IdGroupPermission`, `IdGroup`, `PermissionName`, `PermissionValue`) VALUES(8, 1, 'enableEditLocation', '0');
INSERT IGNORE INTO `#__rsevents_group_permissions` (`IdGroupPermission`, `IdGroup`, `PermissionName`, `PermissionValue`) VALUES(9, 1, 'allowLocations', '0');
INSERT IGNORE INTO `#__rsevents_group_permissions` (`IdGroupPermission`, `IdGroup`, `PermissionName`, `PermissionValue`) VALUES(10, 1, 'allowUpload', '0');
INSERT IGNORE INTO `#__rsevents_group_permissions` (`IdGroupPermission`, `IdGroup`, `PermissionName`, `PermissionValue`) VALUES(11, 1, 'canDelete', '0');