<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die();
 
jimport( 'joomla.application.component.model' );

class rseventsModelArchive extends JModel
{
	var $_query;
	var $_data;
	var $_total=null;
	var $_pagination=null;
	
	function _buildQuery()
	{
		$mainframe =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		
		$filter				= JRequest::getVar('rs_filter', $mainframe->getUserState('com_rsevents.events.archive'));
		$category_filter	= JRequest::getVar('rs_cat_filter');
		$location_filter	= JRequest::getVar('rs_loc_filter');
		$sortOrder			= JRequest::getVar('filter_order_Dir','desc');
		$sortColumn			= JRequest::getVar('filter_order','e.EventStartDate');
		
		$mainframe->setUserState('com_rsevents.events.archive',$filter);
		
		if($category_filter) $cat_filter="AND ec.IdCategory = ".$db->getEscaped($category_filter)." "; else $cat_filter="";
		if($location_filter && $location_filter != JText::_('RSE_EVENT_SELECT_LOCATION')) $loc_filter="AND l.LocationName LIKE '%".$db->getEscaped($location_filter)."%'"; else $loc_filter="";
		
		$this->_query="SELECT e.IdEvent as RecordId, e.EventName ,e.EventEnableRegistration ,  e.IdLocation , e.EventStartDate , e.EventEndDate, e.IdUser , e.IdParent , e.published , l.LocationName , COUNT(IdSubscription) as subscribers  , u.username "
						."FROM #__rsevents_events e "
						."LEFT JOIN #__rsevents_locations l ON e.IdLocation = l.IdLocation "
						."LEFT JOIN #__rsevents_events_cat ec ON ec.IdEvent = e.IdEvent "
						."LEFT JOIN #__rsevents_categories c ON c.IdCategory = ec.IdCategory "
						."LEFT JOIN #__rsevents_subscriptions s ON e.IdEvent = s.IdEvent "
						."LEFT JOIN #__users u ON e.IdUser = u.id "
						."WHERE e.EventName LIKE '%".$db->getEscaped($filter)."%' $cat_filter $loc_filter AND e.published = '-1' "
						."GROUP BY e.IdEvent "
						."ORDER BY $sortColumn $sortOrder ";
		//echo $this->_query;
	}
	function __construct()
	{	
		parent::__construct();
		$this->_buildQuery();
		$mainframe =& JFactory::getApplication();

		// Get pagination request variables
		$limit = $mainframe->getUserStateFromRequest('com_rsevents.archieve.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = $mainframe->getUserStateFromRequest('com_rsevents.archieve.limitstart', 'limitstart', 0, 'int');

		// In case limit has been changed, adjust it
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('com_rsevents.archieve.limit', $limit);
		$this->setState('com_rsevents.archieve.limitstart', $limitstart);
	}
	
	function getData()
	{
		if (empty($this->_data))
			$this->_data=$this->_getList($this->_query,$this->getState('com_rsevents.archieve.limitstart'), $this->getState('com_rsevents.archieve.limit'));

		return $this->_data;
	}
	
	function getTotal()
	{
		if (empty($this->_total))
			$this->_total = $this->_getListCount($this->_query);	

		return $this->_total;
	}
	
	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('com_rsevents.archieve.limitstart'), $this->getState('com_rsevents.archieve.limit'));
		}
		return $this->_pagination;
	}
	
	//remove function
	function remove()
	{
		jimport('joomla.filesystem.file');
		
		$app	=& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$cids	= JRequest::getVar('cid',array(0),'post','array');
		$row 	=& JTable::getInstance('Rsevents_Events','Table');
		$conf	= rseventsHelper::getConfig();
		
		if(!empty($cids))
		{
			foreach($cids as $cid) 
			{
				$db->setQuery("SELECT EventIcon FROM #__rsevents_events WHERE IdEvent='".$cid."'");
				$eventicon = $db->loadResult();
				
				if(!$row->delete($cid)) 
					$msg = JText::_('RSE_EVENT_DELETE_ERROR' );
				else 
				{
					//delete files
					$db->setQuery("SELECT FileLocation FROM #__rsevents_files WHERE IdEvent='".$cid."'");
					$files = $db->loadObjectList();
					
					if (!empty($files))
					foreach ($files as $file)
						JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'files'.DS.$file->FileLocation);
						
					//delete icon if exists
					if ($eventicon != '')
					{
						$ext = JFile::getExt($eventicon);
						$name = JFile::getName($eventicon);
						$name = JFile::stripExt($name);
						$big = $name.'_'.$conf['event.icon.big'].'.'.$ext;
						$small = $name.'_'.$conf['event.icon.small'].'.'.$ext;
						JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$big);
						JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$small);
					}
					
					//delete categories
					$db->setQuery("DELETE FROM #__rsevents_events_cat WHERE IdEvent = '".$cid."' ");
					$db->query();
					
					//delete files from db
					$db->setQuery("DELETE FROM #__rsevents_files WHERE IdEvent='".$cid."'");
					$db->query();
					
					//delete tickets
					$db->setQuery("DELETE FROM #__rsevents_tickets WHERE IdEvent='".$cid."'");
					$db->query();
					
					//delete subscription tickets
					$db->setQuery("SELECT IdSubscription FROM #__rsevents_subscriptions WHERE IdEvent='".$cid."'");
					$subscriptions = $db->loadObjectList();
					
					foreach($subscriptions as $id)
					{
						$db->setQuery("DELETE FROM #__rsevents_subscription_tickets WHERE IdSubscription='".$id->IdSubscription."'");
						$db->query();
					}
					
					//delete subscriptions
					$db->setQuery("DELETE FROM #__rsevents_subscriptions WHERE IdEvent='".$cid."'");
					$db->query();
					
					$row->reorder();
					$msg = JText::_( 'RSE_EVENT_DELETE' );
				}
			}
		} else $msg = JText::_('RSE_EVENT_SELECT' ); 
		
		$app->redirect( 'index.php?option=com_rsevents&task=archive', $msg );
	}
	
	//unarchive events
	function unarchive()
	{
		$app	=& JFactory::getApplication();
		$db 	=& JFactory::getDBO();
		$cid 	= JRequest::getVar('cid',array(),'request','array');
		
		$cids = implode(',', $cid );
		
		$db->setQuery("UPDATE #__rsevents_events SET published = '0' WHERE IdEvent IN (".$cids.") ");
		$db->query();
		$db->setQuery("UPDATE #__rsevents_events SET EventArchive = '1' WHERE IdEvent IN (".$cids.") ");
		$db->query();
		$total = count($cid);		
		
		$app->redirect('index.php?option=com_rsevents&task=archive',$total.' '.JText::_('RSE_EVENT_UNARCHIVED'));
	}
	
}