<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die();
 
jimport( 'joomla.application.component.model' );

class rseventsModelCategories extends JModel
{
	var $_query;
	var $_data;
	var $_total=null;
	var $_pagination=null;
	
	function _buildQuery()
	{
		$mainframe =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		
		$sortColumn		= $mainframe->getUserStateFromRequest('com_rsevents.categories.sortColumn','filter_order','ordering');
		$sortOrder		= $mainframe->getUserStateFromRequest('com_rsevents.categories.sortOrder','filter_order_Dir','asc');
		$filter			= JRequest::getVar('rs_filter', $mainframe->getUserState('com_rsevents.events.categories'));
		
		$mainframe->setUserState('com_rsevents.categories.sortColumn',$sortColumn);
		$mainframe->setUserState('com_rsevents.categories.sortOrder',$sortOrder);
		$mainframe->setUserState('com_rsevents.events.categories',$filter);
		
		if (rseventsHelper::is16())
			$this->_query="SELECT IdCategory as id , CategoryName as title , CategoryColor , CategoryDescription ,parent as parent_id , published , ordering FROM #__rsevents_categories WHERE 1 = 1 ORDER BY $sortColumn $sortOrder";
		else
			$this->_query="SELECT IdCategory as id , CategoryName as name , CategoryColor , CategoryDescription ,parent , published , ordering FROM #__rsevents_categories WHERE 1 = 1 ORDER BY $sortColumn $sortOrder";
		//echo $this->_query;
	}
	
	function __construct()
	{	
		parent::__construct();
		$this->_buildQuery();
		$mainframe =& JFactory::getApplication();

		// Get pagination request variables
		$limit = $mainframe->getUserStateFromRequest('com_rsevents.categories.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = $mainframe->getUserStateFromRequest('com_rsevents.categories.limitstart', 'limitstart', 0, 'int');

		// In case limit has been changed, adjust it
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('com_rsevents.categories.limit', $limit);
		$this->setState('com_rsevents.categories.limitstart', $limitstart);
	}
	
	function getData()
	{
		if (empty($this->_data))
			$this->_data=$this->_getList($this->_query,$this->getState('com_rsevents.categories.limitstart'), $this->getState('com_rsevents.categories.limit'));
		
		return $this->_data;
	}
	
	function getTotal()
	{
		if (empty($this->_total))
			$this->_total = $this->_getListCount($this->_query);	
		
		return $this->_total;
	}
	
	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('com_rsevents.categories.limitstart'), $this->getState('com_rsevents.categories.limit'));
		}
		return $this->_pagination;
	}
	
	//get category
	function getCategories()
	{
		$cid = JRequest::getVar('cid');
		if(is_array($cid)) $cid = intval($cid[0]);
		$row= & JTable::getInstance('Rsevents_Categories','Table');
		$row->load($cid);
		return $row;
	}
	
	//save categoties
	function save()
	{
		$app	=& JFactory::getApplication();
		$post	= JRequest::get('post',JREQUEST_ALLOWRAW);
		$row	=& JTable::getInstance('Rsevents_Categories','Table');
		
		if(!$row->bind($post)) return JError::raiseWarning(500, $row->getError()); 
		if ($row->IdCategory == $row->parent) $row->parent = 0;
		
		$removeparent = isset($post['remove_parent']) ? 1 : 0;
		if ($removeparent) $row->parent = 0;
		
		//creating the alias
		$alias = JFilterOutput:: stringURLSafe($row->CategoryName);
		if(empty($row->CategoryAlias)) $row->CategoryAlias = $alias;

		if ($row->store())
			$msg = JText::_('RSE_CATEGORY_SAVE' );
		else 
		{
			JError::raiseWarning(500, $row->getError());
			$msg = JText::_('RSE_CATEGORY_SAVE_ERROR' );
		}
		
		$row->reorder('parent = '.(int) $row->parent);
		switch(JRequest::getCmd('task'))
		{
			case 'apply' :
					$link = 'index.php?option=com_rsevents&task=editcategories&cid='.$row->IdCategory;
			break;
			
			case 'save' :
					$link = 'index.php?option=com_rsevents&task=listcategories';
			break;
		}
		
		$app->redirect($link, $msg);
	}
	
	//remove categories
	function remove()
	{
		$app	=& JFactory::getApplication();
		$db 	=& JFactory::getDBO();
		$row 	=& JTable::getInstance('Rsevents_Categories','Table');
		$cids	= JRequest::getVar('cid',array(0),'post','array');
		
		$i = 0;
		if (!empty($cids))
		{
			// Add all children to the list
			foreach ($cids as $cid)
				$this->_addChildren($cid, $cids);
			
			JArrayHelper::toInteger($cids);
			
			//set subcategories to category mode
			$where = ' WHERE (IdCategory = ' . implode( ' OR IdCategory = ', $cids ) . ')';
			$db->setQuery("UPDATE #__rsevents_categories SET parent = 0 ".$where);
			$db->query();
			
			foreach ($cids as $cid)
			{
				$row->load($cid);
				
				//check for events
				$db->setQuery("SELECT COUNT(IdEvent) FROM #__rsevents_events_cat WHERE IdCategory = '".$cid."'");
				if ($db->loadResult() > 0)
				{
					$app->enqueueMessage(JText::sprintf('RSE_CATEGORY_HAS_EVENTS',$row->CategoryName));
					continue;
				}
				$row->delete($cid);
				$i++;
			}
		}
		$row->reorder();
		$app->redirect( 'index.php?option=com_rsevents&task=listcategories',JText::sprintf('RSE_CATEGORY_DELETE',$i));
	}
	
	function _addChildren($id, &$list)
	{
		$db =& JFactory::getDBO();
		
		// Initialize variables
		$return = true;

		// Get all rows with parent of $id
		$query = 'SELECT IdCategory as id' .
				' FROM #__rsevents_categories' .
				' WHERE parent = '.(int) $id;
		$db->setQuery( $query );
		$rows = $db->loadObjectList();

		// Make sure there aren't any errors
		if ($db->getErrorNum()) {
			$this->setError($db->getErrorMsg());
			return false;
		}

		// Recursively iterate through all children... kinda messy
		// TODO: Cleanup this method
		foreach ($rows as $row)
		{
			$found = false;
			foreach ($list as $idx)
			{
				if ($idx == $row->id) {
					$found = true;
					break;
				}
			}
			if (!$found) {
				$list[] = $row->id;
			}
			$return = $this->_addChildren($row->id, $list);
		}
		return $return;
	}
	
	
	//publish/unpublish
	function publish()
	{
		$app	=& JFactory::getApplication();
		$row 	=& JTable::getInstance('Rsevents_Categories','Table');
		$cids	= JRequest::getVar('cid',array(0),'post','array');
		$tmpl	= JRequest::getCmd('tmpl');
		JArrayHelper::toInteger($cids, array(0));
		
		$publish	= JRequest::getCmd('task') == 'publish' ? 1 : 0;
		$row->publish($cids,$publish);
		
		$redirect = $tmpl == 'component' ? 'index.php?option=com_rsevents&task=listcategories&tmpl=component' : 'index.php?option=com_rsevents&task=listcategories';
		
		$app->redirect($redirect);
	}
	
	//save ordering
	function saveorder()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$app		=& JFactory::getApplication();
		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$order		= JRequest::getVar( 'order', array (0), 'post', 'array' );
		$total		= count($cid);
		$groupings	= array();

		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toInteger($order, array(0));

		// Instantiate an article table object
		$row = & JTable::getInstance('Rsevents_Categories','Table');

		// update ordering values
		for( $i=0; $i < $total; $i++ ) 
		{
			$row->load( $cid[$i] );
			// track parents
			$groupings[] = $row->parent;
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($row->getError());
					return false;
				}
			} // if
		} // for
		
		// execute updateOrder for each parent group
		$groupings = array_unique( $groupings );
		foreach ($groupings as $group)
			$row->reorder(' AND parent = '.(int) $group.' AND published >=0');
		
		$app->redirect( 'index.php?option=com_rsevents&task=listcategories', JText::_('RSE_CATEGORY_ORDER_SAVE') );
	}
	
	//move
	function move()
	{
		$app 	=& JFactory::getApplication();
		$row 	=& JTable::getInstance('Rsevents_Categories','Table');
		$cid 	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$task 	= JRequest::getCmd('task');
		
		
		$direction = $task=='orderup' ? -1 : 1; 
		if(is_array($cid)) $cid=$cid[0];
		
		if (!$row->load($cid)) 
			return false;
		$row->move($direction);
		$app->redirect( 'index.php?option=com_rsevents&task=listcategories');
	}
	
	
}