<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die();
 
jimport( 'joomla.application.component.model' );

class rseventsModelDesigns extends JModel
{
	var $_query;
	var $_data;
	var $_total=null;
	var $_pagination=null;
	
	function _buildQuery()
	{
		$mainframe =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		
		$sortColumn			= $mainframe->getUserStateFromRequest('com_rsevents.designs.sortColumn','filter_order','DesignName');
		$sortOrder			= $mainframe->getUserStateFromRequest('com_rsevents.designs.sortOrder','filter_order_Dir','ASC');
		$filter				= JRequest::getVar('rs_filter', $mainframe->getUserState('com_rsevents.events.designs'));
		
		$mainframe->setUserState('com_rsevents.designs.sortColumn',$sortColumn);
		$mainframe->setUserState('com_rsevents.designs.sortOrder',$sortOrder);
		$mainframe->setUserState('com_rsevents.events.designs',$filter);
		
		$this->_query="SELECT IdDesign, DesignName , DesignDefault FROM #__rsevents_designs WHERE designtype = 0 AND DesignName LIKE '%".$db->getEscaped($filter)."%' ORDER BY $sortColumn $sortOrder";
		//echo $this->_query;
	}
	
	function __construct()
	{	
		parent::__construct();
		$this->_buildQuery();
		$mainframe =& JFactory::getApplication();

		// Get pagination request variables
		$limit = $mainframe->getUserStateFromRequest('com_rsevents.designs.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = $mainframe->getUserStateFromRequest('com_rsevents.designs.limitstart', 'limitstart', 0, 'int');

		// In case limit has been changed, adjust it
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('com_rsevents.designs.limit', $limit);
		$this->setState('com_rsevents.designs.limitstart', $limitstart);
	}
	
	function getData()
	{
		if (empty($this->_data))
			$this->_data=$this->_getList($this->_query,$this->getState('com_rsevents.designs.limitstart'), $this->getState('com_rsevents.designs.limit'));
		
		return $this->_data;
	}
	
	function getTotal()
	{
		if (empty($this->_total))
			$this->_total = $this->_getListCount($this->_query);	
		
		return $this->_total;
	}
	
	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('com_rsevents.designs.limitstart'), $this->getState('com_rsevents.designs.limit'));
		}
		return $this->_pagination;
	}
	
	//remove designs
	function remove()
	{		
		jimport('joomla.filesystem.folder');
		
		$app	=& JFactory::getApplication();
		$db 	=& JFactory::getDBO();
		$cids	= JRequest::getVar('cid',array(0),'post','array');
		
		if(!empty($cids))
		{
			JArrayHelper::toInteger($cids);
			foreach($cids as $cid) 
			{
				$db->setQuery("SELECT IdDesign FROM #__rsevents_designs WHERE DesignDefault = 1 AND designtype = 0 ");
				$iddesign = $db->loadResult();
				if ($cid == $iddesign) continue;
				
				$db->setQuery("SELECT DesignName FROM #__rsevents_designs WHERE IdDesign='".$cid."'");
				$designname = $db->loadResult();
				
				$db->setQuery("DELETE FROM #__rsevents_designs WHERE IdDesign = '".$cid."' ");
				$db->query();
				JFolder::delete(JPATH_ROOT.DS.'components'.DS.'com_rsevents'.DS.'designs'.DS.'rse_'.strtolower($designname));
			}
			$msg = JText::_('RSE_DESIGN_DELETE' );
		} else $msg = JText::_('RSE_DESIGN_SELECT' );
		
		$app->redirect( 'index.php?option=com_rsevents&task=listdesigns', $msg );
	}
	
	//set the default design
	function makedefault()
	{
		$app	=& JFactory::getApplication();
		$db 	=& JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(), '', 'array' );
		if(is_array($cid)) $cid = intval($cid[0]);
		
		$db->setQuery("UPDATE #__rsevents_designs SET DesignDefault = 0 WHERE designtype = 0");
		if (!$db->query()) JError::raiseError(500, $db->getErrorMsg() );
		
		$db->setQuery("UPDATE #__rsevents_designs SET DesignDefault = 1 WHERE IdDesign= ".$cid);
		if (!$db->query()) JError::raiseError(500, $db->getErrorMsg()); 

		$app->redirect( 'index.php?option=com_rsevents&task=listdesigns' );
	}	
}