<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die();
 
jimport( 'joomla.application.component.model' );

class rseventsModelEvents extends JModel
{
	var $_query;
	var $_data;
	var $_total=null;
	var $_pagination=null;
	
	function _buildQuery()
	{
		$mainframe =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		
		$filter				= JRequest::getVar('rs_filter', $mainframe->getUserState('com_rsevents.events.search'));
		$category_filter	= JRequest::getVar('rs_cat_filter');
		$location_filter	= JRequest::getVar('rs_loc_filter');
		$sortOrder			= JRequest::getVar('filter_order_Dir','desc');
		$sortColumn			= JRequest::getVar('filter_order','e.EventStartDate');
		
		$mainframe->setUserState('com_rsevents.events.search',$filter);
		
		if($category_filter) $cat_filter="AND ec.IdCategory = ".$db->getEscaped($category_filter).""; else $cat_filter="";
		if($location_filter && $location_filter != JText::_('RSE_EVENT_SELECT_LOCATION')) $loc_filter="AND l.LocationName = '".$db->getEscaped($location_filter)."'"; else $loc_filter="";
		
		$this->_query="SELECT e.IdEvent as RecordId, e.EventName ,e.EventEnableRegistration , e.IdLocation , e.EventStartDate , e.EventEndDate, e.IdUser , e.IdParent , e.published , l.LocationName , COUNT(IdSubscription) as subscribers  , u.username "
						."FROM #__rsevents_events e "
						."LEFT JOIN #__rsevents_locations l ON e.IdLocation = l.IdLocation "
						."LEFT JOIN #__rsevents_events_cat ec ON ec.IdEvent = e.IdEvent "
						."LEFT JOIN #__rsevents_categories c ON c.IdCategory = ec.IdCategory "
						."LEFT JOIN #__rsevents_subscriptions s ON e.IdEvent = s.IdEvent "
						."LEFT JOIN #__users u ON e.IdUser = u.id "
						."WHERE e.EventName LIKE '%".$db->getEscaped($filter)."%' $cat_filter $loc_filter AND e.published IN ('0','1') "
						."GROUP BY e.IdEvent "
						."ORDER BY $sortColumn $sortOrder ";
		//echo $this->_query;
	}
	
	function __construct()
	{	
		parent::__construct();
		$this->_buildQuery();
		$mainframe =& JFactory::getApplication();

		// Get pagination request variables
		$limit = $mainframe->getUserStateFromRequest('com_rsevents.events.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = $mainframe->getUserStateFromRequest('com_rsevents.events.limitstart', 'limitstart', 0, 'int');

		// In case limit has been changed, adjust it
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('com_rsevents.events.limit', $limit);
		$this->setState('com_rsevents.events.limitstart', $limitstart);
	}
	
	function getData()
	{
		if (empty($this->_data))
			$this->_data=$this->_getList($this->_query,$this->getState('com_rsevents.events.limitstart'), $this->getState('com_rsevents.events.limit'));
		
		return $this->_data;
	}
	
	function getTotal()
	{
		if (empty($this->_total))
			$this->_total = $this->_getListCount($this->_query);	
		
		return $this->_total;
	}
	
	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('com_rsevents.events.limitstart'), $this->getState('com_rsevents.events.limit'));
		}
		return $this->_pagination;
	}
	
	function getEvent()
	{
		$rseventsConfig = rseventsHelper::getConfig();
		$row =& JTable::getInstance('Rsevents_Events','Table');
		
		$cid = JRequest::getVar('cid');
		if(is_array($cid)) $cid = $cid[0];
		
		$row->load($cid);
		
		if(empty($row->EventStartDate))
		{
			$row->EventStartDate = time();
			if($rseventsConfig['enable.12format'] == 1)
			{
				$row->EventStartDateH='11';
				$row->EventStartDateM='00';
			} else 
			{
				$row->EventStartDateH='20';
				$row->EventStartDateM='00';
			}
		} else 
		{
			if($rseventsConfig['enable.12format'] == 1)
				$row->EventStartDateH = date('g',$row->EventStartDate);
			else
				$row->EventStartDateH = date('H',$row->EventStartDate);
			$row->EventStartDateM = date('i',$row->EventStartDate);
		}
		
		if(empty($row->EventEndDate)) 
		{
			$row->EventEndDate = $row->EventStartDate;
			if($rseventsConfig['enable.12format'] == 1)
			{
				$row->EventEndDateH = '12';
				$row->EventEndDateM = '00';
			} else 
			{
				$row->EventEndDateH = '22';
				$row->EventEndDateM = '00';
			}
		} else 
		{
			if($rseventsConfig['enable.12format'] == 1)
				$row->EventEndDateH = date('g',$row->EventEndDate);
			else
				$row->EventEndDateH = date('H',$row->EventEndDate);
			$row->EventEndDateM = date('i',$row->EventEndDate);
		}
		
		if(empty($row->EventURL) && $row->IdEvent == 0)
			$row->EventURL = 'http://';
		
		return $row;
	}
	
	//get files
	function getFiles()
	{
		$db =& JFactory::getDBO();
		$cid = JRequest::getVar('cid');
		if(is_array($cid)) $cid = $cid[0];
		$db->setQuery("SELECT * FROM #__rsevents_files WHERE IdEvent = '".$cid."'");
		$rows = $db->loadObjectList();
		return $rows;
	}
	
	//get extras
	function getExtras()
	{
		$db =& JFactory::getDBO();
		$cid = JRequest::getVar('cid');
		if(is_array($cid)) $cid = $cid[0];
		$db->setQuery("SELECT IdExtra, IdEvent,ExtraName,ExtraValue FROM #__rsevents_extras WHERE IdEvent= '".$cid."'");
		$rows = $db->loadObjectList();
		return $rows;
	}
	
	//get extra
	function getExtra()
	{
		$db =& JFactory::getDBO();
		$cid = JRequest::getInt('cid');
		$idevent = JRequest::getInt('IdEvent',0);
		$row= & JTable::getInstance('Rsevents_Extras','Table');
		$row->load($cid);
		$row->IdEvent = $idevent;
		return $row;
	}
	
	//get file data
	function getFileData()
	{
		$cid = JRequest::getVar('cid');
		if(is_array($cid)) $cid = intval($cid[0]);
		$row= & JTable::getInstance('Rsevents_Files','Table');
		$row->load($cid);
		return $row;
	}
	
	//save event
	function save()
	{
		jimport('joomla.filesystem.file');
		
		$app			=& JFactory::getApplication();
		$db				=& JFactory::getDBO();
		$post			= JRequest::get('post',JREQUEST_ALLOWHTML);
		$files			= JRequest::get('files');
		$cid 			= JRequest::getInt('cid');
		$tabposition	= JRequest::getInt('tabposition',0);
		$row			=& JTable::getInstance('Rsevents_Events','Table');
		$rseventsConfig = rseventsHelper::getConfig();
		$pathToThumbs 	= JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS;
		
		//get the icon and the files
		$icon  = $files['icon'];
		$files = $files['files'];
		
		//verify if the event has the default ticket
		$db->setQuery("SELECT COUNT(*) FROM #__rsevents_tickets WHERE IdEvent='".$cid."'");
		$defaultticket = $db->loadResult();
		
		$post['EventDescription'] = JRequest::getVar('EventDescription', '', 'post', 'none', JREQUEST_ALLOWRAW);
		
		//load the event
		$row->load($cid);
		
		//bind the event
		if(!$row->bind($post)) return JError::raiseWarning(500, $row->getError());
		
		if($row->EventURL == 'http://') $row->EventURL = '';
		
		//preparing the date into the unix timestamp
		if($rseventsConfig['enable.12format'] == 1)
		{
			if($row->EventAmPm1 == 0)
				$startH = $post['EventStartDateH'].':'.$post['EventStartDateM'].':00 am';
			else 
				$startH = $post['EventStartDateH'].':'.$post['EventStartDateM'].':00 pm';
			
			if($row->EventAmPm2 == 0)
				$endH = $post['EventEndDateH'].':'.$post['EventEndDateM'].':00 am';
			else 
				$endH = $post['EventEndDateH'].':'.$post['EventEndDateM'].':00 pm';
		} else 
		{
			$startH = $post['EventStartDateH'].':'.$post['EventStartDateM'].':00';
			$endH = $post['EventEndDateH'].':'.$post['EventEndDateM'].':00';
		}
		
		$row->EventStartDate	= strtotime($post['EventStartDate'].' '.$startH);
		$row->EventEndDate		= strtotime($post['EventEndDate'].' '.$endH);
		
		$row->EventStartRegistration = empty($row->EventStartRegistration) ? 0 : strtotime($row->EventStartRegistration);
		$row->EventEndRegistration = empty($row->EventEndRegistration) ? 0 : strtotime($row->EventEndRegistration);
		
		if($row->EventEndDate < $row->EventStartDate) 
			if(empty($row->IdEvent))
				$app->redirect('index.php?option=com_rsevents&task=editevent',JText::_('RSE_INVALID_DATE'));
			else
				$app->redirect('index.php?option=com_rsevents&task=editevent&cid='.$row->IdEvent,JText::_('RSE_INVALID_DATE'));
		
		//creating the alias
		$alias = JFilterOutput:: stringURLSafe($row->EventName);
		if(empty($row->EventAlias)) $row->EventAlias = $alias;
		
		//creating the private Url
		if(empty($row->EventPrivateUrl))
		if($row->EventType == '0')
			$row->EventPrivateUrl = uniqid('',FALSE);
		
		if(empty($row->IdEvent)) $row->EventCreation = time();
		
		if (!empty($row->IdEvent))
		{
			$db->setQuery("SELECT designtype FROM #__rsevents_events WHERE IdEvent = '".$row->IdEvent."'");
			$designtype = $db->loadResult();
			
			if ($designtype && $row->IdNewDesign)
			{
				$row->IdDesign = 0;
				$row->designtype = 0;
			}
		}
		
		$row->payments = !empty($post['payments']) ? implode(',',$row->payments) : '';
		$row->early_discount_deadline = empty($row->early_discount_deadline) ? '' : strtotime($row->early_discount_deadline);
		$row->late_fee_date = empty($row->late_fee_date) ? '' : strtotime($row->late_fee_date);
		
		//saving the data
		if ($row->store()) 
		{
			//insert the default ticket when enable registration is on
			if($defaultticket == '0')
			if($row->EventEnableRegistration) 
			{
				$db->setQuery("INSERT INTO #__rsevents_tickets (IdEvent,TicketName,TicketPrice,TicketMaxAudience,ordering) VALUES ('".$row->IdEvent."','".JText::_('RSE_TICKET_DEFAULT')."',0,'0','1')");
				$db->query();
			}
			
			//delete categories
			$db->setQuery("DELETE FROM #__rsevents_events_cat WHERE IdEvent = '".$row->IdEvent."'");
			$db->query();
			
			//insert categories
			foreach($post['IdCategory'] as $catid)
			{
				$db->setQuery("INSERT INTO #__rsevents_events_cat SET IdEvent = ".$row->IdEvent." , IdCategory = '".$catid."'");
				$db->query();
			}
			
			//upload event icon
			if($rseventsConfig['enable.event.icon'] == 1 && !empty($icon['name']))
			{
				if (!in_array(strtolower(JFile::getExt($icon['name'])),array('jpg','jpeg','png','gif'))) 
					$app->redirect('index.php?option=com_rsevents&task=editevent&cid='.$row->IdEvent,JText::_('RSE_ICON_ERROR'));	
				
				JFile::upload($icon['tmp_name'],$pathToThumbs.$icon['name']);
				rseventsHelper::createIcon($icon , $pathToThumbs , $rseventsConfig['event.icon.small'] , $row->IdEvent,0);
				rseventsHelper::createIcon($icon , $pathToThumbs , $rseventsConfig['event.icon.big'] , $row->IdEvent,0);
				JFile::delete($pathToThumbs.$icon['name']);
			}
			
			$allowedExtensions = str_replace(array("\r"," "),"",$rseventsConfig['event.files']);
			$allowedExtensions = explode("\n",$allowedExtensions);
			
			
			$target= JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'files'.DS;
			
			for($i=0;$i<10;$i++)
			{
				if(!empty($files['tmp_name'][$i]))
				{
					$extension = end(explode('.', $files['name'][$i]));

						if($extension != '' && array_search($extension,$allowedExtensions) !== false)
						{
							if($files['tmp_name'][$i]!='')
							{
								$fileLocation = uniqid('',FALSE)."_". basename( $files['name'][$i]);
								$file = $target . $fileLocation;
								JFile::upload($files['tmp_name'][$i], $file);
								$db->setQuery("INSERT INTO #__rsevents_files (IdEvent,FileName,FileLocation,FilePermission) VALUES ('".$row->IdEvent."','".JFile::getName($files['name'][$i])."','".$db->getEscaped($fileLocation)."','111111') "); 
								$db->query();
							}
						} else $app->redirect('index.php?option=com_rsevents&task=editevent&cid='.$row->IdEvent , JText::_('RSE_EVENT_INVALID_FILE'));
				}
			}		
			$msg = JText::_('RSE_EVENT_SAVE' );
		} else $msg = JText::_('RSE_EVENT_SAVE_ERROR' );
		
		switch(JRequest::getCmd('task'))
		{
			case 'apply' :
					$link = 'index.php?option=com_rsevents&task=editevent&cid='.$row->IdEvent.'&tabposition='.$tabposition;
			break;
			
			case 'save' :
					$link = 'index.php?option=com_rsevents&task=listevents';
			break;
		}
		$app->redirect($link, $msg);
	}
	
	//generate a new private url
	function generate()
	{
		$app	=& JFactory::getApplication();
		$cid 	= JRequest::getVar('cid',0,'request');
		$row 	=& JTable::getInstance('Rsevents_Events','Table');
		$row->load($cid);
		$row->EventPrivateUrl = uniqid('',FALSE);
		$row->store();
		$app->redirect('index.php?option=com_rsevents&task=editevent&cid='.$cid);
	}
	
	//save extras
	function saveextras()
	{
		$app		=& JFactory::getApplication();
		$db			=& JFactory::getDBO();
		$post 		= JRequest::get('post',JREQUEST_ALLOWRAW);
		$cid 		= JRequest::getInt('cid',0,'request');
		$idevent 	= JRequest::getInt('IdEvent',0,'request');
		$row 		=& JTable::getInstance('Rsevents_Extras','Table');
		
		$row->IdExtra = $cid;
		$row->IdEvent = $idevent;
		
		//youtube
		if (isset($post['youtubeURL']))
		{
			$row->ExtraName  = 'youtube';
			$row->ExtraValue = $db->getEscaped($post['youtubeURL']);
		}
		
		//flash code
		if (isset($post['flashCode']))
		{
			$row->ExtraName	 = 'flash';
			$row->ExtraValue = $post['flashCode'];
		}
		
		//meebo code
		if (isset($post['meeboCode']))
		{
			$row->ExtraName	 = 'meebo';
			$row->ExtraValue = $post['meeboCode'];
		}
		
		//mp3 code
		if (isset($post['mp3Code']))
		{
			$matches = array();
			$pattern = '/<param name="movie" value="(.*?)"/';
			preg_match($pattern,$post['mp3Code'],$matches);
			if	(count($matches) < 2)
			{
				if (rseventsHelper::is16())
					$app->redirect('index.php?option=com_rsevents&task=editmp3&tmpl=component&IdEvent='.$idevent.'&cid=0' , JText::_('RSE_EXTRA_MP3_INVALID_CODE'));
				else
					$app->redirect('index.php?option=com_rsevents&task=editevent&cid='.$idevent , JText::_('RSE_EXTRA_MP3_INVALID_CODE'));
			}
			
			$row->ExtraName  = 'mp3';
			$row->ExtraValue = $matches[1];
		}
		
		//flickr code
		if (isset($post['flickr']))
		{
			$matches = array();
			$pattern = '/http:\/\/www.flickr.com\/photos\/(.*)\/sets\/([0-9]+)/';
			preg_match($pattern, $post['flickr'], $matches);
			if (empty($matches))
			{
				if (rseventsHelper::is16())
					$app->redirect('index.php?option=com_rsevents&task=editflickr&tmpl=component&IdEvent='.$idevent.'&cid=0' , JText::_('RSE_EXTRA_FLICKR_INVALID_URL'));
				else
					$app->redirect('index.php?option=com_rsevents&task=editevent&cid='.$idevent , JText::_('RSE_EXTRA_FLICKR_INVALID_URL'));
			}
			
			$row->ExtraName  = 'flickr';
			$row->ExtraValue = $post['flickr'];
		}
		
		
		if($row->store())
			$msg=JText::_('RSE_EXTRA_SAVED');
		else
			$msg=JText::_('RSE_EXTRA_ERROR_SAVEING');
		
		if (rseventsHelper::is16())
			echo '<script type="text/javascript">window.parent.location.reload();window.parent.SqueezeBox.close();</script>';
		else
			$app->redirect('index.php?option=com_rsevents&task=editevent&cid='.$idevent.'&tabposition=4' , $msg);
	}
	
	//delete extra
	function deleteextra()
	{
		$app		=& JFactory::getApplication();
		$cid		= JRequest::getInt('cid',0,'request');
		$idevent	= JRequest::getInt('IdEvent',0);
		$row		= & JTable::getInstance('Rsevents_Extras','Table');
		
		if($row->delete($cid))
			$msg=JText::_('RSE_EXTRA_DELETE');
		else
			$msg=JText::_('RSE_EXTRA_DELETE_ERROR');
		$app->redirect('index.php?option=com_rsevents&task=editevent&cid='.$idevent.'&tabposition=4' , $msg);
	}
	
	//remove event
	function remove()
	{
		jimport('joomla.filesystem.file');
		
		$app	=& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$cids	= JRequest::getVar('cid',array(0),'post','array');
		$row 	=& JTable::getInstance('Rsevents_Events','Table');
		$conf	= rseventsHelper::getConfig();
		
		if(!empty($cids))
		{
			foreach($cids as $cid) 
			{
				$db->setQuery("SELECT EventIcon FROM #__rsevents_events WHERE IdEvent='".$cid."'");
				$eventicon = $db->loadResult();
				
				if(!$row->delete($cid)) 
					$msg = JText::_('RSE_EVENT_DELETE_ERROR' );
				else 
				{
					//delete files
					$db->setQuery("SELECT FileLocation FROM #__rsevents_files WHERE IdEvent='".$cid."'");
					$files = $db->loadObjectList();
					
					if (!empty($files))
					foreach ($files as $file)
						JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'files'.DS.$file->FileLocation);
						
					//delete icon if exists					
					if ($eventicon != '')
					{
						$ext = JFile::getExt($eventicon);
						$name = JFile::getName(JFile::stripExt($eventicon));
						$big = $name.'_'.$conf['event.icon.big'].'.'.$ext;
						$small = $name.'_'.$conf['event.icon.small'].'.'.$ext;
						JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$big);
						JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$small);
					}
					
					//delete categories
					$db->setQuery("DELETE FROM #__rsevents_events_cat WHERE IdEvent = '".$cid."' ");
					$db->query();
					
					//delete files from db
					$db->setQuery("DELETE FROM #__rsevents_files WHERE IdEvent='".$cid."'");
					$db->query();
					
					//delete tickets
					$db->setQuery("DELETE FROM #__rsevents_tickets WHERE IdEvent='".$cid."'");
					$db->query();
					
					//delete subscription tickets
					$db->setQuery("SELECT IdSubscription FROM #__rsevents_subscriptions WHERE IdEvent='".$cid."'");
					$subscriptions = $db->loadObjectList();
					
					foreach($subscriptions as $id)
					{
						$db->setQuery("DELETE FROM #__rsevents_subscription_tickets WHERE IdSubscription='".$id->IdSubscription."'");
						$db->query();
					}
					
					//delete subscriptions
					$db->setQuery("DELETE FROM #__rsevents_subscriptions WHERE IdEvent='".$cid."'");
					$db->query();
					
					//delete syncs
					$db->setQuery("DELETE FROM #__rsevents_sync WHERE IdEvent='".$cid."'");
					$db->query();
					
					$row->reorder();
					$msg = JText::_( 'RSE_EVENT_DELETE' );
				}
			}
		} else $msg = JText::_('RSE_EVENT_SELECT' ); 
		
		$app->redirect( 'index.php?option=com_rsevents&task=listevents', $msg );
	}
	
	//publish/unpublish
	function publish()
	{
		$app	=& JFactory::getApplication();
		$row 	=& JTable::getInstance('Rsevents_Events','Table');
		$cids	= JRequest::getVar('cid',array(0),'post','array');
		$tmpl	= JRequest::getCmd('tmpl');
		JArrayHelper::toInteger($cids, array(0));
		
		$publish	= JRequest::getCmd('task') == 'publish' ? 1 : 0;
		$row->publish($cids,$publish);
		
		$redirect = $tmpl == 'component' ? 'index.php?option=com_rsevents&task=listevents&tmpl=component' : 'index.php?option=com_rsevents&task=listevents';
		
		$app->redirect($redirect);
	}
	
	//copy event
	function copy()
	{
		jimport('joomla.filesystem.file');
		
		$app	=& JFactory::getApplication();
		$db 	=& JFactory::getDBO();
		$row	=& JTable::getInstance('Rsevents_Events','Table');
        $cid    = JRequest::getVar( 'cid', array(), 'post', 'array' );
		$config = rseventsHelper::getConfig();
		
		$db->setQuery("SELECT IdEvent FROM #__rsevents_events WHERE IdEvent IN ('".implode("','",$cid)."')");
		$events = $db->loadObjectList();

		if(!empty($events))
			foreach($events as $event)
			{
				$row->load($event->IdEvent);
				$hasicon = $row->EventIcon;
				$row->published=0;
				$row->EventName=JText::_('RSE_COPY_OF').' '.$row->EventName;
				$row->IdEvent=null;
				$ext = JFile::getExt($row->EventIcon);
				$row->store();
				if ($hasicon != '')
				{
					$row->EventIcon = $row->IdEvent.'.'.$ext;
					$row->store();
				}
				
				//copy icon
				if ($hasicon != '')
				{
					JFile::copy(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$event->IdEvent.'_'.$config['event.icon.small'].'.'.$ext , JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$row->IdEvent.'_'.$config['event.icon.small'].'.'.$ext);
					JFile::copy(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$event->IdEvent.'_'.$config['event.icon.big'].'.'.$ext , JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$row->IdEvent.'_'.$config['event.icon.big'].'.'.$ext);
				}
				
				//copy categories
				$db->setQuery("SELECT IdCategory FROM #__rsevents_events_cat WHERE IdEvent = '".$event->IdEvent."'");
				$catids = $db->loadObjectList();
				
				foreach($catids as $cid)
				{
					$db->setQuery("INSERT INTO #__rsevents_events_cat SET IdEvent = ".$row->IdEvent." , IdCategory = ".$cid->IdCategory);
					$db->query();
				}
				
				//copy files
				$db->setQuery("SELECT FileName, FileDescription, FileLocation, FilePermission FROM #__rsevents_files WHERE IdEvent = '".$event->IdEvent."'");
				$files = $db->loadObjectList();
				
				if (!empty($files))
					foreach ($files as $file)
					{
						$fileext = JFile::getExt($file->FileLocation);
						$newfile = uniqid('',false).'.'.$fileext;
						JFile::copy(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'files'.DS.$file->FileLocation , JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'files'.DS.$newfile);
						$db->setQuery("INSERT INTO #__rsevents_files SET FileName = '".$file->FileName."' , FileDescription = '".$file->FileDescription."' , FileLocation = '".$newfile."' , FilePermission = '".$file->FilePermission."' , IdEvent = '".$row->IdEvent."' ");
						$db->query();
					}
				
				//copy extras
				$db->setQuery("SELECT ExtraName ,ExtraValue FROM #__rsevents_extras WHERE IdEvent = '".$event->IdEvent."'");
				$extras = $db->loadObjectList();
				
				if (!empty($extras))
					foreach ($extras as $extra)
					{
						$db->setQuery("INSERT INTO #__rsevents_extras SET ExtraName = '".$extra->ExtraName."' , ExtraValue = '".$db->getEscaped($extra->ExtraValue)."' , IdEvent = '".$row->IdEvent."' ");
						$db->query();
					}
				
				//copy tickets
				$db->setQuery("SELECT TicketName, TicketPrice, TicketMaxAudience, TicketsPerUser, TicketDescription FROM #__rsevents_tickets WHERE IdEvent = '".$event->IdEvent."' ");
				$tickets = $db->loadObjectList();
				
				if (!empty($tickets))
					foreach ($tickets as $ticket)
					{
						$db->setQuery("INSERT INTO #__rsevents_tickets SET TicketName = '".$ticket->TicketName."' , TicketPrice = '".$ticket->TicketPrice."' , TicketMaxAudience = '".$ticket->TicketMaxAudience."' , TicketsPerUser = '".$ticket->TicketsPerUser."' , TicketDescription = '".$ticket->TicketDescription."' , IdEvent = '".$row->IdEvent."' ");
						$db->query();
					}
				
				//copy coupons
				$db->setQuery("SELECT CuponName, CuponCode, CuponType, CuponValue FROM #__rsevents_cupons WHERE IdEvent = '".$event->IdEvent."' ");
				$coupons = $db->loadObjectList();
				
				if (!empty($coupons))
					foreach ($coupons as $coupon)
					{
						$db->setQuery("INSERT INTO #__rsevents_cupons SET CuponName = '".$coupon->CuponName."' , CuponCode = '".$coupon->CuponCode."' , CuponType = '".$coupon->CuponType."' , CuponValue = '".$coupon->CuponValue."' , IdEvent = '".$row->IdEvent."' ");
						$db->query();
					}
				
			}
		else $app->redirect( 'index.php?option=com_rsevents&task=listevents',JText::_('RSE_EVENT_COPY_ERROR'));
		
		$app->redirect( 'index.php?option=com_rsevents&task=listevents',JText::_('RSE_EVENT_COPY'));
	}
	
	//archive event
	function archive()
	{
		$app	=& JFactory::getApplication(); 
		$db		=& JFactory::getDBO();
		$cid 	= JRequest::getVar('cid',array(),'request','array');
		
		$cids = implode(',', $cid );
		
		$db->setQuery("UPDATE #__rsevents_events SET published = '-1' WHERE IdEvent IN (".$cids.") ");
		$db->query();
		
		$db->setQuery("UPDATE #__rsevents_events SET EventArchive = '0' WHERE IdEvent IN (".$cids.") ");
		$db->query();
		$total = count($cid);
		
		$app->redirect('index.php?option=com_rsevents&task=listevents',$total.' '.JText::_('RSE_EVENT_ARCHIVED'));
	}
	
	//delete icon
	function deleteicon()
	{
		jimport('joomla.filesystem.file');
		
		$app			=& JFactory::getApplication();
		$db				=& JFactory::getDBO();
		$cid			= JRequest::getInt('cid','','request');
		$rseventsConfig = rseventsHelper::getConfig();

		$db->setQuery("SELECT EventIcon FROM #__rsevents_events WHERE IdEvent = '".$cid."'");
		$iconName = $db->loadResult();
		$ext = JFile::getExt($iconName);
		
		$small_icon = str_replace('.'.$ext,'_'.$rseventsConfig['event.icon.small'].'.'.$ext,$iconName);
		$big_icon = str_replace('.'.$ext,'_'.$rseventsConfig['event.icon.big'].'.'.$ext,$iconName);
		
		JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$small_icon);
		JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$big_icon);
		
		$db->setQuery("UPDATE #__rsevents_events SET EventIcon = '' WHERE IdEvent = '".$cid."'");
		$db->query();
		
		$app->redirect('index.php?option=com_rsevents&task=editevent&cid='.$cid.'&tabpositon=0' , JText::_('RSE_ICON_DELETED'));
	}
	
	//delete rating
	function deleterating()
	{
		$app			=& JFactory::getApplication();
		$db				=& JFactory::getDBO();
		$cid		 	= JRequest::getVar('cid',array(),'request','array');
		JArrayHelper::toInteger($cid);
		
		if (count($cid) > 0)
		{
			$db->setQuery("DELETE FROM #__rsevents_rating WHERE IdEvent IN (".implode(',',$cid).")");
			$db->query();
		}
		
		$app->redirect('index.php?option=com_rsevents&task=listevents' , JText::_('RSE_DATA_CLEARED'));
	}
}