<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die();
 
jimport( 'joomla.application.component.model' );

class rseventsModelGroups extends JModel
{
	var $_query;
	var $_data;
	var $_db;
	var $_total=null;
	var $_pagination=null;
	
	function _buildQuery()
	{
		$mainframe =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		
		$sortColumn			= $mainframe->getUserStateFromRequest('com_rsevents.groups.sortColumn','filter_order','IdGroup');
		$sortOrder			= $mainframe->getUserStateFromRequest('com_rsevents.groups.sortOrder','filter_order_Dir','asc');
		$filter				= JRequest::getVar('rs_filter', $mainframe->getUserState('com_rsevents.events.groups'));
		
		$mainframe->setUserState('com_rsevents.groups.sortColumn',$sortColumn);
		$mainframe->setUserState('com_rsevents.groups.sortOrder',$sortOrder);
		$mainframe->setUserState('com_rsevents.events.groups',$filter);
		
		$this->_query="SELECT idGroup as RecordId, GroupName FROM #__rsevents_groups WHERE GroupName LIKE '%".$db->getEscaped($filter)."%' ORDER BY $sortColumn $sortOrder";
	}
	
	function __construct()
	{	
		parent::__construct();
		$this->_buildQuery();
		$mainframe =& JFactory::getApplication();

		// Get pagination request variables
		$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = $mainframe->getUserStateFromRequest('com_rsevents.limitstart', 'limitstart', 0, 'int');

		// In case limit has been changed, adjust it
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
	}
	
	function getData()
	{
		if (empty($this->_data))
			$this->_data=$this->_getList($this->_query,$this->getState('limitstart'), $this->getState('limit'));
		
		return $this->_data;
	}
	
	function getTotal()
	{
		if (empty($this->_total))
			$this->_total = $this->_getListCount($this->_query);	
		
		return $this->_total;
	}
	
	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit'));
		}
		return $this->_pagination;
	}
	
	//get the group acls
	function getGroupAcls()
	{
		$db =& JFactory::getDBO();
		$cid= JRequest::getInt('cid',0,'request');
		$db->setQuery("SELECT GroupAcl  FROM #__rsevents_groups_acl Where IdGroup='".$cid."'");
		$rows = $db->loadObjectList();
		return $rows;
	}
	
	//get the group used acls
	function getUsedGroupAcls()
	{
		$db = & JFactory::getDBO();
		$cid= JRequest::getInt('cid',0,'request');
		
		$db->setQuery("SELECT `GroupAcl` FROM `#__rsevents_groups_acl` WHERE `IdGroup`!='".$cid."'");
		$rows = $db->loadObjectList();
		return $rows;
	}
	
	//get the group
	function getGroup()
	{
		$cid= JRequest::getVar('cid',0,'request');
		if(is_array($cid)) $cid = intval($cid[0]);
		$row = & JTable::getInstance('Rsevents_Groups','Table');
		$row->load($cid);
		return $row;
	}
	
	//get the group permissions
	function getGroupPermissions()
	{
		$db  =& JFactory::getDBO();
		$cid = JRequest::getInt('cid');
		
		$db->setQuery("SELECT * FROM #__rsevents_group_permissions WHERE IdGroup='".$cid."'");
		return $db->loadObjectList();
	}
	
	//save group
	function save()
	{
		$app	=& JFactory::getApplication();
		$db 	=& JFactory::getDBO();
		$post	= JRequest::get('post');
		$cid	= JRequest::getInt('cid');
		$row	=& JTable::getInstance('Rsevents_Groups','Table');
		
		if(!isset($post['GroupAcl'])) $app->redirect('index.php?option=com_rsevents&task=listgroups', JText::_('RSE_NO_JGROUPS'));
		
		$acls = $post['GroupAcl'];
		
		//bind the table
		if(!$row->bind($post)) return JError::raiseWarning(500, $row->getError()); 		
		
		// save the group
		if ($row->store()) 
		{
			//first let's delete the old group acls
			$db->setQuery("DELETE FROM #__rsevents_groups_acl WHERE IdGroup = " . $row->IdGroup);
			$db->query();
			
			//insert the group acls into the #__rsevents_groups_acl table
			foreach($acls as $acl)
			{
				$db->setQuery("INSERT INTO #__rsevents_groups_acl SET IdGroup = ".$row->IdGroup." , GroupAcl = ".$acl);
				$db->query();
			}
			
			if (isset($post['gp']))
			{
				//delete old group permissions
				$db->setQuery("DELETE FROM #__rsevents_group_permissions WHERE IdGroup = " . $row->IdGroup);
				$db->query();
				
				foreach ($post['gp'] as $key=>$value)
				{
					$db->setQuery("INSERT INTO #__rsevents_group_permissions SET IdGroup = '".$row->IdGroup."', PermissionName = '".$key."', PermissionValue = '".$value."' ");
					$db->query();
				}
				
			}
			
			$msg = JText::_('RSE_GROUP_SAVE' );
		} else 
		{
			JError::raiseWarning(500, $row->getError());
			$msg = JText::_('RSE_GROUP_SAVE_ERROR' );
		}
		
		switch(JRequest::getCmd('task'))
		{
			case 'apply' :
					$link = 'index.php?option=com_rsevents&task=editgroups&cid='.$row->IdGroup;
			break;
			
			case 'save' :
					$link = 'index.php?option=com_rsevents&task=listgroups';
			break;
		}
		$app->redirect($link, $msg);
	}
	
	
	//remove group
	function remove()
	{
		$app	=& JFactory::getApplication();
		$db 	=& JFactory::getDBO();
		$row 	=& JTable::getInstance('Rsevents_Groups','Table');
		$cids	= JRequest::getVar('cid',array(0),'post','array');
		
		
		//deletes all the groups that have been selected
		if(!empty($cids))
		{
			foreach($cids as $cid) 
			{
				if(!$row->delete($cid))
					$msg = JText::_('RSE_GROUP_DELETE_ERROR' );
				else 
				{
					$db->setQuery("DELETE FROM #__rsevents_groups_acl WHERE IdGroup='".$cid."'");
					$db->query();
					$db->setQuery("DELETE FROM #__rsevents_group_permissions WHERE IdGroup='".$cid."'");
					$db->query();
					$msg = JText::_('RSE_GROUP_DELETE' );
				}
			}
		} else $msg = JText::_('RSE_GROUP_DELETE_ERROR1' );
		
		$app->redirect( 'index.php?option=com_rsevents&task=listgroups',$msg);
	}
	
 
}