<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die();
 
jimport( 'joomla.application.component.model' );

class rseventsModelLocations extends JModel
{
	var $_query;
	var $_data;
	var $_total=null;
	var $_pagination=null;
	
	function _buildQuery()
	{
		$mainframe =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		
		$sortColumn			= $mainframe->getUserStateFromRequest('com_rsevents.locations.sortColumn','filter_order','ordering');
		$sortOrder			= $mainframe->getUserStateFromRequest('com_rsevents.locations.sortOrder','filter_order_Dir','asc');
		$filter				= JRequest::getVar('rs_filter', $mainframe->getUserState('com_rsevents.events.locations'));
		
		$mainframe->setUserState('com_rsevents.locations.sortColumn',$sortColumn);
		$mainframe->setUserState('com_rsevents.locations.sortOrder',$sortOrder);
		$mainframe->setUserState('com_rsevents.events.locations',$filter);
		
		$this->_query="SELECT IdLocation as RecordId, LocationName , LocationDescription,  published , ordering FROM #__rsevents_locations WHERE LocationName LIKE '%".$db->getEscaped($filter)."%' ORDER BY $sortColumn $sortOrder";
	}
	
	function __construct()
	{	
		parent::__construct();
		$this->_buildQuery();
		$mainframe =& JFactory::getApplication();

		// Get pagination request variables
		$limit = $mainframe->getUserStateFromRequest('com_rsevents.locations.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = $mainframe->getUserStateFromRequest('com_rsevents.locations.limitstart', 'limitstart', 0, 'int');

		// In case limit has been changed, adjust it
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('com_rsevents.locations.limit', $limit);
		$this->setState('com_rsevents.locations.limitstart', $limitstart);
	}
	
	function getData()
	{
		if (empty($this->_data))
			$this->_data=$this->_getList($this->_query,$this->getState('com_rsevents.locations.limitstart'), $this->getState('com_rsevents.locations.limit'));
		
		return $this->_data;
	}
	
	function getTotal()
	{
		if (empty($this->_total))
			$this->_total = $this->_getListCount($this->_query);	
		
		return $this->_total;
	}
	
	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('com_rsevents.locations.limitstart'), $this->getState('com_rsevents.locations.limit'));
		}
		return $this->_pagination;
	}
	
	//get location
	function getLocation()
	{
		$cid = JRequest::getVar('cid');
		if(is_array($cid)) $cid = intval($cid[0]);
		$row= & JTable::getInstance('Rsevents_Locations','Table');
		$row->load($cid);
		return $row;
	}
	
	//save location
	function save()
	{
		$app 	=& JFactory::getApplication();
		$post	= JRequest::get('post',JREQUEST_ALLOWHTML);
		$row	=& JTable::getInstance('Rsevents_Locations','Table');
		
		$post['LocationDescription'] = JRequest::getVar('LocationDescription', '', 'post', 'none', JREQUEST_ALLOWRAW);
		
		if(!$row->bind($post))
			return JError::raiseWarning(500, $row->getError());
		
		//creating the alias
		$alias = JFilterOutput::stringURLSafe($row->LocationName);
		if(empty($row->LocationAlias)) $row->LocationAlias = $alias;
		
		if ($row->store())
			$msg = JText::_('RSE_LOCATION_SAVE' );
		else
		{
			JError::raiseWarning(500, $row->getError());
			$msg = JText::_('RSE_LOCATION_SAVE_ERROR' );
		}
		$row->reorder();
		switch(JRequest::getCmd('task'))
		{
			case 'apply' :
					$link = 'index.php?option=com_rsevents&task=editlocation&cid='.$row->IdLocation;
			break;
			
			case 'save' :
					$link = 'index.php?option=com_rsevents&task=listlocations';
			break;
		}
		$app->redirect($link, $msg);
	}
	
	//remove location
	function remove()
	{
		$app	=& JFactory::getApplication();
		$row 	=& JTable::getInstance('Rsevents_Locations','Table');
		$cids	= JRequest::getVar('cid',array(0),'post','array');
		$db 	=& JFactory::getDBO();
		
		$db->setQuery("SELECT COUNT(*) AS cnt FROM #__rsevents_events WHERE IdLocation IN ('".implode("','",$cids)."')");
		$eventsFound = $db->loadResult();
		
		if(empty($eventsFound)) 
		{
			$db->setQuery("DELETE FROM #__rsevents_locations WHERE IdLocation IN ('".implode("','",$cids)."')");
			$db->query();
			$row->reorder();
			$app->redirect( 'index.php?option=com_rsevents&task=listlocations',JText::sprintf('RSE_LOCATION_DELETE',count($cids)));
		} else $app->redirect( 'index.php?option=com_rsevents&task=listlocations', JText::_('RSE_LOCATION_DELETE_ERROR' ) , 'error');
	}
	
	//publish/unpublish
	function publish()
	{
		$app	=& JFactory::getApplication();
		$row 	=& JTable::getInstance('Rsevents_Locations','Table');
		$cids	= JRequest::getVar('cid',array(0),'post','array');
		$tmpl	= JRequest::getCmd('tmpl');
		JArrayHelper::toInteger($cids, array(0));
		
		$publish	= JRequest::getCmd('task') == 'publish' ? 1 : 0;
		$row->publish($cids,$publish);
		
		$redirect = $tmpl == 'component' ? 'index.php?option=com_rsevents&task=listlocations&tmpl=component' : 'index.php?option=com_rsevents&task=listlocations';
		
		$app->redirect($redirect);
	}
	
	//save order
	function saveOrder()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$db			=& JFactory::getDBO();
		$app		=& JFactory::getApplication();
		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$order		= JRequest::getVar( 'order', array (0), 'post', 'array' );

		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toInteger($order, array(0));

		// Instantiate an article table object
		$row = & JTable::getInstance('Rsevents_Locations','Table');
		for( $i=0; $i < count($cid); $i++ )
		{
			$row->load( (int) $cid[$i] );

			if ($row->ordering != $order[$i])
			{	
				$row->ordering = $order[$i];
				if (!$row->store()) 
					return false;
			}
		}
		$row->reorder();
		
		$app->redirect( 'index.php?option=com_rsevents&task=listlocations', JText::_('RSE_LOCATION_SAVE_ORDER') );
	}
	
	//move
	function move() 
	{
		$app	=& JFactory::getApplication();
		$row 	=& JTable::getInstance('Rsevents_Locations','Table');
		$cid 	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$task 	= JRequest::getCmd('task');
		
		if(is_array($cid)) $cid = intval($cid[0]);
		$direction = $task=='orderup' ? -1 : 1;
		
		if (!$row->load($cid)) 
			return false;

		$row->move( $direction);
		$app->redirect( 'index.php?option=com_rsevents&task=listlocations');
	}
}