<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die();
 
jimport( 'joomla.application.component.model' );

class rseventsModelMain extends JModel
{	
	function __construct()
	{	
		parent::__construct();
	}
	
	function getUpcoming()
	{
		$db =& JFactory::getDBO();
		$config = rseventsHelper::getConfig();
		$limit = intval($config['upcoming.limit.module']) ? intval($config['upcoming.limit.module']) : 5;
		
		$db->setQuery("SELECT e.IdEvent , e.EventName FROM #__rsevents_events e LEFT JOIN #__rsevents_subscriptions s ON s.IdEvent = e.IdEvent WHERE e.EventStartDate >= '".time()."' ORDER BY e.EventName ASC LIMIT ".$limit." ");
		
		return $db->loadObjectList();
	}
	
	function getSubscribers()
	{
		$db =& JFactory::getDBO();
		$config = rseventsHelper::getConfig();
		$limit = intval($config['subscribers.limit.module']) ? intval($config['subscribers.limit.module']) : 5;
		
		$db->setQuery("SELECT e.EventName, s.IdSubscription, s.SubscriptionDate, CONCAT_WS(' ',s.FirstName,s.LastName) as name FROM #__rsevents_subscriptions s LEFT JOIN #__rsevents_events e ON e.IdEvent = s.IdEvent ORDER BY s.SubscriptionDate ASC LIMIT ".$limit." ");
		
		return $db->loadObjectList();
	}
	
	function getComments()
	{
		$db =& JFactory::getDBO();
		$config = rseventsHelper::getConfig();
		$limit = intval($config['comments.limit.module']) ? intval($config['comments.limit.module']) : 5;
		
		switch($config['events.commenting'])
		{
			//no comments
			default:
			case '0':
				return array();
			break;
			
			//JComments
			case '1':
				$db->setQuery("SELECT e.IdEvent, e.EventName, c.`id`, c.`name`, c.`comment`, UNIX_TIMESTAMP(c.`date`) as date, c.`published` FROM #__jcomments c LEFT JOIN #__rsevents_events e ON e.IdEvent = c.object_id WHERE c.`object_group`='com_rsevents' ORDER BY c.`date` DESC LIMIT ".$limit);
				$comments = $db->loadObjectList();
			break;
			
			//Jom Comments
			case '2':
				$db->setQuery("SELECT e.IdEvent, e.EventName, c.`id`, c.`name`, c.`comment`, UNIX_TIMESTAMP(c.`date`) as date, c.`published` FROM #__jomcomment c LEFT JOIN #__rsevents_events e ON e.IdEvent = c.contentid WHERE c.`option`='com_rsevents' ORDER BY c.`date` DESC LIMIT ".$limit);
				$comments = $db->loadObjectList();
			break;
			
			//RSComments!
			case '3':
				$db->setQuery("SELECT e.IdEvent,e.EventName, c.`IdComment` as id, c.`name`, c.`comment`, c.`date`, c.`published` FROM #__rscomments_comments c LEFT JOIN #__rsevents_events e ON e.IdEvent = c.id WHERE c.`option`='com_rsevents' ORDER BY c.`date` DESC LIMIT ".$limit);
				$comments = $db->loadObjectList();
			break;
		}
		return $comments;
	}
}