<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die();
 
jimport( 'joomla.application.component.model' );
jimport( 'joomla.plugin.helper' );

class rseventsModelPayments extends JModel
{	
	function __construct()
	{	
		parent::__construct();
	}
	
	function getData()
	{
		$db		 =& JFactory::getDBO();
		$return  = array();
		$plugins = $this->getPlugins();
		
		if (!empty($plugins))
		{
			foreach ($plugins as $element)
			{
				$tmp = new stdClass();
				
				if (rseventsHelper::is16())
					$db->setQuery("SELECT `extension_id` as id, `name`, `enabled` as published FROM #__extensions WHERE `type`='plugin' AND `folder`='system' AND `client_id`='0' AND `element`='".$db->getEscaped($element)."' LIMIT 1");
				else
					$db->setQuery("SELECT `id`, `name`, `published` FROM #__plugins WHERE `folder`='system' AND `client_id`='0' AND `element`='".$db->getEscaped($element)."' LIMIT 1");
				$details = $db->loadObject();
				
				$name = isset($details->name) && !empty($details->name) ? $details->name : $element;
				$name = str_replace(array('System','system','-'),'',$name);
				$name = trim($name);
				
				$tmp->id = $details->id;
				$tmp->name = $name;
				$tmp->type = 'plugin';
				$tmp->published = $details->published;
				
				$return[] = $tmp;
			}
		}
		
		$return = array_merge($return,$this->getWirePayments());
		return $return;
	}
	
	function getPlugins()
	{
		$return		= array();
		$plugins	= JPluginHelper::getPlugin('system');
		
		if (!empty($plugins))
		{
			foreach ($plugins as $plugin)
			{
				if ($plugin->name == 'rseventswire') continue;
				
				if (substr($plugin->name,0,8) == 'rsevents')
					$return[] = $plugin->name;
			}
		}
		
		return $return;
	}
	
	function getWirePayments()
	{
		return $this->_getList("SELECT id,name,published FROM #__rsevents_payments");
	}
	
	
	//get payment details
	function getPayment()
	{
		$cid = JRequest::getVar('cid');
		$cid = is_array($cid) ? (int) $cid[0] : (int) $cid;
		$row= & JTable::getInstance('Rsevents_Payments','Table');
		$row->load($cid);
		return $row;
	}
	
	//save payment
	function save()
	{
		$post	= JRequest::get('post',JREQUEST_ALLOWRAW);
		$row	=& JTable::getInstance('Rsevents_Payments','Table');
		
		if(!$row->bind($post)) 
			return JError::raiseWarning(500, $row->getError());

		if ($row->store())
			return $row;
		else
		{
			JError::raiseWarning(500, $row->getError());
			return false;
		}
	}
	
	//remove payment
	function remove()
	{
		$row 	=& JTable::getInstance('Rsevents_Payments','Table');
		$cids	= JRequest::getVar('cid',array(0),'post','array');
		JArrayHelper::toInteger($cids, array(0));
		
		if (!empty($cids))
			foreach ($cids as $cid)
				$row->delete($cid);
		
		return true;
	}	
	
	//publish/unpublish
	function publish()
	{
		$row 	=& JTable::getInstance('Rsevents_Payments','Table');
		$cids	= JRequest::getVar('cid',array(0),'post','array');
		JArrayHelper::toInteger($cids, array(0));
		
		$publish	= JRequest::getCmd('task') == 'publish' ? 1 : 0;
		$row->publish($cids,$publish);
		return true;
	}
}