<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die();
 
jimport( 'joomla.application.component.model' );

class rseventsModelSettings extends JModel
{
	var $_query;
	var $_data;
	var $_total=null;
	var $_pagination=null;
	
	function __construct()
	{	
		parent::__construct();
		$this->_query="SELECT ConfigName , ConfigValue FROM #__rsevents_config";
	}
	
	function getData()
	{
		if (empty($this->_data))
			$this->_data=$this->_getList($this->_query);

		$rseventsConfig = array();
		foreach($this->_data as $i => $objConfig)
			$rseventsConfig[$objConfig->ConfigName] = $objConfig->ConfigValue;

		return $rseventsConfig;
	}
	
	function getAvailableAvatars()
	{
		jimport('joomla.filesystem.file');

		$return = array(
		'gravatar' => true,
		'comprofiler' => false,
		'community' => false,
		'kunena' => false,
		'fireboard' => false
		);

		foreach ($return as $component => $value)
			if (JFile::exists(JPATH_SITE.DS.'components'.DS.'com_'.$component.DS.$component.'.php'))
				$return[$component] = true;

		return $return;
	}
	
	//save settings
	function save()
	{
		$app 		=& JFactory::getApplication();
		$db 		=& JFactory::getDBO();
		$post 		= JRequest::get('post',JREQUEST_ALLOWRAW);
		$thepost	= $post['rseventsConfig'];
		
		if ($thepost['events.layout'] == 0) $thepost['layouts.eventintro'] = "<div style=\"overflow: hidden\">\n{EventIcon}<a href=\"{EventLink}\"><strong>{EventName}</strong></a><br/>\n{EventSubtitle}\n<p>{EventDescription}</p>\nAt <em>{LocationName}</em> from {EventStartDate} to {EventEndDate} - Hosted by {EventHost} - {CategoryName} - <a href=\"{EventLink}\">Details</a></div>\n<hr/>";
		if ($thepost['events.layout'] == 2) $thepost['layouts.eventintro'] = "<tr>\n\t<td>{EventStartDate} - {EventEndDate}</td>\n\t<td><a href=\"{EventLink}\">{EventName}</a></td>\n\t<td><a href=\"{LocationLink}\">{LocationName}</a></td>\n\t<td>{CategoryName}</td>\n</tr>";
		if (!in_array($thepost['events.layout'],array('0','1','2','3'))) $thepost['layouts.eventintro'] = '';
		
		$msg = array();
		
		if (in_array($thepost['events.layout'],array('0','1','2','3')))
		{
			if (strpos($thepost['layouts.eventintro'],'{EventName}') !== false && strpos($thepost['layouts.eventintro'],'{EventLink}') !== false)
				$msg[] = '';
			else $msg[] = JText::_('RSE_PLACEHOLDER_MISSING');
		}
		
		if(($thepost['locations.gmaps'] == 1 && $thepost['locations.gMaps.key'] != '') || ($thepost['locations.gmaps'] == 0))
			$msg[] = '';
		else $msg[] = JText::_('RSE_GOOGLE_KEY_ERROR');
		
		$db->setQuery("SELECT * FROM `#__rsevents_config`");
		$rseventsConfigDb = $db->loadObjectList();
		
		if (!empty($rseventsConfigDb))
			foreach ($rseventsConfigDb as $objConfig)
			{
				if(isset($thepost[$objConfig->ConfigName]))
				{
					$db->setQuery("UPDATE #__rsevents_config SET ConfigValue='".$db->getEscaped($thepost[$objConfig->ConfigName])."' WHERE ConfigName='".$objConfig->ConfigName."'");
					$db->query();
					$rseventsConfig[$objConfig->ConfigName] = $thepost[$objConfig->ConfigName];
				}
			}
		
		$msg[] = JText::_('RSE_SETTINGS_SAVE');
		
		if (!empty($msg))
			foreach ($msg as $error)
				if (!empty($error))
					$app->enqueueMessage($error);
		
		switch(JRequest::getCmd('task'))
		{
			case 'apply' :
				$link = 'index.php?option=com_rsevents&task=editsettings';
			break;
			
			case 'save' :
				$link = 'index.php?option=com_rsevents';
			break;
		}
		$app->redirect($link);
	}
	
	
	//save the center
	function saveCenter()
	{
		$app 		=& JFactory::getApplication();
		$db 		=& JFactory::getDBO();
		$post 		=JRequest::get('post');
		$thepost = $post['rseventsConfig'];
		
		if(($thepost['locations.gmaps'] == 1 && $thepost['locations.gMaps.key'] != '') || ($thepost['locations.gmaps'] == 0))
		{
			$db->setQuery("UPDATE #__rsevents_config SET ConfigValue='".$db->getEscaped($thepost['locations.gMaps.center'])."' WHERE ConfigName='locations.gMaps.center'");
			$db->query();
		}
		
		if (rseventsHelper::is16())
			echo '<script type="text/javascript">window.parent.location.reload();window.parent.SqueezeBox.close();</script>';
		else
			$app->redirect('index.php?option=com_rsevents&task=editsettings');
	}
 
}