<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die();
 
jimport( 'joomla.application.component.model' );

class rseventsModelSubscriptions extends JModel
{
	var $_query;
	var $_data;
	var $_total=null;
	var $_pagination=null;
	
	function _buildQuery()
	{
		$mainframe =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		
		$ticket_filter		= JRequest::getVar('ticket_filter');
		$event_filter		= JRequest::getVar('rs_evn_filter',$mainframe->getUserState('com_rsevents.subscriptions.rs_evn_filter'));
		$state_filter		= JRequest::getVar('state_filter');
		$archive_filter		= JRequest::getVar('archive_filter',0);
		$sortOrder			= JRequest::getVar('filter_order_Dir','desc');
		$sortColumn			= JRequest::getVar('filter_order','s.SubscriptionDate');
		$filter				= JRequest::getVar('rs_filter', $mainframe->getUserState('com_rsevents.events.subscriptions'));
		
		$mainframe->setUserState('com_rsevents.subscriptions.rs_evn_filter',$event_filter);
		$mainframe->setUserState('com_rsevents.subscriptions.sortColumn',$sortColumn);
		$mainframe->setUserState('com_rsevents.subscriptions.sortOrder',$sortOrder);
		$mainframe->setUserState('com_rsevents.events.subscriptions',$filter);
		
		
		if($event_filter) $evn_filter=" AND e.IdEvent='".$event_filter."' "; else $evn_filter="";
		if($state_filter != '') $state_filter=" AND s.SubscriptionState='".$state_filter."' "; else $state_filter="";
		if($ticket_filter && $event_filter) $ticket_filter=" AND st.IdTicket='".$ticket_filter."' "; else $ticket_filter="";
		if($filter) $filter = " AND (s.FirstName LIKE '%".$db->getEscaped($filter)."%' OR s.LastName LIKE '%".$db->getEscaped($filter)."%' OR s.Email LIKE '%".$db->getEscaped($filter)."%') ";
		
		if ($archive_filter == 0) $archive = ''; elseif ($archive_filter == 1) $archive = ' AND e.published = -1 '; else $archive = ' AND e.published = 1  ';
		
		$query = "SELECT s.IdSubscription as RecordId, s.IdEvent , s.FirstName , s.IdUser, s.LastName , s.Email , s.SubscriptionState ,s.TransactionParams , s.SubscriptionDate , s.UserIp , s.log,  e.IdEvent , e.EventName , u.username FROM #__rsevents_subscriptions s "
		."LEFT JOIN #__rsevents_events e ON e.IdEvent = s.IdEvent "
		."LEFT JOIN #__users u ON s.IdUser = u.id ";
		
		if($ticket_filter && $event_filter)
		{
			$query .= "LEFT JOIN #__rsevents_subscription_tickets st ON st.IdSubscription = s.IdSubscription ";
			$query .= "LEFT JOIN #__rsevents_tickets t ON st.IdTicket=t.IdTicket ";
		}
		
		$query .= "WHERE 1=1 $filter $evn_filter $ticket_filter $state_filter $archive";
		$query .= "ORDER BY $sortColumn $sortOrder ";
		
		$this->_query = $query;
		//echo $this->_query;
	}
	function __construct()
	{	
		parent::__construct();
		$this->_buildQuery();
		$mainframe =& JFactory::getApplication();

		// Get pagination request variables
		$limit = $mainframe->getUserStateFromRequest('com_rsevents.subscriptions.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = $mainframe->getUserStateFromRequest('com_rsevents.subscriptions.limitstart', 'limitstart', 0, 'int');

		// In case limit has been changed, adjust it
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('com_rsevents.subscriptions.limit', $limit);
		$this->setState('com_rsevents.subscriptions.limitstart', $limitstart);
	}
	
	function getData()
	{
		if (empty($this->_data))
			$this->_data=$this->_getList($this->_query,$this->getState('com_rsevents.subscriptions.limitstart'), $this->getState('com_rsevents.subscriptions.limit'));
		
		return $this->_data;
	}
	
	function getTotal()
	{
		if (empty($this->_total))
			$this->_total = $this->_getListCount($this->_query);	
		
		return $this->_total;
	}
	
	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('com_rsevents.subscriptions.limitstart'), $this->getState('com_rsevents.subscriptions.limit'));
		}
		return $this->_pagination;
	}
	
	//get subscription
	function getSubscription()
	{
		$db =& JFactory::getDBO();
		$row =& JTable::getInstance('Rsevents_Subscriptions','Table');
		$cid = JRequest::getVar('cid',array(0),'request','array');
		if(is_array($cid)) $cid = intval($cid[0]);
		$row->load($cid);
		if($cid != 0)
		{
			$db->setQuery("SELECT t.TicketName , st.TicketsSubscribed FROM #__rsevents_subscription_tickets st LEFT JOIN #__rsevents_tickets t ON t.IdTicket = st.IdTicket WHERE IdSubscription=".$cid);
			$details = $db->loadObjectList();			
			$row->tickets = $details;
		} else $row->tickets = '';
		return $row;
	}
	
	//save subscription
	function save()
	{
		$app 			=& JFactory::getApplication();
		$db				=& JFactory::getDBO();
		$post			= JRequest::get('post');
		$cid 			= JRequest::getInt('cid');
		$row			=& JTable::getInstance('Rsevents_Subscriptions','Table');
		$idTicket 		= JRequest::getInt('IdTicket',0);
		$idSubscription = JRequest::getInt('IdSubscription');
		$rseventsConfig = rseventsHelper::getConfig();
		$hastickets		= JRequest::getInt('hastickets',0);
		
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'emails.php');
		
		//get ticket name
		$db->setQuery("SELECT TicketName ,TicketPrice FROM #__rsevents_tickets WHERE IdTicket = ".$idTicket);
		$ticket = $db->loadObject();
		
		//number of tickets
		if (!$hastickets)
		{
			$numTickets = ($post['TicketsSubscribed'] == 0 || empty($post['TicketsSubscribed'])) ? 1 : $post['TicketsSubscribed'];
		}
		
		//get current status
		$db->setQuery("SELECT SubscriptionState FROM #__rsevents_subscriptions WHERE IdSubscription=".$cid);
		$SubscriptionState = $db->loadResult();
		
		if(!$row->bind($post))
			return JError::raiseWarning(500, $row->getError());
		
		$row->SubscriptionDate = strtotime(date('Y-m-d'));
		
		if (!empty($idTicket))
		{
			$db->setQuery("SELECT IdEvent FROM #__rsevents_tickets WHERE IdTicket=".$idTicket);
			$row->IdEvent = $db->loadResult();
		} else 
		{
			$db->setQuery("SELECT IdEvent FROM #__rsevents_subscriptions WHERE IdSubscription=".$cid);
			$row->IdEvent = $db->loadResult();
		}
		
		if ($row->store()) 
		{
			if (!$hastickets)
			{
				if($cid)
				{
					$db->setQuery("UPDATE #__rsevents_subscription_tickets SET IdTicket =".$idTicket." , TicketsSubscribed  = ".$numTickets." WHERE IdSubscription=".$row->IdSubscription);
					$db->query();
				} else
				{
					$db->setQuery("INSERT INTO #__rsevents_subscription_tickets (IdSubscription,IdTicket,TicketsSubscribed) VALUES ('".$row->IdSubscription."' , '".$idTicket."' , ".$numTickets.")");
					$db->query();
				}
			}
			
			if($post['SubscriptionState'] == 1)
			{
				// Send mail if the status of the subscription is accepted				
				$db->setQuery("SELECT t.TicketName , t.TicketPrice , st.TicketsSubscribed FROM #__rsevents_subscription_tickets st LEFT JOIN #__rsevents_tickets t ON t.IdTicket = st.IdTicket WHERE st.IdSubscription = ".$row->IdSubscription." ");
				$tickets = $db->loadObjectList();
				
				$ticketinfo = '';
				$total		= 0;
				
				if (!empty($tickets))
				{
					foreach ($tickets as $ticket)
					{
						$ticketinfo .= $ticket->TicketsSubscribed . ' '.JText::_('RSE_TICKET_SEPARATOR').' '.$ticket->TicketName. '<br />';
						
						if ($ticket->TicketPrice > 0)
							$total += ($ticket->TicketsSubscribed * $ticket->TicketPrice);
					}
				}
				
				if (!empty($row->Discount))
					$total = $total - $row->Discount;
				
				if (!empty($row->early_fee))
					$total = $total - $row->early_fee;
				
				if (!empty($row->late_fee))
					$total = $total + $row->late_fee;
				
				if (!empty($row->tax))
					$total = $total + $row->tax;
				
				if (count($tickets) == 1)
				{
					$ticketprice = $total > 0 ? number_format($total,$rseventsConfig['payment.nrdecimals'], $rseventsConfig['payment.decimal'], $rseventsConfig['payment.thousands']) . ' '.$rseventsConfig['payment.currency'] : JText::_('RSE_TICKET_FREE');
				} else $ticketprice = '';
				
				$ticketstotal = $total > 0 ? number_format($total,$rseventsConfig['payment.nrdecimals'], $rseventsConfig['payment.decimal'], $rseventsConfig['payment.thousands']) . ' '.$rseventsConfig['payment.currency'] : JText::_('RSE_TICKET_FREE');
				
				$ticketsdiscount = $row->Discount > 0 ? $row->Discount. ' '.$rseventsConfig['payment.currency'] : '';
				
				$optionals = array($ticketinfo,$ticketprice,$ticketstotal,$ticketsdiscount);
				if ($SubscriptionState != 1)
					rseventsEmails::activation($row->Email,$row->IdUser,$row->IdEvent,$optionals,$row->IdSubscription);
			}
			
			
			$msg = JText::_('RSE_SUBSCRIBER_SAVE' );
		} else
			$msg = JText::_('RSE_SUBSCRIBER_SAVE_ERROR' );
		
		switch(JRequest::getCmd('task'))
		{
			case 'apply' :
					$link = 'index.php?option=com_rsevents&task=editsubscription&cid='.$row->IdSubscription;
			break;
			
			case 'save' :
					$link = 'index.php?option=com_rsevents&task=listsubscriptions';
			break;
		}
		
		$app->redirect($link, $msg);
	}
	
	//delete subscriber
	function remove()
	{
		$app	=& JFactory::getApplication();
		$db 	=& JFactory::getDBO();
		$row 	=& JTable::getInstance('Rsevents_Subscriptions','Table');
		$cids	= JRequest::getVar('cid',array(0),'request','array');

		if(!empty($cids))
		{
			foreach($cids as $cid)
			{
				if(!$row->delete($cid))
					$msg = JText::_('RSE_SUBSCRIBER_DELETE_ERROR' );
				else 
				{
					$db->setQuery("DELETE FROM #__rsevents_subscription_tickets WHERE IdSubscription=".$cid);
					$db->query();
					$msg = JText::_('RSE_SUBSCRIBER_DELETE1' );
				}
			}
		}
		$app->redirect( 'index.php?option=com_rsevents&task=listsubscriptions', $msg );
	}
	
	//change the status of the subscriber
	function changestatus()
	{
		$app			=& JFactory::getApplication();
		$db 			=& JFactory::getDBO();
		$rseventsConfig = rseventsHelper::getConfig();
		$cid			= JRequest::getVar( 'cid', array(), '', 'array' );
		$cids 			= implode( ',', $cid );
		
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'emails.php');
		
		switch(JRequest::getCmd('task'))
		{
			case 'accepted':
				$state = 1;
				
				// Send mail if the status of the subscription is accepted
				$db->setQuery("SELECT IdSubscription, IdEvent, Email, IdUser, Discount, early_fee, late_fee, tax FROM #__rsevents_subscriptions WHERE IdSubscription IN (".$cids.") ");
				$subscribers = $db->loadObjectList();
				
				foreach ($subscribers as $subscriber)
				{
					$db->setQuery("SELECT t.TicketName , t.TicketPrice , st.TicketsSubscribed FROM #__rsevents_subscription_tickets st LEFT JOIN #__rsevents_tickets t ON t.IdTicket = st.IdTicket WHERE st.IdSubscription = ".$subscriber->IdSubscription." ");
					$tickets = $db->loadObjectList();
					
					$ticketinfo = '';
					$total		= 0;
					
					if (!empty($tickets))
					{
						foreach ($tickets as $ticket)
						{
							$ticketinfo .= $ticket->TicketsSubscribed . ' '.JText::_('RSE_TICKET_SEPARATOR').' '.$ticket->TicketName. '<br />';
							
							if ($ticket->TicketPrice > 0)
								$total += ($ticket->TicketsSubscribed * $ticket->TicketPrice);
						}
					}
					
					if (!empty($subscriber->Discount))
						$total = $total - $subscriber->Discount;
					
					if (!empty($subscriber->early_fee))
						$total = $total - $subscriber->early_fee;
					
					if (!empty($subscriber->late_fee))
						$total = $total + $subscriber->late_fee;
					
					if (!empty($subscriber->tax))
						$total = $total + $subscriber->tax;
					
					if (count($tickets) == 1)
					{
						$ticketprice = $total > 0 ? number_format($total,$rseventsConfig['payment.nrdecimals'], $rseventsConfig['payment.decimal'], $rseventsConfig['payment.thousands']) . ' '.$rseventsConfig['payment.currency'] : JText::_('RSE_TICKET_FREE');
					} else $ticketprice = '';
					
					$ticketstotal = $total > 0 ? number_format($total,$rseventsConfig['payment.nrdecimals'], $rseventsConfig['payment.decimal'], $rseventsConfig['payment.thousands']) . ' '.$rseventsConfig['payment.currency'] : JText::_('RSE_TICKET_FREE');
					
					$ticketsdiscount = $subscriber->Discount > 0 ? $subscriber->Discount. ' '.$rseventsConfig['payment.currency'] : '';
					
					$optionals = array($ticketinfo,$ticketprice,$ticketstotal,$ticketsdiscount);
					rseventsEmails::activation($subscriber->Email,$subscriber->IdUser,$subscriber->IdEvent,$optionals,$subscriber->IdSubscription);
				}
				$action = JText::_('RSE_SUBSCRIBER_ACTION_AC');
			break;
			case 'pending':
			default:
				$state = 0;
				$action = JText::_('RSE_SUBSCRIBER_ACTION_PE');
			break;
			case 'denied':
				$state = -1; 
				$action = JText::_('RSE_SUBSCRIBER_ACTION_DE');
			break;
		}
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1)
			JError::raiseError(500, JText::_('RSE_SUBSCRIBER_SELECT_ACTION' .$action, true ) );
		
		$query = 'UPDATE #__rsevents_subscriptions'
		. ' SET SubscriptionState = ' . (int) $state
		. ' WHERE IdSubscription IN ( '. $cids .' )'
		;
		$db->setQuery( $query );
		if (!$db->query())
			JError::raiseError(500, $db->getErrorMsg());

		$app->redirect( 'index.php?option=com_rsevents&task=listsubscriptions' );
	}
	
	function getCard()
	{
		$db		=& JFactory::getDBO();
		$cid	= JRequest::getInt('cid');
		$return = new stdClass();
		
		$db->setQuery("SELECT * FROM #__rsevents_cards WHERE ids = ".$cid." ");
		$details = $db->loadObject();
		
		if (!empty($details))
		{
			require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'crypt.php');
			
			$name = $details->card_fname. ' '.$details->card_lname;
			$crypt = new RseventsCryptHelper(null,null,$name);
			
			$return->card_number = $crypt->decrypt($details->card_number);
			$return->card_csc = $crypt->decrypt($details->card_csc);
			$return->card_exp = $details->card_exp;
			$return->name =  $name;
		} else 
		{
			$return->card_number = $return->card_csc = $return->card_exp = $return->name =  '';
		}
		
		return $return;
	}
	
	function getLog()
	{
		$db  =& JFactory::getDBO();
		$cid = JRequest::getInt('cid');
		
		$db->setQuery("SELECT log FROM #__rsevents_subscriptions WHERE IdSubscription = ".$cid." ");
		return $db->loadResult();
	}
}