<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die();
 
jimport( 'joomla.application.component.model' );

class rseventsModelThemes extends JModel
{
	var $_query;
	var $_data;
	var $_total=null;
	var $_pagination=null;
	
	function _buildQuery()
	{
		$mainframe =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		
		$sortColumn			= $mainframe->getUserStateFromRequest('com_rsevents.themes.sortColumn','filter_order','name');
		$sortOrder			= $mainframe->getUserStateFromRequest('com_rsevents.themes.sortOrder','filter_order_Dir','asc');
		$filter				= JRequest::getVar('rs_filter', $mainframe->getUserState('com_rsevents.events.themes'));
		
		$mainframe->setUserState('com_rsevents.themes.sortColumn',$sortColumn);
		$mainframe->setUserState('com_rsevents.themes.sortOrder',$sortOrder);
		$mainframe->setUserState('com_rsevents.events.themes',$filter);
		
		$this->_query="SELECT `id`, `name`, `default` FROM #__rsevents_themes WHERE name LIKE '%".$db->getEscaped($filter)."%' ORDER BY $sortColumn $sortOrder";
		//echo $this->_query;
	}
	
	function __construct()
	{	
		parent::__construct();
		$this->_buildQuery();
		$mainframe =& JFactory::getApplication();

		// Get pagination request variables
		$limit = $mainframe->getUserStateFromRequest('com_rsevents.themes.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = $mainframe->getUserStateFromRequest('com_rsevents.themes.limitstart', 'limitstart', 0, 'int');

		// In case limit has been changed, adjust it
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('com_rsevents.themes.limit', $limit);
		$this->setState('com_rsevents.themes.limitstart', $limitstart);
	}
	
	function getData()
	{
		if (empty($this->_data))
			$this->_data=$this->_getList($this->_query,$this->getState('com_rsevents.themes.limitstart'), $this->getState('com_rsevents.themes.limit'));
		
		return $this->_data;
	}
	
	function getTotal()
	{
		if (empty($this->_total))
			$this->_total = $this->_getListCount($this->_query);	
		
		return $this->_total;
	}
	
	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('com_rsevents.themes.limitstart'), $this->getState('com_rsevents.themes.limit'));
		}
		return $this->_pagination;
	}
	
	function getTheme()
	{
		$cid = JRequest::getVar('cid');
		$cid = is_array($cid) ? intval($cid[0]) : intval($cid);
		
		$row =& JTable::getInstance('Rsevents_Themes','Table');
		$row->load($cid);
		
		return $row;
	}
	
	function edit()
	{
		$app	=& JFactory::getApplication();
		$row	=& JTable::getInstance('Rsevents_Themes','Table');
		$cid	= JRequest::getVar('cid');
		$cid	= is_array($cid) ? intval($cid[0]) : intval($cid);
		
		if ($cid)
			$app->redirect('index.php?option=com_rsevents&task=edittheme&cid='.$cid);
		else 
		{		
			$row->name = JText::_('RSE_NEW_THEME');
			$row->default = 0;
			$row->store();
			$app->redirect('index.php?option=com_rsevents&task=edittheme&cid='.$row->id);
		}
	}
	
	//save theme
	function save()
	{
		$app	=& JFactory::getApplication();
		$post	= JRequest::get('post',JREQUEST_ALLOWRAW);
		$row	=& JTable::getInstance('Rsevents_Themes','Table');
		
		if(!$row->bind($post)) return JError::raiseWarning(500, $row->getError());
		
		if ($row->store())
			$msg = JText::_('RSE_THEME_SAVED' );
		else 
		{
			JError::raiseWarning(500, $row->getError());
			$msg = JText::_('RSE_THEME_SAVED_ERROR' );
		}
		
		switch(JRequest::getCmd('task'))
		{
			case 'apply' :
					$link = 'index.php?option=com_rsevents&task=edittheme&cid='.$row->id;
			break;
			
			case 'save' :
					$link = 'index.php?option=com_rsevents&task=themes';
			break;
		}
		
		$app->redirect($link, $msg);
	}
	
	
	//remove themes
	function remove()
	{	
		$app	=& JFactory::getApplication();
		$db 	=& JFactory::getDBO();
		$cids	= JRequest::getVar('cid',array(0),'post','array');
		
		if(!empty($cids))
		{
			JArrayHelper::toInteger($cids);
			foreach($cids as $cid)
			{
				$db->setQuery("SELECT `default` FROM #__rsevents_themes WHERE id = '".$cid."' ");
				$isdefault = $db->loadResult();
				
				if ($isdefault) continue;
				$db->setQuery("DELETE FROM #__rsevents_themes WHERE id = ".$cid." ");
				$db->query();
				$db->setQuery("DELETE FROM #__rsevents_themes_position WHERE id = ".$cid." ");
				$db->query();
			}
		}
		$app->redirect( 'index.php?option=com_rsevents&task=themes', JText::_('RSE_THEMES_DELETED') );
	}
	
	//set the default theme
	function makedefault()
	{
		$app	=& JFactory::getApplication();
		$db 	=& JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(), '', 'array' );
		if(is_array($cid)) $cid = intval($cid[0]);
		
		$db->setQuery("UPDATE #__rsevents_themes SET `default` = 0 ");
		$db->query();
		
		$db->setQuery("UPDATE #__rsevents_themes SET `default` = 1 WHERE id = '".$cid."' ");
		if (!$db->query()) JError::raiseError(500, $db->getErrorMsg()); 

		$app->redirect( 'index.php?option=com_rsevents&task=themes' );
	}
}