<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die();
 
jimport( 'joomla.application.component.model' );

class rseventsModelTickets extends JModel
{
	var $_query;
	var $_data;
	var $_total=null;
	var $_pagination=null;
	
	function _buildQuery()
	{
		$mainframe =& JFactory::getApplication();
		
		$sortColumn=$mainframe->getUserStateFromRequest('com_rsevents.tickets.sortColumn','filter_order','ordering');
		$sortOrder=$mainframe->getUserStateFromRequest('com_rsevents.tickets.sortOrder','filter_order_Dir','asc');
		$mainframe->setUserState('com_rsevents.tickets.sortColumn',$sortColumn);
		$mainframe->setUserState('com_rsevents.tickets.sortOrder',$sortOrder);
		
		$idevent = JRequest::getInt('IdEvent');
		$filter=JRequest::getVar('rs_filter');

		$this->_query="SELECT IdTicket as RecordId, IdEvent , TicketName , TicketPrice , TicketMaxAudience , TicketDescription , ordering FROM #__rsevents_tickets WHERE IdEvent=".$idevent." ORDER BY $sortColumn $sortOrder";
		//echo $this->_query;
	}
	
	function __construct()
	{	
		parent::__construct();
		$this->_buildQuery();
		
		$mainframe =& JFactory::getApplication();

		// Get pagination request variables
		$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = $mainframe->getUserStateFromRequest('com_rsevents.limitstart', 'limitstart', 0, 'int');

		// In case limit has been changed, adjust it
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
	}
	
	function getData()
	{
		if (empty($this->_data))
			$this->_data=$this->_getList($this->_query,$this->getState('limitstart'), $this->getState('limit'));

		return $this->_data;
	}
	
	function getTotal()
	{
		if (empty($this->_total))
			$this->_total = $this->_getListCount($this->_query);	

		return $this->_total;
	}
	
	function getPagination()
	{
		// Load the content if it doesn't already exist
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit'));
		}
		return $this->_pagination;
	}
	
	//get ticket details
	function getTicket()
	{
		$db =& JFactory::getDBO();
		$cid = JRequest::getVar('cid',array(0),'request','array');
		if(is_array($cid)) $cid = $cid[0];
		$row = & JTable::getInstance('Rsevents_Tickets','Table');
		$row->load($cid);
		return $row;
	}
	
	//get the coupon list
	function getCupons()
	{
		$db =& JFactory::getDBO();
		$cid = JRequest::getInt('cid');
		$db->setQuery("SELECT IdCupon , CuponName, CouponStart, CouponEnd FROM #__rsevents_cupons WHERE IdEvent = ".$cid);
		return $db->loadObjectList();
	}
	
	//get coupon
	function getCupon()
	{
		$cid = JRequest::getInt('cid');
		$row = & JTable::getInstance('Rsevents_Cupons','Table');
		$row->load($cid);
		return $row;
	}
	
	//save ticket
	function save()
	{
		$app 	=& JFactory::getApplication();	
		$post	= JRequest::get('post');
		$cid 	= JRequest::getInt('cid');
		$row	=& JTable::getInstance('Rsevents_Tickets','Table');
		
		$idevent = JRequest::getVar('IdEvent',array(0),'request','array');
		if(is_array($idevent)) $idevent = $idevent[0];
		 
		$post['TicketDescription'] = JRequest::getVar('TicketDescription', '', 'post', 'none', JREQUEST_ALLOWRAW);
		
		//bind the post
		if(!$row->bind($post))
			return JError::raiseWarning(500, $row->getError());
		
		if($row->TicketsPerUser == 0 || $row->TicketsPerUser == '') $row->TicketsPerUser = 1;
		if(empty($row->ordering)) $row->ordering = 9999999;
		
		//if ($row->TicketsPerUser > $row->TicketMaxAudience) $row->TicketsPerUser = $row->TicketMaxAudience;
		
		if ($row->store()) 
			$msg = JText::_('RSE_TICKETS_SAVE' );
		else
			$msg = JText::_('RSE_TICKETS_SAVE_ERROR' );
		
		$row->reorder('IdEvent='.$idevent);
		switch(JRequest::getCmd('task'))
		{
			case 'apply' :
					$link = 'index.php?option=com_rsevents&task=editticket&cid='.$row->IdTicket;
			break;
			
			case 'save' :
					$link = 'index.php?option=com_rsevents&task=listtickets&IdEvent='.$idevent;
			break;
		}
		
		$app->redirect($link, $msg);
	}
	
	//remove ticket
	function remove()
	{
		$app 		=& JFactory::getApplication();
		$db 		=& JFactory::getDBO();
		$cids 		= JRequest::getVar('cid',array(0),'request','array');
		$idevent 	= JRequest::getInt('IdEvent',0,'request');
		$row 		=& JTable::getInstance('Rsevents_Tickets','Table');
		
		//deletes all the tickets that have been selected
		if(!empty($cids))
		{
			foreach($cids as $cid) 
			{
				$db->setQuery("SELECT COUNT(st.IdTicket) FROM #__rsevents_subscription_tickets st LEFT JOIN #__rsevents_subscriptions s ON s.IdSubscription=st.IdSubscription WHERE st.IdTicket ='".$cid."'");
				if ($db->loadResult() == 0)
				{
					if(!$row->delete($cid)) 
						$msg = JText::_('RSE_TICKETS_DELETE_ERROR' );
					else 
						$msg = JText::_('RSE_TICKETS_DELETE1' );
					$row->reorder('IdEvent='.$idevent);
				} else $msg = JText::_('RSE_TICKET_CONTAINS_SUBSCRIBERS');
			}
		} else
			$msg = JText::_('RSE_TICKETS_DELETE_ERROR1' );
		
		$app->redirect( 'index.php?option=com_rsevents&task=listtickets&IdEvent='.$idevent, $msg );
	}
	
	//save ordering
	function saveOrder()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$app 		=& JFactory::getApplication();
		$db			=& JFactory::getDBO();
		$cid		= JRequest::getVar( 'cid', array(0), 'request', 'array' );
		$idevent 	= JRequest::getVar('IdEvent',array(0),'request', 'array');
		$order		= JRequest::getVar( 'order', array (0), 'post', 'array' );
		if(is_array($idevent)) $idevent = $idevent[0];

		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toInteger($order, array(0));

		// Instantiate an article table object
		$row = & JTable::getInstance('Rsevents_Tickets','Table');
		for( $i=0; $i < count($cid); $i++ )
		{
			$row->load( (int) $cid[$i] );

			if ($row->ordering != $order[$i])
			{	
				$row->ordering = $order[$i];
				if (!$row->store()) 
					return false;
			}
		}
		
		$row->reorder('IdEvent='.$idevent);
		$app->redirect( 'index.php?option=com_rsevents&task=listtickets&IdEvent='.$idevent,JText::_('RSE_TICKETS_ORDER_SAVE'));

	}
	
	//move ticket
	function move() 
	{
		$app 		=& JFactory::getApplication();
		$cid 		= JRequest::getVar( 'cid', array(0), 'request', 'array' );
		$idevent 	= JRequest::getVar('IdEvent',array(0),'request', 'array');
		$row 		=& JTable::getInstance('Rsevents_Tickets','Table');
		$task 		= JRequest::getCmd('task');
		
		if(is_array($idevent)) $idevent = intval($idevent[0]);
		if(is_array($cid)) $cid = intval($cid[0]);
		
		$direction = ($task=='orderup') ? -1 : 1;
		
		
		$row->load($cid);
		if (!$row->load($cid)) 
			return false;

		$row->move($direction,'IdEvent='.$idevent);
		$row->reorder('IdEvent='.$idevent);
	
		$app->redirect( 'index.php?option=com_rsevents&task=listtickets&IdEvent='.$idevent);
	}
	
	//save coupon
	function savecoupon()
	{
		$app 	=& JFactory::getApplication();
		$post	= JRequest::get('post');
		$row	=& JTable::getInstance('Rsevents_Cupons','Table');
		
		
		if(!$row->bind($post))
			return JError::raiseWarning(500, $row->getError());
		
		$row->CouponStart = empty($row->CouponStart) ? 0 : strtotime($row->CouponStart); 
		$row->CouponEnd = empty($row->CouponEnd) ? 0 : strtotime($row->CouponEnd);
		
		if ($row->store())
			$msg = JText::_('RSE_CUPON_SAVE' );	
		else
			$msg = JText::_('RSE_CUPON_SAVE_ERROR' );
		
		switch(JRequest::getCmd('task'))
		{
			case 'applycupon' :
					$link = 'index.php?option=com_rsevents&task=editcupon&cid='.$row->IdCupon.'&IdEvent='.$row->IdEvent;
			break;
			
			case 'savecupon' :
					$link = 'index.php?option=com_rsevents&task=cupons&cid='.$row->IdEvent;
			break;
		}
		
		$app->redirect($link, $msg);
	}
	
	//remove coupon
	function removecoupon()
	{
		$app		=& JFactory::getApplication();
		$cids		= JRequest::getVar('cid',array(0),'post','array');
		$row 		=& JTable::getInstance('Rsevents_Cupons','Table');
		$idevent 	= JRequest::getInt('IdEvent');
		
		//deletes all the cupons that have been selected
		if(!empty($cids))
		{
			foreach($cids as $cid) 
			{
				if(!$row->delete($cid)) 
					$msg = JText::_('RSE_CUPON_DELETE_ERROR' );
				else
					$msg = JText::_('RSE_CUPON_DELETED' );
			}
		} else
			$msg = JText::_('RSE_NO_CUPONS_SELECTED' );
		
		$app->redirect( 'index.php?option=com_rsevents&task=cupons&cid='.$idevent, $msg );
	}
	
	
}