<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' ); 
jimport( 'joomla.application.component.view');
jimport( 'joomla.application.component.model' );

class rseventsViewArchive extends JView
{
	function display($tpl = null)
	{
		$db = & JFactory::getDBO();
		$app = & JFactory::getApplication();
		$this->assignRef('db',$db);
		
		// loads the settings
		$rseventsConfig = rseventsHelper::getConfig();
		
		JSubMenuHelper::addEntry(JText::_('RSE_OVERVIEW'), 'index.php?option=com_rsevents'); 
		JSubMenuHelper::addEntry(JText::_('RSE_EVENT_MANAGER'), 'index.php?option=com_rsevents&task=listevents'); 
		JSubMenuHelper::addEntry(JText::_('RSE_ARCHIVE'), 'index.php?option=com_rsevents&task=archive',true);
		JSubMenuHelper::addEntry(JText::_('RSE_SUBSCRIPTION_MANAGER'), 'index.php?option=com_rsevents&task=listsubscriptions');
		JSubMenuHelper::addEntry(JText::_('RSE_CATEGORIES'), 'index.php?option=com_rsevents&task=listcategories');
		JSubMenuHelper::addEntry(JText::_('RSE_LOCATIONS'), 'index.php?option=com_rsevents&task=listlocations');
		JSubMenuHelper::addEntry(JText::_('RSE_THEMES'), 'index.php?option=com_rsevents&task=themes');
		JSubMenuHelper::addEntry(JText::_('RSE_DESIGNS'), 'index.php?option=com_rsevents&task=listdesigns');
		JSubMenuHelper::addEntry(JText::_('RSE_GROUPS'), 'index.php?option=com_rsevents&task=listgroups');
		JSubMenuHelper::addEntry(JText::_('RSE_IMPORT'), 'index.php?option=com_rsevents&task=import');
		JSubMenuHelper::addEntry(JText::_('RSE_PAYMENTS'), 'index.php?option=com_rsevents&task=payments');
		JSubMenuHelper::addEntry(JText::_('RSE_SETTINGS'), 'index.php?option=com_rsevents&task=editsettings');
		JSubMenuHelper::addEntry(JText::_('RSE_UPDATES'), 'index.php?option=com_rsevents&task=update');
		
		JToolBarHelper::title(JText::_('RSE_ARCHIVE'),'generic.png');
		JToolBarHelper::unarchiveList();
		JToolBarHelper::deleteList(JText::_('RSE_DELETE_ARCHIVE'), 'remove' , "Delete");
		JToolBarHelper::cancel();
		JToolBarHelper::custom('main','preview.png','preview_f2.png',JText::_('RSE_RS_PRODUCT'),false);
		
		$filter				= $app->getUserState('com_rsevents.events.archive');
		$category_filter 	= JRequest::getVar('rs_cat_filter');
		$location_filter	= JRequest::getVar('rs_loc_filter');
		$sortColumn			= JRequest::getVar('filter_order','e.EventStartDate');
		$sortOrder			= JRequest::getVar('filter_order_Dir','desc');
		$data				= $this->get('data');
		$pagination			= $this->get('pagination');
		
		
		//get categories list
		$db->setQuery("SELECT IdCategory, CategoryName  FROM #__rsevents_categories");
		$catlist[]				= JHTML::_('select.option',  '0', JText::_( 'RSE_EVENT_SELECT_CATEGORY' ), 'IdCategory', 'CategoryName' );
		$catlist				= array_merge( $catlist, $db->loadObjectList() );
		$lists['categories']    = JHTML::_('select.genericlist', $catlist, 'rs_cat_filter', 'class="inputbox" size="1" onchange="submitbutton(\'archive\');"','IdCategory', 'CategoryName', $category_filter  );
		
		
		//get locations list
		$db->setQuery("SELECT LocationName FROM #__rsevents_locations");
		$loclist[]				= JHTML::_('select.option',  '0', JText::_( 'RSE_EVENT_SELECT_LOCATION' ), 'LocationName', 'LocationName' );
		$loclist				= array_merge( $loclist, $db->loadObjectList() );
		$lists['locations']		= JHTML::_('select.genericlist', $loclist, 'rs_loc_filter', 'class="inputbox" size="1" onchange="submitbutton(\'archive\');"','LocationName', 'LocationName', $location_filter  );
	

		$this->assignRef('rseventsConfig',$rseventsConfig);
		$this->assignRef('location_filter',$category_filter);
		$this->assignRef('category_filter',$category_filter);
		$this->assignRef('lists'      	, $lists);
		$this->assignRef('filter',$filter);
		$this->assignRef('sortColumn',$sortColumn);
		$this->assignRef('sortOrder',$sortOrder);
		$this->assignRef('data',$data);
		$this->assignRef('pagination',$pagination);
		
		parent::display($tpl);
	}
}