<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' ); 
jimport( 'joomla.application.component.view');

class rseventsViewCategories extends JView
{
	function display($tpl = null)
	{		
		JSubMenuHelper::addEntry(JText::_('RSE_OVERVIEW'), 'index.php?option=com_rsevents'); 
		JSubMenuHelper::addEntry(JText::_('RSE_EVENT_MANAGER'), 'index.php?option=com_rsevents&task=listevents'); 
		JSubMenuHelper::addEntry(JText::_('RSE_ARCHIVE'), 'index.php?option=com_rsevents&task=archive');
		JSubMenuHelper::addEntry(JText::_('RSE_SUBSCRIPTION_MANAGER'), 'index.php?option=com_rsevents&task=listsubscriptions');
		JSubMenuHelper::addEntry(JText::_('RSE_CATEGORIES'), 'index.php?option=com_rsevents&task=listcategories',true);
		JSubMenuHelper::addEntry(JText::_('RSE_LOCATIONS'), 'index.php?option=com_rsevents&task=listlocations');
		JSubMenuHelper::addEntry(JText::_('RSE_THEMES'), 'index.php?option=com_rsevents&task=themes');
		JSubMenuHelper::addEntry(JText::_('RSE_DESIGNS'), 'index.php?option=com_rsevents&task=listdesigns');
		JSubMenuHelper::addEntry(JText::_('RSE_GROUPS'), 'index.php?option=com_rsevents&task=listgroups');
		JSubMenuHelper::addEntry(JText::_('RSE_IMPORT'), 'index.php?option=com_rsevents&task=import');
		JSubMenuHelper::addEntry(JText::_('RSE_PAYMENTS'), 'index.php?option=com_rsevents&task=payments');
		JSubMenuHelper::addEntry(JText::_('RSE_SETTINGS'), 'index.php?option=com_rsevents&task=editsettings');
		JSubMenuHelper::addEntry(JText::_('RSE_UPDATES'), 'index.php?option=com_rsevents&task=update');
		
		JHTML::_('behavior.tooltip');
		
		// load the settings
		$rseventsConfig = rseventsHelper::getConfig();
		$this->assignRef('rseventsConfig',$rseventsConfig);
		$db =& JFactory::getDBO();
		$app =& JFactory::getApplication();
		$this->assignRef('db',$db);
		$task=JRequest::getVar('task','','request');
		
		switch($task)
		{
			case 'listcategories':
			{
				JToolBarHelper::title(JText::_('RSE_CATEGORY_LIST'),'generic.png');
				JToolBarHelper::addNewX('editcategories');
				JToolBarHelper::editListX('editcategories');
				JToolBarHelper::deleteList();
				JToolBarHelper::publishList();
				JToolBarHelper::unpublishList();
				JToolBarHelper::custom('main','preview.png','preview_f2.png',JText::_('RSE_RS_PRODUCT'),false);
				
				$filter			= $app->getUserState('com_rsevents.events.categories');
				$sortColumn		= JRequest::getVar('filter_order','ordering');
				$sortOrder		= JRequest::getVar('filter_order_Dir','asc');
				$categories		= $this->get('data');
				$pagination		= $this->get('pagination');
				
				if ($filter) 
				{
					$query = "SELECT IdCategory as id" .
							" FROM #__rsevents_categories" .
							" WHERE CategoryName LIKE '%".$db->getEscaped($filter,true)."%' ";
					$db->setQuery( $query );
					$search_rows = $db->loadResultArray();
				}
				
				
				$children = array();
				if (!empty($categories))
				foreach ( $categories as $v )
				{
					if (rseventsHelper::is16())
						$pt 	= $v->parent_id;
					else
						$pt 	= $v->parent;
					$list 	= @$children[$pt] ? $children[$pt] : array();
					array_push( $list, $v );
					$children[$pt] = $list;
				}
				
				$list = JHTML::_('menu.treerecurse', 0, '', array(), $children, 9999, 0, 1 );
				
				if ($filter) 
				{
					$list1 = array();
					foreach ($search_rows as $sid )
					{
						foreach ($list as $item)
						{
							if ($item->id == $sid) {
								$list1[] = $item;
							}
						}
					}
					// replace full list with found items
					$list = $list1;
				}
				
				// Ensure ampersands and double quotes are encoded in item titles
				foreach ($list as $i => $item) 
				{
					$treename = $item->treename;
					$treename = JFilterOutput::ampReplace($treename);
					$treename = str_replace('"', '&quot;', $treename);
					$list[$i]->treename = $treename;
				}
				
				$list = array_merge($list,array());
				
				//Ordering allowed ?
				$ordering = ($sortColumn == 'ordering');
				
				$this->assignRef('filter',$filter);
				$this->assignRef('sortColumn',$sortColumn);
				$this->assignRef('sortOrder',$sortOrder);
				$this->assignRef('data',$list);
				$this->assignRef('ordering',$ordering);
				$this->assignRef('pagination',$pagination);
			} break;
			
			case 'editcategories':
			{
				$cid = JRequest::getVar('cid',array(0),'request','array');
				if(is_array($cid)) $cid = intval($cid[0]);
				
				if($cid==0) 
					JToolBarHelper::title(JText::_('RSE_CATEGORY_NEW','generic.png'));
				else 
					JToolBarHelper::title(JText::_('RSE_CATEGORY_EDIT','generic.png'));
				JToolBarHelper::save();
				JToolBarHelper::apply();
				JToolBarHelper::cancel();
				
				//get category details
				$category		= $this->get('Categories');
				
				$name = 'parent';
				$params = 'class="inputbox" size="10" style="width: 15%;"';
				
				if ($category->IdCategory)
				{
					$disabled = array();
					$this->addChildren($category->IdCategory,$disabled);
				} else $disabled = null;				
				$parent = rseventsHelper::getCategories($name,$params,$category->parent,null,$disabled,1);
				
				//set publish to 1 if the category is new
				if($cid == 0) $category->published=1;
				
				$this->assignRef('data',$category);
				$this->assignRef('parent',$parent);
			} break;
		}
		parent::display($tpl);
	}
	
	function addChildren($id, &$list)
	{
		$db =& JFactory::getDBO();
		
		// Initialize variables
		$return = true;

		// Get all rows with parent of $id
		$query = 'SELECT IdCategory as id' .
				' FROM #__rsevents_categories' .
				' WHERE parent = '.(int) $id;
		$db->setQuery( $query );
		$rows = $db->loadObjectList();

		// Make sure there aren't any errors
		if ($db->getErrorNum()) {
			$this->setError($db->getErrorMsg());
			return false;
		}

		// Recursively iterate through all children... kinda messy
		// TODO: Cleanup this method
		foreach ($rows as $row)
		{
			$found = false;
			foreach ($list as $idx)
			{
				if ($idx == $row->id) {
					$found = true;
					break;
				}
			}
			if (!$found) {
				$list[] = $row->id;
			}
			$return = $this->addChildren($row->id, $list);
		}
		return $return;
	}
	
}