<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' ); 
jimport( 'joomla.application.component.view');
jimport( 'joomla.application.component.model' );

class rseventsViewEvents extends JView
{
	function display($tpl = null)
	{
		JSubMenuHelper::addEntry(JText::_('RSE_OVERVIEW'), 'index.php?option=com_rsevents'); 
		JSubMenuHelper::addEntry(JText::_('RSE_EVENT_MANAGER'), 'index.php?option=com_rsevents&task=listevents',true); 
		JSubMenuHelper::addEntry(JText::_('RSE_ARCHIVE'), 'index.php?option=com_rsevents&task=archive');
		JSubMenuHelper::addEntry(JText::_('RSE_SUBSCRIPTION_MANAGER'), 'index.php?option=com_rsevents&task=listsubscriptions');
		JSubMenuHelper::addEntry(JText::_('RSE_CATEGORIES'), 'index.php?option=com_rsevents&task=listcategories');
		JSubMenuHelper::addEntry(JText::_('RSE_LOCATIONS'), 'index.php?option=com_rsevents&task=listlocations');
		JSubMenuHelper::addEntry(JText::_('RSE_THEMES'), 'index.php?option=com_rsevents&task=themes');
		JSubMenuHelper::addEntry(JText::_('RSE_DESIGNS'), 'index.php?option=com_rsevents&task=listdesigns');
		JSubMenuHelper::addEntry(JText::_('RSE_GROUPS'), 'index.php?option=com_rsevents&task=listgroups');
		JSubMenuHelper::addEntry(JText::_('RSE_IMPORT'), 'index.php?option=com_rsevents&task=import');
		JSubMenuHelper::addEntry(JText::_('RSE_PAYMENTS'), 'index.php?option=com_rsevents&task=payments');
		JSubMenuHelper::addEntry(JText::_('RSE_SETTINGS'), 'index.php?option=com_rsevents&task=editsettings');
		JSubMenuHelper::addEntry(JText::_('RSE_UPDATES'), 'index.php?option=com_rsevents&task=update');
		
		
		$db 	=& JFactory::getDBO();
		$task	= JRequest::getVar('task','','request');
		
		$app =& JFactory::getApplication();
		$this->assignRef('app',$app);
		
		// load the settings
		$rseventsConfig = rseventsHelper::getConfig();
		$this->assignRef('rseventsConfig',$rseventsConfig);
		$this->assignRef('db',$db);		
		
		switch($task)
		{
			case 'listevents':
			{	
				JToolBarHelper::title(JText::_('RSE_EVENT_LIST'),'generic.png');
				JToolBarHelper::custom('previewevent','copy','copy',JText::_('RSE_PREVIEW'),true);
				JToolBarHelper::addNewX('editevent');
				JToolBarHelper::editListX('editevent');
				JToolBarHelper::custom( 'copy', 'copy.png', 'copy_f2.png', 'Duplicate' );
				JToolBarHelper::deleteList(JText::_('RSE_DELETE_EVENT_MESSAGE'), 'remove' , "Delete");
				if ($rseventsConfig['event.rating'])
					JToolBarHelper::deleteList(JText::_('RSE_DELETE_RATING_MESSAGE'), 'deleterating' , JText::_('RSE_CLEAR_RATING'));
				JToolBarHelper::archiveList();
				JToolBarHelper::publishList();
				JToolBarHelper::unpublishList();	
				JToolBarHelper::custom('main','preview.png','preview_f2.png',JText::_('RSE_RS_PRODUCT'),false);
				
				$filter					= $app->getUserState('com_rsevents.events.search');
				$category_filter 		= JRequest::getVar('rs_cat_filter');
				$location_filter		= JRequest::getVar('rs_loc_filter');
				$sortColumn				= JRequest::getVar('filter_order','e.EventStartDate');
				$sortOrder				= JRequest::getVar('filter_order_Dir','desc');
				$data					= $this->get('data');
				$pagination				= $this->get('pagination');
				
				//get categories list
				$db->setQuery("SELECT IdCategory, CategoryName  FROM #__rsevents_categories");
				$catlist[]         		= JHTML::_('select.option',  '0', JText::_( 'RSE_EVENT_SELECT_CATEGORY' ), 'IdCategory', 'CategoryName' );
				$catlist         		= array_merge( $catlist, $db->loadObjectList() );
				$lists['categories']    = JHTML::_('select.genericlist', $catlist, 'rs_cat_filter', 'class="inputbox" size="1" onchange="submitbutton(\'listevents\');"','IdCategory', 'CategoryName', $category_filter  );
				
				//get locations list
				$db->setQuery("SELECT LocationName  FROM #__rsevents_locations");
				$loclist[]         		= JHTML::_('select.option',  '0', JText::_( 'RSE_EVENT_SELECT_LOCATION' ), 'LocationName', 'LocationName' );
				$loclist         		= array_merge( $loclist, $db->loadObjectList() );
				$lists['locations']     = JHTML::_('select.genericlist', $loclist, 'rs_loc_filter', 'class="inputbox" size="1" onchange="submitbutton(\'listevents\');"','LocationName', 'LocationName', $location_filter  );
			

				$this->assignRef('location_filter',$category_filter);
				$this->assignRef('category_filter',$category_filter);
				$this->assignRef('lists', $lists);
				$this->assignRef('filter',$filter);
				$this->assignRef('sortColumn',$sortColumn);
				$this->assignRef('sortOrder',$sortOrder);
				$this->assignRef('data',$data);
				$this->assignRef('pagination',$pagination);

			} break;
			
			case 'editevent':
			{
				//loads the event to edit
				$event		= $this->get('Event');
				$cid		= JRequest::getVar('cid',array(0),'request','array');
				if(is_array($cid)) $cid=intval($cid[0]);				
				
				if($cid==0) 
					JToolBarHelper::title(JText::_('RSE_EVENT_NEW','generic.png')); 
				else  
					JToolBarHelper::title(JText::_('RSE_EVENT_EDIT','generic.png').' : <small>['.$event->EventName.']</small>');
				if($cid) JToolBarHelper::custom('previewevent','copy','copy',JText::_('RSE_PREVIEW'),false);
				JToolBarHelper::save();
				JToolBarHelper::apply();
				JToolBarHelper::cancel();
				
				if ($event->designtype)
					JError::raiseNotice('200',JText::_('RSE_EVENT_DESIGN_NOTICE'));
				
				JHTML::_('behavior.modal');
				JHTML::_('behavior.mootools');
				JHTML::_('behavior.tooltip');
				jimport('joomla.html.pane');
				$params = array();
				$params['startOffset'] = JRequest::getInt('tabposition', 0);
				$tabs= & JPane::getInstance('Tabs',$params,true);
				
				//set published to 1 if is a new event
				if($cid == 0) $event->published = 1;
				
				//get all the files
				$files = $this->get('Files');
				
				//get extras
				$extras = $this->get('Extras');
				
				$on = JURI::root().'administrator/components/com_rsevents/assets/images/icons/tick.png';
				$off = JURI::root().'administrator/components/com_rsevents/assets/images/icons/delete.png';
				
				if(!empty($files))
				{
					foreach($files as $i=>$file)
					{
						if(empty($file->FilePermission))
						$file->FilePermission = '111111';
						
						$files[$i]->fp0 = ($file->FilePermission[0]==0 ? '<img src="'.$off.'">' : '<img src="'.$on.'">');		
						$files[$i]->fp1 = ($file->FilePermission[1]==0 ? '<img src="'.$off.'">' : '<img src="'.$on.'">');		
						$files[$i]->fp2 = ($file->FilePermission[2]==0 ? '<img src="'.$off.'">' : '<img src="'.$on.'">');			
						$files[$i]->fp3 = ($file->FilePermission[3]==0 ? '<img src="'.$off.'">' : '<img src="'.$on.'">');			
						$files[$i]->fp4 = ($file->FilePermission[4]==0 ? '<img src="'.$off.'">' : '<img src="'.$on.'">');			
						$files[$i]->fp5 = ($file->FilePermission[5]==0 ? '<img src="'.$off.'">' : '<img src="'.$on.'">');						
					}
				}
				
				$db->setQuery("SELECT IdCategory FROM #__rsevents_events_cat WHERE IdEvent = '".$event->IdEvent."'");
				$categ_selected = $db->loadResultArray();
				$default = JHTML::_('select.option',  '0', JText::_( 'RSE_EVENT_SELECT_CATEGORY' ), 'value', 'text' );
				$lists['categories'] = rseventsHelper::getCategories('IdCategory[]','class="inputbox" size="7" style="width:15%" multiple="multiple"',empty($categ_selected) ? 0 : $categ_selected,$default);
				
				
				$db->setQuery("SELECT IdLocation,LocationName FROM #__rsevents_locations WHERE published = 1 ORDER BY LocationName ASC");
				$locationList = $db->loadObjectList();
				$loclist[]				= JHTML::_('select.option',  '0', JText::_( 'RSE_EVENT_SELECT_LOCATION' ), 'IdLocation', 'LocationName' );
				$loclist				= array_merge( $loclist, $locationList );
				$lists['locations']     = JHTML::_('select.genericlist', $loclist, 'IdLocation', 'class="inputbox" size="1"','IdLocation', 'LocationName', intval( $event->IdLocation ) );
			
				$db->setQuery("SELECT IdDesign,DesignName FROM #__rsevents_designs WHERE designtype = 0");
				if ($event->designtype)
					$designs[]				= JHTML::_('select.option',  '0', JText::_( 'RSE_EVENT_OLD_DESIGN_OPTION' ), 'IdDesign', 'DesignName' );
				else
					$designs[]				= JHTML::_('select.option',  '0', JText::_( 'RSE_EVENT_SELECT_DESIGN' ), 'IdDesign', 'DesignName' );
				$designs				= array_merge( $designs, $db->loadObjectList() );
				$lists['designs']      = JHTML::_('select.genericlist', $designs, 'IdNewDesign', 'class="inputbox" size="1"','IdDesign', 'DesignName', intval( $event->IdNewDesign ) );
				
				$db->setQuery("SELECT id,name FROM #__rsevents_themes");
				$lists['themes']		= JHTML::_('select.genericlist', $db->loadObjectList(), 'IdTheme', 'class="inputbox" size="1"','id', 'name', intval( $event->IdTheme ) );
				
				$selectedp = !empty($event->payments) ? explode(',',$event->payments) : '';
				$payments = rseventsHelper::getPayments();
				$lists['payments']		= JHTML::_('select.genericlist', $payments, 'payments[]', 'class="inputbox" size="5" multiple="multiple"','value', 'text', $selectedp);
				
				
				//do we have payment on this event?
				$db->setQuery("SELECT SUM(TicketPrice) as Price, COUNT(*) as Cnt FROM `#__rsevents_tickets` WHERE `IdEvent` = '".$cid."'");
				$ticketProperties = $db->loadObject();
			
				$pieces = array(16=>16,17=>17,18=>18,19=>19,20=>20,26=>26);
				if(!$ticketProperties->Price) 
				{
					unset($pieces[20]);
					unset($pieces[26]);
					if($ticketProperties->Cnt == 1) unset($pieces[19]);
				}
				
				if (file_exists(JPATH_SITE.DS.'components'.DS.'com_rsform'.DS.'rsform.php'))
				{
					$db->setQuery("SELECT DISTINCT f.FormId ,f.FormName FROM #__rsform_forms f WHERE f.Published = 1 ORDER BY FormId DESC");
					$forms = $db->loadObjectList();
				}
				
				$flist[]         = JHTML::_('select.option',  '0', JText::_( 'RSE_DEFAULT_FORM' ), 'FormId', 'FormName' );
				
				if (file_exists(JPATH_SITE.DS.'components'.DS.'com_rsform'.DS.'rsform.php'))
				{
					if(!empty($forms))
						foreach($forms as $i=>$form)
						{
							//Check what items does it have
							$db->setQuery("SELECT COUNT(*) Cnt FROM #__rsform_components WHERE FormId = '".$form->FormId."' AND Published=1 AND ComponentTypeId IN ('".implode("','",$pieces)."')");

							if(count($pieces)!=$db->loadResult()) 
							{
								$forms[$i]->disable = true;
								$forms[$i]->FormName .= ' ('.JText::_('RSE_ADD_RSEVENTS_COMPONENTS').')';
							}
							
						}
					if(!empty($forms))
					$flist = array_merge($flist , $forms);
				}
				
				$lists['forms']      = JHTML::_('select.genericlist', $flist, 'EventRegistrationForm', 'class="inputbox" size="1"','FormId', 'FormName', empty($event->EventRegistrationForm) ? $rseventsConfig['event.registration.form'] : $event->EventRegistrationForm);
				
				$lists['early_discount'] = JHTML::_('select.booleanlist','early_discount_type','class="inputbox"',$event->early_discount_type,JText::_('RSE_VALUE'),JText::_('RSE_PERCENTAGE'));
				$lists['late_fee'] = JHTML::_('select.booleanlist','late_fee_type','class="inputbox"',$event->late_fee_type,JText::_('RSE_VALUE'),JText::_('RSE_PERCENTAGE'));
				
				$this->assignRef('files',$files);
				$this->assignRef('extras',$extras);
				$this->assignRef('data',$event);
				$this->assignRef('locationList',$locationList);
				$this->assignRef('tabs',$tabs);
				$this->assignRef('lists',$lists);
				
			} break;
			
			case 'edityoutube':
			case 'editflash':
			case 'editmp3':
			case 'editmeebo':
			case 'editflickr':
			{
				$data = $this->get('Extra');
				$this->assignRef('data',$data);
			} break;
			
			case 'rsform':
				$formid = JRequest::getVar('formid',0,'request');
				echo $formid;
			exit();
			break;
		}
		parent::display($tpl);
	}
}