<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' ); 
jimport( 'joomla.application.component.view');

class rseventsViewGroups extends JView
{
	function display($tpl = null)
	{
		$db =& JFactory::getDBO();
		$app =& JFactory::getApplication();
		$task=JRequest::getVar('task','','request');
		
		JSubMenuHelper::addEntry(JText::_('RSE_OVERVIEW'), 'index.php?option=com_rsevents'); 
		JSubMenuHelper::addEntry(JText::_('RSE_EVENT_MANAGER'), 'index.php?option=com_rsevents&task=listevents'); 
		JSubMenuHelper::addEntry(JText::_('RSE_ARCHIVE'), 'index.php?option=com_rsevents&task=archive');
		JSubMenuHelper::addEntry(JText::_('RSE_SUBSCRIPTION_MANAGER'), 'index.php?option=com_rsevents&task=listsubscriptions');
		JSubMenuHelper::addEntry(JText::_('RSE_CATEGORIES'), 'index.php?option=com_rsevents&task=listcategories');
		JSubMenuHelper::addEntry(JText::_('RSE_LOCATIONS'), 'index.php?option=com_rsevents&task=listlocations');
		JSubMenuHelper::addEntry(JText::_('RSE_THEMES'), 'index.php?option=com_rsevents&task=themes');
		JSubMenuHelper::addEntry(JText::_('RSE_DESIGNS'), 'index.php?option=com_rsevents&task=listdesigns');
		JSubMenuHelper::addEntry(JText::_('RSE_GROUPS'), 'index.php?option=com_rsevents&task=listgroups',true);
		JSubMenuHelper::addEntry(JText::_('RSE_IMPORT'), 'index.php?option=com_rsevents&task=import');
		JSubMenuHelper::addEntry(JText::_('RSE_PAYMENTS'), 'index.php?option=com_rsevents&task=payments');
		JSubMenuHelper::addEntry(JText::_('RSE_SETTINGS'), 'index.php?option=com_rsevents&task=editsettings');
		JSubMenuHelper::addEntry(JText::_('RSE_UPDATES'), 'index.php?option=com_rsevents&task=update');
		
		switch($task)
		{
			case 'listgroups':
			{
				JToolBarHelper::title(JText::_('RSE_GROUP_LIST'),'generic.png');
				JToolBarHelper::addNewX('editgroups');
				JToolBarHelper::editListX('editgroups');
				JToolBarHelper::deleteList();
				JToolBarHelper::custom('main','preview.png','preview_f2.png',JText::_('RSE_RS_PRODUCT'),false);
				
				//get data
				$filter			= $app->getUserState('com_rsevents.events.groups');
				$sortColumn		= JRequest::getVar('filter_order','#__rsevents_groups.IdGroup');
				$sortOrder		= JRequest::getVar('filter_order_Dir','asc');
				$groups			= $this->get('data');
				$pagination		= $this->get('pagination');			
				
				//assign values
				$this->assignRef('filter',$filter);
				$this->assignRef('sortColumn',$sortColumn);
				$this->assignRef('sortOrder',$sortOrder);
				$this->assignRef('data',$groups);
				$this->assignRef('pagination',$pagination);
				
			} break;
			
			case 'editgroups':
			{
				$cid = JRequest::getVar('cid',array(0),'request','array');
				if(is_array($cid)) $cid=intval($cid[0]);
				
				if($cid==0) 
					JToolBarHelper::title(JText::_('RSE_GROUP_NEW','generic.png')); 
				else 
					JToolBarHelper::title(JText::_('RSE_GROUP_EDIT','generic.png'));
				JToolBarHelper::save();
				JToolBarHelper::apply();
				JToolBarHelper::cancel();
				
				//Get the group
				$group = $this->get('Group');
				$this->assignRef('Group',$group);
				
				//Get the group permissions
				$GroupPermissions=$this->get('GroupPermissions');
				
				if(!empty($GroupPermissions))
				foreach($GroupPermissions as $permissionRow)
					$permissions[$permissionRow->PermissionName]=$permissionRow->PermissionValue;
				$this->assignRef('permissions',$permissions);
				
				//Get the group acls
				$GroupAcls = $this->get('GroupAcls');		
				
				//Initialize the access list dropdown
				$AccessList = array();
				
				foreach($GroupAcls as $GroupAcl)
				{
					if (rseventsHelper::is16() && $GroupAcl->GroupAcl == '29' ) $GroupAcl->GroupAcl = 1;
					$AccessList[] = $GroupAcl->GroupAcl;
				}
				
				//Get the used acls
				$usedAcls = array();
				$otherGroups = $this->get('UsedGroupAcls');

				foreach ($otherGroups as $otherGroup)
					$usedAcls[] = $otherGroup->GroupAcl;
				
				if (rseventsHelper::is16())
				{				
					$doc =& JFactory::getDocument();
					$doc->addScriptDeclaration("window.addEvent('domready', function() { rse_acls(); }); ");
					$this->assignRef('acls',$AccessList);
					$this->assignRef('used',implode(',',$usedAcls));
					
				} else 
				{
					
					//Load all Joomla! user groups
					$JoomlaAcls		= & JFactory::getACL();

					//Create custom group levels to include into the public group selectList
					$access   = array();
					$access = array_merge( $access, $JoomlaAcls->get_group_children_tree( null, 'USERS', false ) );

					if (count($usedAcls) == 9) $app->redirect('index.php?option=com_rsevents&task=listgroups', JText::_('RSE_NO_JGROUPS'));
					
					//Disable the used group acls
					foreach ($access as $key => $accessObject)
						if (array_search($accessObject->value,$usedAcls) !== false)
							$access[$key]->disable = true;
					
					
					//Create the access control list
					$accessLists['access1']	= JHTML::_('select.genericlist', $access, 'GroupAcl[]', 'class="inputbox" size="8" multiple="multiple"', 'value', 'text', $AccessList );
					
					$this->assignRef('accessLists'	, $accessLists);
				}
			} break;	
		}
		parent::display($tpl);
	}
}