<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' ); 
jimport( 'joomla.application.component.view');

class rseventsViewMain extends JView
{
	function display($tpl = null)
	{
		$config = rseventsHelper::getConfig();
		$task = JRequest::getCmd('task','main','request');
		$this->assignRef('rseventsConfig',$config);
		JHTML::_('behavior.tooltip');
		
		$doc =& JFactory::getDocument();
		$doc->addScript(JURI::root(true).'/administrator/components/com_rsevents/assets/js/jquery-1.4.4.min.js');
		$doc->addScript(JURI::root(true).'/administrator/components/com_rsevents/assets/js/jquery-ui-1.8.10.custom.min.js');
		$doc->addScriptDeclaration('jQuery.noConflict();');
		
		if ($tpl) $task .= '_'.$tpl;
		
		$jversion = new JVersion();
		
		switch($task)
		{
			//default:
			case 'main':
			{
				JSubMenuHelper::addEntry(JText::_('RSE_OVERVIEW'), 'index.php?option=com_rsevents',true); 
				JSubMenuHelper::addEntry(JText::_('RSE_EVENT_MANAGER'), 'index.php?option=com_rsevents&task=listevents'); 
				JSubMenuHelper::addEntry(JText::_('RSE_ARCHIVE'), 'index.php?option=com_rsevents&task=archive');
				JSubMenuHelper::addEntry(JText::_('RSE_SUBSCRIPTION_MANAGER'), 'index.php?option=com_rsevents&task=listsubscriptions');
				JSubMenuHelper::addEntry(JText::_('RSE_CATEGORIES'), 'index.php?option=com_rsevents&task=listcategories');
				JSubMenuHelper::addEntry(JText::_('RSE_LOCATIONS'), 'index.php?option=com_rsevents&task=listlocations');
				JSubMenuHelper::addEntry(JText::_('RSE_THEMES'), 'index.php?option=com_rsevents&task=themes');
				JSubMenuHelper::addEntry(JText::_('RSE_DESIGNS'), 'index.php?option=com_rsevents&task=listdesigns');
				JSubMenuHelper::addEntry(JText::_('RSE_GROUPS'), 'index.php?option=com_rsevents&task=listgroups');
				JSubMenuHelper::addEntry(JText::_('RSE_IMPORT'), 'index.php?option=com_rsevents&task=import');
				JSubMenuHelper::addEntry(JText::_('RSE_PAYMENTS'), 'index.php?option=com_rsevents&task=payments');
				JSubMenuHelper::addEntry(JText::_('RSE_SETTINGS'), 'index.php?option=com_rsevents&task=editsettings');
				JSubMenuHelper::addEntry(JText::_('RSE_UPDATES'), 'index.php?option=com_rsevents&task=update');
				
				JToolBarHelper::title(JText::_('RSE_MAIN_MENU'),'rsevents');
				JToolBarHelper::custom('main','preview.png','preview_f2.png',JText::_('RSE_RS_PRODUCT'),false);		
				$this->assignRef('code',$config['global.register.code']);
				if ($jversion->isCompatible('1.6.0'))
				{
					$user =& JFactory::getUser();
					if ($user->authorise('core.admin', 'com_rsevents'))
						JToolBarHelper::preferences('com_rsevents');
				}
			} break;
			
			case 'main_module1':
			case 'main_module2':
			case 'main_module5':
			break;
			
			case 'main_module3':
				$events = $this->get('Upcoming');
				$this->assignRef('events',$events);
			break;
			
			case 'main_module4':
				$subscribers = $this->get('Subscribers');
				$this->assignRef('subscribers',$subscribers);
			break;
			
			case 'main_module6':
				$comments = $this->get('Comments');
				$this->assignRef('comments',$comments);
			break;
			
			case 'update':
			{
				JSubMenuHelper::addEntry(JText::_('RSE_OVERVIEW'), 'index.php?option=com_rsevents'); 
				JSubMenuHelper::addEntry(JText::_('RSE_EVENT_MANAGER'), 'index.php?option=com_rsevents&task=listevents'); 
				JSubMenuHelper::addEntry(JText::_('RSE_ARCHIVE'), 'index.php?option=com_rsevents&task=archive');
				JSubMenuHelper::addEntry(JText::_('RSE_SUBSCRIPTION_MANAGER'), 'index.php?option=com_rsevents&task=listsubscriptions');
				JSubMenuHelper::addEntry(JText::_('RSE_CATEGORIES'), 'index.php?option=com_rsevents&task=listcategories');
				JSubMenuHelper::addEntry(JText::_('RSE_LOCATIONS'), 'index.php?option=com_rsevents&task=listlocations');
				JSubMenuHelper::addEntry(JText::_('RSE_THEMES'), 'index.php?option=com_rsevents&task=themes');
				JSubMenuHelper::addEntry(JText::_('RSE_DESIGNS'), 'index.php?option=com_rsevents&task=listdesigns');
				JSubMenuHelper::addEntry(JText::_('RSE_GROUPS'), 'index.php?option=com_rsevents&task=listgroups');
				JSubMenuHelper::addEntry(JText::_('RSE_IMPORT'), 'index.php?option=com_rsevents&task=import');
				JSubMenuHelper::addEntry(JText::_('RSE_PAYMENTS'), 'index.php?option=com_rsevents&task=payments');
				JSubMenuHelper::addEntry(JText::_('RSE_SETTINGS'), 'index.php?option=com_rsevents&task=editsettings');
				JSubMenuHelper::addEntry(JText::_('RSE_UPDATES'), 'index.php?option=com_rsevents&task=update',true);
				
				JToolBarHelper::title(JText::_('RSE_UPDATE'),'generic.png');
				JToolBarHelper::custom('main','preview.png','preview_f2.png',JText::_('RSE_RS_PRODUCT'),false);
			}
			break;
		}
		parent::display($tpl);
	}
	
	function getModules($column)
	{
		$db =& JFactory::getDBO();
		$config = rseventsHelper::getConfig();
		
		$db->setQuery("SELECT `position` , `module` FROM `#__rsevents_modules` WHERE `column` = '".$db->getEscaped($column)."' ORDER BY `position` ASC ");
		$modules = $db->loadObjectList();
		
		foreach ($modules as $i => $module)
		{
			if (!$config[$module->module])
				unset($modules[$i]);
		}
		
		return $modules;
	}
	
	function showContent($comment,$id,$more=' ...')
	{
		$config = rseventsHelper::getConfig();
		
		if (strlen($comment) > 100)
			$comment = substr($comment,0,100).$more;
		
		switch ($config['events.commenting'])
		{
			default:
			case '0':
				return $comment;
			break;
			
			//JComments
			case '1':
				$comment = '<a href="index.php?option=com_jcomments&task=edit&cid='.$id.'">'.$comment.'</a>';
			break;
			
			//Jom Comment
			case '2':
				$comment = '<a href="index.php?option=com_jomcomment">'.$comment.'</a>';
			break;
			
			//RSComments!
			case '3':
				$comment = '<a href="index.php?option=com_rscomments&view=comments&layout=edit&cid='.$id.'">'.$comment.'</a>';
			break;
		}
		
		return $comment;
	}
	
	function genKeyCode()
	{
		$rseventsConfig = rseventsHelper::getConfig();
		return md5($rseventsConfig['global.register.code'].RSE_RS_KEY);
	}
	
	function getTickets($id)
	{
		$db =& JFactory::getDBO();
		
		$db->setQuery("SELECT st.TicketsSubscribed, t.TicketName FROM #__rsevents_subscription_tickets st LEFT JOIN #__rsevents_tickets t ON t.IdTicket = st.IdTicket WHERE st.IdSubscription = ".(int) $id." ");
		return $db->loadObjectList();
	}
	
	function getSubscribers($cid)
	{
		$db =& JFactory::getDBO();
		
		$db->setQuery("SELECT COUNT(IdSubscription) FROM #__rsevents_subscriptions WHERE IdEvent = ".$cid." ");
		return $db->loadResult();
	}
}