<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' ); 
jimport( 'joomla.application.component.view');
jimport( 'joomla.plugin.helper');

class rseventsViewSettings extends JView
{
	function display($tpl = null)
	{
		jimport('joomla.html.pane');
		jimport('joomla.filesystem.folder');
		
		$db 		=& JFactory::getDBO();
		$mainframe	=& JFactory::getApplication(); 
		$document 	=& JFactory::getDocument();
		$task		= JRequest::getCmd('task','','request');
		$tabs		=& JPane::getInstance('Tabs',array(),true);
		$editor		=& JFactory::getEditor();
		
		switch($task)
		{
			case 'map':
			{
				//load config
				$data		= $this->get('data');
				$this->assignRef('data',$data);
			}
			break;
			
			case 'editsettings':
			{
				JHTML::_('behavior.modal');
				JHTML::_('behavior.mootools');
				JHTML::_('behavior.tooltip');
				JHTML::_('behavior.switcher');				
				
				
				//Build submenu
				$contents = '';
				ob_start();
				require_once(JPATH_COMPONENT.DS.'views'.DS.'settings'.DS.'tmpl'.DS.'navigation.php');
				$contents = ob_get_contents();
				ob_end_clean();
				
				
				$document->setBuffer($contents, 'modules', 'submenu');
				
				JToolBarHelper::title(JText::_('RSE_SETTINGS'),'generic.png');
				JToolBarHelper::apply();
				JToolBarHelper::save();
				JToolBarHelper::cancel();
				JToolBarHelper::custom('main','preview.png','preview_f2.png',JText::_('RSE_RS_PRODUCT'),false);
				
				$data		= $this->get('data');
				
				//set the comment system options
				$jcomment 	= file_exists(JPATH_SITE.DS.'components'.DS.'com_jcomments'.DS.'jcomments.php');
				$jomcomment = file_exists(JPATH_SITE.DS.'plugins'.DS.'content'.DS.'jom_comment_bot.php');
				$rscomments = file_exists(JPATH_SITE.DS.'components'.DS.'com_rscomments'.DS.'helpers'.DS.'rscomments.php');
				
				$commentsystem = array();
				$commentsystem[] = JHTML::_('select.option', '0', JText::_( 'RSE_NO_COMMENTS' ) );	
				$commentsystem[] = JHTML::_('select.option', '4', 'Facebook'  , 'value' , 'text');
				$commentsystem[] = JHTML::_('select.option', '1', JText::_( 'JComments' )  , 'value' , 'text', !$jcomment );
				$commentsystem[] = JHTML::_('select.option', '2', JText::_( 'Jom Comments' ) , 'value' , 'text', !$jomcomment);
				$commentsystem[] = JHTML::_('select.option', '3', JText::_( 'RSComments!' )  , 'value' , 'text', !$rscomments);
				$commentoptions = JHTML::_('select.genericlist', $commentsystem, 'rseventsConfig[events.commenting]', 'size="1" class="inputbox"', 'value', 'text', $data['events.commenting'] );
				
				
				$redirection = $profile = $udetails = array();
				$cb = file_exists(JPATH_SITE.DS.'components'.DS.'com_comprofiler'.DS.'comprofiler.php');
				$jm = file_exists(JPATH_SITE.DS.'components'.DS.'com_joomunity'.DS.'joomunity.php');
				$js = file_exists(JPATH_SITE.DS.'components'.DS.'com_community'.DS.'community.php');
				

				$redirection[] = JHTML::_('select.option', '0', JText::_( 'RSE_JOOMLA_DEFAULT' ) );
				$redirection[] = JHTML::_('select.option', '1', JText::_( 'RSE_CB_LINK' )  , 'value' , 'text', !$cb);
				
				
				$profile[] = JHTML::_('select.option', '0', JText::_( 'RSE_NO_PROFILE' ) );
				$profile[] = JHTML::_('select.option', '1', JText::_( 'Comunity Builder' ) , 'value' , 'text', !$cb);
				$profile[] = JHTML::_('select.option', '2', JText::_( 'Joomunity' )  , 'value' , 'text', !$jm);
				$profile[] = JHTML::_('select.option', '3', JText::_( 'JomSocial' )  , 'value' , 'text', !$js);
				
				$udetails[] = JHTML::_('select.option', 'username', JText::_( 'RSE_UD_USERNAME' ));
				$udetails[] = JHTML::_('select.option', 'name', JText::_( 'RSE_UD_NAME' ));
				$udetails[] = JHTML::_('select.option', 'cb', JText::_( 'RSE_UD_CB' ), 'value' , 'text', !$cb);
				
				//load the avatar list
				$avatars = $this->get('AvailableAvatars');
				$avatars_array = array(JHTML::_('select.option', '', JText::_('RSE_NO_AVATAR'),'value', 'text'));
				foreach ($avatars as $component => $enabled)
					$avatars_array[] = JHTML::_('select.option', $component, JText::_('RSE_'.strtoupper($component)),'value', 'text', $enabled ? false : true);
				
				$lists['avatars'] = JHTML::_('select.genericlist', $avatars_array, 'rseventsConfig[avatar]', '', 'value', 'text', $data['avatar']);
				$lists['udetails'] = JHTML::_('select.genericlist', $udetails, 'rseventsConfig[user.details]', 'size="1" class="inputbox"', 'value', 'text', $data['user.details'] );
				$lists['profile'] = JHTML::_('select.genericlist', $profile, 'rseventsConfig[subscribers.link]', 'size="1" class="inputbox"', 'value', 'text', $data['subscribers.link'] );
				$lists['redirection'] = JHTML::_('select.genericlist', $redirection, 'rseventsConfig[cb.redirect]', 'size="1" class="inputbox"', 'value', 'text', $data['cb.redirect'] );				
				
				$lists['flash'] = JHTML::_('select.booleanlist', 'rseventsConfig[events.extras.flash]' , '' , $data['events.extras.flash']);
				$lists['youtube'] = JHTML::_('select.booleanlist', 'rseventsConfig[events.extras.youtube]' , '' , $data['events.extras.youtube']);
				$lists['mp3'] = JHTML::_('select.booleanlist', 'rseventsConfig[events.extras.mp3]' , '' , $data['events.extras.mp3']);
				$lists['meebo'] = JHTML::_('select.booleanlist', 'rseventsConfig[events.extras.meebo]' , '' , $data['events.extras.meebo']);
				$lists['gMaps'] = JHTML::_('select.booleanlist', 'rseventsConfig[locations.gmaps]' , '' , $data['locations.gmaps']);
				$lists['flickr'] = JHTML::_('select.booleanlist', 'rseventsConfig[events.extras.flickr]' , '' , $data['events.extras.flickr']);
				
				$payment_methods = rseventsHelper::getPayments(true);
				$lists['payment'] = JHTML::_('select.genericlist', $payment_methods, 'rseventsConfig[payment.default]', 'size="1" class="inputbox"', 'value', 'text', $data['payment.default'] );
				
				$maps = array();
				$maps[] = JHTML::_('select.option', 'G_NORMAL_MAP', JText::_( 'RSE_MAP_NORMAL' ) );
				$maps[] = JHTML::_('select.option', 'G_HYBRID_MAP', JText::_( 'RSE_MAP_HYBRID' ) );
				$maps[] = JHTML::_('select.option', 'G_SATELLITE_MAP', JText::_( 'RSE_MAP_SATELLITE' ) );
				
				$lists['maps'] = JHTML::_('select.genericlist', $maps, 'rseventsConfig[google.map]', 'size="1" class="inputbox"', 'value', 'text', $data['google.map'] );
				
				$layouts = array();
				$layouts[] = JHTML::_('select.option', '0', JText::_( 'RSE_DEFAULT_LAYOUT' ) );
				$layouts[] = JHTML::_('select.option', '1', JText::_( 'RSE_DEFAULT_CUSTOM_LAYOUT' ) );
				$layouts[] = JHTML::_('select.option', '2', JText::_( 'RSE_TABLE_LAYOUT' ) );
				$layouts[] = JHTML::_('select.option', '3', JText::_( 'RSE_TABLE_CUSTOM_LAYOUT' ) );
				
				jimport('joomla.utilities.simplexml');
				$files = JFolder::folders(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'designs','intro');
				
				if (!empty($files))
					foreach ($files as $file)
					{						
						$file = str_replace('intro_','',$file);
						
						$xml = new JSimpleXML;
						$xml->loadFile(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'designs'.DS.'intro_'.$file.DS.$file.'.xml');
						$name = $xml->document->attributes('name');
						$type = $xml->document->attributes('type');
						
						$layouts[] = JHTML::_('select.option', $file , $name. ' ('.$type.')' );
					}
				
				$lists['layout'] = JHTML::_('select.genericlist', $layouts, 'rseventsConfig[events.layout]', 'onchange="changeLayout(this.value);" size="1" class="inputbox"', 'value', 'text', $data['events.layout'] );
			
				$pieces = array(16=>16,17=>17,18=>18);				
				if (file_exists(JPATH_SITE.DS.'components'.DS.'com_rsform'.DS.'rsform.php'))
				{
					$db->setQuery("SELECT DISTINCT f.FormId ,f.FormName FROM #__rsform_forms f WHERE f.Published = 1 ORDER BY FormId DESC");
					$forms = $db->loadObjectList();
				}
				
				$flist[]         = JHTML::_('select.option',  '0', JText::_( 'RSE_DEFAULT_FORM' ), 'FormId', 'FormName' );
				
				if (file_exists(JPATH_SITE.DS.'components'.DS.'com_rsform'.DS.'rsform.php'))
				{
					if(!empty($forms))
					foreach($forms as $i=>$form)
					{
						//Check what items does it have
						$db->setQuery("SELECT COUNT(*) Cnt FROM #__rsform_components WHERE FormId = '".$form->FormId."' AND Published=1 AND ComponentTypeId IN ('".implode("','",$pieces)."')");
						
						if(count($pieces)!=$db->loadResult()) 
						{
							$forms[$i]->disable = true;
							$forms[$i]->FormName .= ' ('.JText::_('RSE_ADD_RSEVENTS_COMPONENTS').')';
						}
						
					}
					
					if(!empty($forms))
					$flist = array_merge($flist , $forms);
				}
				
				$lists['forms']      = JHTML::_('select.genericlist', $flist, 'rseventsConfig[event.registration.form]', 'class="inputbox" size="1"','FormId', 'FormName', $data['event.registration.form'] );
				
				$db->setQuery("SELECT IdLocation, LocationName FROM #__rsevents_locations");
				$loclist[]         		= JHTML::_('select.option',  '0', JText::_( 'RSE_GOOGLE_LOCATION_DEFAULT' ), 'IdLocation', 'LocationName' );
				$loclist         		= array_merge( $loclist, $db->loadObjectList() );
				$lists['locations'] = JHTML::_('select.genericlist', $loclist, 'rseventsConfig[google.location]', 'class="inputbox" size="1"','IdLocation', 'LocationName', $data['google.location']);
				$lists['flocations'] = JHTML::_('select.genericlist', $loclist, 'rseventsConfig[facebook.location]', 'class="inputbox" size="1"','IdLocation', 'LocationName', $data['facebook.location']);
				
				$db->setQuery("SELECT IdCategory, CategoryName  FROM #__rsevents_categories");
				$cats 					= $db->loadObjectList();
				$lists['categories']    = JHTML::_('select.genericlist', $cats, 'rseventsConfig[google.category]', 'class="inputbox" size="1"','IdCategory', 'CategoryName', $data['google.category'] );
				$lists['fcategories']    = JHTML::_('select.genericlist', $cats, 'rseventsConfig[facebook.category]', 'class="inputbox" size="1"','IdCategory', 'CategoryName', $data['facebook.category'] );
				
				
				
				$this->assignRef('commentoptions',$commentoptions);
				$this->assignRef('lists',$lists);
				$this->assignRef('data',$data);
				$this->assignRef('tabs',$tabs);
				$this->assignRef('editor',$editor);

			} break;	
		}
		parent::display($tpl);
	}
}