<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' ); 
jimport( 'joomla.application.component.view');
jimport( 'joomla.html.parameter');

class rseventsViewSubscriptions extends JView
{
	function display($tpl = null)
	{		
		JSubMenuHelper::addEntry(JText::_('RSE_OVERVIEW'), 'index.php?option=com_rsevents'); 
		JSubMenuHelper::addEntry(JText::_('RSE_EVENT_MANAGER'), 'index.php?option=com_rsevents&task=listevents'); 
		JSubMenuHelper::addEntry(JText::_('RSE_ARCHIVE'), 'index.php?option=com_rsevents&task=archive');
		JSubMenuHelper::addEntry(JText::_('RSE_SUBSCRIPTION_MANAGER'), 'index.php?option=com_rsevents&task=listsubscriptions',true);
		JSubMenuHelper::addEntry(JText::_('RSE_CATEGORIES'), 'index.php?option=com_rsevents&task=listcategories');
		JSubMenuHelper::addEntry(JText::_('RSE_LOCATIONS'), 'index.php?option=com_rsevents&task=listlocations');
		JSubMenuHelper::addEntry(JText::_('RSE_THEMES'), 'index.php?option=com_rsevents&task=themes');
		JSubMenuHelper::addEntry(JText::_('RSE_DESIGNS'), 'index.php?option=com_rsevents&task=listdesigns');
		JSubMenuHelper::addEntry(JText::_('RSE_GROUPS'), 'index.php?option=com_rsevents&task=listgroups');
		JSubMenuHelper::addEntry(JText::_('RSE_IMPORT'), 'index.php?option=com_rsevents&task=import');
		JSubMenuHelper::addEntry(JText::_('RSE_PAYMENTS'), 'index.php?option=com_rsevents&task=payments');
		JSubMenuHelper::addEntry(JText::_('RSE_SETTINGS'), 'index.php?option=com_rsevents&task=editsettings');
		JSubMenuHelper::addEntry(JText::_('RSE_UPDATES'), 'index.php?option=com_rsevents&task=update');
		
		$app	=& JFactory::getApplication();
		$db		= & JFactory::getDBO();
		$task	= JRequest::getCmd('task','','request');
		
		//get config data
		$rseventsConfig = rseventsHelper::getConfig();
		$this->assignRef('rseventsConfig',$rseventsConfig);
		
		switch($task)
		{
			case 'listsubscriptions':
			{
				JHTML::_('behavior.modal');
				
				JToolBarHelper::title(JText::_('RSE_LIST_SUBSCRIPTION'),'generic.png');
				JToolBarHelper::addNewX('editsubscription');
				JToolBarHelper::editListX('editsubscription');
				JToolBarHelper::deleteList();
				JToolBarHelper::custom('accepted','apply.png','apply_f2.png',JText::_('RSE_SUBSCRIBER_ACCEPTED'));
				JToolBarHelper::custom('pending','default.png','default_f2.png',JText::_('RSE_SUBSCRIBER_PENDING'));
				JToolBarHelper::custom('denied','cancel.png','cancel_f2.png',JText::_('RSE_SUBSCRIBER_DENIED'));
				JToolBarHelper::custom('main','preview.png','preview_f2.png',JText::_('RSE_RS_PRODUCT'),false);
				
				//get filters
				$event_filter		= $app->getUserState('com_rsevents.subscriptions.rs_evn_filter');
				$ticket_filter		= JRequest::getVar('ticket_filter');
				$state_filter		= JRequest::getVar('state_filter');
				$archive_filter		= JRequest::getVar('archive_filter',0);
				$filter				= $app->getUserState('com_rsevents.events.subscriptions');
				$sortColumn			= JRequest::getVar('filter_order','s.SubscriptionDate');
				$sortOrder			= JRequest::getVar('filter_order_Dir','desc');
				
				//create the events filter
				$db->setQuery("SELECT IdEvent, EventName  FROM #__rsevents_events");
				$eventlist[]		= JHTML::_('select.option',  '0', JText::_( 'RSE_SUBSCRIBER_SELECT_EVENT' ),'IdEvent','EventName');
				$eventlist			= array_merge($eventlist, $db->loadObjectList());
				$lists['events']	= JHTML::_('select.genericlist', $eventlist, 'rs_evn_filter', 'class="inputbox" size="1" onchange="submitbutton(\'listsubscriptions\');"','IdEvent','EventName', $event_filter  );
				
				//create the tickets filter
				$db->setQuery("SELECT IdTicket, TicketName  FROM #__rsevents_tickets WHERE IdEvent='".$event_filter."'");
				$ticketlist[]		= JHTML::_('select.option','0',JText::_( 'RSE_SUBSCRIBER_SELECT_TICKET' ),'IdTicket','TicketName' );
				$ticketlist         = array_merge($ticketlist, $db->loadObjectList());
				$lists['tickets']   = JHTML::_('select.genericlist', $ticketlist, 'ticket_filter', 'class="inputbox" size="1" onchange="submitbutton(\'listsubscriptions\');"','IdTicket', 'TicketName',$ticket_filter);
				
				//create the state filter
				$state[]			= JHTML::_('select.option',  '', JText::_( 'RSE_SUBSCRIBER_SELECT_STATE' ), 'value', 'text' );
				$state[]			= JHTML::_('select.option',  '-1', JText::_( 'RSE_SUBSCRIBER_DENIED' ), 'value', 'text' );
				$state[]			= JHTML::_('select.option',  '0', JText::_( 'RSE_SUBSCRIBER_PENDING' ), 'value', 'text' );
				$state[]			= JHTML::_('select.option',  '1', JText::_( 'RSE_SUBSCRIBER_ACCEPTED' ), 'value', 'text' );
				$lists['state']		= JHTML::_('select.genericlist', $state, 'state_filter', 'class="inputbox" size="1" onchange="submitbutton(\'listsubscriptions\');"','value', 'text' , $state_filter);
				
				$archive[]  = JHTML::_('select.option',  '0', JText::_( 'RSE_ALL_EVENTS' ), 'value', 'text' );
				$archive[]  = JHTML::_('select.option',  '1', JText::_( 'RSE_ARCHIVE_EVENTS' ), 'value', 'text' );
				$archive[]  = JHTML::_('select.option',  '2', JText::_( 'RSE_CURRENT_EVENTS' ), 'value', 'text' );
				$lists['archive'] = JHTML::_('select.genericlist', $archive, 'archive_filter', 'class="inputbox" size="1" onchange="submitbutton(\'listsubscriptions\');"','value', 'text' , $archive_filter);
				
				//get data
				$subscribers		= $this->get('data');
				$pagination			= $this->get('pagination');
				
				$this->assignRef('data',$subscribers);
				$this->assignRef('filter',$filter);
				$this->assignRef('event_filter',$event_filter);
				$this->assignRef('lists', $lists);
				$this->assignRef('sortColumn',$sortColumn);
				$this->assignRef('sortOrder',$sortOrder);
				$this->assignRef('pagination',$pagination);
			} break;
			
			case 'editsubscription':
			{
				JHTML::_('behavior.modal');
				$cid = JRequest::getVar('cid',array(0),'request','array');
				if(is_array($cid)) $cid=intval($cid[0]);
				
				if($cid==0) 
					JToolBarHelper::title(JText::_('RSE_SUBSCRIBER_NEW','generic.png')); 
				else 
					JToolBarHelper::title(JText::_('RSE_SUBSCRIBER_EDIT','generic.png'));
				JToolBarHelper::save();
				JToolBarHelper::apply();
				JToolBarHelper::cancel();
				
				//get data
				$subscription		= $this->get('Subscription');
				
				//get the status list
				$slist[]			= JHTML::_('select.option',  '1', JText::_( 'RSE_SUBSCRIBER_ACCEPTED' ), 'value', 'text' );
				$slist[]        	= JHTML::_('select.option',  '0', JText::_( 'RSE_SUBSCRIBER_PENDING' ), 'value', 'text' );
				$slist[]        	= JHTML::_('select.option',  '-1', JText::_( 'RSE_SUBSCRIBER_DENIED' ), 'value', 'text' );
				$lists['status']    = JHTML::_('select.genericlist', $slist, 'SubscriptionState', 'class="inputbox" size="1"','value', 'text', intval( $subscription->SubscriptionState ));

				//set the events-tickets dropdown
				$db->setQuery("SELECT IdEvent, EventName FROM #__rsevents_events WHERE EventEnableRegistration='1'");
				$events = $db->loadObjectList();
				
				$eventlist[]         = JHTML::_('select.option',  '0', JText::_( 'RSE_SUBSCRIBER_SELECT_TICKET' ), 'IdEvent', 'EventName' );
				foreach($events as $event)
				{
					$eventlist[]         = JHTML::_('select.optgroup', $this->escape($event->EventName), 'IdEvent', 'EventName' );
					$db->setQuery("SELECT IdTicket,TicketName ,TicketPrice FROM #__rsevents_tickets WHERE IdEvent=".$event->IdEvent);
					$tickets = $db->loadObjectList();
					
					foreach($tickets as $ticket)
						$eventlist[] = JHTML::_('select.option' , $ticket->IdTicket,$this->escape($ticket->TicketName) . ' (' . number_format($ticket->TicketPrice,$rseventsConfig['payment.nrdecimals'], $rseventsConfig['payment.decimal'], $rseventsConfig['payment.thousands']).' '.$rseventsConfig['payment.currency'].')', 'IdEvent','EventName' );
				}
				
				$lists['events']    = JHTML::_('select.genericlist', $eventlist, 'IdTicket', 'class="inputbox" size="1"','IdEvent', 'EventName', empty($subscription->IdTicket) ? '' : intval($subscription->IdTicket)  );

				
				
				$this->assignRef('lists',$lists);
				$this->assignRef('data',$subscription);
				
			} break;
			
			case 'showtransaction':
			{
				//load the RSForm! Pro files
				if(file_exists(JPATH_SITE.DS.'components'.DS.'com_rsform'.DS.'rsform.php'))
					require_once(JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_rsform'.DS.'helpers'.DS.'rsform.php');
				
				$cid = JRequest::getInt('cid',0,'request');
				
				//get the subscription
				$db->setQuery("SELECT IdSubscription, IdEvent, SubscriptionVerification, TransactionGateway, TransactionParams, SubscriptionFormId, Discount, early_fee, late_fee, tax FROM #__rsevents_subscriptions WHERE IdSubscription = ".$cid." ");
				$subscription = $db->loadObject();
				
				if($subscription->TransactionGateway == 'paypal')
				{
					if (!empty($subscription->TransactionParams))
					{
						$paypal = new JParameter($subscription->TransactionParams);
						$TD = $this->parseParams($paypal);
					} else $TD = '';
				}
				
				//get extra fields when using rsform forms
				$db->setQuery("SELECT EventRegistrationForm FROM #__rsevents_events WHERE IdEvent = '".$subscription->IdEvent."'");
				$formid = $db->loadResult();
				
				if($formid != 0)
				{
					//here we will get the extra fields
					if($subscription->SubscriptionFormId != 0 && $formid != 0)
					{
						$where = " WHERE sv.FormId = '".$formid."' AND sv.SubmissionId = '".$subscription->SubscriptionFormId."'";
						$db->setQuery("SELECT DISTINCT sv.FieldName , sv.FieldValue FROM #__rsform_submission_values sv LEFT JOIN #__rsform_submissions s ON s.FormId=sv.FormId ".$where);
						$res = $db->loadObjectList();
					}
					
					$fields = array();
					if(!empty($res))
					foreach ($res as $row)
					{
						if (strpos($row->FieldValue,JPATH_SITE) !== FALSE)
							$row->FieldValue = str_replace(array(JPATH_SITE,DS),array(substr(JURI::root(),0,-1),'/'),$row->FieldValue);
						$fields[$row->FieldName] = $row->FieldValue;
					}
					unset($fields['RSEventsFirstName'],$fields['RSEventsLastName'],$fields['RSEventsEmail'],$fields['RSEventsTickets'],$fields['RSEventsPayment'] ,$fields['formId']);
					
					$captions = array();
					foreach ($fields as $fieldname => $fieldvalue)
						$captions[$fieldname] = rseventsViewSubscriptions::RSFPgetName($fieldname);
					
				}
				
				if (rseventsHelper::is16())
					$db->setQuery("SELECT `extension_id` FROM `#__extensions` WHERE `type` = 'plugin' AND `element` = 'rsepdf' AND `folder` = 'system' AND `enabled` = 1");
				else
					$db->setQuery("SELECT `id` FROM `#__plugins` WHERE `element` = 'rsepdf' AND `folder` = 'system' AND `published` = 1");
				$isPdf = $db->loadResult();
				
				if ($isPdf)
				{
					require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'pdf'.DS.'barcodes.php');
					$barcode = new TCPDFBarcode('RSET-'.$subscription->IdSubscription,$rseventsConfig['barcode']);
					$barcodeHTML = $barcode->getBarcodeSVGcode();
					$this->assignRef('barcode',$barcodeHTML);
				}
				
				
				$db->setQuery("SELECT t.TicketPrice, st.TicketsSubscribed FROM #__rsevents_subscription_tickets st LEFT JOIN #__rsevents_tickets t ON t.IdTicket = st.IdTicket WHERE st.IdSubscription = '".$subscription->IdSubscription."' ");
				$tickets = $db->loadObjectList();
				
				$this->assignRef('TD',$TD);
				$this->assignRef('ispdf',$isPdf);
				$this->assignRef('fields',$fields);
				$this->assignRef('captions',$captions);
				$this->assignRef('gateway',$subscription->TransactionGateway);
				$this->assignRef('data',$subscription);
				$this->assignRef('tickets',$tickets);
				$this->assignRef('card',$this->get('card'));
			}
			break;
			
			case 'log':
				$this->assignRef('log',$this->get('log'));
			break;
		}
		
		
		parent::display($tpl);
	}
	
	function RSFPgetName($fieldname)
	{
		$db = JFactory::getDBO();
		
		$db->setQuery("SELECT ComponentId FROM #__rsform_properties WHERE PropertyName='NAME' AND PropertyValue='".$db->getEscaped($fieldname)."'");
		$db->setQuery("SELECT PropertyValue FROM #__rsform_properties WHERE PropertyName='CAPTION' AND ComponentId='".$db->loadResult()."'");
		$caption = $db->loadResult();
		
		return $caption;
	}
	
	function getTickets($id)
	{
		$db =& JFactory::getDBO();
		
		$db->setQuery("SELECT st.TicketsSubscribed, t.TicketName FROM #__rsevents_subscription_tickets st LEFT JOIN #__rsevents_tickets t ON t.IdTicket = st.IdTicket WHERE st.IdSubscription = ".(int) $id." ");
		return $db->loadObjectList();
	}
	
	function parseParams($params)
	{
		$transactionDetails = array();
		$transactionDetails['TransactionTitle'] = $params->get('item_name','') . ' - ' . $params->get('mc_gross','') . ' ' . $params->get('mc_currency','');
		$transactionDetails['TransactionCustomer'] = $params->get('first_name','') . ' ' . $params->get('last_name','');
		$transactionDetails['TransactionEmail'] = $params->get('payer_email','');
		$transactionDetails['TransactionAddressStreet'] = $params->get('address_street','');
		$transactionDetails['TransactionAddress'] = $params->get('address_city','').', '.$params->get('address_state','').', '.$params->get('address_country','');
		$transactionDetails['TransactionItem'] = $params->get('item_name','');
		$transactionDetails['TransactionItemPrice'] = $params->get('mc_gross','') . ' ' . $params->get('mc_currency','');
		$transactionDetails['TransactionDate'] = $params->get('payment_date','');
		$transactionDetails['TransactionGateway'] = 'Paypal';
		
		return $transactionDetails;
	}
	
}