<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' ); 
jimport( 'joomla.application.component.view');

class rseventsViewThemes extends JView
{
	function display($tpl = null)
	{
		$task = JRequest::getVar('task','','request');
		JHTML::_('behavior.tooltip');
		$app =& JFactory::getApplication();
		
		JSubMenuHelper::addEntry(JText::_('RSE_OVERVIEW'), 'index.php?option=com_rsevents'); 
		JSubMenuHelper::addEntry(JText::_('RSE_EVENT_MANAGER'), 'index.php?option=com_rsevents&task=listevents'); 
		JSubMenuHelper::addEntry(JText::_('RSE_ARCHIVE'), 'index.php?option=com_rsevents&task=archive');
		JSubMenuHelper::addEntry(JText::_('RSE_SUBSCRIPTION_MANAGER'), 'index.php?option=com_rsevents&task=listsubscriptions');
		JSubMenuHelper::addEntry(JText::_('RSE_CATEGORIES'), 'index.php?option=com_rsevents&task=listcategories');
		JSubMenuHelper::addEntry(JText::_('RSE_LOCATIONS'), 'index.php?option=com_rsevents&task=listlocations');
		JSubMenuHelper::addEntry(JText::_('RSE_THEMES'), 'index.php?option=com_rsevents&task=themes',true);
		JSubMenuHelper::addEntry(JText::_('RSE_DESIGNS'), 'index.php?option=com_rsevents&task=listdesigns');
		JSubMenuHelper::addEntry(JText::_('RSE_GROUPS'), 'index.php?option=com_rsevents&task=listgroups');
		JSubMenuHelper::addEntry(JText::_('RSE_IMPORT'), 'index.php?option=com_rsevents&task=import');
		JSubMenuHelper::addEntry(JText::_('RSE_PAYMENTS'), 'index.php?option=com_rsevents&task=payments');
		JSubMenuHelper::addEntry(JText::_('RSE_SETTINGS'), 'index.php?option=com_rsevents&task=editsettings');
		JSubMenuHelper::addEntry(JText::_('RSE_UPDATES'), 'index.php?option=com_rsevents&task=update');
		
		switch($task)
		{
			case 'themes':
			{
				JToolBarHelper::title(JText::_('RSE_THEMES_LIST'),'generic.png');
				JToolBarHelper::addNewX('edittheme');
				JToolBarHelper::makeDefault('makeDefault');
				JToolBarHelper::deleteList(JText::_('RSE_DESIGN_DELETE_CONFIRM'), 'remove' , "Delete");
				JToolBarHelper::custom('main','preview.png','preview_f2.png',JText::_('RSE_RS_PRODUCT'),false);
				
				//get data
				$themes			= $this->get('data');
				$pagination		= $this->get('pagination');
				$filter			= $app->getUserState('com_rsevents.events.themes');
				$sortColumn		= JRequest::getVar('filter_order','name');
				$sortOrder		= JRequest::getVar('filter_order_Dir','asc');
				
				//assign values
				$this->assignRef('filter',$filter);
				$this->assignRef('sortColumn',$sortColumn);
				$this->assignRef('sortOrder',$sortOrder);
				$this->assignRef('data',$themes);
				$this->assignRef('pagination',$pagination);
				$this->assignRef('filter',$filter);
				$this->assignRef('sortColumn',$sortColumn);
				$this->assignRef('sortOrder',$sortOrder);

			} break;
			
			
			case 'edittheme':
				JToolBarHelper::title(JText::_('RSE_THEME_EDIT'),'generic.png');
				JToolBarHelper::save();
				JToolBarHelper::apply();
				JToolBarHelper::cancel();
				
				$doc =& JFactory::getDocument();
				$doc->addScript(JURI::root(true).'/administrator/components/com_rsevents/assets/js/jquery-1.4.4.min.js');
				$doc->addScript(JURI::root(true).'/administrator/components/com_rsevents/assets/js/jquery-ui-1.8.10.custom.min.js');
				$doc->addScriptDeclaration('jQuery.noConflict();');
				
				//get theme details
				$theme = $this->get('Theme');
				$this->assignRef('data',$theme);
				
				//config
				$config = rseventsHelper::getConfig();
				
				$jcomment 	= file_exists(JPATH_SITE.DS.'components'.DS.'com_jcomments'.DS.'jcomments.php');
				$jomcomment = file_exists(JPATH_SITE.DS.'plugins'.DS.'content'.DS.'jom_comment_bot.php');
				$rscomments = file_exists(JPATH_SITE.DS.'components'.DS.'com_rscomments'.DS.'helpers'.DS.'rscomments.php');
				$comments = $jcomment || $jomcomment || $rscomments;
				
				//create the placeholders list
				$plist[] 	= JHTML::_('select.optgroup', JText::_('RSE_PL_EVENT_DETAILS'));
				$plist[]	= JHTML::_('select.option',  '1', JText::_( 'RSE_PL_EVENTNAME' ));
				$plist[]	= JHTML::_('select.option',  '2', JText::_( 'RSE_PL_EVENTURL' ));
				$plist[]	= JHTML::_('select.option',  '3', JText::_( 'RSE_PL_EVENTSUBTITLE' ));
				$plist[]	= JHTML::_('select.option',  '4', JText::_( 'RSE_PL_EVENTHOST' ));
				$plist[]	= JHTML::_('select.option',  '5', JText::_( 'RSE_PL_EVENTOWNER' ));
				$plist[]	= JHTML::_('select.option',  '6', JText::_( 'RSE_PL_EVENTSTARTDATE' ));
				$plist[]	= JHTML::_('select.option',  '7', JText::_( 'RSE_PL_EVENTSTARTDATEONLY' ));
				$plist[]	= JHTML::_('select.option',  '8', JText::_( 'RSE_PL_EVENTSTARTTIME' ));
				$plist[]	= JHTML::_('select.option',  '9', JText::_( 'RSE_PL_EVENTENDDATE' ));
				$plist[]	= JHTML::_('select.option',  '10', JText::_( 'RSE_PL_EVENTENDDATEONLY' ));
				$plist[]	= JHTML::_('select.option',  '11', JText::_( 'RSE_PL_EVENTENDTIME' ));
				$plist[]	= JHTML::_('select.option',  '12', JText::_( 'RSE_PL_EVENTDESCRIPTION' ));
				$plist[]	= JHTML::_('select.option',  '13', JText::_( 'RSE_PL_EVENTPHONE' ));
				$plist[]	= JHTML::_('select.option',  '14', JText::_( 'RSE_PL_EVENTEMAIL' ));
				$plist[]	= JHTML::_('select.option',  '36', JText::_( 'RSE_PL_EVENTLINK' ));
				$plist[]	= JHTML::_('select.option',  '15', JText::_( 'RSE_PL_EVENTICON' ));
				$plist[]	= JHTML::_('select.option',  '16', JText::_( 'RSE_PL_EVENTICONSMALL' ));
				$plist[]	= JHTML::_('select.option',  '17', JText::_( 'RSE_PL_EVENTICONBIG' ));
				$plist[] 	= JHTML::_('select.optgroup', JText::_('RSE_PL_LOCATION_DETAILS'));
				$plist[]	= JHTML::_('select.option',  '18', JText::_( 'RSE_PL_LOCATIONNAME' ));
				$plist[]	= JHTML::_('select.option',  '19', JText::_( 'RSE_PL_LOCATIONURL' ));
				$plist[]	= JHTML::_('select.option',  '20', JText::_( 'RSE_PL_LOCATIONADDRESS' ));
				$plist[]	= JHTML::_('select.option',  '21', JText::_( 'RSE_PL_LOCATIONCITY' ));
				$plist[]	= JHTML::_('select.option',  '22', JText::_( 'RSE_PL_LOCATIONSTATE' ));
				$plist[]	= JHTML::_('select.option',  '23', JText::_( 'RSE_PL_LOCATIONDESCRIPTION' ));
				$plist[]	= JHTML::_('select.option',  '39', JText::_( 'RSE_PL_LOCATIONZIP' ));
				$plist[]	= JHTML::_('select.option',  '40', JText::_( 'RSE_PL_LOCATIONCOUNTRY' ));
				$plist[] 	= JHTML::_('select.optgroup', JText::_('RSE_PL_EXTRA_DETAILS'));
				$plist[]	= JHTML::_('select.option',  '24', JText::_( 'RSE_PL_TICKETSAVAILABLE' ));
				$plist[]	= JHTML::_('select.option',  '25', JText::_( 'RSE_PL_EVENTSHARING' ));
				$plist[]	= JHTML::_('select.option',  '26', JText::_( 'RSE_PL_EVENTFILES' ));
				$plist[]	= JHTML::_('select.option',  '27', JText::_( 'RSE_PL_EVENTYOUTUBE' ));
				$plist[]	= JHTML::_('select.option',  '28', JText::_( 'RSE_PL_EVENTMP3' ));
				$plist[]	= JHTML::_('select.option',  '29', JText::_( 'RSE_PL_EVENTFLASH' ));
				$plist[]	= JHTML::_('select.option',  '30', JText::_( 'RSE_PL_EVENTMEEBO' ));
				$plist[]	= JHTML::_('select.option',  '31', JText::_( 'RSE_PL_GOOGLEMAP' ));
				$plist[]	= JHTML::_('select.option',  '32', JText::_( 'RSE_PL_EVENTPHOTOS' ));
				$plist[]	= JHTML::_('select.option',  '34', JText::_( 'RSE_PL_EVENTRATING' ));
				$plist[]	= JHTML::_('select.option',  '35', JText::_( 'RSE_PL_EVENTGUESTS' ));
				
				if ($comments || $config['events.commenting'] == '4')
					$plist[]	= JHTML::_('select.option',  '33', JText::_( 'RSE_PL_EVENTCOMMENTS' ));
				
				$plist[] 	= JHTML::_('select.optgroup', JText::_('RSE_PL_MENUS'));
				$plist[]	= JHTML::_('select.option',  '37', JText::_( 'RSE_PL_GUESTMENU' ));
				$plist[]	= JHTML::_('select.option',  '38', JText::_( 'RSE_PL_HOSTMENU' ));
				
				$placeholders = JHTML::_('select.genericlist', $plist, 'placeholders', 'class="inputbox" size="1"','value', 'text');
				$this->assignRef('placeholders',$placeholders);
			break;
			
		}
		parent::display($tpl);
	}
	
	function getPlaceholders($column,$id)
	{
		$db =& JFactory::getDBO();
		
		$db->setQuery("SELECT `position` , `placeholder` , `block` FROM `#__rsevents_themes_position` WHERE `column` = '".$db->getEscaped($column)."' AND `id` = '".$db->getEscaped($id)."' ORDER BY `position` ASC ");
		$placeholders = $db->loadObjectList();
		
		return $placeholders;
	}
	
}