<?php
/**
* @version 1.0.0
* @package RSEvents! 1.0.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

// no direct access
defined('_JEXEC') or die('Restricted access');
jimport('joomla.filesystem.file');

class modRseventsHelper
{

	/**
	 * Method to get the events
	 *
	 * @access public
	 * @return array
	 */
	function getList(&$params)
	{
		$db			=& JFactory::getDBO();
		
		//check for rsevents
		if(file_exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'rsevents.php'))
		{
			require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'events.php');
			require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'rsevents.php');
		} else return;
		
		//get config
		$db->setQuery("SELECT * FROM `#__rsevents_config`");
		$rseventsConfigDb = $db->loadObjectList();
		foreach ($rseventsConfigDb as $objConfig)
			$rseventsConfig[$objConfig->ConfigName] = $objConfig->ConfigValue;
		
		$where = "";
		
		//get parameters
		$current_time	= time();
		$locationIds	= $params->get('locids','');
		$categoryIds = $params->get('catids','');
		$repeatingEvents = $params->get('repeatevents','0');
		$itid			= $params->get('itemid','');
		$limit		 = (int)$params->get('evnumber');
		if($limit == 0) $limit= 1000000;
		$ordering = $params->get('ordering','0');
		$order = ($ordering == 0) ? 'DESC' : 'ASC';
		$target = ($params->get('target','0') == 0) ? '_blank' : '_self';
		$todayevents = $params->get('today','1');
		$tday = mktime(0,0,0,date('n'),date('j'),date('Y'));
		
		if(is_array($locationIds)) $locids = implode(',', $locationIds); else $locids = $locationIds;
		if(is_array($categoryIds)) $catids = implode(',', $categoryIds); else $catids = $categoryIds;
		
		$where_active_today = " ((e.EventStartDate <= '".$tday."' AND e.EventEndDate >= '".$tday."') OR (e.EventStartDate >= '".$tday."' AND e.EventStartDate <= '".($tday+86400)."')) ";
		$where_upcoming		= " e.EventStartDate >= '".$current_time."' ";
		if ($todayevents == 1) // active today + upcoming
			$where .= " AND (($where_active_today) OR ($where_upcoming))";
		elseif ($todayevents == 2) // upcoming
			$where .= " AND $where_upcoming";
		elseif ($todayevents == 0) // active today
			$where .= " AND $where_active_today";
		
		if(!empty($locationIds))
			$where .= " AND l.IdLocation IN (".$locids.") ";
		if(!empty($categoryIds))
			$where .= " AND c.IdCategory IN (".$catids.") ";
			
			$where .= " AND e.published = 1 AND e.EventType = 1 ";
		
		if($repeatingEvents == 1 ) $where .= " AND e.IdParent = 0 ";
			else $where .= "";
		
		$query = "SELECT e.IdEvent , e.EventName ,e.EventEnableRegistration, l.IdLocation , l.LocationName , e.EventStartDate , e.EventEndDate , e.EventIcon ,  c.IdCategory , c.CategoryName FROM #__rsevents_events e "
				." LEFT JOIN #__rsevents_locations l ON e.IdLocation=l.IdLocation LEFT JOIN #__rsevents_events_cat ec ON ec.IdEvent = e.IdEvent LEFT JOIN #__rsevents_categories c ON c.IdCategory = ec.IdCategory WHERE 1=1 ".$where." GROUP BY e.IdEvent ORDER BY e.EventStartDate ".$order." LIMIT ".$limit;
		
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		
		
		$Itemid = JRequest::getInt('Itemid','','request');
		if(!empty($Itemid))
		{
			if($itid == '' || empty($itid)) $itemId =  '&Itemid='.$Itemid;
				else $itemId = '&Itemid='.$itid;
		} else $itemId='';
		
		$i		= 0;
		$lists	= array();
		if(!empty($rows))
		foreach ( $rows as $row )
		{
			$categnames = array();
			$layout = $params->get('layout','{EventName} - {EventLocation}');
			$eventlink = JRoute::_('index.php?option=com_rsevents&view=events&layout=show&cid='.eventsHelper::sef($row->IdEvent,$row->EventName).$itemId,false);
			
			
			if($rseventsConfig['enable.event.icon'] == 1 && $row->EventIcon != '')
				$eventIcon = '<img src="'.JURI::root().'components/com_rsevents/assets/images/thumbs/'.str_replace('.'.JFile::getExt($row->EventIcon),'_'.$rseventsConfig['event.icon.small'].'.'.JFile::getExt($row->EventIcon),$row->EventIcon).'" />';
			 else $eventIcon = '';
			
			$db->setQuery("SELECT c.CategoryName , c.IdCategory FROM #__rsevents_categories c LEFT JOIN #__rsevents_events_cat ec ON ec.IdCategory = c.IdCategory WHERE ec.IdEvent =".$row->IdEvent);
			$categs = $db->loadObjectList();
			foreach($categs as $categ)
				$categnames[] = '<a target="'.$target.'" href="'.JRoute::_('index.php?option=com_rsevents&view=events&layout=listcategoryevents&cid='.$categ->IdCategory.$itemId,false).'">'.$categ->CategoryName.'</a>';
			
			$categnames = implode(',',$categnames);
			
			if($row->EventEnableRegistration == 1)
			$eventsubscribe = '<a href="'.JRoute::_('index.php?option=com_rsevents&view=events&layout=subscribe&cid='.$row->IdEvent.$itemId,false).'">'.JText::_('RSE_MENU_EVENT_SUBSCRIBE').'</a>';
			else
				$eventsubscribe = '';
			
			$row->EventName = htmlspecialchars( $row->EventName, ENT_COMPAT, 'UTF-8');
			$locationlink = JRoute::_('index.php?option=com_rsevents&view=locations&layout=show&cid='.eventsHelper::sef($row->IdLocation,$row->LocationName).'&IdEvent='.eventsHelper::sef($row->IdEvent,$row->EventName).$itemId,false);
			$row->EventName = '<a target="'.$target.'" href="'.$eventlink.'">'.$row->EventName.'</a>';
			$row->CategoryName = $categnames;
			$row->LocationName = '<a target="'.$target.'" href="'.$locationlink.'">'.$row->LocationName.'</a>';
			$row->EventStartDate = rseventsHelper::translateDate(date($rseventsConfig['global.dateformat'],$row->EventStartDate)); 
			$row->EventEndDate   = rseventsHelper::translateDate(date($rseventsConfig['global.dateformat'],$row->EventEndDate));
			
			$bad  = array('{EventName}','{EventLocation}','{EventCategory}','{EventStartDate}','{EventEndDate}','{EventIcon}','{EventSubscribe}','{EventHref}');
			$good = array($row->EventName , $row->LocationName , $row->CategoryName , $row->EventStartDate , $row->EventEndDate, $eventIcon,$eventsubscribe,$eventlink);
			
			$layout = str_replace($bad,$good,$layout);
			
			if (file_exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'emails.php'))
			{
				require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'emails.php');
				$layout = rseventsEmails::placeholders($layout,$row->IdEvent);
			}
			
			$lists[$i]->layout = $layout;

			$i++;
		}
		

		return $lists;
		
		
	}
}