<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2011 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');
jimport('joomla.filesystem.file');
require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'rsevents.php');


class modRseventsSliderHelper
{
	/**
	 * Method to get the events
	 *
	 * @access public
	 * @return array
	 */
	function getConfig($param){
		$db			=& JFactory::getDBO();
		//get config
		$db->setQuery("SELECT * FROM `#__rsevents_config`");
		$rseventsConfigDb = $db->loadObjectList();
		
		foreach ($rseventsConfigDb as $objConfig)
			$rseventsConfig[$objConfig->ConfigName] = $objConfig->ConfigValue;
			if($param)
				return $rseventsConfig[$param];
			else return
				$rseventsConfig;
	}
	function getEvents(&$params)
	{
		$db					=& JFactory::getDBO();
		//params
		$theme 				= $params->get('theme','red');
		$type 				= $params->get('type','simple_vertical');
		$nr_slides 			= (int) $params->get('number_of_fields','3');
		$event_desc_length 	= (int) $params->get('event_desc_length','200');
		$categoryIds		= $params->get('catids','');
		$locationIds		= $params->get('locids','');	
		$todayevents 		= (int) $params->get('today','1');
		$itemId 			= $params->get('itemid','');
		$autoplay			= (int) $params->get('autoplay','1');
		$duration			= (int) $params->get('duration','1');
		if($duration == 0) $duration = 1;
		$text_above			= $params->get('text_above','');
		$text_below			= $params->get('text_below','');
		$tday 				= mktime(0,0,0,date('n'),date('j'),date('Y'));

		$itemId = (empty($itemId) ? '' : '&Itemid='.$itemId);

		$where = '';
		if(is_array($locationIds)) $locids = implode(',', $locationIds); else $locids = $locationIds;
		if(is_array($categoryIds)) $catids = implode(',', $categoryIds); else $catids = $categoryIds;

		if(!empty($locationIds))
			$where .= " AND l.IdLocation IN (".$locids.") ";
		if(!empty($categoryIds))
			$where .= " AND c.IdCategory IN (".$catids.") ";
		//query 

		$where_active_today = " ((e.EventStartDate <= '".$tday."' AND e.EventEndDate >= '".$tday."') OR (e.EventStartDate >= '".$tday."' AND e.EventStartDate <= '".($tday+86400)."')) ";
		$where_upcoming		= " e.EventStartDate >= '".time()."' ";
		if ($todayevents == 1) // active today + upcoming
			$where .= " AND (($where_active_today) OR ($where_upcoming))";
		elseif ($todayevents == 2) // upcoming
			$where .= " AND $where_upcoming";
		elseif ($todayevents == 0) // active today
			$where .= " AND $where_active_today";
		
		$query = "SELECT e.IdEvent , e.EventName , e.EventHost, e.EventStartDate, e.EventDescription, e.EventEndDate, e.EventIcon, l.IdLocation, l.LocationName, c.IdCategory, c.CategoryName 
					FROM #__rsevents_events e 
					LEFT JOIN #__rsevents_locations l ON e.IdLocation= l.IdLocation 
					LEFT JOIN #__rsevents_events_cat ec ON e.IdEvent = ec.IdEvent 
					LEFT JOIN #__rsevents_categories c ON ec.IdCategory = c.IdCategory
					WHERE e.published = '1' ".$where." GROUP BY e.IdEvent ORDER BY e.EventStartDate ASC ".($nr_slides > 0 ? "LIMIT ".$nr_slides : "");


		$db->setQuery($query);

		$rows = $db->loadObjectList();
		
		$i=0;
		foreach($rows as $row ){
			$introtxt = $params->get('introtxt','{EventName} - {EventLocation}');
			$eventlink = JRoute::_('index.php?option=com_rsevents&view=events&layout=show&cid='.$row->IdEvent.$itemId,false);
			$introtxt = $params->get('introtxt','{EventName} - {EventLocationName}');

			$row ->	EventStartDate 		= rseventsHelper::translateDate(date(modRseventsSliderHelper::getConfig('global.dateformat'), $row->EventStartDate));
			$row -> EventEndDate 		= rseventsHelper::translateDate(date(modRseventsSliderHelper::getConfig('global.dateformat'), $row->EventEndDate));
			$row -> LocationName	 	= '<a href="'.$eventlink.'">'.$row -> LocationName.'</a>';
			$row -> EventLink 			= $eventlink;

			$old  = array('{EventStartDate}','{EventLocationName}','{EventEndDate}', '{EventDescription}');
			$new = array($row->EventStartDate , $row->LocationName , $row->EventEndDate, substr(stripslashes(strip_tags($row->EventDescription)),0, $event_desc_length));

			$introtxt = str_replace($old,$new,$introtxt);


			$rows[$i]->IntroText = $introtxt;
			++$i;
		}
		return $rows;
	}
	
	function isJ16(){
		$jversion = new JVersion();
		$current_version =  $jversion->getShortVersion();
		return (version_compare('1.6.0', $current_version) <= 0);
	}
}