<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2010 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/


defined( '_JEXEC' ) or die( 'Restricted access' );
$db =& JFactory::getDBO();

$jversion = new JVersion();
$current_version =  $jversion->getShortVersion();
$is16 = (version_compare('1.6.0', $current_version) <= 0);

// Get a new installer
$installer = new JInstaller();

$installer->install($this->parent->getPath('source').DS.'modules'.DS.'mod_rsevents_guestmenu');
$installer->install($this->parent->getPath('source').DS.'modules'.DS.'mod_rsevents_hostmenu');

if (!$is16)
{
	$db->setQuery("SELECT id FROM #__plugins WHERE `element`='rseventswire' AND `folder`='system' LIMIT 1");
	$plg_id = $db->loadResult();
	if ($plg_id) $installer->uninstall('plugin', $plg_id);
	
	
	/* START UPDATE PROCEDURE FOR CONFIG TABLE */

	$db->setQuery("DESCRIBE `#__rsevents_config`");
	$config_table = $db->loadObjectList();
	foreach ($config_table as $config_row)
	{
		if($config_row->Field == 'IdConfig')
		{
			$db->setQuery("ALTER TABLE `#__rsevents_config` DROP `IdConfig`");
			$db->query();
			$db->setQuery("ALTER TABLE `#__rsevents_config` ADD PRIMARY KEY(`ConfigName`)");
			$db->query();
		}
	}


	/* END UPDATE PROCEDURE FOR CONFIG TABLE */


	/* START UPDATE PROCEDURE FOR EVENTS TABLE */
	$db->setQuery("DESCRIBE `#__rsevents_events`"); 
	$events_table = $db->loadObjectList();

	foreach($events_table as $event_row)
	{
		if(!($event_row->Field == 'IdParent'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `IdParent` TINYINT( 2 ) NOT NULL");
			$db->query();
		}
		
		if(!($event_row->Field == 'EventEnableRepeat'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventEnableRepeat` TINYINT( 2 ) NOT NULL");
			$db->query();
		}
		
		if(!($event_row->Field == 'EventRepeatType'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventRepeatType` TINYINT( 2 ) NOT NULL");
			$db->query();
		}
		
		if(!($event_row->Field == 'EventRepeatNumber'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventRepeatNumber` INT( 10 ) NOT NULL");
			$db->query();
		}
		
		if(!($event_row->Field == 'EventRepeatUntil'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventRepeatUntil` INT( 11 ) NOT NULL");
			$db->query();
		}
		
		if(!($event_row->Field == 'EventRepeatAlso'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventRepeatAlso` TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL");
			$db->query();
		}
		if(!($event_row->Field == 'EventRegistrationForm'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventRegistrationForm` TINYINT( 2 ) NOT NULL");
			$db->query();
		}
		if(!($event_row->Field == 'EventArchive'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventArchive` TINYINT( 2 ) NOT NULL");
			$db->query();
		}
		if(!($event_row->Field == 'EventAutoApprove'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventAutoApprove` TINYINT( 2 ) NOT NULL");
			$db->query();
		}
		if(!($event_row->Field == 'EventPaypalEmail'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventPaypalEmail` VARCHAR( 255 ) NOT NULL");
			$db->query();
		}
		if(!($event_row->Field == 'EventReturnUrl'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventReturnUrl` VARCHAR( 255 ) NOT NULL");
			$db->query();
		}
		if(!($event_row->Field == 'EventIcon'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventIcon` TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL");
			$db->query();
		}
		if(!($event_row->Field == 'EventKeywords'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventKeywords` VARCHAR( 255 ) NOT NULL");
			$db->query();
		}
		if(!($event_row->Field == 'EventMetaDescription'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventMetaDescription` VARCHAR( 255 ) NOT NULL");
			$db->query();
		}
		if(!($event_row->Field == 'EventAmPm1'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventAmPm1` INT( 1 ) NOT NULL");
			$db->query();
		}
		if(!($event_row->Field == 'EventAmPm2'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventAmPm2` INT( 1 ) NOT NULL");
			$db->query();
		}
		if(!($event_row->Field == 'EventCreation'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventCreation` INT( 15 ) NOT NULL");
			$db->query();
		}
		if(!($event_row->Field == 'EventRepeatDays'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventRepeatDays` TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL");
			$db->query();
		}
		if(!($event_row->Field == 'EventPageTitle'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventPageTitle` VARCHAR( 255 ) NOT NULL");
			$db->query();
		}
		if(!($event_row->Field == 'EventStartRegistration'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventStartRegistration` INT( 15 ) NOT NULL");
			$db->query();
		}
		if(!($event_row->Field == 'EventEndRegistration'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `EventEndRegistration` INT( 15 ) NOT NULL");
			$db->query();
		}
		if(!($event_row->Field == 'IdNewDesign'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `IdNewDesign` INT( 10 ) NOT NULL");
			$db->query();
		}
		if(!($event_row->Field == 'IdTheme'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `IdTheme` INT( 10 ) NOT NULL");
			$db->query();
		}
		if(!($event_row->Field == 'designtype'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `designtype` INT( 1 ) NOT NULL");
			$db->query();
		}
		if(!($event_row->Field == 'SubscriptionNotification'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `SubscriptionNotification` TINYINT( 1 ) NOT NULL");
			$db->query();
		}
		
		if(!($event_row->Field == 'payments'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `payments` VARCHAR( 255 ) NOT NULL");
			$db->query();
		}
		
		if(!($event_row->Field == 'early_discount_type'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `early_discount_type` TINYINT(1) NOT NULL");
			$db->query();
		}
		
		if(!($event_row->Field == 'early_discount_value'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `early_discount_value` FLOAT NOT NULL");
			$db->query();
		}
		
		if(!($event_row->Field == 'early_discount_deadline'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `early_discount_deadline` INT(11) NOT NULL");
			$db->query();
		}
		
		if(!($event_row->Field == 'late_fee_type'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `late_fee_type` TINYINT(1) NOT NULL");
			$db->query();
		}
		
		if(!($event_row->Field == 'late_fee_value'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `late_fee_value` FLOAT NOT NULL");
			$db->query();
		}
		
		if(!($event_row->Field == 'late_fee_date'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `late_fee_date` INT(11) NOT NULL");
			$db->query();
		}
		
		if(!($event_row->Field == 'ticket_pdf'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `ticket_pdf` TINYINT( 1 ) NOT NULL");
			$db->query();
		}
		
		if(!($event_row->Field == 'ticket_pdf_layout'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_events` ADD `ticket_pdf_layout` TEXT NOT NULL");
			$db->query();
		}
		
	}

	$db->setQuery("ALTER TABLE `#__rsevents_events` CHANGE `EventRegistrationForm` `EventRegistrationForm` INT( 5 ) NOT NULL");
	$db->query();
	
	$db->setQuery("UPDATE #__rsevents_events SET designtype = 1 WHERE IdDesign != 0");
	$db->query();
	
	/* END UPDATE PROCEDURE FOR EVENTS TABLE */


	/* START UPDATE PROCEDURE FOR SUBSCRIPTIONS TABLE */
	$db->setQuery("DESCRIBE `#__rsevents_subscriptions`");
	$subscriptions_table = $db->loadObjectList();

	foreach($subscriptions_table as $subscription_row)
	{
		if(!($subscription_row->Field == 'SubscriptionFormId'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_subscriptions` ADD `SubscriptionFormId` INT( 2 ) NOT NULL");
			$db->query();
		}
		if(!($subscription_row->Field == 'UserIp'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_subscriptions` ADD `UserIp` VARCHAR( 15 ) NOT NULL");
			$db->query();
		}
		if(!($subscription_row->Field == 'PaymentUrl'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_subscriptions` ADD `PaymentUrl` TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL");
			$db->query();
		}
		if(!($subscription_row->Field == 'Discount'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_subscriptions` ADD `Discount` DOUBLE NOT NULL");
			$db->query();
		}
		if ($subscription_row->Field == 'SubscriptionTotalFee')
		{
			$db->setQuery("ALTER TABLE `#__rsevents_subscriptions` DROP `SubscriptionTotalFee`");
			$db->query();
		}
		if ($subscription_row->Field == 'ValidationDate')
		{
			$db->setQuery("ALTER TABLE `#__rsevents_subscriptions` DROP `ValidationDate`");
			$db->query();
		}
		if ($subscription_row->Field == 'ConfirmationDate')
		{
			$db->setQuery("ALTER TABLE `#__rsevents_subscriptions` DROP `ConfirmationDate`");
			$db->query();
		}
		if(!($subscription_row->Field == 'early_fee'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_subscriptions` ADD `early_fee` FLOAT NOT NULL");
			$db->query();
		}
		if(!($subscription_row->Field == 'late_fee'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_subscriptions` ADD `late_fee` FLOAT NOT NULL");
			$db->query();
		}
		if(!($subscription_row->Field == 'tax'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_subscriptions` ADD `tax` FLOAT NOT NULL");
			$db->query();
		}
		if(!($subscription_row->Field == 'log'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_subscriptions` ADD `log` TEXT NOT NULL");
			$db->query();
		}
	}
	/* END UPDATE PROCEDURE FOR SUBSCRIPTIONS TABLE */

	
	/* START UPDATE PROCEDURE FOR SUBSCRIPTIONS TICKETS TABLE */
	
	$db->setQuery("ALTER TABLE #__rsevents_subscription_tickets DROP INDEX IdSubscription_2");
	$db->query();
	$db->setQuery("ALTER TABLE #__rsevents_subscription_tickets DROP INDEX IdSubscription");
	$db->query();
	$db->setQuery("ALTER TABLE #__rsevents_subscription_tickets DROP INDEX IdFee");
	$db->query();
	
	$db->setQuery("DESCRIBE `#__rsevents_subscription_tickets`");
	$subscription_tickets_table = $db->loadObjectList();
	
	foreach ($subscription_tickets_table as $subscription_ticket)
	{
		if ($subscription_ticket->Field == 'Discount')
		{
			$db->setQuery("SELECT IdSubscription, Discount FROM #__rsevents_subscription_tickets");
			$objects = $db->loadObjectList();
			
			if (!empty($objects))
				foreach ($objects as $object)
				{
					$db->setQuery("UPDATE #__rsevents_subscriptions SET Discount = '".$db->getEscaped($object->Discount)."' WHERE IdSubscription = ".(int) $object->IdSubscription." ");
					$db->query();
				}
			
			$db->setQuery("ALTER TABLE `#__rsevents_subscription_tickets` DROP `Discount`");
			$db->query();
		}
	}
	
	/* END UPDATE PROCEDURE FOR SUBSCRIPTIONS TICKETS TABLE */
	

	/* START UPDATE PROCEDURE FOR TICKETS TABLE */
	$db->setQuery("DESCRIBE `#__rsevents_tickets`");
	$tickets_table = $db->loadObjectList();

	foreach($tickets_table as $ticket_row)
	{
		if(!($ticket_row->Field == 'TicketsPerUser'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_tickets` ADD `TicketsPerUser` INT( 5 ) NOT NULL");
			$db->query();
		}
	}
	/* END UPDATE PROCEDURE FOR TICKETS TABLE */


	/* START UPDATE PROCEDURE FOR CATEGORIES TABLE */
	$db->setQuery("DESCRIBE `#__rsevents_categories`");
	$categories_table = $db->loadObjectList();

	foreach($categories_table as $cat_row)
	{
		if(!($cat_row->Field == 'parent'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_categories` ADD `parent` INT( 10 ) NOT NULL");
			$db->query();
		}
	}

	$db->setQuery("SELECT IdEvent , IdCategory FROM #__rsevents_events");
	$categories = $db->loadObjectList();

	if(!empty($categories))
	foreach($categories as $cat)
	{
		$db->setQuery("SELECT IdEventCategory FROM #__rsevents_events_cat WHERE IdEvent = '".$cat->IdEvent."' AND IdCategory = '".$cat->IdCategory."' LIMIT 1 ");
		$idevcat = $db->loadResult();
		
		if ($idevcat == 0)
		{
			$db->setQuery("INSERT INTO #__rsevents_events_cat SET IdEvent = ".$cat->IdEvent." , IdCategory =".$cat->IdCategory);
			$db->query();
		}
	}
	/* END UPDATE PROCEDURE FOR CATEGORIES TABLE */

	/* START UPDATE PROCEDURE FOR RATINGS TABLE */

	$db->setQuery("DESCRIBE `#__rsevents_rating`");
	$ratings_table = $db->loadObjectList();

	foreach($ratings_table as $rating_row)
	{
		if($rating_row->Field == 'uid')
		{
			$db->setQuery("ALTER TABLE `#__rsevents_rating` DROP `uid` ");
			$db->query();
		}
	}
	/* END UPDATE PROCEDURE FOR RATINGS TABLE */

	/* START UPDATE PROCEDURE FOR SUBSCRIPTIONS TICKETS TABLE */

	$db->setQuery("DESCRIBE `#__rsevents_subscription_tickets`");
	$st_table = $db->loadObjectList();

	foreach($st_table as $st_row)
	{
		if(!($st_row->Field == 'Discount'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_subscription_tickets` ADD `Discount` FLOAT NOT NULL");
			$db->query();
		}
	}

	/* END UPDATE PROCEDURE FOR SUBSCRIPTIONS TICKETS TABLE */

	/* START UPDATE PROCEDURE FOR COUPONS TABLE */

	$db->setQuery("DESCRIBE `#__rsevents_cupons`");
	$coupons_table = $db->loadObjectList();

	foreach($coupons_table as $coupon_row)
	{
		if(!($coupon_row->Field == 'CouponStart'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_cupons` ADD `CouponStart` INT(15) NOT NULL");
			$db->query();
		}
		if(!($coupon_row->Field == 'CouponEnd'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_cupons` ADD `CouponEnd` INT(15) NOT NULL");
			$db->query();
		}
		if(!($coupon_row->Field == 'CouponLimit'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_cupons` ADD `CouponLimit` INT(5) NOT NULL");
			$db->query();
		}
		if(!($coupon_row->Field == 'CouponUsed'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_cupons` ADD `CouponUsed` INT(5) NOT NULL");
			$db->query();
		}
		if(!($coupon_row->Field == 'CouponAction'))
		{
			$db->setQuery("ALTER TABLE `#__rsevents_cupons` ADD `CouponAction` INT(2) NOT NULL");
			$db->query();
		}
	}

	$db->setQuery("ALTER TABLE `#__rsevents_cupons` CHANGE `CuponValue` `CuponValue` FLOAT NOT NULL ");
	$db->query();

	/* END UPDATE PROCEDURE FOR COUPONS TABLE */
	
	
	/* START UPDATE PROCEDURE FOR DESIGNS TABLE */
	
	$db->setQuery("DESCRIBE `#__rsevents_designs`");
	$designs_table = $db->loadObjectList();
	
	
	foreach($designs_table as $design_row)
	{
		if($design_row->Field == 'published')
		{
			$db->setQuery("ALTER TABLE `#__rsevents_designs` DROP `published`");
			$db->query();
		}
		if($design_row->Field == 'ordering')
		{
			$db->setQuery("ALTER TABLE `#__rsevents_designs` DROP `ordering`");
			$db->query();
		}
	}
	
	$db->setQuery("DESCRIBE `#__rsevents_designs` `designtype` ");
	$result = $db->loadResult();
	if (empty($result))
	{
		$db->setQuery("ALTER TABLE `#__rsevents_designs` ADD `designtype` INT(1) NOT NULL");
		$db->query();
		$db->setQuery("UPDATE #__rsevents_designs SET designtype = 1");
		$db->query();
	}
	
	$db->setQuery("INSERT IGNORE INTO `#__rsevents_designs` (`IdDesign`, `DesignName`, `DesignDefault`, `designtype`) VALUES('100', 'Default', 1, 0)");
	$db->query();
	$db->setQuery("INSERT IGNORE INTO `#__rsevents_designs` (`IdDesign`, `DesignName`, `DesignDefault`, `designtype`) VALUES('101', 'Blue', 0, 0)");
	$db->query();
	$db->setQuery("INSERT IGNORE INTO `#__rsevents_designs` (`IdDesign`, `DesignName`, `DesignDefault`, `designtype`) VALUES('102', 'Pink', 0, 0)");
	$db->query();
	$db->setQuery("INSERT IGNORE INTO `#__rsevents_designs` (`IdDesign`, `DesignName`, `DesignDefault`, `designtype`) VALUES('103', 'Classic', 0, 0)");
	$db->query();
	$db->setQuery("INSERT IGNORE INTO `#__rsevents_designs` (`IdDesign`, `DesignName`, `DesignDefault`, `designtype`) VALUES('104', 'Dark', 0, 0)");
	$db->query();
	$db->setQuery("INSERT IGNORE INTO `#__rsevents_designs` (`IdDesign`, `DesignName`, `DesignDefault`, `designtype`) VALUES('105', 'Green', 0, 0)");
	$db->query();
	
	/* END UPDATE PROCEDURE FOR DESIGNS TABLE */



	/* FUTURE EVENTS */
	$db->setQuery("SELECT `id` FROM `#__menu` WHERE `link` LIKE '%&view=events&layout=featureevents%' ");
	$future_menus = $db->loadObjectList();
	foreach ($future_menus as $menu)
	{
		$db->setQuery("UPDATE `#__menu` SET `link` = 'index.php?option=com_rsevents&view=events&layout=futureevents' WHERE `id` = '".$menu->id."' ");
		$db->query();
	}

	// CATEGORY EVENTS & LOCATION EVENTS
	$registry =& JRegistry::getInstance('');
	$pattern = '#cid=([0-9]+)#is';
	$matches = array();
	$db->setQuery("SELECT `id`,`link`,`params` FROM `#__menu` WHERE `link` LIKE '%index.php?option=com_rsevents&view=events&layout=listcategoryevents&cid=%'");
	$categories_menus = $db->loadObjectList();
	foreach ($categories_menus as $menu)
	{
		preg_match($pattern,$menu->link,$matches);
		if (!empty($matches[1])) $cid = $matches[1]; else $cid = 0;
		$registry->loadINI($menu->params);
		$registry->setValue('categories',$cid);
		$newparams = $registry->toString();
		$db->setQuery("UPDATE `#__menu` SET `link` = 'index.php?option=com_rsevents&view=events&layout=listcategoryevents' , `params` = '".$newparams."' WHERE `id` = '".$menu->id."' ");
		$db->query();
		unset($matches);
	}


	$db->setQuery("SELECT `id`,`link`,`params` FROM `#__menu` WHERE `link` LIKE '%index.php?option=com_rsevents&view=events&layout=listlocationevents&cid=%'");
	$locations_menus = $db->loadObjectList();
	foreach ($locations_menus as $menu)
	{
		preg_match($pattern,$menu->link,$matches);
		if (!empty($matches[1])) $cid = $matches[1]; else $cid = 0;
		$registry->loadINI($menu->params);
		$registry->setValue('categories',$cid);
		$newparams = $registry->toString();
		$db->setQuery("UPDATE `#__menu` SET `link` = 'index.php?option=com_rsevents&view=events&layout=listlocationevents' , `params` = '".$newparams."' WHERE `id` = '".$menu->id."' ");
		$db->query();
	}
}


	/*		MODULE REPLACE		*/

	// Module - RSEvents! Category
	$mod_rse_cat 	   = false;
	$mod_rse_cat_exists = false;
	$mod_rse_cat_msg    = '';
	$published 		   = 1;

	// Search for the old module
	$db->setQuery("SELECT * FROM #__modules WHERE module='mod_rsevents_category'");
	$module = $db->loadObject();
	// Found it
	if (!empty($module))
	{
		$modules = true;
		$mod_rse_cat_exists = true;
		$published = $module->published;
		
		// Install
		if ($installer->install($this->parent->getPath('source').DS.'modules'.DS.'mod_rsevents_category'))
		{
			$db->setQuery("UPDATE #__modules SET published='".$published."' WHERE `module`='mod_rsevents_category'");
			$db->query();
			
			$mod_rse_cat = true;
			$mod_rse_cat_msg .= 'The installer found the old module and updated it.';
		}
		else
		{
			$name = $module->name;
			if (strpos($name, ' (no longer supported, disabled)') === false)
				$name .= ' (no longer supported, disabled)';
			
			$db->setQuery("UPDATE #__modules SET published='0', name='".$db->getEscaped($name)."' WHERE `module`='mod_rsevents_category'");
			$db->query();
			
			$mod_rse_cat_msg .= 'The installer could not update the old module. Since the module is no longer supported by this version of RSEvents!, it has been disabled. You should check if /modules is writable and try to update it again.';
		}
	}
	
	
	// Module - RSEvents! Calendar
	$mod_rse_cal 	   = false;
	$mod_rse_cal_exists = false;
	$mod_rse_cal_msg    = '';
	$published 		   = 1;

	// Search for the old module
	$db->setQuery("SELECT * FROM #__modules WHERE module='mod_rsevents_calendar'");
	$module = $db->loadObject();
	// Found it
	if (!empty($module))
	{
		$modules = true;
		$mod_rse_cal_exists = true;
		$published = $module->published;
		
		// Install
		if ($installer->install($this->parent->getPath('source').DS.'modules'.DS.'mod_rsevents_calendar'))
		{
			$db->setQuery("UPDATE #__modules SET published='".$published."' WHERE `module`='mod_rsevents_calendar'");
			$db->query();
			
			$mod_rse_cal = true;
			$mod_rse_cal_msg .= 'The installer found the old module and updated it.';
		}
		else
		{
			$name = $module->name;
			if (strpos($name, ' (no longer supported, disabled)') === false)
				$name .= ' (no longer supported, disabled)';
			
			$db->setQuery("UPDATE #__modules SET published='0', name='".$db->getEscaped($name)."' WHERE `module`='mod_rsevents_calendar'");
			$db->query();
			
			$mod_rse_cal_msg .= 'The installer could not update the old module. Since the module is no longer supported by this version of RSEvents!, it has been disabled. You should check if /modules is writable and try to update it again.';
		}
	}

	// Module - Upcoming events
	$mod_rse_upc 	   = false;
	$mod_rse_upc_exists = false;
	$mod_rse_upc_msg    = '';
	$published 		   = 1;

	// Search for the old module
	$db->setQuery("SELECT * FROM #__modules WHERE module='mod_rsevents_upcoming'");
	$module = $db->loadObject();
	// Found it
	if (!empty($module))
	{
		$modules = true;
		$mod_rse_upc_exists = true;
		$published = $module->published;
		
		// Install
		if ($installer->install($this->parent->getPath('source').DS.'modules'.DS.'mod_rsevents_upcoming'))
		{
			$db->setQuery("UPDATE #__modules SET published='".$published."' WHERE `module`='mod_rsevents_upcoming'");
			$db->query();
			
			$mod_rse_upc = true;
			$mod_rse_upc_msg .= 'The installer found the old module and updated it.';
		}
		else
		{
			$name = $module->name;
			if (strpos($name, ' (no longer supported, disabled)') === false)
				$name .= ' (no longer supported, disabled)';
			
			$db->setQuery("UPDATE #__modules SET published='0', name='".$db->getEscaped($name)."' WHERE `module`='mod_rsevents_upcoming'");
			$db->query();
			
			$mod_rse_upc_msg .= 'The installer could not update the old module. Since the module is no longer supported by this version of RSEvents!, it has been disabled. You should check if /modules is writable and try to update it again.';
		}
	}


	// Module - Search events
	$mod_rse_search	   = false;
	$mod_rse_search_exists = false;
	$mod_rse_search_msg    = '';
	$published 		   = 1;

	// Search for the old module
	$db->setQuery("SELECT * FROM #__modules WHERE module='mod_rsevents_search'");
	$module = $db->loadObject();
	// Found it
	if (!empty($module))
	{
		$modules = true;
		$mod_rse_search_exists = true;
		$published = $module->published;
		
		// Install
		if ($installer->install($this->parent->getPath('source').DS.'modules'.DS.'mod_rsevents_search'))
		{
			$db->setQuery("UPDATE #__modules SET published='".$published."' WHERE `module`='mod_rsevents_search'");
			$db->query();
			
			$mod_rse_search = true;
			$mod_rse_search_msg .= 'The installer found the old module and updated it.';
		}
		else
		{
			$name = $module->name;
			if (strpos($name, ' (no longer supported, disabled)') === false)
				$name .= ' (no longer supported, disabled)';
			
			$db->setQuery("UPDATE #__modules SET published='0', name='".$db->getEscaped($name)."' WHERE `module`='mod_rsevents_search'");
			$db->query();
			
			$mod_rse_search_msg .= 'The installer could not update the old module. Since the module is no longer supported by this version of RSEvents!, it has been disabled. You should check if /modules is writable and try to update it again.';
		}
	}

	/*		PLUGIN REPLACE		*/


	// System - RSForm! Pro - RSEvents! Plugin
	$plg_rsevents 	   = false;
	$plg_rsevents_exists = false;
	$plg_rsevents_msg    = '';
	$published 		   = 1;

	// Search for the old plugin
	if ($is16)
		$db->setQuery("SELECT extension_id as id, name, state as published FROM #__extensions WHERE `type` = 'plugin' AND folder='system' AND element='rsfprsevents'");
	else
		$db->setQuery("SELECT * FROM #__plugins WHERE folder='system' AND element='rsfprsevents'");
	$plugin = $db->loadObject();
	// Found it
	if (!empty($plugin))
	{
		$plugins = true;
		$plg_rsevents_exists = true;
		$published = $plugin->published;
		
		// Install
		if ($installer->install($this->parent->getPath('source').DS.'plugins'.DS.'plg_rsevents'))
		{
			if ($is16)
				$db->setQuery("UPDATE #__extensions SET state = '".$published."' WHERE `type` = 'plugin' AND folder='system' AND element='rsfprsevents'");
			else
				$db->setQuery("UPDATE #__plugins SET published='".$published."' WHERE `element`='rsfprsevents' AND `folder`='system'");
			$db->query();
			
			$plg_rsevents = true;
			$plg_rsevents_msg .= 'The installer found the old plugin and updated it.';
		}
		else
		{
			$name = $plugin->name;
			if (strpos($name, ' (no longer supported, disabled)') === false)
				$name .= ' (no longer supported, disabled)';
			
			if ($is16)
				$db->setQuery("UPDATE #__extensions SET state = 0, name='".$db->getEscaped($name)."' WHERE `type` = 'plugin' AND folder='system' AND element='rsfprsevents'");
			else
				$db->setQuery("UPDATE #__plugins SET published='0', name='".$db->getEscaped($name)."' WHERE `element`='rsfprsevents' AND `folder`='system'");
			$db->query();
			
			$plg_rsevents_msg .= 'The installer could not update the old plugin. Since the plugin is no longer supported by this version of RSEvents!, it has been disabled. You should check if /plugins/system is writable and try to update it again.';
		}
	}

	// Joomla Search Plugin
	$plg_rse_search 	   = false;
	$plg_rse_search_exists = false;
	$plg_rse_search_msg    = '';
	$published 		   = 1;

	// Search for the old plugin
	if ($is16)
		$db->setQuery("SELECT extension_id as id, name, state as published FROM #__extensions WHERE `type` = 'plugin' AND folder='system' AND element='rsevents.search'");
	else
		$db->setQuery("SELECT * FROM #__plugins WHERE folder='search' AND element='rsevents.search'");
	$plugin = $db->loadObject();
	// Found it
	if (!empty($plugin))
	{
		$plugins = true;
		$plg_rse_search_exists = true;
		$published = $plugin->published;
		
		// Install
		if ($installer->install($this->parent->getPath('source').DS.'plugins'.DS.'rsevents.search'))
		{
			if ($is16)
				$db->setQuery("UPDATE #__extensions SET state = '".$published."' WHERE `type` = 'plugin' AND folder='system' AND element='rsevents.search'");
			else
				$db->setQuery("UPDATE #__plugins SET published='".$published."' WHERE `element`='rsevents.search' AND `folder`='search'");
			$db->query();
			
			$plg_rse_search = true;
			$plg_rse_search_msg .= 'The installer found the old plugin and updated it.';
		}
		else
		{
			$name = $plugin->name;
			if (strpos($name, ' (no longer supported, disabled)') === false)
				$name .= ' (no longer supported, disabled)';
				
			if ($is16)
				$db->setQuery("UPDATE #__extensions SET state = 0, name='".$db->getEscaped($name)."' WHERE `type` = 'plugin' AND folder='system' AND element='rsevents.search'");
			else
				$db->setQuery("UPDATE #__plugins SET published='0', name='".$db->getEscaped($name)."' WHERE `element`='rsevents.search' AND `folder`='system'");
			$db->query();
			
			$plg_rse_search_msg .= 'The installer could not update the old plugin. Since the plugin is no longer supported by this version of RSEvents!, it has been disabled. You should check if /plugins/search is writable and try to update it again.';
		}
	}
?>
	<style type="text/css">
		.green { color: #009E28; }
		.red { color: #B8002E; }
		#rsevents_changelog
		{
			list-style-type: none;
			padding: 0;
		}
		#rsevents_changelog li
		{
			background: url(images/tick.png) no-repeat center left;
			padding-left: 24px;
		}

		#rsevents_links
		{
			list-style-type: none;
			padding: 0;
		}
	</style>
	
	<table class="adminlist">
		<thead>
			<tr>
				<th class="title" colspan="2"><?php echo JText::_('Extension'); ?></th>
				<th width="30%"><?php echo JText::_('Status'); ?></th>
			</tr>
		</thead>
		<tfoot>
			<tr>
				<td colspan="3"></td>
			</tr>
		</tfoot>
		<tbody>
			<tr class="row0">
				<td class="key" colspan="2"><?php echo 'RSEvents! '.JText::_('Component'); ?></td>
				<td><strong><?php echo JText::_('Installed'); ?></strong></td>
			</tr>
			<tr>
				<th><?php echo JText::_('Modules'); ?></th>
				<th></th>
				<th></th>
			</tr>
			<tr class="row0">
				<td class="key">Guest Menu module</td>
				<td class="key"></td>
				<td><strong><?php echo JText::_('Installed'); ?></strong></td>
			</tr>
			<tr class="row0">
				<td class="key">Host Menu module</td>
				<td class="key"></td>
				<td><strong><?php echo JText::_('Installed'); ?></strong></td>
			</tr>
			<?php if (!empty($plugins)) { ?>
			<?php if ($plg_rsevents_exists) { ?>
			<tr class="row0">
				<td class="key">System - RSForm! Pro - RSEvents!</td>
				<td class="key">system</td>
				<td>
				<?php if ($plg_rsevents) { ?>
				<strong class="green"><?php echo JText::_('Installed'); ?></strong>
				<?php } else { ?>
				<strong class="red"><?php echo JText::_('Not Installed'); ?></strong>
				<?php } ?>
				<?php echo $plg_rsevents_msg; ?>
				</td>
			</tr>
			<?php } ?>
			<?php if ($plg_rse_search_exists) { ?>
			<tr class="row1">
				<td class="key">Search - RSEvents!</td>
				<td class="key">search</td>
				<td>
				<?php if ($plg_rse_search) { ?>
				<strong class="green"><?php echo JText::_('Installed'); ?></strong>
				<?php } else { ?>
				<strong class="red"><?php echo JText::_('Not Installed'); ?></strong>
				<?php } ?>
				<?php echo $plg_rse_search_msg; ?>
				</td>
			</tr>
			<?php } ?>
			<?php } ?>
			
			<?php if (!empty($modules)) { ?>
			<tr>
				<th colspan="3"><?php echo JText::_('Module'); ?></th>
			</tr>
			<?php if ($mod_rse_cal_exists) { ?>
			<tr class="row0">
				<td class="key" colspan="2">Module - RSEvents! Calendar</td>
				<td>
				<?php if ($mod_rse_cal) { ?>
				<strong class="green"><?php echo JText::_('Installed'); ?></strong>
				<?php } else { ?>
				<strong class="red"><?php echo JText::_('Not Installed'); ?></strong>
				<?php } ?>
				<?php echo $mod_rse_cal_msg; ?>
				</td>
			</tr>
			<?php } ?>
			<?php if ($mod_rse_upc_exists) { ?>
			<tr class="row1">
				<td class="key" colspan="2">Module - Upcoming events</td>
				<td>
				<?php if ($mod_rse_upc) { ?>
				<strong class="green"><?php echo JText::_('Installed'); ?></strong>
				<?php } else { ?>
				<strong class="red"><?php echo JText::_('Not Installed'); ?></strong>
				<?php } ?>
				<?php echo $mod_rse_upc_msg; ?>
				</td>
			</tr>
			<?php } ?>
			<?php if ($mod_rse_search_exists) { ?>
			<tr class="row0">
				<td class="key" colspan="2">Module - Search events</td>
				<td>
				<?php if ($mod_rse_search) { ?>
				<strong class="green"><?php echo JText::_('Installed'); ?></strong>
				<?php } else { ?>
				<strong class="red"><?php echo JText::_('Not Installed'); ?></strong>
				<?php } ?>
				<?php echo $mod_rse_search_msg; ?>
				</td>
			</tr>
			<?php } ?>
			<?php if ($mod_rse_cat_exists) { ?>
			<tr class="row1">
				<td class="key" colspan="2">Module - RSEvents! Category</td>
				<td>
				<?php if ($mod_rse_cat) { ?>
				<strong class="green"><?php echo JText::_('Installed'); ?></strong>
				<?php } else { ?>
				<strong class="red"><?php echo JText::_('Not Installed'); ?></strong>
				<?php } ?>
				<?php echo $mod_rse_cat_msg; ?>
				</td>
			</tr>
			<?php } ?>
			<?php } ?>
		</tbody>
	</table>
	<br/>
	<table>
		<tr>
			<td width="1%"><img src="components/com_rsevents/assets/images/rsevents.png" alt="RSEvents! Box" /></td>
			<td align="left">
			<div id="rsevents_message">
			<p>Thank you for choosing RSEvents!</p>
			<p>New in this version:</p>
			<ul id="rsevents_changelog">
				<li>Offline payment plugin.</li>
				<li>You can add multiple offline payment types (Pay at the door, Mail in payment)</li>
				<li>Enable/Disable Multiple tickets registration</li>
				<li>Payment log (<span style="color:red;font-weight: bold;">Please update your payment plugins.</span>)</li>
				<li>Early registration fee / Late registration fee (<span style="color:red;font-weight: bold;">Please update your payment plugins.</span>)</li>
				<li>Attach a PDF ticket to the Activation email (Requires the PDF plugin)</li>
				<li>Events map view.</li>
			</ul>
			<a href="http://www.rsjoomla.com/support/documentation/view-knowledgebase/131-changelog.html" target="_blank">Full Changelog</a>
			<ul id="rsevents_links">
				<li>
					<div class="button2-left">
						<div class="next">
							<a href="index.php?option=com_rsevents">Start using RSEvents!</a>
						</div>
					</div>
				</li>
				<li>
					<div class="button2-left">
						<div class="readmore">
							<a href="http://www.rsjoomla.com/support/documentation/view-knowledgebase/41-rsevents-user-guide.html" target="_blank">Read the RSEvents! User Guide</a>
						</div>
					</div>
				</li>
				<li>
					<div class="button2-left">
						<div class="blank">
							<a href="http://www.rsjoomla.com/support.html" target="_blank">Get Support!</a>
						</div>
					</div>
				</li>
			</ul>
			</div>
			</td>
		</tr>
	</table><br/>
<?php 

//ADD CONFIG
$buffer = file_get_contents($this->parent->getPath('source').DS.'admin'.DS.'config.sql');
jimport('joomla.installer.helper');
$queries = JInstallerHelper::splitSql($buffer);
// Process each query in the $queries array (split out of sql file).
foreach ($queries as $query)
{
	$query = trim($query);
	if ($query != '' && $query{0} != '#') {
		$db->setQuery($query);
		if (!$db->query()) {
			JError::raiseWarning(1, 'JInstaller::install: '.JText::_('SQL Error')." ".$db->stderr(true));
		}
	}
}

//ADD THEMES
$db->setQuery("SELECT COUNT(id) FROM #__rsevents_themes_position");
if ($db->loadResult() == 0)
{
	$buffer = file_get_contents($this->parent->getPath('source').DS.'admin'.DS.'themes.sql');
	jimport('joomla.installer.helper');
	$queries = JInstallerHelper::splitSql($buffer);
	// Process each query in the $queries array (split out of sql file).
	foreach ($queries as $query)
	{
		$query = trim($query);
		if ($query != '' && $query{0} != '#') {
			$db->setQuery($query);
			if (!$db->query()) {
				JError::raiseWarning(1, 'JInstaller::install: '.JText::_('SQL Error')." ".$db->stderr(true));
			}
		}
	}
}
?>