<?php
/**
* @version 1.0.0
* @package RSMembership! 2Checkout 1.0.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/

defined('_JEXEC') or die('Restricted access');
define('RSEVENTS_2CO','2CO');
jimport( 'joomla.plugin.plugin' );

class plgSystemRSEvents2CO extends JPlugin
{
	var $_db;
	
	function plgSystemRSEvents2CO(&$subject, $config)
	{
		parent::__construct($subject, $config);
		$this->_plugin =& JPluginHelper::getPlugin('system', 'rsevents2co');
		$this->_params = new JParameter($this->_plugin->params);
		
		$this->_db = JFactory::getDBO();
	}
	
	function onAfterRender()
	{
		global $mainframe;
		
		//Cron that sets non paid subscribers to denied after 12 h
		$this->_db->setQuery("UPDATE #__rsevents_subscriptions SET SubscriptionState = -1 WHERE TransactionGateway = '2co' AND SubscriptionState = 0 AND SubscriptionDate < '".strtotime('-12 hours')."'");
		$this->_db->query();
		
		$app =& JFactory::getApplication();		
		if($app->getName() != 'site') return;

		$twocopayment = JRequest::getVar('rse2co', '');
		if (!empty($twocopayment))
			$this->onPaymentNotification();
	}
	
	function onPaymentNotification()
	{		
		$custom = JRequest::getVar('custom', 0, 'post');
		
		$this->_db->setQuery("SELECT e.IdEvent ,e.EventName ,e.EventDescription ,e.EventStartDate , e.EventEndDate , e.EventHost , l.LocationName, l.LocationCity , l.LocationZip , l.LocationCountry , c.CategoryName, u.username, s.Email FROM #__rsevents_events e LEFT JOIN #__rsevents_subscriptions s ON s.IdEvent = e.IdEvent LEFT JOIN #__users u ON u.id=s.IdUser LEFT JOIN #__rsevents_locations l ON e.IdLocation=l.IdLocation LEFT JOIN #__rsevents_categories c ON e.IdCategory=c.IdCategory WHERE MD5(CONCAT(s.IdEvent,s.SubscriptionVerification,s.IdSubscription)) = '".$this->_db->getEscaped($custom)."' LIMIT 1");
		$subscriptionDetails = $this->_db->loadObject();
		
		$this->_db->setQuery("SELECT t.TicketPrice , t.TicketName , st.TicketsSubscribed FROM #__rsevents_subscription_tickets st LEFT JOIN #__rsevents_subscriptions s ON s.IdSubscription=st.IdSubscription LEFT JOIN #__rsevents_tickets t ON st.IdTicket=t.IdTicket WHERE s.TransactionGateway ='2co' AND MD5(CONCAT(s.IdEvent,s.SubscriptionVerification,s.IdSubscription)) = '".$this->_db->getEscaped($custom)."' ");
		$ticketDetails = $this->_db->loadObject();
		
		// subscription exists
		if (empty($subscriptionDetails)) return;
		
		
		$secret_word = $this->_params->get('secret_word');
		$sid = $this->_params->get('id');
		$ordernumber = $this->_params->get('mode') ? $_POST['order_number'] : 1;
		$total = $_POST['total'];
		
		// calculate the hash
		$hash = strtoupper(md5($secret_word.$sid.$ordernumber.$total));
		$key = $_POST['key'];
		
		if ($hash != $key) return;
		
		
		// check if the amount is correct
		if (($this->_convertNumber($ticketDetails->TicketPrice) * $ticketDetails->TicketsSubscribed ) > $total) return;
		
		$this->_db->setQuery("SELECT * FROM `#__rsevents_config`");
		$rseventsConfigDb = $this->_db->loadObjectList();
		
		foreach ($rseventsConfigDb as $objConfig)
			$rseventsConfig[$objConfig->ConfigName] = $objConfig->ConfigValue;
		
		// process payment
		$processed = $_POST['credit_card_processed'];
		if ($processed == 'Y')
		{
			
			$this->_db->setQuery("UPDATE #__rsevents_subscriptions SET SubscriptionState = 1 WHERE MD5(CONCAT(IdEvent,SubscriptionVerification,IdSubscription)) = '".$this->_db->getEscaped($custom)."' AND TransactionGateway ='2co' LIMIT 1");
			$this->_db->query();	
			
			//ticket info
			$ticketinfo = $ticketDetails->TicketsSubscribed . ' x '.$ticketDetails->TicketName;
			
			$eventLink = '<a target="_blank" href="'.html_entity_decode(JRoute::_(JURI::root().'index.php?option=com_rsevents&view=events&layout=show&cid='.$subscriptionDetails->IdEvent.':'.JFilterOutput::stringURLSafe($subscriptionDetails->EventName))).'">'.$subscriptionDetails->EventName.'</a>';

			$toChange = array('{EventName}','{EventDescription}','{EventStartDate}','{EventEndDate}','{EventHost}','{LocationName}','{LocationCity}','{CategoryName}','{username}','{EventLink}','{LocationCountry}','{LocationZip}','{TicketInfo}');
			$with = array($subscriptionDetails->EventName , $subscriptionDetails->EventDescription , date($rseventsConfig['global.dateformat'],$subscriptionDetails->EventStartDate) , date($rseventsConfig['global.dateformat'],$subscriptionDetails->EventEndDate), $subscriptionDetails->EventHost,$subscriptionDetails->LocationName,$subscriptionDetails->LocationCity,$subscriptionDetails->CategoryName, $subscriptionDetails->username,$eventLink,$subscriptionDetails->LocationCountry,$subscriptionDetails->LocationZip,$ticketinfo);
			
			$from		= $rseventsConfig['emails.from'];
			$fromName	= $rseventsConfig['emails.from.name'];
			$to			= $subscriptionDetails->Email;
			$subject	= $rseventsConfig['emails.activation.subject'];
			$body		= $rseventsConfig['emails.activation.content'];
			$body		= str_replace($toChange , $with ,$body);
			$mode		= $rseventsConfig['emails.activation.type'];
			$replyto	= $rseventsConfig['emails.reply'];
			$cc			= !empty($rseventsConfig['emails.cc']) ? $rseventsConfig['emails.cc'] : null;
			$bcc		= !empty($rseventsConfig['emails.bcc']) ? $rseventsConfig['emails.bcc'] : null;
			
			if($rseventsConfig['emails.activation.enable'] == 1) JUtility::sendMail($from , $fromName , $to , $subject , $body , $mode , $cc , $bcc , null , $replyto);
			
		}
	}
	
	function _convertNumber($number)
	{
		return number_format($number, 2, '.', '');
	}
}