<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

/**
 * RSEvents! system plugin
 */
class plgSystemRSEPDF extends JPlugin
{
	/**
	 * Constructor
	 *
	 * For php4 compatibility we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @access	protected
	 * @param	object	$subject The object to observe
	 * @param 	array   $config  An array that holds the plugin configuration
	 * @since	1.0
	 */
	function plgSystemRSEPDF(&$subject, $config)
	{
		parent::__construct($subject, $config);
		$this->params = $config;
	}
	
	function canRun()
	{
		if (file_exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'rsevents.php'))
		{
			require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'rsevents.php');
			rseventsHelper::readConfig();
			return true;
		}
		
		return false;
	}
	
	function rse_backednEventTabs($vars)
	{
		if (!$this->canRun()) return;
		jimport('joomla.html.pane');
		$tabs =& JPane::getInstance('Tabs', array(), true);
		
		$editor =& JFactory::getEditor();
		$lang =& JFactory::getLanguage();
		$lang->load('plg_system_rsepdf');
		
		$data = $vars['data'];
		
		echo $tabs->startPanel(JText::_('RSE_TICKET_PDF'),"event-pdf");
		echo '<table class="adminform">';
		echo '<tr>';
		echo '<td width="200"><label for="ticket_pdf">'.JText::_( 'RSE_TICKET_PDF_ATTACH' ).'</label></td>';
		echo '<td>'.JHTML::_('select.booleanlist','ticket_pdf','class="inputbox"',$data->ticket_pdf).'</td>';
		echo '</tr>';
		echo '<tr>';
		echo '<td width="200"><label for="ticket_pdf_layout">'.JText::_( 'RSE_TICKET_PDF_LAYOUT' ).' :</label></td>';
		echo '<td>'.$editor->display('ticket_pdf_layout',$data->ticket_pdf_layout,550,400,70,10).'</td>';
		echo '</tr>';
		echo '</table>';
		echo $tabs->endPanel();
	}
	
	function rse_frontendEventTabs($vars)
	{
		if (!$this->canRun()) return;
		$editor =& JFactory::getEditor();
		$lang =& JFactory::getLanguage();
		$lang->load('plg_system_rsepdf',JPATH_ADMINISTRATOR);
		
		$data = $vars['data'];
		
		echo '<tr>';
		echo '<td>';
		echo '<fieldset class="rsevents">';
		echo '<legend>'.JText::_('RSE_TICKET_PDF').'</legend>';
		echo '<table cellpadding="5" cellspacing="0" border="0" width="100%" class="rse_table">';
		echo '<tr>';
		echo '<td><label for="ticket_pdf">'.JText::_( 'RSE_TICKET_PDF_ATTACH' ).'</label></td>';
		echo '<td>'.JHTML::_('select.booleanlist','ticket_pdf','class="inputbox"',$data->ticket_pdf).'</td>';
		echo '</tr>';
		echo '<tr>';
		echo '<td><label for="ticket_pdf_layout">'.JText::_( 'RSE_TICKET_PDF_LAYOUT' ).' :</label></td>';
		echo '<td>'.$editor->display('ticket_pdf_layout',$data->ticket_pdf_layout,450,300,70,10).'</td>';
		echo '</tr>';
		echo '</table>';
		echo '</fieldset>';
		echo '</td>';
		echo '</tr>';
		
	}
	
	function rse_settingsTab($vars)
	{
		if (!$this->canRun()) return;
		$lang =& JFactory::getLanguage();
		$lang->load('plg_system_rsepdf',JPATH_ADMINISTRATOR);
		
		$data = $vars['data'];
		
		$options = array(
			JHTML::_('select.option',  'C39', JText::_( 'Code 39' )),
			JHTML::_('select.option',  'C39E', JText::_( 'Code 39 Extended' )),
			JHTML::_('select.option',  'C93', JText::_( 'Code 93' )),
			JHTML::_('select.option',  'C128', JText::_( 'Code 128' ))
		);
		
		echo '<fieldset class="rsevents">';
		echo '<legend>'.JText::_('RSE_BARCODE_LEGEND').'</legend>';
		echo '<table cellpadding="0" cellspacing="0" border="0" width="100%" class="adminform">';
		echo '<tr>';
		echo '<td width="200"><label for="barcode_code">'.JText::_( 'RSE_BARCODE_TYPE' ).'</label></td>';
		echo '<td>'.JHTML::_('select.genericlist', $options, 'rseventsConfig[barcode]', 'class="inputbox" size="1"','value', 'text', $data['barcode'] ).'</td>';
		echo '</tr>';
		echo '</table>';
		echo '</fieldset>';
	}
	
	function rse_activationEmail($vars)
	{
		if (!$this->canRun()) return;
		$lang =& JFactory::getLanguage();
		$lang->load('plg_system_rsepdf',JPATH_ADMINISTRATOR);
		
		$db =& JFactory::getDBO();
	
		$id = $vars['id'];
		$layout = $vars['layout'];
		$tmp = $this->_getTmp();
		$tid = $this->_createId('activation');
		
		$db->setQuery("SELECT ticket_pdf FROM #__rsevents_events WHERE IdEvent = ".(int) $id." ");
		$pdf = $db->loadResult();
		
		if ($pdf)
		{
			jimport('joomla.filesystem.file');
			
			$filename = 'Ticket';
			$activation_filename = $this->_getFilename($filename);
			
			require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'pdf.php');
			$pdf = new RSEventsPDF();
			$buffer = $pdf->write($layout);
			$path 	= $tmp.DS.$tid.DS.$activation_filename;
			if (JFile::write($path, $buffer))
				$vars['attachment'][] = $path;
		}
	}
	
	function rse_activationEmailCleanup($vars)
	{
		if (!$this->canRun()) return;
		$lang =& JFactory::getLanguage();
		$lang->load('plg_system_rsepdf',JPATH_ADMINISTRATOR);
		
		$db =& JFactory::getDBO();
		$id = $vars['id'];
		
		$db->setQuery("SELECT ticket_pdf FROM #__rsevents_events WHERE IdEvent = ".(int) $id." ");
		$pdf = $db->loadResult();
		
		if ($pdf)
		{
			jimport('joomla.filesystem.file');
			jimport('joomla.filesystem.folder');
			
			$tmp = $this->_getTmp();
			$tid = $this->_createId('activation');
			
			$dir  = $tmp.DS.$tid;
			if (is_dir($dir))
				JFolder::delete($dir);
		}
	}
	
	function _getFilename($filename)
	{
		$filename = str_replace(array('\\', '/'), '', $filename);
		if (empty($filename))
			$filename = 'attachment';
		
		return $filename.'.pdf';
	}
	
	function _createId($suffix)
	{
		static $hash;
		if (!$hash)
		{
			$session =& JFactory::getSession();
			$hash = md5($session->getId());
		}
		
		return $hash.'_'.$suffix;
	}
	
	function _getTmp()
	{
		static $tmp;
		if (!$tmp)
		{
			$mainframe =& JFactory::getApplication();
			$tmp = $mainframe->getCfg('tmp_path');
		}
		
		return $tmp;
	}
}