<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );
jimport( 'joomla.html.parameter' );


class plgSystemRSEventsoffline extends JPlugin
{
	//set the value of the payment option
	var $rsoption = 'offline';
	
	function plgSystemRSEventsoffline( &$subject, $config )
	{
		parent::__construct( $subject, $config );
		$this->_plugin =& JPluginHelper::getPlugin('system', 'rseventsoffline');
		$this->_params = new JParameter($this->_plugin->params);
	}
	
	/*
	*	Is RSEvents! installed
	*/
	
	function canRun()
	{
		return file_exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'rsevents.php');
	}
	
	/*
	*	Add the current payment option to the Payments List
	*/

	function rse_addOptions()
	{
		$lang = JFactory::getLanguage();
		$lang->load('plg_system_rseventsoffline',JPATH_ADMINISTRATOR);
		
		if ($this->canRun())
			return JHTML::_('select.option', $this->rsoption, JText::_('RSE_PLG_PLUGIN_OFFLINE_NAME'));
		else return JHTML::_('select.option', '', '');
	}
	
	/*
	*	Add optional fields for the payment plugin. Example: Credit Card Number, etc.
	*	Please use the syntax <form method="post" action="index.php?option=com_rsevents&task=process" name="paymentForm">
	*	The action provided in the form will actually run the rse_processForm() of your payment plugin.
	*/
	
	function rse_showForm($vars)
	{
		$app =& JFactory::getApplication();		
		if($app->getName() != 'site') return;
		
		//check to see if we can show something
		if (!$this->canRun()) return;
		
		if (isset($vars['method']) && $vars['method'] == $this->rsoption)
		{
			$lang = JFactory::getLanguage();
			$lang->load('plg_system_rseventsoffline',JPATH_ADMINISTRATOR);
			$lang->load('com_rsevents',JPATH_SITE);
		
			jimport('joomla.mail.helper');
			$db =& JFactory::getDBO();
			
			//is the plugin enabled ?
			$enable = JPluginHelper::isEnabled('system', 'rseventsoffline');
			if (!$enable) return;
			
			$details = $vars['details'];
			$tickets = $vars['tickets'];
			
			//check to see if its a payment request
			if (empty($details->custom) && empty($details->IdEvent) && empty($details->Email) && empty($tickets)) return;
			
			//get the currency
			$currency = $vars['currency'];
			
			JHTML::_('behavior.tooltip');
			
			require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'rsevents.php');
			rseventsHelper::readConfig();
			$config = rseventsHelper::getConfig();
			
			//get the months and years dropdowns
			$months[] = JHTML::_('select.option', '01', '01-'.JText::_('RSE_PLG_PLUGIN_OFFLINE_MONTH1'));
			$months[] = JHTML::_('select.option', '02', '02-'.JText::_('RSE_PLG_PLUGIN_OFFLINE_MONTH2'));
			$months[] = JHTML::_('select.option', '03', '03-'.JText::_('RSE_PLG_PLUGIN_OFFLINE_MONTH3'));
			$months[] = JHTML::_('select.option', '04', '04-'.JText::_('RSE_PLG_PLUGIN_OFFLINE_MONTH4'));
			$months[] = JHTML::_('select.option', '05', '05-'.JText::_('RSE_PLG_PLUGIN_OFFLINE_MONTH5'));
			$months[] = JHTML::_('select.option', '06', '06-'.JText::_('RSE_PLG_PLUGIN_OFFLINE_MONTH6'));
			$months[] = JHTML::_('select.option', '07', '07-'.JText::_('RSE_PLG_PLUGIN_OFFLINE_MONTH7'));
			$months[] = JHTML::_('select.option', '08', '08-'.JText::_('RSE_PLG_PLUGIN_OFFLINE_MONTH8'));
			$months[] = JHTML::_('select.option', '09', '09-'.JText::_('RSE_PLG_PLUGIN_OFFLINE_MONTH9'));
			$months[] = JHTML::_('select.option', '10', '10-'.JText::_('RSE_PLG_PLUGIN_OFFLINE_MONTH10'));
			$months[] = JHTML::_('select.option', '11', '11-'.JText::_('RSE_PLG_PLUGIN_OFFLINE_MONTH11'));
			$months[] = JHTML::_('select.option', '12', '12-'.JText::_('RSE_PLG_PLUGIN_OFFLINE_MONTH12'));
			
			$exp_month = JHTML::_('select.genericlist', $months, 'cc_exp_m', 'class="rse_select" size="1"','value','text',date('m'));
			
			$years = array();
			for ($i=2011;$i<=2025;$i++)
				$years[] = JHTML::_('select.option', $i, $i);
			
			$exp_year = JHTML::_('select.genericlist', $years, 'cc_exp_y', 'class="rse_select" size="1"','value','text',date('Y'));
			
			$formURL = $this->_params->get('use_ssl',0) ? JRoute::_('index.php?option=com_rsevents&task=process',false,true) : rseventsHelper::route('index.php?option=com_rsevents&task=process',false);
			
			$html = '';
			$html .= '<h2 class="componentheading">'.JText::_('RSE_PLG_PLUGIN_OFFLINE_NAME').'</h2>'."\n";
			$html .= '<div class="rse_offline">'.JText::_('RSE_PLG_PLUGIN_OFFLINE_INFO').'</div>'."\n";
			
			$html .= '<form method="post" action="'.$formURL.'" onsubmit="return rse_cc_form();" autocomplete="off">'."\n";
			$html .= '<div class="rse_payment_offline">'."\n";
			
			$html .= '<fieldset>'."\n";
			$html .= '<legend>'.JText::_('RSE_PLG_PLUGIN_OFFLINE_TICKETS_INFO').'</legend>'."\n";
			$html .= '<table cellspacing="10" cellpadding="0">'."\n";
			$html .= '<tr>'."\n";
			$html .= '<td>'.JText::_('RSE_PLG_PLUGIN_OFFLINE_TICKETS').'</td>'."\n";
			$html .= '<td>'."\n";
			
			$discount = $details->Discount;
			$total = 0;
			if (!empty($tickets)) { 
				foreach ($tickets as $ticket) 
				{
					if (empty($ticket->TicketPrice))
						$html .= $ticket->TicketsSubscribed. ' x '.JText::_('RSE_TICKET_FREE'). '<br />';
					else
						$html .= $ticket->TicketsSubscribed. ' x '.$this->convertNumber($ticket->TicketPrice). ' ' .$config['payment.currency']. '<br />';
					
					if ($ticket->TicketPrice > 0)
						$total += ($ticket->TicketsSubscribed * $ticket->TicketPrice);
				}
			} 
			if (!empty($discount)) $total = $total - $discount;
			
			$html .= '</td>'."\n";
			$html .= '</tr>'."\n";
			
			if (!empty($discount))
			{
				$html .= '<tr>'."\n";
				$html .= '<td>'.JText::_('RSE_PLG_PLUGIN_OFFLINE_TICKETS_DISCOUNT').'</td>'."\n";
				$html .= '<td>'.$this->convertNumber($discount).' '.$config['payment.currency'].'</td>'."\n";
				$html .= '</tr>'."\n";
			}
			
			if ($details->early_fee)
			{
				$total = $total - $details->early_fee;
				$html .= '<tr>'."\n";
				$html .= '<td>'.JText::_('RSE_PLG_PLUGIN_OFFLINE_EARLY_FEE').'</td>'."\n";
				$html .= '<td>'."\n";
				$html .= $this->convertNumber($details->early_fee). ' '.$config['payment.currency'];
				$html .= '</td>'."\n";
				$html .= '</tr>'."\n";
			}
			
			if ($details->late_fee)
			{
				$total = $total + $details->late_fee;
				$html .= '<tr>'."\n";
				$html .= '<td>'.JText::_('RSE_PLG_PLUGIN_OFFLINE_LATE_FEE').'</td>'."\n";
				$html .= '<td>'."\n";
				$html .= $this->convertNumber($details->late_fee). ' '.$config['payment.currency'];
				$html .= '</td>'."\n";
				$html .= '</tr>'."\n";
			}
			
			if (!empty($details->tax))
			{
				$total = $total + $details->tax;
				$html .= '<tr>'."\n";
				$html .= '<td>'.JText::_('RSE_PLG_PLUGIN_OFFLINE_TICKETS_TAX').'</td>'."\n";
				$html .= '<td>'.$this->convertNumber($details->tax).' '.$config['payment.currency'].'</td>'."\n";
				$html .= '</tr>'."\n";
			}
			
			$html .= '<tr>'."\n";
			$html .= '<td>'.JText::_('RSE_PLG_PLUGIN_OFFLINE_TICKETS_TOTAL').'</td>'."\n";
			$html .= '<td>'.$this->convertNumber($total).' '.$config['payment.currency'].'</td>'."\n";
			$html .= '</tr>'."\n";
			
			$html .= '</table>'."\n";
			$html .= '</fieldset>'."\n";
			
			$html .= '<fieldset>'."\n";
			$html .= '<legend>'.JText::_('RSE_PLG_PLUGIN_OFFLINE_CC_INFO').'</legend>'."\n";
			$html .= '<table width="100%" cellspacing="10" cellpadding="0" border="0" class="rse_table">'."\n";
			$html .= '<tr><td height="40"></td><td><img alt="'.JText::_('RSE_PLG_PLUGIN_OFFLINE_CARDS').'" src="'.JURI::root().'components/com_rsevents/assets/images/cc_logo.gif"></td></tr>'."\n";
			$html .= '<tr>'."\n";
			$html .= '<td height="40">'.JText::_('RSE_PLG_PLUGIN_OFFLINE_CARD_NUMBER').'</td>'."\n";
			$html .= '<td><input type="text" onkeyup="return rse_check_card(this);" onkedown="return rse_check_card(this);" maxlength="19" size="40" value="" id="cc_number" name="cc_number" class="rse_textbox"> '.JText::_('RSE_PLG_PLUGIN_OFFLINE_CARD_CSC').' <input type="text" onkeyup="return rse_check_card(this);" onkedown="return rse_check_card(this);" maxlength="4" style="width: 45px; text-align: center;" size="40" value="" id="cc_csc" name="cc_csc" class="rse_textbox"> <span onmouseout="rse_tooltip.hide();" onmouseover="rse_tooltip.show(\'rse_tooltip\');" id="rse_whats_csc">'.JText::_('RSE_PLG_PLUGIN_OFFLINE_CARD_CSC_WHATS_THIS').'</span></td>'."\n";
			$html .= '</tr>'."\n";
			$html .= '<tr>'."\n";
			$html .= '<td height="40">'.JText::_('RSE_PLG_PLUGIN_OFFLINE_CARD_EXP_DATE').'</td>'."\n";
			$html .= '<td>'.JText::_('RSE_PLG_PLUGIN_OFFLINE_CARD_EXP_MONTH').' '.$exp_month.'  '.JText::_('RSE_PLG_PLUGIN_OFFLINE_CARD_EXP_YEAR').' '.$exp_year.'</td>'."\n";
			$html .= '</tr>'."\n";
			$html .= '<tr>'."\n";
			$html .= '<td height="40">'.JText::_('RSE_PLG_PLUGIN_OFFLINE_FIRST_NAME').'</td>'."\n";
			$html .= '<td><input type="text" class="rse_textbox" id="cc_fname" name="cc_fname" value="" /></td>'."\n";
			$html .= '</tr>'."\n";
			$html .= '<tr>'."\n";
			$html .= '<td height="40">'.JText::_('RSE_PLG_PLUGIN_OFFLINE_LAST_NAME').'</td>'."\n";
			$html .= '<td><input type="text" class="rse_textbox" id="cc_lname" name="cc_lname" value="" /></td>'."\n";
			$html .= '</tr>'."\n";
			$html .= '<tr>'."\n";
			$html .= '<td colspan="2"><button type="submit" class="rse_button">'.JText::_('RSE_PLG_PLUGIN_OFFLINE_PAY').'</button></td>'."\n";
			$html .= '</tr>'."\n";
			$html .= '</table>'."\n";
			$html .= '</fieldset>'."\n";
			$html .= '</div>'."\n";
			$html .= '<input type="hidden" name="ids" value="'.$details->IdSubscription.'" />'."\n";
			$html .= '</form>'."\n";

			$html .= '<div id="rse_tooltip" style="display: none;">'."\n"; 
			$html .= '<div>'.JText::_('RSE_PLG_PLUGIN_OFFLINE_CARD_CSC_DESC').'</div>'."\n";
			$html .= '<div align="center"><img src="'.JURI::root().'components/com_rsevents/assets/images/cc_csc.gif" alt="CSC" /></div>';
			$html .= '</div>'."\n";
			
			echo $html;			
		}
	}
	
	/*
	*	Process the form
	*/
	
	function rse_processForm($vars)
	{
		//check to see if we can show something
		if (!$this->canRun()) return;
		
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'rsevents.php');
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'crypt.php');
		
		$db   =& JFactory::getDBO();
		$app  =& JFactory::getApplication();
		$lang = JFactory::getLanguage();
		$lang->load('plg_system_rseventsoffline',JPATH_ADMINISTRATOR);	
		
		$data = $vars['data'];
		
		$cc_number	= isset($data['cc_number']) && !empty($data['cc_number']) ? $data['cc_number'] : '';
		$cc_csc		= isset($data['cc_csc']) && !empty($data['cc_csc']) ? $data['cc_csc'] : '';
		$cc_exp_m	= isset($data['cc_exp_m']) && !empty($data['cc_exp_m']) ? $data['cc_exp_m'] : '';
		$cc_exp_y	= isset($data['cc_exp_y']) && !empty($data['cc_exp_y']) ? $data['cc_exp_y'] : '';
		$f_name		= isset($data['cc_fname']) && !empty($data['cc_fname']) ? $data['cc_fname'] : '';
		$l_name		= isset($data['cc_lname']) && !empty($data['cc_lname']) ? $data['cc_lname'] : '';
		$ids		= $data['ids'];
		$cc_exp		= $cc_exp_m.' / '.$cc_exp_y;
		$name		= $f_name. ' ' .$l_name;
		
		$db->setQuery("SELECT TransactionGateway FROM #__rsevents_subscriptions WHERE IdSubscription = ".(int) $ids." ");
		$gateway = $db->loadResult();
		
		if ($gateway != $this->rsoption) return;
		
		if (empty($ids)) $app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events',false),JText::_('RSE_PLG_PLUGIN_OFFLINE_INVALID_SUBSCRIPTION'));
		
		$crypt = new RseventsCryptHelper($cc_number,$cc_csc,$name);
		
		$cc_number = $crypt->get('cc_number');
		$cc_csc = $crypt->get('cc_csc');
		
		$db->setQuery("INSERT INTO `#__rsevents_cards` SET `ids` = ".(int) $ids." , `card_number` = '".$db->getEscaped($cc_number)."' , `card_csc` = '".$db->getEscaped($cc_csc)."' , `card_exp` = '".$db->getEscaped($cc_exp)."' , `card_fname` = '".$db->getEscaped($f_name)."' , `card_lname` = '".$db->getEscaped($l_name)."'");
		$db->query();
		
		$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events',false),JText::_('RSE_PLG_PLUGIN_OFFLINE_PAYMENT_RECEIVED'));
	}
	
	function rse_tax($vars)
	{
		if (isset($vars['method']) && $vars['method'] == $this->rsoption)
		{
			require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'rsevents.php');
			
			$total		= isset($vars['total']) ? $vars['total'] : 0;
			$tax_value	= $this->_params->get('tax_value',0);
			$tax_type	= $this->_params->get('tax_type',0);
			
			return rseventsHelper::setTax($total,$tax_type,$tax_value);
		}
	}
	
	function convertNumber($number)
	{
		return number_format($number, 2, '.', '');
	}
}