<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' ); 

jimport('joomla.application.component.controller');

class rseventsController extends JController
{
	function __construct()
	{
		parent::__construct();
	}
	
	function importyahoo()
	{
		JRequest::setVar('view','events');
		JRequest::setVar('layout','importyahoo');
		parent::display();
	}
	
	function importgmail()
	{
		JRequest::setVar('view','events');
		JRequest::setVar('layout','importgmail');
		parent::display();
	}
	
	function refreshlocations()
	{
		JRequest::setVar('view','locations');
		parent::display();
		exit();
	}

	function checkvalue()
	{
		JRequest::setVar('view','tickets');
		parent::display();
		exit();
	}
	
	function location_filter()
	{
		$db =& JFactory::getDBO();
		$string = JRequest::getVar('string');
		$return = '';
		
		
		$db->setQuery("SELECT IdLocation,LocationName FROM #__rsevents_locations WHERE LocationName LIKE '%".$db->getEscaped($string)."%' ");
		$locations = $db->loadObjectList();
		$return .= '<select id="IdLocation" class="inputbox" size="1" name="IdLocation">'; 
		$return .= '<option value="0">'.JText::_('RSE_EVENT_SELECT_LOCATION').'</option>';
		foreach($locations as $location)
			$return .= '<option value="'.$location->IdLocation.'">'.$location->LocationName.'</option>'; 
		$return .= '</select>';
		
		echo $return;
		exit();
	}
	
	function automaticreminder()
	{
		// no need to edit below
		$db =& JFactory::getDBO();
		$rseventsConfig = rseventsHelper::getConfig();
		
		// number of days - you can change this to the number of days that you require
		$days = $rseventsConfig['emails.rem.days'];
		
		$days_offset = $days*86400;
		
		if (!$rseventsConfig['emails.rem.run'])
		{
			//before the event will end
			$db->setQuery("SELECT IdEvent FROM #__rsevents_events WHERE '".time()."' > `EventEndDate`-'".$days_offset."' AND '".time()."' < EventEndDate AND IdEvent NOT IN (SELECT IdEvent FROM #__rsevents_events_reminders) AND published='1'");
		} else {
			//before the event will start
			$db->setQuery("SELECT IdEvent FROM #__rsevents_events WHERE '".time()."' < `EventStartDate`-'".$days_offset."' AND '".time()."' < EventStartDate AND IdEvent NOT IN (SELECT IdEvent FROM #__rsevents_events_reminders) AND published='1'");
		}
		
		$events = $db->loadResultArray();
		if (empty($events))
			die();
		
		foreach ($events as $cid)
		{			
			$db->setQuery("SELECT IdEvent, EventName FROM #__rsevents_events WHERE IdEvent='".$cid."'");
			$row = $db->loadObject();
			if (empty($row)) continue;
			
			echo 'Sending reminders for "'.$row->EventName.'"<br />';
			
			$db->setQuery("INSERT INTO #__rsevents_events_reminders SET IdEvent='".$row->IdEvent."', `Sent`='1'");
			$db->query();
			
			//get subscribers 
			$db->setQuery("SELECT IdUser, Email FROM #__rsevents_subscriptions WHERE IdEvent = '".$row->IdEvent."' AND SubscriptionState IN (0,1) ");
			$subscribers = $db->loadObjectList();
			
			foreach ($subscribers as $subscriber)
				rseventsEmails::reminder($subscriber->Email,$subscriber->IdUser,$row->IdEvent);			
		}
		die();
	}
	
	function captcha()
	{
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'captcha'.DS.'image.php');
		die();
	}
	
	function checkcaptcha()
	{
		$session =& JFactory::getSession();
		$secret  = JRequest::getVar('secret');

		echo ($session->get('security_number') == $secret) ? 1 : 0;
		die();
	}
	
	//feedback function
	function feedback()
	{
		$db		=& JFactory::getDBO();
		$cid	= JRequest::getInt('cid',0);
		$vote	= JRequest::getInt('feedback',0);
		$ip		= $_SERVER['REMOTE_ADDR'];
		
		//check for the id of the event and for the number of votes
		if ($cid == 0 || $vote == 0)
		{
			echo JText::_('RSE_INVALID_EVENT_OR_BLANK_VOTE');
			exit();
		}
		
		//check for vote number
		if ($vote > 5) 
		{
			echo JText::_('RSE_INVALID_VOTE');
			exit();
		}
		
		//check if the user or the ip has already voted
		$db->setQuery("SELECT `id` FROM `#__rsevents_rating` WHERE `ip` = '".$ip."' AND IdEvent = '".$cid."' LIMIT 1");
		$voted = $db->loadResult();
		
		//if the user voted do nothing
		if ($voted)
		{
			echo JText::_('RSE_ALREADY_VOTED');
			exit();
		}
		
		//insert the vote
		$db->setQuery("INSERT INTO `#__rsevents_rating` SET `ip` = '".$ip."' , IdEvent = '".$cid."' , `rating` = '".$vote."' ");
		$db->query();
		
		//get the total votes
		$db->setQuery("SELECT CEIL(IFNULL(SUM(rating)/COUNT(id),0)) FROM #__rsevents_rating WHERE IdEvent = '".$cid."'");
		$rating = $db->loadResult();
		
		echo JText::_('RSE_FEEDBACK_ADDED');
		echo "\n";
		echo $rating;
		exit();
	}
	
	//search function
	function ajaxsearch()
	{
		jimport('joomla.application.module.helper');
		jimport( 'joomla.application.component.view');
		
		$db		=& JFactory::getDBO();
		$string = JRequest::getVar('string');
		$view 	= new JView();
		$output = '';
		
		jimport('joomla.html.parameter');
		
		//get parameters
		$module = JModuleHelper::getModule('rsevents_ajax_search');
		$params = new JParameter($module->params);
		$limit = intval($params->get('limit',10));
		if ($limit == 0) $limit = 10;
		$itemid = ($params->get('itemid','') != '') ? '&Itemid='.$params->get('itemid','') : '';
		
		$db->setQuery("SELECT IdEvent,EventName FROM #__rsevents_events WHERE EventName LIKE '%".$db->getEscaped($string)."%' AND published = 1 AND EventType = 1 LIMIT ".$limit." ");
		$events = $db->loadObjectList();
		
		if (!empty($events))
			foreach ($events as $i => $event)
				$output .= '<li><a href="'.JRoute::_('index.php?option=com_rsevents&view=events&layout=show&cid='.$event->IdEvent.':'.JFilterOutput::stringURLSafe($event->EventName).$itemid,false).'" id="result_'.$i.'" class="rsInactive">'.$view->escape($event->EventName).'</a></li>'."\n";
				
		if($output == '') $output = '<li>'.JText::_('RSE_NO_EVENTS_FOUND').'</li>';
		echo $output;
		exit();
	}
	
	
	function payment()
	{
		$db =& JFactory::getDBO();
		$app =& JFactory::getApplication();
		$config = rseventsHelper::getConfig();
		
		$method = JRequest::getVar('method');
		$hash	= JRequest::getVar('hash');
		
		$db->setQuery("SELECT s.IdSubscription, s.IdEvent, s.IdUser, s.FirstName, s.LastName, s.Email, s.Discount, s.early_fee, s.late_fee, s.tax,  MD5(CONCAT(s.IdEvent,s.SubscriptionVerification,s.IdSubscription)) as custom FROM #__rsevents_subscriptions s WHERE MD5(CONCAT(s.IdSubscription,s.FirstName,s.LastName,s.Email)) = '".$db->getEscaped($hash)."' ");
		$details = $db->loadObject();
		
		$db->setQuery("SELECT st.TicketsSubscribed, t.TicketName, t.TicketPrice FROM #__rsevents_subscription_tickets st LEFT JOIN #__rsevents_tickets t ON t.IdTicket = st.IdTicket WHERE st.IdSubscription = ".(int) $details->IdSubscription." ");
		$tickets = $db->loadObjectList();
		
		$app->triggerEvent('rse_showForm',array(array('method'=>&$method, 'details'=>&$details, 'tickets'=>&$tickets, 'currency'=>&$config['payment.currency'])));
	}
	
	function process()
	{
		$app =& JFactory::getApplication();
		$data = JRequest::get('request');
		
		$app->triggerEvent('rse_processForm',array(array('data'=>&$data)));
	}
}
?>