<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class rseventsControllerEvents extends rseventsController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();
		$this->registerTask('apply' ,  'save');
	}

	/**
	 * save a record 
	 * @return void
	 */
	function save()
	{
		$model = $this->getModel('events');
		$model->save();
	}
	
	//generate a new Private Url
	function generate()
	{	
		$model = $this->getModel('events');
		$model->generate();
	}
	
	//invite code 
	function invite()
	{
		$model = $this->getModel('events');
		$model->invite();
	}
	
	//export event via ics file
	function export()
	{
		$model = $this->getModel('events');
		$model->export();
	}
	
	//export the guests of the event
	function exportGuests()
	{
		$model = $this->getModel('events');
		$model->exportGuests();
	}
	
	// code for sending message to  guests
	function guestsendmessage()
	{
		$model = $this->getModel('events');
		$model->guestsendmessage();
	}

	//cancel an event ( delete )
	function cancelEvent()
	{
		$model = $this->getModel('events');
		$msg = $model->cancelEvent();
		
		$this->setRedirect(rseventsHelper::route('index.php?option=com_rsevents&view=events',false), $msg );
	}

	//cancel
	function cancel()
	{
		$this->setRedirect(rseventsHelper::route('index.php?option=com_rsevents&view=events',false), JText::_( 'RSE_CANCELED_OPERATION' ) );
	}

	//saving the youtube extra
	function saveYoutube()
	{
		$model = $this->getModel('events');
		$model->saveYoutube();
	}
	
	//saving the flickr extra
	function saveFlickr()
	{
		$model = $this->getModel('events');
		$model->saveFlickr();		
	}
	
	//saving the meebo code
	function saveMeebo()
	{
		$model = $this->getModel('events');
		$model->saveMeebo();
	}
	
	//saving the flash extra
	function saveFlash()
	{
		$model = $this->getModel('events');
		$model->saveFlash();
	}
	
	//saving the mp3 Ieemem extra
	function saveMp3()
	{
		$model = $this->getModel('events');
		$model->saveMp3();
	}
	
	//delete  extra 
	function deleteExtra()
	{
		$model = $this->getModel('events');
		$model->deleteExtra();
 	}
	 
	function saveRegistration()
	{
		eventsHelper::saveRegistration();
	}
	
	//unsubscribe the event
	function eventUnsubscribe()
	{
		$model = $this->getModel('events');
		$model->eventUnsubscribe();
	}
	
	//send post reminder emails 
	function postreminder()
	{
		$model = $this->getModel('events');
		$model->postreminder();
	}
	
	//send reminder email
	function reminder()
	{
		$model = $this->getModel('events');
		$model->reminder();
	}
	
	//save flickr link
	function savePhotos()
	{
		$model = $this->getModel('events');
		$model->savePhotos();
	}	

	//delete icond function
	function deleteicon()
	{
		$model = $this->getModel('events');
		$model->deleteicon();
	}
	
	//duplicate event
	function duplicateevent()
	{
		$model = $this->getModel('events');
		$model->copy();
	}
	
	//repeat event
	function repeat()
	{
		$model = $this->getModel('events');
		$model->repeat();
	}
	
}