<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('JPATH_BASE') or die;

jimport('joomla.form.formfield');

/**
 * Supports a modal article picker.
 *
 * @package		RSEvents!
 * @subpackage	com_rsevents
 * @since		1.6
 */
class JFormFieldCategoriesField extends JFormField
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'CategoriesField';

	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	protected function getInput()
	{
		$db =& JFactory::getDBO();
		
		$db->setQuery("SELECT IdCategory,CategoryName FROM #__rsevents_categories");
		$options = $db->loadObjectList();
		$result = '<select name="'.$this->name.'[]" id="'.$this->name.'" class="inputbox" multiple="multiple">';
		
		foreach( $options as $option ) {
			$option->CategoryName = htmlentities($option->CategoryName, ENT_COMPAT, 'utf-8');
			if(is_array( $this->value) ) {
				if( in_array( $option->IdCategory, $this->value ) ) {
					$result .= '<option selected="true" value="'.$option->IdCategory.'" >'.$option->CategoryName.'</option>';
				} else {
					$result .= '<option value="'.$option->IdCategory.'" >'.$option->CategoryName.'</option>';
				}
			} elseif ( $this->value ) {
				if( $this->value == $option->IdCategory ) {
					$result .= '<option selected="true" value="'.$option->IdCategory.'" >'.$option->CategoryName.'</option>';
				} else {
					$result .= '<option value="'.$option->IdCategory.'" >'.$option->CategoryName.'</option>';
				}
			} elseif ( !( $this->value ) ) {
				$result .= '<option value="'.$option->IdCategory.'" >'.$option->CategoryName.'</option>';
			}
		}
		$result .= '</select>';
		return $result;
	}
}