<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' ); 
require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'events.php');

class RSEventsCalendar
{
	/**
	 * Array containing the order of week days
	 * @var array
	 */
	var $_weekdays = array();
	
	/**
	 * Week starts on this day
	 * @var int 
	 * @val 0,1,6
	 */
	var $_weekstart = 1;
	
	/**
	 * Week ends on this day
	 * @var int 
	 * @val 6,0,5
	 */
	var $_weekend = 0;
	
	/**
	 * Array containing all months
	 * @var array
	 */
	var $_months = array();
	
	/**
	 * Show title
	 * @var int 
	 * @val 1-12
	 */
	var $showtitle;
	
	/**
	 * Current month
	 * @var int 
	 * @val 1-12
	 */
	var $_month;
	
	/**
	 * Number of days in current month
	 * @var int 
	 * @val 28-31
	 */
	var $_month_days;
	
	/**
	 * The first day of the month in unix format
	 * @var int 
	 */
	var $_month_start_unixdate;
	
	/**
	 * The first day of the month in week format
	 * @var int 
	 * @val 1-7
	 */
	var $_month_start_day;
	
	/**
	 * Current year
	 * @var int 
	 */
	var $_year;
	
	/**
	 * Unix date used in calculations
	 * @var int 
	 */
	var $_unixdate;
	
	/**
	 * Today's date j.n.Y
	 * @var string
	 */
	var $today;
	
	/**
	 * If US format, starts with Sunday instead of Monday
	 * @var boolean
	 */
	var $is_us_format = false;
	
	/**
	 * If is module, shows the small calendar
	 * @var boolean
	 */
	var $is_module = false;
	
	/**
	 * If is module, set the class suffix
	 * @var string
	 */
	var $class_suffix ;
	
	/**
	 * Array of events
	 * @var array
	*/
	var $_events = array();
	
	/**
	 * Array of dates that contain events
	 * @var array
	*/
	var $_event_dates = array();
	
	/**
	 * List of events 
	 * @var string
	*/
	var $_event_list = null;
	
	/**
	 * List of event details 
	 * @var string
	*/
	var $_event_details = null;
	
	/**
	 * optional Itemid
	 * @var integer
	*/
	var $_itemid = null;	
	
	
	/**
	* Initializes the calendar based on today's date
	*/
	function RSEventsCalendar()
	{
		$mainframe =& JFactory::getApplication();
		$params = &$mainframe->getParams();
		$this->_weekstart = $params->get('startday','1');
		
		$startday = JRequest::getVar('startday', false);
		if ($startday !== false)
			$this->_weekstart = $startday;
		
		$this->_weekstart = (int) $this->_weekstart;
		
		$this->_getEvents();
		
		$this->today = date('j.n.Y');
		$this->setDate();
	}
	
	/**
	* Sets the date
	* @access public
	* @return true if successful
	*/
	function setDate($month=0, $year=0)
	{
		$this->setWeekStart($this->_weekstart);
		$this->_setMonths();
		$month = $month == 0 ? date('n') : $month;
		$year = $year == 0 ? date('Y') : $year;
		
		if (is_numeric($year) && $year >=1970)
			$this->_year = (int) $year;
			
		if (is_numeric($month) && $month >= 1 && $month <= 12)
		{
			$this->_month = (int) $month;
			$this->_setDate();
			$this->_month_days = date('t', $this->_unixdate);
			$this->_month_start_unixdate = strtotime(date('Y-m-01', $this->_unixdate));
			$this->_month_start_day = date('w', $this->_month_start_unixdate);
			
			$this->_createMonthObject();
		}
		return true;
	}
	
	function setWeekStart($i)
	{
		switch ($i)
		{
			case 0:
			if($this->is_module)
			$this->_weekdays = array(
			0 => JText::_('RSE_MONTH_SHORT_SUNDAY'),
			1 => JText::_('RSE_MONTH_SHORT_MONDAY'),
			2 => JText::_('RSE_MONTH_SHORT_TUESDAY'),
			3 => JText::_('RSE_MONTH_SHORT_WEDNESDAY'),
			4 => JText::_('RSE_MONTH_SHORT_THURSDAY'),
			5 => JText::_('RSE_MONTH_SHORT_FRIDAY'),
			6 => JText::_('RSE_MONTH_SHORT_SATURDAY')
			);
			else $this->_weekdays = array(
			0 => JText::_('RSE_MONTH_SUNDAY'),
			1 => JText::_('RSE_MONTH_MONDAY'),
			2 => JText::_('RSE_MONTH_TUESDAY'),
			3 => JText::_('RSE_MONTH_WEDNESDAY'),
			4 => JText::_('RSE_MONTH_THURSDAY'),
			5 => JText::_('RSE_MONTH_FRIDAY'),
			6 => JText::_('RSE_MONTH_SATURDAY')
			);
			$this->_weekstart = 0;
			$this->_weekend = 6;
			break;
			
			case 1:
			if($this->is_module)
			$this->_weekdays = array(
			1 => JText::_('RSE_MONTH_SHORT_MONDAY'),
			2 => JText::_('RSE_MONTH_SHORT_TUESDAY'),
			3 => JText::_('RSE_MONTH_SHORT_WEDNESDAY'),
			4 => JText::_('RSE_MONTH_SHORT_THURSDAY'),
			5 => JText::_('RSE_MONTH_SHORT_FRIDAY'),
			6 => JText::_('RSE_MONTH_SHORT_SATURDAY'),
			0 => JText::_('RSE_MONTH_SHORT_SUNDAY')
			);
			else $this->_weekdays = array(
			1 => JText::_('RSE_MONTH_MONDAY'),
			2 => JText::_('RSE_MONTH_TUESDAY'),
			3 => JText::_('RSE_MONTH_WEDNESDAY'),
			4 => JText::_('RSE_MONTH_THURSDAY'),
			5 => JText::_('RSE_MONTH_FRIDAY'),
			6 => JText::_('RSE_MONTH_SATURDAY'),
			0 => JText::_('RSE_MONTH_SUNDAY')
			);
			$this->_weekstart = 1;
			$this->_weekend = 0;
			break;
			
			case 6:
			if($this->is_module)
			$this->_weekdays = array(
			6 => JText::_('RSE_MONTH_SHORT_SATURDAY'),
			0 => JText::_('RSE_MONTH_SHORT_SUNDAY'),
			1 => JText::_('RSE_MONTH_SHORT_MONDAY'),
			2 => JText::_('RSE_MONTH_SHORT_TUESDAY'),
			3 => JText::_('RSE_MONTH_SHORT_WEDNESDAY'),
			4 => JText::_('RSE_MONTH_SHORT_THURSDAY'),
			5 => JText::_('RSE_MONTH_SHORT_FRIDAY')
			);
			else $this->_weekdays = array(
			6 => JText::_('RSE_MONTH_SATURDAY'),
			0 => JText::_('RSE_MONTH_SUNDAY'),
			1 => JText::_('RSE_MONTH_MONDAY'),
			2 => JText::_('RSE_MONTH_TUESDAY'),
			3 => JText::_('RSE_MONTH_WEDNESDAY'),
			4 => JText::_('RSE_MONTH_THURSDAY'),
			5 => JText::_('RSE_MONTH_FRIDAY')
			);
			$this->_weekstart = 6;
			$this->_weekend = 5;
			break;
		}
	}
	
	function _setMonths()
	{
		$this->_months = array(
		'1' => JText::_('RSE_JANUARY'),
		'2' => JText::_('RSE_FEBRUARY'),
		'3' => JText::_('RSE_MARCH'),
		'4' => JText::_('RSE_APRIL'),
		'5' => JText::_('RSE_MAY'),
		'6' => JText::_('RSE_JUNE'),
		'7' => JText::_('RSE_JULY'),
		'8' => JText::_('RSE_AUGUST'),
		'9' => JText::_('RSE_SEPTEMBER'),
		'10' => JText::_('RSE_OCTOBER'),
		'11' => JText::_('RSE_NOVEMBER'),
		'12' => JText::_('RSE_DECEMBER')
		);
	}
	
	/**
	* Sets the unix date used in calculations
	* @access private
	*/
	function _setDate()
	{
		$this->_unixdate = mktime(0,0,0,$this->_month,1,$this->_year);
	}
	
	/**
	* Get the events
	* @access private
	*/
	function _getEvents()
	{
		$mainframe =& JFactory::getApplication();
		$params = &$mainframe->getParams();
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'events.php');
		$events = rseventsModelEvents::getEventCalendar($params);
		
		$showfullevents = $params->get('fullevents',1);
		
		if (!$showfullevents)
			require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'events.php');
		
		$displayevents = $params->get('display',0);
		
		if (!empty($events))
		foreach ($events as $event)
		{
			if (!$showfullevents)
			{
				$eventfull = eventsHelper::eventisfull($event->IdEvent);
				if ($eventfull) continue;
			}
			$this->_events[$event->IdEvent] = $event;
			
			// Event start date
			$this->_event_dates[date('d.m.Y', $event->EventStartDate)][$event->IdEvent] = $event->IdEvent;
			
			// Event occuring dates
			if ($displayevents == 0)
			{
				$start = mktime(0, 0, 0, date('n', $event->EventStartDate), date('j', $event->EventStartDate), date('Y', $event->EventStartDate));
				$end = mktime(0, 0, 0, date('n', $event->EventEndDate), date('j', $event->EventEndDate), date('Y', $event->EventEndDate));
				for ($i=$start; $i<=$end; $i+=86400)
					$this->_event_dates[date('d.m.Y', $i)][$event->IdEvent] = $event->IdEvent;
			}
			
			// Event end date
			if ($displayevents == 0 || $displayevents == 2)
				$this->_event_dates[date('d.m.Y', $event->EventEndDate)][$event->IdEvent] = $event->IdEvent;
		}
	}
	
	
	/**
	* Get the colour of the event categ
	* @access private
	*/
	function _getColour($id)
	{
		$db =& JFactory::getDBO();
		$db->setQuery("SELECT c.CategoryColor FROM #__rsevents_categories c LEFT JOIN #__rsevents_events_cat ec ON ec.IdCategory = c.IdCategory WHERE ec.IdEvent = ".$id);
		
		return $db->loadResult();
	}
	
	/**
	* Get the categories names and colours
	* @access private
	*/
	function _getCategColours()
	{
		$app	=& JFactory::getApplication();
		$db 	=& JFactory::getDBO();
		$params = &$app->getParams();
		$categs = $params->get('catids',0);
		$items 	= '';
		$where	= '';
		
		$colors = $params->get('colors',0);
		$legend = $params->get('colorlegend',0);
		$catfilter = $params->get('catfil',1);
		
		$allcateg = array();
		
		if ($colors && $legend && !$catfilter)
		{
			$object = new stdClass();
			$object->IdCategory = '';
			$object->CategoryName = JText::_('RSE_SHOW_ALL_CATEGORIES');
			$object->CategoryColor = '#fff';
			$allcateg = array($object);
		}
		
		if (!is_array($categs) && $categs != 0) $categs = array($categs);
		
		$where = $categs != 0 ? " AND IdCategory IN (".implode(',',$categs).") " : "";
		
		$db->setQuery("SELECT IdCategory, CategoryName ,CategoryColor FROM #__rsevents_categories WHERE 1 = 1 ".$where."");
		$categories = array_merge($allcateg,$db->loadObjectList());
		
		$items .= '<table width="100%">'; 
		
		$i = 0;		
		foreach ($categories as $categ)
		{
			$i++;
			
			if ($i % 3 == 1) $items .= "\n\t".'<tr>';
			$items .= "\n\t\t".'<td><div class="rse_calendar_legend"><span class="rse_calendar_legend_span" style="background:'.$categ->CategoryColor.';border:2px solid '.$categ->CategoryColor.'"></span> <a href="javascript:void(0);" onclick="rse_setCateg(\''.$categ->IdCategory.'\');">'.$categ->CategoryName.'</a></div></td>';
			if ($i % 3 == 0) $items .= "\n\t".'</tr>';
		}
		$items .= '</table>';
		
		return $items;
	}
	
		
	/**
	* Show details of the events
	* @access private
	*/
	function _showDetails($event, $type)
	{
		$details = '';
		switch ($type)
		{
			case 'component': $details = $this->_showDetailsComponent($event); break;
			case 'module': $details = $this->_showDetailsModule($event); break;
		}
		return $details;
	}
	
	function _showDetailsComponent($event)
	{		
		jimport( 'joomla.application.component.view');
		$view = new JView();
		$rseventsConfig = rseventsHelper::getConfig();
		
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'events.php');
		
		$eventfull = eventsHelper::eventisfull($event->IdEvent);
		$class = $eventfull ? 'rse_event_full_class' : 'rse_event_not_full';
		
		$details = htmlentities('<span class="'.$class.'">'.$view->escape($event->EventName).'</span>',ENT_COMPAT,'UTF-8').'::';
		$details .= JText::_('RSE_STARTS_ON').' '.rseventsHelper::translateDate(date($rseventsConfig['global.dateformat'],$event->EventStartDate)).'<br/>';
		$details .= JText::_('RSE_ENDS_ON').' '.rseventsHelper::translateDate(date($rseventsConfig['global.dateformat'],$event->EventEndDate)).'<br/>';
		$details .= JText::_('RSE_AT_LOCATION').' '.$view->escape($event->LocationName).'<br/>';
		
		return $details;
	}
	
	function _showDetailsModule($event)
	{
		jimport( 'joomla.application.component.view');
		$view = new JView();
		$lang =& JFactory::getLanguage();
		$lang->load('com_rsevents',JPATH_SITE);
		
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'events.php');
		
		$details = '';
		if (!empty($event))
		{
			$count = count($event);
			$details = $count.' '.JText::_('RSE_EVENT_MODULE').($count > 1 ? JText::_('RSE_EVENT_MODULE_PLURAL') : '').'::';
			$i = 0;
			foreach ($event as $IdEvent)
			{
				$eventfull = eventsHelper::eventisfull($IdEvent);
				$class = $eventfull ? 'rse_event_full_class' : 'rse_event_not_full';
				$i++;
				$details .= htmlentities('<span class="'.$class.'">'.$view->escape($this->_events[$IdEvent]->EventName).'</span>',ENT_COMPAT,'UTF-8').($i != $count ? ', ' : '');
			}
		}
		else
			$details = JText::_('RSE_NO_EVENTS_MODULE').'::'.JText::_('RSE_NO_EVENTS_MODULE');
		
		return $details;
	}
	
	function _createMonthObject()
	{
		$month = new stdClass();
		// Days in order
		$month->weekdays = $this->_weekdays;
		// Number of days in month
		$month->nr_days = $this->_month_days;
		// Days
		$month->days = array();
		
		// Days in previous month
		if ($this->_month_start_day != $this->_weekstart)
		{
			$day = new stdClass();
			$day->day = $this->_weekstart;
		
			$i = 0;
			foreach ($this->_weekdays as $position => $weekday)
				if ($position == $this->_month_start_day)
					break;
				else
					$i++;
			
			for ($i; $i>0; $i--)
			{
				$day = new stdClass();
				$unixdate = strtotime('-'.$i.' days', $this->_month_start_unixdate);
				$day->unixdate = $unixdate;
				$day->day = date('w', $unixdate);
				$day->week = date('W', $unixdate);
				$day->class = 'prev-month';
				$day->events = false;
				if (!empty($this->_event_dates[date('d.m.Y', $unixdate)]))
					$day->events = $this->_event_dates[date('d.m.Y', $unixdate)];
				if (!empty($day->events))
					$day->class .= ' has-events';
				
				$month->days[] = $day;
			}
		}
		
		// Days in current month
		for ($i=1; $i<=$month->nr_days; $i++)
		{
			$day = new stdClass();
			$unixdate = mktime(0, 0, 0, $this->_month, $i, $this->_year);
			$day->unixdate = $unixdate;
			$day->day = date('w', $unixdate);
			$day->week = date('W', $unixdate);
			$day->class = 'curr-month';
			if (date('d.m.Y', $day->unixdate) == date('d.m.Y'))
				$day->class .= ' curr-day';
			$day->events = false;
				if (!empty($this->_event_dates[date('d.m.Y', $unixdate)]))
					$day->events = $this->_event_dates[date('d.m.Y', $unixdate)];
			if (!empty($day->events))
				$day->class .= ' has-events';
			
			$month->days[] = $day;
		}
		
		// Days in next month
		$i = 1;
		if ($day->day != $this->_weekend)
			while($day->day != $this->_weekend)
			{
				$day = new stdClass();
				$unixdate = mktime(0, 0, 0, $this->_month, $month->nr_days+$i, $this->_year);
				$day->unixdate = $unixdate;
				$day->day = date('w', $unixdate);
				$day->week = date('W', $unixdate);
				$day->class = 'next-month';
				$day->events = false;
				if (!empty($this->_event_dates[date('d.m.Y', $unixdate)]))
					$day->events = $this->_event_dates[date('d.m.Y', $unixdate)];
				if (!empty($day->events))
					$day->class .= ' has-events';
				$i++;
				
				$month->days[] = $day;
			}
		
		$this->_days = $month;
	}
	
	/**
	* Display the calendar 
	* @access private
	*/
	function display() 
	{
		$mainframe =& JFactory::getApplication();
		jimport( 'joomla.application.component.view');
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'rsevents.php');
		$db =& JFactory::getDBO();
		$doc =& JFactory::getDocument();
		$view = new JView();
		
		$params = &$mainframe->getParams();
		$title = $params->get('page_title','calendar');
		$title = str_replace(' ','',$title);
		
		$idcateg = JRequest::getVar('idcat','','post');
		$idcateg		= $mainframe->getUserStateFromRequest('calendaridcat'.$title, 'idcat', 0, 'int');
		$tmpl = JRequest::getVar('tmpl');
		
		//get the suffix
		$suffix       = $this->is_module ? 'module' : 'component';
		
		$session = JFactory::getSession();
        $session->set('rsevents.idcateg', $idcateg);
		if (empty($idcateg)) $session->clear('rsevents.idcateg');
		
		//get optional itemid for the module
		$itemId = ($this->is_module && !empty($this->_itemid)) ? '&Itemid='.$this->_itemid : '';
		
		//get parameters
		$show_week = $params->get('sweek','1');
		$show_details = $params->get('detailview','1');
		$show_catfil = $params->get('catfil','1');
		$color = $params->get('colors','0');
		$legend = $params->get('colorlegend','0');
		$categoriesfilter = $params->get('catids',0);
		$categoriesfilter = $categoriesfilter == 0 ? null : $categoriesfilter;
		$design = $params->get('design','default');
		
		if (!$this->is_module)
			$doc->addStyleSheet(JURI::root().'components/com_rsevents/assets/calendar/'.$design.'/'.$design.'_component.css');
		
		//get the total number of categories
		$db->setQuery("SELECT COUNT(IdCategory) FROM #__rsevents_categories");
		$numcats = $db->loadResult();
		
		$defaultoptiondisabled = $categoriesfilter == null ? false : true;
		if ($numcats == count($categoriesfilter)) $defaultoptiondisabled = false;
		
		$default = JHTML::_('select.option',  '0', JText::_( 'RSE_EVENT_SELECT_CATEGORY' ), 'value', 'text' , $defaultoptiondisabled );
		$lists['categories'] = rseventsHelper::getCategories('idcat','class="inputbox" size="1"',$idcateg,$default,$categoriesfilter);
	?>
		<?php if(($tmpl != 'component' && $this->is_module) || !$this->is_module){ ?>
			<div id="rsevents_calendar_<?php echo $suffix; ?>" class="rsevents_calendar_<?php echo $suffix.$this->class_suffix; ?>">
		<?php }	?>
		<?php if(!$this->is_module) { ?>
		<form action="<?php echo htmlentities(JRequest::getURI(), ENT_COMPAT, 'utf-8'); ?>" method="post" name="rse_calendar_form">
		<?php } ?>
		
		<table cellpadding="0" cellspacing="2" border="0" width="100%">
			<tr>
				<td align="left">					
					<!-- left arrow -->
					<?php
						$lhref = $this->is_module ? 'javascript:void(0)' : rseventsHelper::route('index.php?option=com_rsevents&view=calendar&month='.date('m', strtotime('-1 month', $this->_unixdate)).'&year='.date('Y', strtotime('-1 month', $this->_unixdate)),false);
						$lscript = $this->is_module ? 'onclick="rse_calendar_change_month(\''.rseventsHelper::route('index.php?option=com_rsevents&view=calendar&month='.date('m', strtotime('-1 month', $this->_unixdate)).'&year='.date('Y', strtotime('-1 month', $this->_unixdate)).'&tmpl=component&startday='.$this->_weekstart.$itemId,false).'\')"' : '';
						$lstyle = $this->is_module ? 'class="rsevents_calendar_arrows_module" id="rsevents_calendar_arrow_left_module"' : 'class="rsevents_calendar_arrows" id="rsevents_calendar_arrow_left"';
					?>
					<a rel="nofollow" href="<?php echo $lhref; ?>" <?php echo $lscript; ?> <?php echo $lstyle; ?> >&laquo;</a>					
				</td>
				<?php if($this->is_module) { ?>
				<td align="center"><?php echo $this->_months[$this->_month].' '.date('Y', $this->_unixdate); ?></td>
				<?php } else { ?>
				<td align="center">
					<input type="hidden" name="option" value="com_rsevents" />
					<input type="hidden" name="view" value="calendar" />
					<select name="month">
					<?php foreach ($this->_months as $i => $month) { ?>
					<option <?php echo $this->_month == $i ? 'selected="selected"' : ''; ?> value="<?php echo $i; ?>"><?php echo $month; ?></option>
					<?php } ?>
					</select>
					<select name="year">
					<?php for($i=1999;$i<=2037;$i++) {  ?>
					<option <?php echo $this->_year == $i ? 'selected="selected"' : ''; ?> value="<?php echo $i; ?>"><?php echo $i; ?></option>
					<?php } ?>
					</select>
					<?php if($show_catfil) echo $lists['categories']; else { ?> <input type="hidden" name="idcat" id="idcat" value="" /> <?php } ?>
					<button type="submit" class="button"><?php echo JText::_('RSE_GO'); ?></button>
				</td>
				<?php } ?>
				<td align="right">
					<!-- right arrow -->
					<?php
						$rhref = $this->is_module ? 'javascript:void(0)' : rseventsHelper::route('index.php?option=com_rsevents&view=calendar&month='.date('m', strtotime('+1 month', $this->_unixdate)).'&year='.date('Y', strtotime('+1 month', $this->_unixdate)),false);
						$rscript = $this->is_module ? 'onclick="rse_calendar_change_month(\''.rseventsHelper::route('index.php?option=com_rsevents&view=calendar&month='.date('m', strtotime('+1 month', $this->_unixdate)).'&year='.date('Y', strtotime('+1 month', $this->_unixdate)).'&tmpl=component&startday='.$this->_weekstart.$itemId,false).'\')"' : '';
						$rstyle = $this->is_module ? 'class="rsevents_calendar_arrows_module" id="rsevents_calendar_arrow_right_module"' : 'class="rsevents_calendar_arrows" id="rsevents_calendar_arrow_right"';
					?>
					<a rel="nofollow" href="<?php echo $rhref; ?>" <?php echo $rscript; ?> <?php echo $rstyle; ?> >&raquo;</a>
				</td>
			</tr>
		</table>

		<table class="rsevents_calendar_<?php echo $suffix; ?>" cellpadding="0" cellspacing="0" width="100%">
			<thead>
				<tr>
					<?php  if(!$this->is_module && $show_week ==1) { ?><th width="3%"><?php echo JText::_('RSE_WEEK'); ?></th><?php } ?>
					<?php foreach ($this->_days->weekdays as $weekday) { ?>
					<th><?php echo $weekday; ?></th>
					<?php } ?>
				</tr>
			</thead>
			<tbody>
			<?php foreach ($this->_days->days as $day) {
					if ($day->day == $this->_weekstart) { ?>
						<tr>
						<?php if (!$this->is_module && $show_week ==1) { ?>
							<td class="week"><a href="<?php echo rseventsHelper::route('index.php?option=com_rsevents&view=calendar&layout=week&date='.date('m/d/Y', $day->unixdate).$itemId); ?>"><?php echo $day->week; ?></a></td>
						<?php } ?>
					<?php } ?>
					
					<td class="<?php echo $day->class; ?>"><a href="<?php echo rseventsHelper::route('index.php?option=com_rsevents&view=calendar&layout=day&date='.date('m/d/Y',$day->unixdate).$itemId);?>" <?php echo $this->is_module ? 'class="editlinktip hasTip" title="'.$this->_showDetails($day->events, $suffix).'"' : ''; ?>>
					<span class="rse_date"><?php echo date('j', $day->unixdate); ?></span></a>
						<?php if (!empty($day->events) && !$this->is_module && $show_details == 0) { ?> 
							<div class="rse_event">
								<a style="text-decoration:none;cursor:pointer;" class="editlinktip hasTip" title="<?php echo $this->_showDetails($day->events, 'module'); ?>"><?php echo count($day->events).' '.(count($day->events) > 1 ? JText::_('RSE_EVENTS') : JText::_('RSE_EVENT')); ?></a>
							</div>
						<?php } ?>
					<?php if (!empty($day->events) && !$this->is_module && $show_details == 1) foreach ($day->events as $event) { ?>
						<?php $evcolor = $this->_getColour($event); $style = empty($evcolor) ? 'border-left: 2px solid #809FFF;' : 'border-left: 2px solid '.$evcolor; ?>
						<div class="rse_event"<?php echo ' style="'.$style.'"' ?>>
							<a href="<?php echo rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=show&cid='.eventsHelper::sef($event,$this->_events[$event]->EventName).$itemId); ?>" class="editlinktip hasTip" <?php if ($color) { ?> style="color:<?php echo $this->_getColour($event); ?>;" <?php } ?> title="<?php echo $this->_showDetails($this->_events[$event], $suffix); ?>"><?php echo $view->escape($this->_events[$event]->EventName); ?></a>
						</div>
					<?php } ?>
					</td>
					<?php if ($day->day == $this->_weekend) { ?></tr><?php } ?>
			<?php } ?>			
			</tbody>
		</table>
		<?php if(!$this->is_module) { ?>
		<br/>
		<?php if($show_catfil) { ?>
		<input type="hidden" name="fromcalendar" value="1" />
		<?php } ?>
		</form>
		<?php } ?>
		
	<?php if(($tmpl != 'component' && $this->is_module) || !$this->is_module){ ?>
	</div>
	<?php } ?>
		<?php if (!$this->is_module) { ?>
		<?php if ($color && $legend) { ?>
		<strong><?php echo JText::_('RSE_LEGEND'); ?></strong>
		<br /><br />
		<?php echo $this->_getCategColours(); ?>
		
		<script type="text/javascript">
			function rse_setCateg(cid)
			{
				document.getElementById('idcat').value = cid;
				document.rse_calendar_form.submit();
			}
		</script>
		
		<?php } } ?>
		
		
	<?php } 
	
}