<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' ); 
require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'events.php');

class rseventsEmails
{
	
	/*
	*	Get available placeholders
	*/
	
	function placeholders($text,$id,$uid = null, $optionals = null, $iconclass = null, $idsubscriber = null)
	{
		jimport('joomla.filesystem.file');
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'rsevents.php');
		rseventsHelper::readConfig();
		
		$db =& JFactory::getDBO();
		$u =& JFactory::getURI();
		$app =& JFactory::getApplication();
		$lang =& JFactory::getLanguage();
		$lang->load('com_rsevents');
		
		//get the post
		$post = JRequest::get('post',JREQUEST_ALLOWRAW);
		
		//sanitize the id
		$id = intval($id);
		
		//get the config
		$config = rseventsHelper::getConfig();
		
		$columns = array();
		//get the desired columns
		$columns[] = 'e.EventName';				$columns[] = 'e.EventDescription';				$columns[] = 'e.EventStartDate';			$columns[] = 'e.EventEndDate';
		$columns[] = 'e.EventHost';				$columns[] = 'e.EventSubtitle';					$columns[] = 'e.EventURL';					$columns[] = 'e.EventPhone';
		$columns[] = 'e.EventEmail';			$columns[] = 'e.EventIcon';						$columns[] = 'e.IdEvent';
		
		$columns[] = 'l.LocationName';			$columns[] = 'l.LocationDescription';			$columns[] = 'l.LocationURL';				$columns[] = 'l.LocationCountry';
		$columns[] = 'l.LocationCity';			$columns[] = 'l.LocationAddress';				$columns[] = 'l.LocationZip';				$columns[] = 'l.LocationState';
		$columns[] = 'l.IdLocation';
		
		if (!is_null($uid)) $columns[] = $config['posted.by'] ? 'u.name' : 'u.username';
		
		$joins = array();
		//get table joins
		$joins[] = "LEFT JOIN #__rsevents_locations l ON e.IdLocation = l.IdLocation";
		
		if (!is_null($uid))
			$joins[] = "LEFT JOIN #__users u ON u.id = '".$uid."'";
		
		$columns = !empty($columns) ? implode(' , ',$columns) : 'e.IdEvent';
		$joins   = !empty($joins) ? implode(' ',$joins) : '';
		
		//get details
		$db->setQuery("SELECT ".$columns." FROM #__rsevents_events e ".$joins." WHERE e.IdEvent = ".$id." ");
		$details = $db->loadObject();
		
		//get categories		
		$categories = eventsHelper::createCategories($id);
		
		//get site url
		$site = $u->toString(array('scheme','host'));
		
		//get the private link if exists
		$private = JRequest::getVar('privateUrl') != '' ? '&privateUrl='.JRequest::getVar('privateUrl') : '';
		
		$elink = rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=show&cid='.eventsHelper::sef($details->IdEvent,$details->EventName).$private,false);
		
		if ($app->getName() == 'site')
			$elink = $site.$elink;
		else 
			$elink = JURI::root().$elink;		
		
		//event link
		$eventlink = '<a target="_blank" href="'.$elink.'">'.$details->EventName.'</a>';
		
		//get the event icon
		$smallicon = str_replace('.'.JFile::getExt($details->EventIcon),'_'.$config['event.icon.small'].'.'.JFile::getExt($details->EventIcon),$details->EventIcon);
		$bigicon = str_replace('.'.JFile::getExt($details->EventIcon),'_'.$config['event.icon.big'].'.'.JFile::getExt($details->EventIcon),$details->EventIcon);
		
		if($config['enable.event.icon'] && $details->EventIcon != '')
		{
			if (!is_null($iconclass))
			{
				$start = '<div class="rsevents_icon">';
				$end = '</div>';
			} else $start = $end = '';
			
			$eventsmallicon = $start.'<a href="'.$elink.'"><img src="'.JURI::root().'components/com_rsevents/assets/images/thumbs/'.$smallicon.'" alt="" /></a>'.$end;
			$eventbigicon = $start.'<a href="'.$elink.'"><img src="'.JURI::root().'components/com_rsevents/assets/images/thumbs/'.$bigicon.'" alt="" /></a>'.$end;
		} else $eventsmallicon = $eventbigicon = '';
		
		//get dates
		$dateonly		= str_replace(array('H:i:s','H:i','H','h:i:s','h:i','h','g','G','a','A','H i s','H i','h i s','h i','H/i/s','H/i','h/i/s','h/i','H-i-s','H-i','h-i-s','h-i'),'',$config['global.dateformat']);
		$timeformat		= empty($config['global.time']) ? 'H:i:s' : $config['global.time'];
		$startDateFull	= rseventsHelper::translateDate(date($config['global.dateformat'],$details->EventStartDate));
		$endDateFull	= rseventsHelper::translateDate(date($config['global.dateformat'],$details->EventEndDate));
		$startDateDate	= rseventsHelper::translateDate(date($dateonly,$details->EventStartDate));
		$startDateTime	= date($timeformat,$details->EventStartDate);
		$endDateDate	= rseventsHelper::translateDate(date($dateonly,$details->EventEndDate));
		$endDateTime	= date($timeformat,$details->EventEndDate);
		
		//get optional message
		$optionalmessage = isset($post['message']) ? $post['message'] : '';
		
		$eventurl = $elink;		
		$locationlink = rseventsHelper::route('index.php?option=com_rsevents&view=locations&layout=show&cid='.$details->IdLocation.'&IdEvent='.$details->IdEvent,false);
		
		if ($app->getName() == 'site')
			$locationlink = $site.$locationlink;
		else 
			$locationlink = JURI::root().$locationlink;		
		
		$search 	= array('{EventName}','{EventLink}','{EventDescription}','{EventStartDate}','{EventStartDateOnly}','{EventStartTime}','{EventEndDate}','{EventEndDateOnly}','{EventEndTime}','{EventHost}','{EventSubtitle}','{EventURL}','{EventPhone}','{EventEmail}','{LocationName}','{LocationDescription}','{LocationURL}','{LocationCountry}','{LocationCity}','{LocationAddress}','{LocationZip}','{LocationState}','{EventCategories}','{CategoryName}','{EventIcon}','{EventIconSmall}','{EventIconBig}','{message}','{EventLocationHref}','{LocationLink}');
		$replace 	= array($details->EventName,$eventlink,$details->EventDescription,$startDateFull,$startDateDate,$startDateTime,$endDateFull,$endDateDate,$endDateTime,$details->EventHost,$details->EventSubtitle,$details->EventURL,$details->EventPhone,$details->EventEmail,$details->LocationName,$details->LocationDescription,$details->LocationURL,$details->LocationCountry,$details->LocationCity,$details->LocationAddress,$details->LocationZip,$details->LocationState,$categories,$categories,$eventsmallicon,$eventsmallicon,$eventbigicon,$optionalmessage,$eventurl,$locationlink);
		
		$text = str_replace($search,$replace,$text);
		
		if (!is_null($uid))
		{
			$username = $config['posted.by'] ? $details->name : $details->username;
			if (empty($username))
			{
				if (!is_null($idsubscriber))
				{
					$db->setQuery("SELECT CONCAT_WS(' ',FirstName,LastName) FROM #__rsevents_subscriptions WHERE IdSubscription = ".intval($idsubscriber)." ");
					$username = $db->loadResult();
				}
			}
			
			$text = str_replace('{username}',$username,$text);
		}
		
		if (!is_null($optionals) && is_array($optionals))
			$text = str_replace(array('{TicketInfo}','{TicketPrice}','{TicketsTotal}','{Discount}'),$optionals,$text);
		
		return $text;
	}
	
	
	/*
	*	Invite e-mail
	*/
	
	function invite($from,$to,$id)
	{
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'rsevents.php');
		rseventsHelper::readConfig();
		$config = rseventsHelper::getConfig();
		
		$fromName	= $config['emails.from.name'];
		$subject	= $config['emails.invite.subject'];
		$subject	= rseventsEmails::placeholders($subject,$id);
		$body		= $config['emails.invite.content'];
		$body		= rseventsEmails::placeholders($body,$id);
		$mode		= $config['emails.invite.type'];
		$replyto	= $config['emails.reply'];			
		$cc			= !empty($config['emails.cc']) ? $config['emails.cc'] : null;
		$bcc		= !empty($config['emails.bcc']) ? $config['emails.bcc'] : null;
		
		JUtility::sendMail($from , $fromName , $to , $subject , $body , $mode , $cc , $bcc , null , $replyto);
		
		return true;
	}
	
	
	/*
	*	Registration e-mail
	*/
	
	function registration($to,$uid,$id,$optionals,$idsubscriber=null)
	{
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'rsevents.php');
		rseventsHelper::readConfig();
		$config = rseventsHelper::getConfig();
		
		$from		= $config['emails.from'];
		$fromName	= $config['emails.from.name'];
		$subject	= $config['emails.registration.subject'];
		$subject	= rseventsEmails::placeholders($subject,$id,$uid,$optionals,null,$idsubscriber);
		$body		= $config['emails.registration.content'];
		$body		= rseventsEmails::placeholders($body,$id,$uid,$optionals,null,$idsubscriber);
		$mode		= $config['emails.registration.type'];
		$replyto	= $config['emails.reply'];
		$cc			= !empty($config['emails.cc']) ? $config['emails.cc'] : null;
		$bcc		= !empty($config['emails.bcc']) ? $config['emails.bcc'] : null;
		
		if ($config['emails.registration.enable'])
			JUtility::sendMail($from , $fromName , $to , $subject , $body , $mode , $cc , $bcc , null , $replyto);
		
		return true;
	}
	
	
	/*
	*	Activation e-mail
	*/
	
	function activation($to,$uid,$id,$optionals,$idsubscriber = null)
	{
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'rsevents.php');
		rseventsHelper::readConfig();
		$config = rseventsHelper::getConfig();
		
		$db			=& JFactory::getDBO();
		$app		=& JFactory::getApplication();
		$from		= $config['emails.from'];
		$fromName	= $config['emails.from.name'];
		$subject	= $config['emails.activation.subject'];
		$subject	= rseventsEmails::placeholders($subject,$id,$uid,$optionals,null,$idsubscriber);
		$body		= $config['emails.activation.content'];
		$body		= rseventsEmails::placeholders($body,$id,$uid,$optionals,null,$idsubscriber);
		$mode		= $config['emails.activation.type'];
		$replyto	= $config['emails.reply'];
		$cc			= !empty($config['emails.cc']) ? $config['emails.cc'] : null;
		$bcc		= !empty($config['emails.bcc']) ? $config['emails.bcc'] : null;
		
		$attachment = rseventsEmails::pdfAttachement($to,$uid,$id,$optionals,$idsubscriber);
		
		if($config['emails.activation.enable'])
		{
			if (JUtility::sendMail($from , $fromName , $to , $subject , $body , $mode , $cc , $bcc , $attachment , $replyto))
			{
				$app->triggerEvent('rse_activationEmailCleanup',array(array('id'=>&$id)));
				
				$db->setQuery("SELECT ticket_pdf_layout FROM #__rsevents_events WHERE IdEvent = ".(int) $id." ");
				$layout = $db->loadResult();
				
				if (strpos($layout,'{barcode}') !== FALSE)
				{
					jimport('joomla.filesystem.file');
					JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'barcode'.DS.'rset-'.$idsubscriber.'.png');
				}
			}
		}
		
		return true;
	}
	
	
	/*
	*	Unsubscribe e-mail
	*/
	
	function unsubscribe($to,$uid,$id,$idsubscriber = null)
	{
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'rsevents.php');
		rseventsHelper::readConfig();
		$config = rseventsHelper::getConfig();
		
		$from		= $config['emails.from'];
		$fromName	= $config['emails.from.name'];
		$subject	= $config['emails.unsubscribe.subject'];
		$subject	= rseventsEmails::placeholders($subject,$id,$uid,null,null,$idsubscriber);
		$body		= $config['emails.unsubscribe.content'];
		$body		= rseventsEmails::placeholders($body,$id,$uid);
		$mode		= $config['emails.unsubscribe.type'];
		$replyto	= $config['emails.reply'];
		$cc			= !empty($config['emails.cc']) ? $config['emails.cc'] : null;
		$bcc		= !empty($config['emails.bcc']) ? $config['emails.bcc'] : null;
		
		if ($config['emails.unsubscribe.enable'])
			JUtility::sendMail($from , $fromName , $to , $subject , $body , $mode , $cc , $bcc , null , $replyto);
		
		return true;
	}
	
	
	/*
	*	Reminder e-mail
	*/
	
	function reminder($to,$uid,$id)
	{
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'rsevents.php');
		rseventsHelper::readConfig();
		$config = rseventsHelper::getConfig();
		
		$from		= $config['emails.from'];
		$fromName	= $config['emails.from.name'];
		$subject	= $config['emails.rem.subject'];
		$subject	= rseventsEmails::placeholders($subject,$id,$uid);
		$body		= $config['emails.rem.content'];
		$body		= rseventsEmails::placeholders($body,$id,$uid);
		$mode		= $config['emails.rem.type'];
		$replyto	= $config['emails.reply'];
		$cc			= !empty($config['emails.cc']) ? $config['emails.cc'] : null;
		$bcc		= !empty($config['emails.bcc']) ? $config['emails.bcc'] : null;
		
		if($from != '') 
			JUtility::sendMail($from , $fromName , $to , $subject , $body , $mode , $cc , $bcc , null , $replyto);
	}
	
	
	/*
	*	Post-reminder e-mail
	*/
	
	function postreminder($to,$uid,$id)
	{
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'rsevents.php');
		rseventsHelper::readConfig();
		$config = rseventsHelper::getConfig();
		
		$from		= $config['emails.from'];
		$fromName	= $config['emails.from.name'];
		$subject	= $config['emails.reminder.subject'];
		$subject	= rseventsEmails::placeholders($subject,$id,$uid);
		$body		= $config['emails.reminder.content'];
		$body		= rseventsEmails::placeholders($body,$id,$uid);
		$mode		= $config['emails.reminder.type'];
		$replyto	= $config['emails.reply'];
		$cc			= !empty($config['emails.cc']) ? $config['emails.cc'] : null;
		$bcc		= !empty($config['emails.bcc']) ? $config['emails.bcc'] : null;		
		
		if($from != '') 
			JUtility::sendMail($from , $fromName , $to , $subject , $body , $mode , $cc , $bcc , null , $replyto);
		
		return true;
	}
	
	
	function pdfAttachement($to,$uid,$id,$optionals,$idsubscriber)
	{
		$db  =& JFactory::getDBO();
		$app =& JFactory::getApplication();
		
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'rsevents.php');
		rseventsHelper::readConfig();
		$config = rseventsHelper::getConfig();
		
		if (rseventsHelper::is16())
			$db->setQuery("SELECT `extension_id` FROM `#__extensions` WHERE `type` = 'plugin' AND `element` = 'rsepdf' AND `folder` = 'system' AND `enabled` = 1");
		else
			$db->setQuery("SELECT `id` FROM `#__plugins` WHERE `element` = 'rsepdf' AND `folder` = 'system' AND `published` = 1");
		$isPdf = $db->loadResult();
		
		if ($isPdf)
		{
			$db->setQuery("SELECT ticket_pdf_layout FROM #__rsevents_events WHERE IdEvent = ".(int) $id." ");
			$layout = $db->loadResult();
			$layout = utf8_decode($layout);
			$layout = rseventsEmails::placeholders($layout,$id,$uid,$optionals,null,$idsubscriber);
			
			if (strpos($layout,'{barcode}') !== FALSE)
			{
				jimport('joomla.filesystem.file');
				require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'pdf'.DS.'barcodes.php');
				$barcode = new TCPDFBarcode('RSET-'.$idsubscriber,$config['barcode']);
				
				ob_start();
				$barcode->getBarcodePNG();
				$thecode = ob_get_contents();
				ob_end_clean();
				
				$file = JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'barcode'.DS.'rset-'.$idsubscriber.'.png';
				$upload = JFile::write($file,$thecode);
				$barcodeHTML = $upload ? '<img src="'.$file.'" alt="" />' : '';
				
				$layout = str_replace('{barcode}',$barcodeHTML,$layout);
			}
			
			$attachment = null;
			$app->triggerEvent('rse_activationEmail',array(array('id'=>&$id,'attachment'=>&$attachment,'layout'=>&$layout)));
			return $attachment;
		}
		
		return null;
	}
}