<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' ); 


class EventDesign
{
	
	/*
	*	Design type
	*	@var string|int
	*/
	var $_type = null;
	
	/*
	*	Database object
	*	@var db object
	*/
	var $_db = null;
	
	/*
	*	Design
	*	@var html object
	*/
	var $_design = null;

	/*
	*	Events
	*	@var events object
	*/
	var $events = null;

	/*
	*	Config
	*	@var config object
	*/
	var $config = null;

	
	
	/*
	*	Main constructor
	*/
	
	function EventDesign($type, $design, $events)
	{
		//load the language
		$lang =& JFactory::getLanguage();
		$lang->load('com_rsevents',JPATH_SITE);
		
		//set the database object
		$this->_db =& JFactory::getDBO();
		
		//set the type 
		$this->_type = $type;
		
		//set the events object
		$this->events = $events;
		
		//set the design
		$this->_design = $design;
		
		//set the config
		rseventsHelper::readConfig();
		$this->config = rseventsHelper::getConfig();
	}
	
	
	/*
	*	Table header
	*/
	
	function getHeaderTable()
	{
		$return = '<thead>';
		$return .= "\t".'<tr>'."\n";
		$return .= "\t\t".'<th>'.JText::_('RSE_DATE').'</th>'."\n";
		$return .= "\t\t".'<th>'.JText::_('RSE_EVENTNAME').'</th>'."\n";
		$return .= "\t\t".'<th>'.JText::_('RSE_LOCATION_NAME').'</th>'."\n";
		$return .= "\t\t".'<th>'.JText::_('RSE_CATEGORY_NAME').'</th>'."\n";
		$return .= "\t".'</tr>'."\n";
		$return .= '</thead>';
		
		return $return;
	}
	
	/*
	*	render events
	*/
	
	function render()
	{
		if (empty($this->events)) return JText::_('RSE_NO_EVENTS');
		
		$return = '';
		
		if ($this->_type == '0' || $this->_type == '1')
		{
			foreach ($this->events as $event)
				$return .= $this->getBlock($event,$this->_design);
			
		} else if ($this->_type == '2' || $this->_type == '3') {
			$return .= '<table class="rsevents-table-list" cellspacing="0" cellpadding="0" width="100%">';
			$return .= $this->getHeaderTable();
			
			foreach ($this->events as $event)
				$return .= $this->getBlock($event,$this->_design);
			
			$return .= '</table>';
		} else 
		{			
			if (file_exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'designs'.DS.'intro_'.$this->_type.DS.$this->_type.'.php'))
			{
				jimport('joomla.utilities.simplexml');
				$head = '';
				$xml = new JSimpleXML;
				$xml->loadFile(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'designs'.DS.'intro_'.$this->_type.DS.$this->_type.'.xml');
				$type = @$xml->document->attributes('type');
				if (empty($type)) $type = 'xhtml';
				
				if (file_exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'designs'.DS.'intro_'.$this->_type.DS.'style.css'))
				{
					$doc =& JFactory::getDocument();
					$doc->addStyleSheet(JURI::root().'components/com_rsevents/designs/intro_'.$this->_type.'/style.css');
				}
				
				ob_start();
				include_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'designs'.DS.'intro_'.$this->_type.DS.$this->_type.'.php');
				$content = ob_get_contents();
				ob_clean();
				
				if ($type == 'table')
					$return .= '<table width="100%" cellspacing="0" cellpadding="0" class="rse_table_list">';
				
				if ($type == 'table')
				{
					if (file_exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'designs'.DS.'intro_'.$this->_type.DS.'head.php'))
					{
						ob_start();
						include_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'designs'.DS.'intro_'.$this->_type.DS.'head.php');
						$head = ob_get_contents();
						ob_clean();
						
						$return .= $head;
					}
				}
				
				foreach ($this->events as $event)
					$return .= $this->getBlock($event,$content);
					
				if ($type == 'table')
					$return .= '</table>';
			}
		}
		
		return $return;
	}
	
	/*
	*	replace placeholders
	*/
	
	function getBlock($event,$layout)
	{
		jimport( 'joomla.application.component.view');
		
		$db =& JFactory::getDBO();
		$view = new JView();
		
		$rseventsConfig = rseventsHelper::getConfig();
		
		//do we have registration on ?
		$db->setQuery("SELECT EventEnableRegistration FROM #__rsevents_events WHERE IdEvent = ".$event->IdEvent);
		$hasregistration = $db->loadResult();
		
		//is the event full ? 
		$eventfull = $hasregistration ? eventsHelper::eventisfull($event->IdEvent) : 0;
		
		// event & location link
		$eventlink = rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=show&cid='.eventsHelper::sef($event->IdEvent,$event->EventName),false);
		$locationlink = rseventsHelper::route('index.php?option=com_rsevents&view=locations&layout=show&cid='.$event->IdLocation.'&IdEvent='.$event->IdEvent,false);						
		if($hasregistration == 1)
			$subscribelink = '<a href="'.rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=subscribe&cid='.eventsHelper::sef($event->IdEvent,$event->EventName),false).'">'.JText::_('RSE_MENU_EVENT_SUBSCRIBE').'</a>';
		else $subscribelink = '';

		$bad  = array('{EventLink}','{LocationLink}','{EventSubscribe}','{EventFullClass}');
		$good = array($eventlink,$locationlink,$subscribelink,($eventfull) ? 'class="rsevents_full"' : '');
		
		$layout = str_replace($bad,$good,$layout);
		$properties = array(); $values = array();
		
		//prepare the description
		$description = rseventsHelper::strip_html_tags($event->EventDescription);
		$description = trim($description);
		$event->EventDescription = rseventsHelper::shortenjs($description,$event->IdEvent);
		
		foreach($event as $property => $value)
		{
			if ($property == 'EventHost') $value = $rseventsConfig['hostedby'] == 1 ? eventsHelper::linkprofile($value) : $value;
			if ($property == 'EventIcon') $value = '{EventIcon}';
			if ($property == 'EventStartDate') $value = '{EventStartDate}';
			if ($property == 'EventEndDate') $value = '{EventEndDate}';
			
			$properties[] = '{'.$property.'}';
			if ($property == 'EventHost' || $property == 'EventDescription')
				$values[] = $value;
			else	
				$values[] = $view->escape($value);
		}
		
		$layout = str_replace($properties, $values, $layout);
		$layout = rseventsEmails::placeholders($layout,$event->IdEvent,null,null,'true');
		
		$pattern = '#__(.*?)__#is';
		preg_match_all($pattern,$layout,$matches);
		
		if (!empty($matches) && !empty($matches[0]))
			foreach ($matches[0] as $match)
				$layout = str_replace($match,JText::_('RSE'.$match),$layout);
		
		return $layout;
	}
	
}