<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' ); 

require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'events.php');
jimport('joomla.filesystem.file');

class eventsHelper
{
	
	//load the files for this event
	function getFiles()
	{
		$db =& JFactory::getDBO();
		$cid = JRequest::getInt('cid',0);
		$db->setQuery("SELECT IdFile, IdEvent, FileName , FileLocation, FilePermission FROM #__rsevents_files WHERE IdEvent='".$cid."'");
		$rows = $db->loadObjectList();
		return $rows;
	}
	
	//load the extras
	function getExtras()
	{
		$db =& JFactory::getDBO();
		$cid = JRequest::getInt('cid',0,'request');
		$db->setQuery("SELECT IdExtra,ExtraName , ExtraValue FROM #__rsevents_extras WHERE IdEvent='".$cid."'");
		$rows = $db->loadObjectList();
		return $rows;
	}	
	
	function getExtraPhotos()
	{
		$cid = JRequest::getInt('cid',0);
		$row= & JTable::getInstance('Rsevents_Extras','Table');
		$row->load($cid);
		return $row;
	}	
	
	
	//load a specific extra
	function getExtra()
	{
		$cid = JRequest::getInt('cid',0);
		$idevent = JRequest::getInt('IdEvent',0);
		$row= & JTable::getInstance('Rsevents_Extras','Table');
		$row->load($cid);
		$row->IdEvent = $idevent;
		return $row;
	}
	
	//make url safe
	function sef($id,$name)
	{
		return $id.':'.JFilterOutput::stringURLSafe($name);
	}
	
	//link hosted by to profile
	function linkprofile($name,$id=null)
	{
		$db =& JFactory::getDBO();
		$config = rseventsHelper::getConfig();
		
		if (is_null($id))
		{
			$db->setQuery("SELECT id FROM #__users WHERE username = '".$name."' OR name = '".$name."' LIMIT 1 ");
			$id = $db->loadResult();
		}
		
		if ($id > 0)
		{
			switch($config['subscribers.link'])
			{
				case '0':
					$return = $name;
				break;
				
				case '1':
					$return = '<a href="'.rseventsHelper::route('index.php?option=com_comprofiler&task=userProfile&user='.$id,false).'">'.$name.'</a>';
				break;
				
				case '2':
					$return = '<a href="'.rseventsHelper::route('index.php?option=com_joomunity&cmd=Profile.View.'.$id,false).'">'.$name.'</a>';
				break;
				
				case '3':
					$return = '<a href="'.rseventsHelper::route('index.php?option=com_community&view=profile&userid='.$id,false).'">'.$name.'</a>';
				break;
			}
		} else $return = $name;
		
		return $return;
	}
	
	//create categories
	function createCategories($id)
	{
		$u =& JFactory::getURI();
		$db =& JFactory::getDBO();
		$root = $u->toString(array('scheme','host'));
		
		$categories = array();
		$db->setQuery("SELECT c.CategoryName , c.IdCategory FROM #__rsevents_categories c LEFT JOIN #__rsevents_events_cat ec ON ec.IdCategory = c.IdCategory WHERE ec.IdEvent =".$id);
		$categs = $db->loadObjectList();
		
		if (!empty($categs))
		foreach($categs as $cat)
			$categories[] = '<a href="'.$root.rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=listcategoryevents&cid='.eventsHelper::sef($cat->IdCategory,$cat->CategoryName),false,JRequest::getInt('Itemid')).'">'.htmlentities($cat->CategoryName, ENT_COMPAT, 'utf-8').'</a>';
		$categories = implode(',',$categories);
		
		return $categories;
	}
	
	//check to see if the event is full
	function eventisfull($id)
	{
		$db =& JFactory::getDBO();
		$id = intval($id);
		$array = array();
		
		$db->setQuery("SELECT EventEnableRegistration, EventOverbooking FROM #__rsevents_events WHERE IdEvent = ".$id);
		$details = $db->loadObject();
		
		if ($details->EventEnableRegistration == 0 || $details->EventOverbooking == 1) return 0;
		
		//get the tickets 
		$db->setQuery("SELECT IdTicket, TicketPrice, TicketMaxAudience FROM #__rsevents_tickets WHERE IdEvent = ".$id);
		$tickets = $db->loadObjectList();
		
		//parse tickets
		if(!empty($tickets))
		foreach($tickets as $ticket)
		{
			$db->setQuery("SELECT SUM(st.TicketsSubscribed) FROM #__rsevents_subscription_tickets st LEFT JOIN #__rsevents_subscriptions s ON s.IdSubscription=st.IdSubscription WHERE st.IdTicket='".$ticket->IdTicket."' AND s.SubscriptionState IN (1,0)");
			$result = $db->loadResult();
			if($ticket->TicketMaxAudience <= $result) continue;
			$array[] = $ticket; 
		}
		
		//set response
		if (empty($array)) return 1; else return 0;		
	}
	
	//show the main event body 
	function showEvent($body = 'info')
	{		
		//get variables
		$db 			=& JFactory::getDBO();
		$mainframe		=& JFactory::getApplication();
		$document 		=& JFactory::getDocument();
		$user			= JFactory::getUser();
		$cid			= JRequest::getInt('cid',0,'request');
		$pathway 		= & $mainframe->getPathWay();
		$rseventsConfig = rseventsHelper::getConfig();
		
		//Load the event
		$event = $this->get('Event');		
		
		if (rseventsHelper::is16())
			$groups = JAccess::getGroupsByUser($user->id);
		
		//set pathway
		$pathway->addItem($event->EventName, rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=show&cid='.eventsHelper::sef($event->IdEvent,$event->EventName),false,JRequest::getInt('Itemid')));
		
		//get private url
		$privateUrl = JRequest::getCmd('privateUrl','','request');
		
		//is the event full
		$eventfull = $event->EventEnableRegistration ? eventsHelper::eventisfull(JRequest::getInt('cid')) : 0;
		
		//set the page title and metas
		$document->setTitle($document->getTitle().' - '.$event->EventName);
		if (trim($event->EventPageTitle) != '')
		{
			$event->EventPageTitle = str_replace('{eventname}',$event->EventName,$event->EventPageTitle);
			$document->setTitle($event->EventPageTitle);
		}
		
		if(trim($event->EventKeywords) !='') $document->setMetaData('keywords',$event->EventKeywords);
		if(trim($event->EventMetaDescription) !='') $document->setDescription($event->EventMetaDescription);
		
		//get registered people
		$registeredUsers = $event->EventEnableRegistration ? $this->get('Registered') : array();
		
		$this->assignRef('registeredUsers',$registeredUsers);
		$this->assignRef('data',$event);
		$this->assignRef('rseventsConfig',$rseventsConfig);
		
		//Is event viewable (public=1 OR (private=0 AND (PrivateUrl == EventPrivateUrl OR I'm the event owner)) check)
		$EventPublicPrivate = ($event->EventType || (!$event->EventType && ($privateUrl == $event->EventPrivateUrl || $event->IdUser == $user->id))) ? 1:0;
		
		//If IdEvent exists AND (Event is published OR (Event is unpublished AND I am the owner)) AND Event is public/private viewable
		if($event->IdEvent != 0 && ($event->published || (!$event->published && ($event->IdUser == $user->id || $user->usertype =='Super Administrator')) || (!$event->published && ($event->IdUser == $user->id || (rseventsHelper::is16() && in_array(8,$groups)))) ) && $EventPublicPrivate)
		{
			//get the event design
			$db->setQuery("SELECT IdDesign FROM #__rsevents_events WHERE IdEvent = '".$event->IdEvent."' ");
			$iddesign = $db->loadResult();
			
			$db->setQuery("SELECT DesignName FROM #__rsevents_designs WHERE IdDesign = '".$iddesign."' ");
			$designname = $db->loadResult();
			
			//check to see if the design exists on the server
			if(!file_exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'designs'.DS.$designname.DS.$designname.'.html')) $designname = 'default';
			
			$layout = file_get_contents(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'designs'.DS.$designname.DS.$designname.'.html');
			$document->addStyleSheet(JURI::root().'components/com_rsevents/designs/'.$designname.'/'.$designname.'.css'); 
			
			//keep the unix time
			$event->EventStartDateToTime = $event->EventStartDate;
			$event->EventEndDateToTime = $event->EventEndDate;
			
			//replace the location link
			$link = rseventsHelper::route('index.php?option=com_rsevents&view=locations&layout=show&cid='.$event->IdLocation.'&IdEvent='.$event->IdEvent,false);
			$layout = str_replace('{locationUrl}' , $link , $layout);
			$eventLocationUrl = JText::_('RSE_AT_LOCATION').' <a href="'.$link.'">'.$event->LocationName.'</a>';
			
			//dates
			$dateonly		= str_replace(array('H:i:s','H:i','H','h:i:s','h:i','h','g','G','a','A','H i s','H i','h i s','h i','H/i/s','H/i','h/i/s','h/i','H-i-s','H-i','h-i-s','h-i'),'',$rseventsConfig['global.dateformat']);
			$timeformat		= empty($rseventsConfig['global.time']) ? 'H:i:s' : $rseventsConfig['global.time'];
			$startDateFull	= rseventsHelper::translateDate(date($rseventsConfig['global.dateformat'],$event->EventStartDate));
			$endDateFull	= rseventsHelper::translateDate(date($rseventsConfig['global.dateformat'],$event->EventEndDate));
			$startDateDate	= rseventsHelper::translateDate(date($dateonly,$event->EventStartDate));
			$startDateTime	= date($timeformat,$event->EventStartDate);
			$endDateDate	= rseventsHelper::translateDate(date($dateonly,$event->EventEndDate));
			$endDateTime	= date($timeformat,$event->EventEndDate);

			//get categories
			$categories = eventsHelper::createCategories($event->IdEvent);
			
			//get tickets
			$db->setQuery("SELECT IdTicket, TicketName, TicketPrice, TicketMaxAudience FROM #__rsevents_tickets WHERE IdEvent = '".$event->IdEvent."'");
			$tickets = $db->loadObjectList();
			
			$ticketsavailable = JText::_('RSE_TICKETS_AVAILABLE_TEXT').'<br/>';
			$ticketsavailable .= '<ul class="rse_available_tickets">';
			//check for available tickets
			foreach ($tickets as $ticket)
			{
				$db->setQuery("SELECT SUM(st.TicketsSubscribed) FROM #__rsevents_subscription_tickets st LEFT JOIN #__rsevents_subscriptions s ON s.IdSubscription = st.IdSubscription WHERE s.IdEvent = '".$event->IdEvent."' AND s.SubscriptionState IN (0,1) AND st.IdTicket = '".$ticket->IdTicket."' ");
				$subscribedTickets = $db->loadResult();
				
				if ($subscribedTickets >= $ticket->TicketMaxAudience) continue;
				$text = '<li>'.($ticket->TicketMaxAudience -$subscribedTickets) . '  "' .$ticket->TicketName.'" '.JText::_('RSE_TICKETS').'</li>';
				if ($ticket->TicketPrice == 0 && $ticket->TicketMaxAudience == 0) $text = '<li>'.JText::_('RSE_UNLIMITED_TICKETS').' "'.$ticket->TicketName.'" '.JText::_('RSE_TICKETS').'</li>';
				$ticketsavailable .= $text;
			}
			$ticketsavailable .= '</ul>';
			
			//get host and owner
			$host  = $rseventsConfig['hostedby'] ? eventsHelper::linkprofile($event->EventHost) : $event->EventHost;
			$owner = $rseventsConfig['postedby'] ? eventsHelper::linkprofile($event->EventOwner,$event->IdUser) : $event->EventOwner;
			
			$smallicon = str_replace('.'.JFile::getExt($event->EventIcon),'_'.$rseventsConfig['event.icon.small'].'.'.JFile::getExt($event->EventIcon),$event->EventIcon);
			$bigicon = str_replace('.'.JFile::getExt($event->EventIcon),'_'.$rseventsConfig['event.icon.big'].'.'.JFile::getExt($event->EventIcon),$event->EventIcon);
			
			if($rseventsConfig['enable.event.icon'] && $event->EventIcon != '')
			{
				$eventsmallicon = '<img src="'.JURI::root().'components/com_rsevents/assets/images/thumbs/'.$smallicon.'" alt="" />';
				$eventbigicon = '<img src="'.JURI::root().'components/com_rsevents/assets/images/thumbs/'.$bigicon.'" alt="" />';
			} else $eventsmallicon = $eventbigicon = '';
			
			//event sharing
			$eventsharing = '';
			if ($rseventsConfig['event.sharing'] == 1)
			{
				$url = JFactory::getURI();
				$event_url = $url->toString();
				
				$eventsharing .= '<table width="95%" class="rse_event_sharing"><tr>';
				
				if ($rseventsConfig['event.twitter'])
				{
					$eventsharing .= "<td nowrap=\"nowrap\"><script type=\"text/javascript\">
										tweetmeme_url = '".JText::_($event_url,true)."';
										tweetmeme_style = 'compact';
									</script>
					<script type=\"text/javascript\" src=\"http://tweetmeme.com/i/scripts/button.js\"></script></td>";
				}
				
				if ($rseventsConfig['event.buzz'])
				{
					$document->addScript('http://www.google.com/buzz/api/button.js');
					$eventsharing .= '<td nowrap="nowrap"><a href="http://www.google.com/buzz/post" class="google-buzz-button" title="Google Buzz" data-locale="en" data-button-style="small-count"></a></td>';
				}
				
				if ($rseventsConfig['event.facebook.share'])
				{
					$document->addScript('http://static.ak.fbcdn.net/connect.php/js/FB.Share');
					$eventsharing .= '<td nowrap="nowrap"><a name="fb_share" type="button_count" href="http://www.facebook.com/sharer.php">'.JText::_('RSE_SHARE').'</a></td>';
				}
				
				if ($rseventsConfig['event.facebook.like'])
				{
					$eventsharing .= '<td nowrap="nowrap"><iframe src="http://www.facebook.com/plugins/like.php?href='.urlencode($event_url).'&amp;layout=button_count&amp;show_faces=false&amp;width=450&amp;action=like&amp;colorscheme=light&amp;height=35" scrolling="no" frameborder="0" style="border:none;overflow:hidden;height:35px;" allowTransparency="true"></iframe></td>';
				}
				
				$eventsharing .= '</tr></table>';
			}
			
			//event placeholders
			$find = array('{EventName}', '{EventSubtitle}', '{EventHost}', '{EventStartDate}', '{EventEndDate}', '{LocationName}', '{LocationAddress}', '{LocationCity}', '{LocationState}', '{EventPhone}', '{EventEmail}', '{EventURL}', '{EventOwner}', '{EventDescription}', '{EventIcon}', '{LocationZip}', '{LocationCountry}', '{EventCategories}','{TicketsAvailable}','{EventSharing}','{EventStartDateOnly}','{EventStartTime}','{EventEndDateOnly}','{EventEndTime}','{LocationDescription}','{LocationURL}','{EventIconSmall}','{EventIconBig}');
			
			//values for replacement
			$replace = array($this->escape($event->EventName), $this->escape($event->EventSubtitle), JText::_('RSE_HOSTED_BY').' '.$host, JText::_('RSE_START_EVENT').' '.$startDateFull, JText::_('RSE_END_EVENT').' '.$endDateFull, $eventLocationUrl, $this->escape($event->LocationAddress), $this->escape($event->LocationCity), $event->LocationState , $event->EventPhone , $event->EventEmail , $event->EventURL , JText::_('RSE_EVENT_POSTED').' '.$owner , $event->EventDescription , $eventbigicon, $event->LocationZip, $event->LocationCountry,$categories,$ticketsavailable,$eventsharing,$startDateDate,$startDateTime,$endDateDate,$endDateTime,$event->LocationDescription, $event->LocationURL,$eventsmallicon,$eventbigicon); 
			
			$mainframe->triggerEvent('rse_onBeforeShowEvent',array(array('event'=>&$event,'layout'=>&$layout,'find'=>&$find,'replace'=>&$replace)));
			$layout = str_replace($find , $replace , $layout);
			
			
			//replace the host and guest menu
			$layout = str_replace('{EventHostMenu}','', $layout);
			$layout = str_replace('{EventGuestMenu}','',$layout);
			$layout = str_replace('{EventFullClass}',($eventfull) ? 'class="rsevents_full"' : '',$layout);
			
			/* Switch Body */
			switch($body)
			{
				case 'info':
					$layout = str_replace(array('{EventStartInfo}','{EventEndInfo}'),'',$layout);
					$layout = eventsHelper::createExtras($event, $layout);
				break;
				
				case 'invite':
				case 'guestsendmessage':
				case 'subscribe':
				case 'photos':
				case 'importyahoo':
				case 'importgmail':
					$layout = eventsHelper::splitLayout($event, $layout);
					$layout = eventsHelper::createExtras($event, $layout);
					$this->assignRef('data',$event);
				break;
				
			}
			
			$mainframe->triggerEvent('rse_onAfterShowEvent',array(array('event'=>&$event,'layout'=>&$layout)));
			
			$this->assignRef('layout',$layout);
		} else
			$mainframe->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events',false),JText::_('RSE_EVENT_INVALID'));
	}
	
	//split the layout
	function splitLayout($event, $layout)
	{
		$find = explode('{EventStartInfo}',$layout);
		$l[0] = $find[0];
		$end = explode('{EventEndInfo}',$find[1]);
		$l[1] = $end[1];
		
		return $l;
	}
	
	//create the Host menu
	function createHostMenu($event,$attribs=null)
	{
		$user 			=& JFactory::getUser();
		$rseventsConfig = rseventsHelper::getConfig();
		
		$isModule	= isset($attribs['jmodule']) ? 1 : 0;
		
		$host_module = '';
		
		//Create the Host Menu
		if (!$isModule)
		{
			$host_module .= '<div id="rsevents_menu">';
			$host_module .= '<h2><span>'.JText::_('RSE_HOST_MENU').'</span></h2>';
		}
		
		//get and set the Private Url
		$privateUrl = JRequest::getCmd('privateUrl','','request');
		$private = !empty($privateUrl) ? '&privateUrl='.$privateUrl : '';
		
		$type = $isModule ? '_module' : '';
		
		if (!$rseventsConfig['modal.type'])
		{
			//modal scripts
			$document =& JFactory::getDocument();
			$document->addCustomTag('<script type="text/javascript">jQuery(document).ready(function(){
			jQuery("a[rel=\'repeatmodal'.$type.'\']").colorbox({iframe:true, innerWidth:650, innerHeight:400 , title:\''.JText::_('RSE_REPEAT_DESC',true).'\'});
			jQuery("a[rel=\'invitemodal2'.$type.'\']").colorbox({iframe:true, innerWidth:530, innerHeight:500, title:\''.JText::_('RSE_INVITE_DESC',true).'\'});
			jQuery("a[rel=\'guestmodal'.$type.'\']").colorbox({iframe:true, innerWidth:550, innerHeight:550, title:\''.JText::_('RSE_GUESTSEND_DESC',true).'\'});
			});</script>');
		} else JHTML::_('behavior.modal');
		
		$modal_class = $rseventsConfig['modal.type'] ? ' class="modal"' : '';
		$repeat_rel  = $rseventsConfig['modal.type'] ? ' rel="{handler: \'iframe\',size: {x:650,y:400}}"' : ' rel="repeatmodal'.$type.'"';
		$invite_rel  = $rseventsConfig['modal.type'] ? ' rel="{handler: \'iframe\',size: {x:530,y:500}}"' : ' rel="invitemodal2'.$type.'"';
		$guest_rel   = $rseventsConfig['modal.type'] ? ' rel="{handler: \'iframe\',size: {x:550,y:550}}"' : ' rel="guestmodal'.$type.'"';
		
		$host_module .= '<ul>';
		$host_module .= '<li><a href="'.rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=addeditevent&cid='.eventsHelper::sef($event->IdEvent,$event->EventName),false).'">'.JText::_('RSE_MENU_EVENT_EDIT').'</a></li>';
		if($event->IdParent == 0)
		$host_module .= '<li><a href="'.rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=repeat&cid='.eventsHelper::sef($event->IdEvent,$event->EventName),false).'"'.$repeat_rel.$modal_class.'>'.JText::_('RSE_MENU_REPEAT_EVENT').'</a></li>';
		$host_module .= '<li><a href="'.rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=invite&cid='.eventsHelper::sef($event->IdEvent,$event->EventName),false).'"'.$invite_rel.$modal_class.'>'.JText::_('RSE_MENU_EVENT_INVITE').'</a></li>';
		
		if($event->EventEnableRegistration == 1) $host_module .= '<li><a href="'.rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=guestssendmessage&cid='.eventsHelper::sef($event->IdEvent,$event->EventName),false).'"'.$guest_rel.$modal_class.'>'.JText::_('RSE_MENU_EVENT_SEND_MESSAGES').'</a></li>';
		if($event->EventEnableRegistration == 1) $host_module .= '<li><a href="'.rseventsHelper::route('index.php?option=com_rsevents&task=exportguests&controller=events&cid='.eventsHelper::sef($event->IdEvent,$event->EventName),false).'">'.JText::_('RSE_MENU_EVENT_EXPORT').'</a></li>';
		if($event->EventEnableRegistration == 1) $host_module .= '<li><a href="'.rseventsHelper::route('index.php?option=com_rsevents&view=subscriptions&IdEvent='.eventsHelper::sef($event->IdEvent,$event->EventName),false).'">'.JText::_('RSE_MENU_EVENT_SUBSCRIBERS').'</a></li>';
		$host_module .= '<li><a href="'.rseventsHelper::route('index.php?option=com_rsevents&task=duplicateevent&controller=events&cid='.eventsHelper::sef($event->IdEvent,$event->EventName),false).'">'.JText::_('RSE_MENU_EVENT_DUPLICATE').'</a></li>';
		if((time() > $event->EventEndDateToTime) && ($event->EventEnableRegistration == 1) ) $host_module .= '<li><a href="'.rseventsHelper::route('index.php?option=com_rsevents&task=postreminder&controller=events&cid='.eventsHelper::sef($event->IdEvent,$event->EventName).$private,false).'" onclick="javascript:if(!confirm(\' '.JText::_('RSE_MENU_EVENT_PREMINDER_CONFIRM').' \')) return false;" >'.JText::_('RSE_MENU_EVENT_PREMINDER').'</a></li>';
		$host_module .= '<li><a href="'.rseventsHelper::route('index.php?option=com_rsevents&task=reminder&controller=events&cid='.eventsHelper::sef($event->IdEvent,$event->EventName).$private,false).'" onclick="javascript:if(!confirm(\''.JText::_('RSE_MENU_EVENT_REMINDER_CONFIRM').'\')) return false;">'.JText::_('RSE_MENU_EVENT_REMINDER').'</a></li>';
		$host_module .= '<li><a href="'.rseventsHelper::route('index.php?option=com_rsevents&task=cancelevent&controller=events&cid='.eventsHelper::sef($event->IdEvent,$event->EventName),false).'"  onclick="javascript:if(!confirm(\' '.JText::_('RSE_MENU_EVENT_DELETE_CONFIRM').' \')) return false;">'.JText::_('RSE_MENU_EVENT_CANCEL').'</a></li>';
		$host_module .= '</ul>';
		
		if (!$isModule)
			$host_module .= '</div>';
		
		return $host_module;
	}
	
	
	//create the Guest menu
	function createGuestMenu($event,$attribs=null)
	{
		$db 			=& JFactory::getDBO();
		$user 			=& JFactory::getUser();
		$rseventsConfig = rseventsHelper::getConfig();
		
		$isModule	= isset($attribs['jmodule']) ? 1 : 0;
		
		//is the current user registered already ?
		$isRegistered = rseventsModelEvents::getSubscriber();
		
		//get the permissions
		$permissions = rseventsModelEvents::getPermissions();
		
		$canedit = isset($permissions['canEdit']) ? $permissions['canEdit'] : 0;
		$candelete = isset($permissions['canDelete']) ? $permissions['canDelete'] : 0;
		$cansubscribe = isset($permissions['allowRegistration']) ? $permissions['allowRegistration'] : 0;
		$canunsubscribe = isset($permissions['allowRegistrationCancel']) ? $permissions['allowRegistrationCancel'] : 0;
		
		//get and set the Private Url
		$privateUrl = JRequest::getCmd('privateUrl','','request');
		$link = ($privateUrl !='') ? $link = '&privateUrl='.$privateUrl : '';
		
		$guest_module = '';
		
		if (!$isModule)
		{
			$guest_module .= '<div id="rsevents_menu">';
			$guest_module .= '<h2><span>'.JText::_('RSE_GUEST_MENU').'</span></h2>';
		}
		
		$guest_module .= '<ul>';
		
		//can edit event
		if($canedit) $guest_module .= '<li><a href="'.rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=addeditevent&cid='.eventsHelper::sef($event->IdEvent,$event->EventName),false).'">'.JText::_('RSE_MENU_EVENT_EDIT').'</a></li>';
		
		//can delete event
		if ($candelete) $guest_module .= '<li><a href="'.rseventsHelper::route('index.php?option=com_rsevents&task=cancelevent&controller=events&cid='.eventsHelper::sef($event->IdEvent,$event->EventName),false).'"  onclick="javascript:if(!confirm(\' '.JText::_('RSE_MENU_EVENT_DELETE_CONFIRM').' \')) return false;">'.JText::_('RSE_MENU_EVENT_CANCEL').'</a></li>';
		
		//subscribe link
		$show = true;
		if (($event->EventEnableRegistration == 1 && !$isRegistered && $event->published != '-1') || ($rseventsConfig['event.multiple.reg'] == 1 && $event->EventEnableRegistration == 1))
		{
			if (!empty($event->EventStartRegistration) && !empty($event->EventEndRegistration))
			{
				if ($event->EventStartRegistration <= time() && $event->EventEndRegistration >= time() || $event->EventStartRegistration >= time() && $event->EventEndRegistration <= time())
					$show = true;
				else $show = false;
				
			} elseif (empty($event->EventStartRegistration) && !empty($event->EventEndRegistration))
			{
				if ($event->EventEndRegistration >= time())
					$show = true;
				else $show = false;
				
			} elseif (!empty($event->EventStartRegistration) && empty($event->EventEndRegistration))
			{
				if ($event->EventStartRegistration <= time())
					$show = true;
				else $show = false;
				
			} elseif (empty($event->EventStartRegistration) && empty($event->EventEndRegistration))
			{
				$show = true;
			}
		} else $show = false;
		
		if (!$cansubscribe) $show = false;
		
		$db->setQuery("SELECT EventRegistrationForm FROM #__rsevents_events WHERE IdEvent = '".$event->IdEvent."' ");
		$form = $db->loadResult();
		$position = $form == 0 ? 'innerWidth:520, innerHeight:380' : 'innerWidth:700, innerHeight:500';
		
		$type = $isModule ? '_module' : '';
		
		if (!$rseventsConfig['modal.type'])
		{
				//modal scripts
				$document =& JFactory::getDocument();
				$document->addCustomTag('<script type="text/javascript">jQuery(document).ready(function(){
			jQuery("a[rel=\'subscrmodal'.$type.'\']").colorbox({iframe:true, '.$position.' , title:\''.JText::_('RSE_SUBSCRIBE_DESC',true).'\'});
			jQuery("a[rel=\'invitemodal'.$type.'\']").colorbox({iframe:true, innerWidth:530, innerHeight:500, title:\''.JText::_('RSE_INVITE_DESC',true).'\'});
			jQuery("a[rel=\'photosmodal'.$type.'\']").colorbox({iframe:true, innerWidth:600, innerHeight:250, title:\''.JText::_('RSE_PHOTOS_DESC',true).'\'});
			});</script>');
		} else JHTML::_('behavior.modal');
		
		$modal_class = $rseventsConfig['modal.type'] ? ' class="modal"' : '';
		$positions	 = $form == 0 ? '{x:520,y:380}' : '{x:700,y:500}';
		$subscr_rel  = $rseventsConfig['modal.type'] ? ' rel="{handler: \'iframe\',size: '.$positions.'}"' : ' rel="subscrmodal'.$type.'"';
		$invite_rel  = $rseventsConfig['modal.type'] ? ' rel="{handler: \'iframe\',size: {x:530,y:500}}"' : ' rel="invitemodal'.$type.'"';
		$photo_rel   = $rseventsConfig['modal.type'] ? ' rel="{handler: \'iframe\',size: {x:600,y:250}}"' : ' rel="photosmodal'.$type.'"';
		
		if ($show)		
			$guest_module .= '<li><a href="'.rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=subscribe&cid='.eventsHelper::sef($event->IdEvent,$event->EventName).$link.'&tmpl=component',false).'" '.$modal_class.$subscr_rel.'>'.JText::_('RSE_MENU_EVENT_SUBSCRIBE').'</a></li>';
		
		//invite link
		if($rseventsConfig['event.show.invite'] && $event->published != '-1') $guest_module .= '<li><a href="'.rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=invite&cid='.eventsHelper::sef($event->IdEvent,$event->EventName).$link,false).'" '.$modal_class.$invite_rel.'>'.JText::_('RSE_MENU_EVENT_INVITE').'</a></li>';
		
		//add flickr photos
		if($rseventsConfig['events.extras.flickr']) $guest_module .= '<li><a href="'.rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=photos&cid='.eventsHelper::sef($event->IdEvent,$event->EventName).$link,false).'" '.$modal_class.$photo_rel.'>'.JText::_('RSE_MENU_EVENT_ADD_PHOTOS').'</a></li>';
		
		//export to calendar
		if ($rseventsConfig['event.show.outlook']) $guest_module .= '<li><a href="'.rseventsHelper::route('index.php?option=com_rsevents&task=export&controller=events&cid='.eventsHelper::sef($event->IdEvent,$event->EventName),false).'">'.JText::_('RSE_MENU_EVENT_EXPORT_EVENT').'</a></li>';
		
		//print link
		if ($rseventsConfig['event.show.print']) $guest_module .= '<li><a href="'.rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=printevent&cid='.eventsHelper::sef($event->IdEvent,$event->EventName).'&tmpl=component',false).'"  onclick="window.open(this.href,\'win2\',\'status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no\'); return false;">'.JText::_('RSE_MENU_EVENT_PRINT').'</a></li>';
		
		//unsubscribe link
		if ($canunsubscribe)
		{
			if($isRegistered && $event->published != '-1') 
				$guest_module .= '<li><a href="'.rseventsHelper::route('index.php?option=com_rsevents&task=eventunsubscribe&controller=events&cid='.eventsHelper::sef($event->IdEvent,$event->EventName),false).'" onclick="javascript:if(!confirm(\' '.JText::_('RSE_MENU_EVENT_UNSUBSCRIBE_CONFIRM').' \')) return false;">'.JText::_('RSE_MENU_EVENT_UNSUBSCRIBE').'</a></li>';
		}
		
		$guest_module .= '</ul>';
		
		if (!$isModule)
			$guest_module .= '</div>';
		
		return $guest_module;
	}
	
	//create and replace all extras
	function createExtras($event, $layout, $array = null, $youtube = null)
	{
		$user			 =& JFactory::getUser();
		$rseventsConfig  = rseventsHelper::getConfig();
		
		//is the current user registered already ?
		$isRegistered = rseventsModelEvents::getSubscriber();
		
		//youtube params
		$youtube = is_null($youtube) ? array('w'=>560, 'h'=>349) : $youtube;
		
		//load the files
		$fileList = eventsHelper::getFiles();
		
		//load the extras
		$extras = eventsHelper::getExtras();
		
		//get the map
		$map = $rseventsConfig['locations.gmaps'] ? eventsHelper::getMap($event->IdLocation) : '';
		
		//get the permissions
		$permissions = rseventsModelEvents::getPermissions();
		
		if (rseventsHelper::is16())
			$groups = JAccess::getGroupsByUser($user->id);
		
		//do we allow users to download?
		$allowDownload = (@$permissions['allowDownload'] || $user->usertype =='Super Administrator' || (rseventsHelper::is16() && in_array(8,$groups))) ? 1 : 0 ;
		
		//Determine the interval you are in (before/during/after)
		if(time() < $event->EventStartDateToTime) $interval = 'before';
		if(time() >= $event->EventStartDateToTime && time() < $event->EventEndDateToTime) $interval = 'during';
		if(time() >= $event->EventEndDateToTime) $interval = 'after';

		//Show files
		$files = array();
		if(!empty($fileList))
			foreach($fileList as $i => $file)
			{
				if((!$isRegistered && $allowDownload &&  (($interval == 'before' && $file->FilePermission[0]==1) || ($interval == 'during' && $file->FilePermission[1]==1) || ($interval == 'after' && $file->FilePermission[2]==1)))||($isRegistered && $allowDownload &&  (($interval == 'before' && $file->FilePermission[3]==1) || ($interval == 'during' && $file->FilePermission[4]==1) || ($interval == 'after' && $file->FilePermission[5]==1)))) 
				$files[] = '<li><a href="'.JURI::root().'components/com_rsevents/assets/files/'.$file->FileLocation.'" target="_blank">'.$file->FileName.'</a></li>';
			}
		


		$youtubeURL = $meeboCode = $photos = $mp3URL = $flashURL = array();
		
		//parse extras
		foreach($extras as $i => $objExtra)
		{
			if($extras[$i]->ExtraName=='youtube')
			{
				$yURL = str_replace('watch?v=','v/',$objExtra->ExtraValue);
				$youtubeURL[]='<object width="'.$youtube['w'].'" height="'.$youtube['h'].'"><param name="movie" value="'.$yURL.'&hl=en&fs=1"></param><param name="allowFullScreen" value="true"></param><param name="allowscriptaccess" value="always"></param><embed src="'.$yURL.'&hl=en&fs=1" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="'.$youtube['w'].'" height="'.$youtube['h'].'"></embed></object>';
			}
			
			if($extras[$i]->ExtraName == 'meebo')
				$meeboCode[] = $objExtra->ExtraValue;
			
			if($extras[$i]->ExtraName == 'flickr')
				$photos[] = rseventsViewEvents::getPhotos($objExtra->IdExtra, $objExtra->ExtraValue);
				
			if($extras[$i]->ExtraName=='mp3')
				$mp3URL[]='<object width="300" height="110"><param name="movie" value="'.$objExtra->ExtraValue.'"></param><param name="wmode" value="transparent"></param><embed src="'.$objExtra->ExtraValue.'" type="application/x-shockwave-flash" width="300" height="110" wmode="transparent"></embed></object>';
			
			if($extras[$i]->ExtraName=='flash')
				$flashURL[]=$objExtra->ExtraValue;
			
		}
		
		$photos = (count($photos) > 0 && !empty($photos)) ? '<p>'.JText::_('RSE_EVENT_PHOTOS').'</p><ul class="rsevents-extra-photos">'.implode('',$photos).'</ul><span class="rsevents-clear"/>' : '';
		
		if (!is_null($array))
			$find = $array;
		else
			$find 		= array('{youtubeURL}' , '{meeboCode}' , '{EventPhotos}' , '{mp3URL}' , '{flashURL}' , '{EventFiles}' , '{googleMap}');
		$replace 	= array(implode('',$youtubeURL) , implode('',$meeboCode) , $photos , implode('',$mp3URL) , implode('',$flashURL) , '<ul>'.implode('',$files).'</ul>' , $map);
		
		//Replace the placeholders in the layout
		$layout = str_replace($find,$replace,$layout);
		
		return $layout;
	}
	
	
	//save registration
	function saveRegistration($subscriptionId = null)
	{
		jimport('joomla.mail.helper');
		
		$db			=& JFactory::getDBO();
		$user		=& JFactory::getUser();
		$mainframe	=& JFactory::getApplication();
		$idevent	= JRequest::getInt('cid',0,'request');
		$info		= rseventsHelper::getConfig();
		$post		= JRequest::get('post');
		$fName		= @($post['form']['RSEventsFirstName'] == '') ? $post['FirstName'] : $post['form']['RSEventsFirstName'];
		$lName		= @($post['form']['RSEventsLastName'] == '') ? $post['LastName'] : $post['form']['RSEventsLastName'];
		$email		= @($post['form']['RSEventsEmail'] == '') ? $post['Email'] : $post['form']['RSEventsEmail'];
		$ticket		= @($post['form']['RSEventsTickets'][0] == '') ? $post['IdTicket'] : $post['form']['RSEventsTickets'][0];
		$numTickets = @($post['form']['RSEventsNumTickets'][0] == '') ? @$post['rse_numtickets'] : $post['form']['RSEventsNumTickets'][0] ;
		$payment	= @($post['form']['RSEventsPayment'] == '') ? @$post['payment'] : $post['form']['RSEventsPayment'];
		$coupon		= @($post['form']['RSEventsCupon'] == '') ? @$post['CuponCode'] : $post['form']['RSEventsCupon'];
		$userip		= $_SERVER['REMOTE_ADDR'];
		$config		= JFactory::getConfig();
		$session	=& JFactory::getSession();
		$numTickets = !isset($numTickets) ? 1 : $numTickets;
		
		$tickets = array();
		
		if (!empty($post['tickets']))
		{
			foreach ($post['tickets'] as $item)
				$tickets[$item] = isset($post['notickets'][$item]) ? intval($post['notickets'][$item]) : 1;
		} else $tickets[$ticket] = $numTickets;
		
		if (empty($payment)) $payment = 'none';
		
		//get event details
		$db->setQuery("SELECT IdUser, EventName, SubscriptionNotification, EventAutoApprove, early_discount_type, early_discount_value, early_discount_deadline, late_fee_type, late_fee_value, late_fee_date FROM #__rsevents_events WHERE IdEvent = '".$idevent."'");
		$event = $db->loadObject();
		
		$db->setQuery("SELECT id FROM #__users WHERE email = '".$email."'");
		$uid = $db->loadResult();
		
		//Check if user exists(if not, we create it)
		if($fName != '' && $email != '' && JMailHelper::isEmailAddress($email))
		{
			if ($info['event.enable.guests'] == 0)
				$userId = eventsHelper::returnUser($db->getEscaped($email),$db->getEscaped($fName)." ".$db->getEscaped($lName));
			elseif (empty($user->id) && empty($uid)) $userId = 0;
			else $userId = $uid;
		}
		else 
			$mainframe->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=subscribe&cid='.eventsHelper::sef($idevent,$event->EventName),false),JText::_('RSE_SUBSCRIBER_NAME_EMAIL_ERROR'));
		
		//check if user is already subscribed
		$db->setQuery("SELECT COUNT(IdSubscription) FROM #__rsevents_subscriptions WHERE IdEvent='".$idevent."' AND Email='".$db->getEscaped($email)."'");
		$issubscribed = $db->loadResult();
		if($info['event.multiple.reg'] == 1) $issubscribed = 0;
		
		if($issubscribed)
		{
			echo eventsHelper::setMessage(JText::_('RSE_SUBSCRIBER_ALLREADY_REGISTERED'),1);
			return;
		}
		else
		{
			if (!empty($tickets))
			{
				$autoapprove	= $event->EventAutoApprove;
				$verification	= md5(uniqid(''));
				$date			= time();
				$state			= 0;
				$formId			= ($subscriptionId != null) ? $subscriptionId : '';
				
				$mainframe->triggerEvent('rse_onBeforeStoreSubmission',array(array('idEvent'=>&$idevent,'userId'=>&$userId,'fName'=>&$fName,'lName'=>&$lName,'email'=>&$email,'subscriptionId'=>&$formId,'SubscriptionState'=>&$state)));
				
				//get the name of the payment
				$db->setQuery("SELECT name FROM #__rsevents_payments WHERE id = '".$db->getEscaped($payment)."' ");
				$db_payment = $db->loadResult();
				
				$isWire	 = (!empty($db_payment) && strlen($db_payment) > 0) ? true : false;
				$wireId	 = $isWire ? (int) $payment : 0;
				$payment = $isWire ? $db_payment : $payment;
				
				//Add to Subscriptions
				$db->setQuery("INSERT INTO #__rsevents_subscriptions (IdEvent , IdUser , FirstName , LastName , Email , SubscriptionDate, SubscriptionVerification , TransactionGateway , SubscriptionFormId , UserIp , SubscriptionState) VALUES ('".$idevent."' , '".$userId."' , '".$db->getEscaped($fName)."' , '".$db->getEscaped($lName)."' , '".$db->getEscaped($email)."' , '".$date."','".$verification."' , '".$payment."' , '".$formId."' , '".$userip."' , '".$state."') ");
				$success = $db->query();
				$idSubscription = $db->insertid();
				
				if ($success)
				{
					if ($event->SubscriptionNotification)
					{
						$theuser	=& JFactory::getUser($event->IdUser); 
						$siteconf	= new JConfig();
						$from		= $siteconf->mailfrom;
						$fromName	= $siteconf->fromname;
						$subject	= JText::sprintf('RSE_NEW_SUBSCRIPTION_NOTIFICATION_SUBJECT',$event->EventName);
						$body		= JText::sprintf('RSE_NEW_SUBSCRIPTION_NOTIFICATION_BODY',$theuser->get('name'),$event->EventName);
						
						JUtility::sendMail($from , $fromName , $theuser->get('email') , $subject , $body , 1);
					}
					
					
					$total		= 0;
					$ticketInfo	= '';
					$discount	= 0;
					$ticketsno	= 0;
					
					$db->setQuery("SELECT CouponAction FROM #__rsevents_cupons WHERE IdEvent = ".(int) $idevent." AND CuponCode = '".$db->getEscaped($coupon)."' LIMIT 1");
					$couponAction = $db->loadObject();
					
					foreach ($tickets as $ticket => $quantity)
					{
						$ticket = (int) $ticket; $quantity = (int) $quantity;
						
						//Get ticket details
						$db->setQuery("SELECT TicketName, TicketPrice FROM #__rsevents_tickets WHERE IdTicket = ".$ticket." ");
						$details = $db->loadObject();
						
						$db->setQuery("INSERT INTO #__rsevents_subscription_tickets (IdSubscription , IdTicket , TicketsSubscribed) VALUES ('".$idSubscription."' , '".$ticket."' , ".$quantity.")");
						$db->query();
						
						if ($details->TicketPrice > 0)
							$total += ($quantity * $details->TicketPrice);
						
						$ticketInfo .= $quantity . ' '.JText::_('RSE_TICKET_SEPARATOR').' '.$details->TicketName. '<br />';
						
						if (!$couponAction && $details->TicketPrice > 0)
							$discount += eventsHelper::processCupon($idevent,$quantity,$details->TicketPrice,$coupon,0);
						
						if ($details->TicketPrice > 0)
							$ticketsno += $quantity;
					}
					
					// the total
					$thetotal = $total;
					
					if ($couponAction)
						$discount = eventsHelper::processCupon($idevent,$ticketsno,$total,$coupon,0);
					
					// check to see if the discount is grater or equal to the total amount
					// if true set the discount to 0
					if ($discount > $thetotal)
						$discount = 0;
					
					if ($discount)
					{
						$db->setQuery("UPDATE #__rsevents_subscriptions SET Discount = '".$db->getEscaped($discount)."' WHERE IdSubscription = ".$idSubscription." ");
						$db->query();
						
						// update the total
						$thetotal = $thetotal - $discount;
					}
					
					if ($event->early_discount_deadline > time())
					{
						$early = rseventsHelper::setTax($thetotal,$event->early_discount_type,$event->early_discount_value);
						$thetotal = $thetotal - $early;
					}
					else $early = 0;

					if ($event->late_fee_date < time())
					{
						$late = rseventsHelper::setTax($thetotal,$event->late_fee_type,$event->late_fee_value);
						$thetotal = $thetotal + $late;
					}
					else $late = 0;
					
					$db->setQuery("UPDATE #__rsevents_subscriptions SET early_fee = '".$db->getEscaped($early)."' , late_fee = '".$db->getEscaped($late)."' WHERE IdSubscription = ".$idSubscription." ");
					$db->query();
					
					if (count($tickets) == 1)
					{
						$ticketprice = $thetotal > 0 ? number_format($thetotal,$info['payment.nrdecimals'], $info['payment.decimal'], $info['payment.thousands']) . ' '.$info['payment.currency'] : JText::_('RSE_TICKET_FREE');
					} else $ticketprice = '';
					
					$ticketstotal = $thetotal > 0 ? number_format($thetotal,$info['payment.nrdecimals'], $info['payment.decimal'], $info['payment.thousands']) . ' '.$info['payment.currency'] : '';
					
					$ticketsdiscount = $discount > 0 ? $discount. ' '.$info['payment.currency'] : '';
					
					if ($total == 0 && $autoapprove)
					{
						$db->setQuery("UPDATE #__rsevents_subscriptions SET SubscriptionState = 1 WHERE IdSubscription = ".$idSubscription." ");
						$db->query();
						$state = 1;
					}
					
					$session->set('rsevents.redirect'.$idevent, 1);
					
					$mainframe->triggerEvent('rse_onAfterStoreSubmission',array(array('idEvent'=>&$idevent,'userId'=>&$userId,'fName'=>&$fName,'lName'=>&$lName,'email'=>&$email,'IdSubscription'=>&$idSubscription,'SubscriptionState'=>&$state)));
					
					//START sending the registration email
					$optionals = array($ticketInfo,$ticketprice,$ticketstotal,$ticketsdiscount);
					rseventsEmails::registration($email,$userId,$idevent,$optionals,$idSubscription);
					
					//Send activation email if the user has purchased a free ticket
					if($state == 1)
						rseventsEmails::activation($email,$userId,$idevent,$optionals,$idSubscription);
					
					if ($thetotal > 0)
					{
						$ttax = 0;
						if($isWire)
						{
							$wire = !empty($wireId) ? '&pid='.$wireId : '';
							
							$db->setQuery("SELECT tax_type, tax_value FROM #__rsevents_payments WHERE id = ".(int) $wireId." ");
							$wireDetails = $db->loadObject();
							$ttax = rseventsHelper::setTax($thetotal,$wireDetails->tax_type,$wireDetails->tax_value);
							
							$db->setQuery("UPDATE #__rsevents_subscriptions SET PaymentUrl = '".$db->getEscaped(base64_encode('index.php?option=com_rsevents&view=events&layout=wire&cid='.eventsHelper::sef($idevent,$event->EventName).'&subscription='.$idSubscription.$wire))."', `tax` = '".$db->getEscaped($ttax)."' WHERE IdSubscription = ".$idSubscription." ");
							$db->query();
							
							echo eventsHelper::setMessage(JText::_('RSE_REDIRECTING'),1,rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=wire&cid='.eventsHelper::sef($idevent,$event->EventName).'&subscription='.$idSubscription.$wire,false));
							
							if(!isset($post['form']['formId'])) return; else die();
						}
						
						$taxes = $mainframe->triggerEvent('rse_tax',array(array('method'=>&$payment, 'total'=>$thetotal)));
						if (!empty($taxes))
						foreach ($taxes as $tax)
							if (!empty($tax)) $ttax = $tax;
						
						$db->setQuery("UPDATE #__rsevents_subscriptions SET PaymentUrl = '".$db->getEscaped(base64_encode('index.php?option=com_rsevents&task=payment&method='.$payment.'&hash='.md5($idSubscription.$fName.$lName.$email)))."' , `tax` = '".$db->getEscaped($ttax)."' WHERE IdSubscription = ".$idSubscription." ");
						$db->query();
						
						echo eventsHelper::setMessage(JText::_('RSE_REDIRECTING'),1,rseventsHelper::route('index.php?option=com_rsevents&task=payment&method='.$payment.'&hash='.md5($idSubscription.$fName.$lName.$email),false));
						
						if(!isset($post['form']['formId'])) return; else die();
					} else {
						$session->set('rsevents.redirect.rsformpro'.$idevent, 1);
					}
					
					if(!isset($post['form']['formId']))
					{
						echo eventsHelper::setMessage(JText::_('RSE_SUBSCRIBER_SUCCESS'),1);
						return;
					}
				} else 
				{
					echo eventsHelper::setMessage(JText::_('RSE_ERROR_SAVING_REGISTRATION'),1);
					return;
				}
			} else 
			{
				echo eventsHelper::setMessage(JText::_('RSE_NO_TICKETS_SELECTED'),1);
				return;
			}
		}
	}
	
	
	//check if the coupon code is available and apply the discount
	function processCupon($idevent,$number,$price,$coupon,$type)
	{
		$db =& JFactory::getDBO();
		$rseventsConfig = rseventsHelper::getConfig();
		
		$db->setQuery("SELECT CuponType, CuponValue, CouponStart, CouponEnd, CouponLimit, CouponUsed, CouponAction FROM #__rsevents_cupons WHERE IdEvent = ".intval($idevent)." AND CuponCode = '".$db->getEscaped($coupon)."' LIMIT 1");
		$couponobj = $db->loadObject();
		
		//check if the tickets number and the price is 0
		if ($number == 0 || $price == 0)
			return 0;
		
		//check if the coupon exists
		if (empty($couponobj))
			if ($type == 0) return 0; else return intval($number) * $price;
		
		//check if we can apply the coupon
		if ($couponobj->CouponUsed >= $couponobj->CouponLimit && !empty($couponobj->CouponLimit))
			if ($type == 0) return 0; else return intval($number) * $price;
		
		//check if the coupon is available
		$available = true;
		if (empty($couponobj->CouponStart) && empty($couponobj->CouponEnd))
			$available = true;
		elseif (!empty($couponobj->CouponStart) && empty($couponobj->CouponEnd))
		{
			if ($couponobj->CouponStart >= time())
				$available = true;
			else $available = false;
		} elseif (empty($couponobj->CouponStart) && !empty($couponobj->CouponEnd))
		{
			if ($couponobj->CouponEnd <= time())
				$available = false;
			else $available = true;
		} else 
		{
			if ($couponobj->CouponStart <= time() && $couponobj->CouponEnd >= time() || $couponobj->CouponStart >= time() && $couponobj->CouponEnd <= time())
				$available = true;
			else $available = false;
		}
		
		if (!$available)
			if ($type == 0) return 0; else return intval($number) * $price;
		
		//return the price with the discount applied
		if ($type)
		{
			//check to see if the coupon is applied to one ticket or to the total value
			if ($couponobj->CouponAction)
			{
				if ($rseventsConfig['event.multiple.tickets'])
					$total = $price;
				else
					$total = intval($number) * $price;
				
				if ($couponobj->CuponType == 0)
					$return = $total - $couponobj->CuponValue;
				else 				
					$return = $total - ($total * ($couponobj->CuponValue / 100));
			} else
			{
				if ($rseventsConfig['event.multiple.tickets'])
					$total = $price;
				else
					$total = intval($number) * $price;
				if ($couponobj->CuponType == 0)
					$return = $total - ($number * $couponobj->CuponValue);
				else 				
					$return = $total - ($total * ($couponobj->CuponValue / 100));
			}
		}
		//return the discount
		else 
		{
			if ($couponobj->CouponAction)
			{
				if ($rseventsConfig['event.multiple.tickets'])
					$total = $price;
				else
					$total = intval($number) * $price;
				
				if ($couponobj->CuponType == 0)
					$return = $couponobj->CuponValue;
				else
					$return = $total * ($couponobj->CuponValue / 100);
			} else 
			{
				if ($rseventsConfig['event.multiple.tickets'])
					$total = $price;
				else
					$total = intval($number) * $price;
				
				if ($couponobj->CuponType == 0)
					$return = $number * $couponobj->CuponValue;
				else 				
					$return = $total * ($couponobj->CuponValue / 100);
			}
		}
		
		$db->setQuery("UPDATE #__rsevents_cupons SET CouponUsed = CouponUsed + 1 WHERE IdEvent = '".intval($idevent)."' AND CuponCode = '".$db->getEscaped($coupon)."' ");
		$db->query();
		
		return $return;
	}
	
	//load the google map
	function getMap($num = '',$direction = null) 
	{		
		$db =& JFactory::getDBO();
		$rseventsConfig = rseventsHelper::getConfig();
		$db->setQuery("SELECT LocationName, LocationAddress, LocationCity, LocationCountry, LocationLat, LocationLon  FROM #__rsevents_locations WHERE IdLocation = '".$db->getEscaped($num)."' ");
		$row = $db->loadObject();

		if (!empty($row->LocationLat) && !empty($row->LocationLon)) 
		{
			if (empty($num)) $num = '';
				
			$map ='
				<script src="http://maps.google.com/maps?file=api&amp;v=2&amp;key='.$rseventsConfig['locations.gMaps.key'].'" type="text/javascript"></script>
				<script src="http://www.google.com/uds/api?file=uds.js&v=1.0&key='.$rseventsConfig['locations.gMaps.key'].'" type="text/javascript"></script>
				<script src="http://www.google.com/uds/solutions/localsearch/gmlocalsearch.js" type="text/javascript"></script>

				<style type="text/css">
					@import url("http://www.google.com/uds/css/gsearch.css");
					@import url("http://www.google.com/uds/solutions/localsearch/gmlocalsearch.css");
				</style>
				<script type="text/javascript">

					function addListener(element, baseName, handler) {
						if (element.addEventListener)
							element.addEventListener(baseName, handler, false);
						else if (element.attachEvent)
							element.attachEvent("on"+baseName,handler);
					}
					
					function initialize'.$num.'() 
					{
					
						if (GBrowserIsCompatible()) 
						{
							var map'.$num.' = new GMap2(document.getElementById("google_map'.$num.'"),{mapTypes:['.$rseventsConfig['google.map'].']});
							var point = new GLatLng('.$row->LocationLat.','.$row->LocationLon.');
							map'.$num.'.setCenter(new GLatLng('.$row->LocationLat.','.$row->LocationLon.'),4);
							var mapControl = new GMapTypeControl();
							map'.$num.'.addControl(mapControl);
							map'.$num.'.addControl(new GLargeMapControl());
							map'.$num.'.addControl(new GOverviewMapControl());
							map'.$num.'.enableDoubleClickZoom();
							map'.$num.'.enableScrollWheelZoom();
							var bounds = new GLatLngBounds;
							
							
							gdir = new GDirections(map'.$num.', document.getElementById("rse_directions"));
							GEvent.addListener(gdir, "error", handleErrors);
							
							var myIcon = new GIcon();
							myIcon.image = "http://www.google.com/mapfiles/marker.png";
							myIcon.iconAnchor = new GPoint((markerImage1.width/2),markerImage1.height);
							
							
							
							bounds.extend(point);
							setBounds(map'.$num.',bounds);				
							
							function createMarker(point) 
							{
								var marker = new GMarker(point);
								GEvent.addListener(marker,"click", function() {
								var myHtml = "<b>'.addslashes($row->LocationName).'</b><br/>'.addslashes($row->LocationAddress).' , '.addslashes($row->LocationCity).' - '.addslashes($row->LocationCountry).'";
								map'.$num.'.openInfoWindowHtml(point, myHtml);
								});
								return marker;
							}
							map'.$num.'.addOverlay(createMarker(point));
						}
					}
					
					function setDirections(fromAddress, toAddress) 
					{
						if (fromAddress != "")
							gdir.load("from: " + fromAddress + " to: " + toAddress,{ "locale": "en_US" });
					}
					
					function handleErrors(){
						if (gdir.getStatus().code == 602)
							alert("'.JText::_('RSE_GOOGLE_ERR_602',true).'");
						else if (gdir.getStatus().code == 500)
							alert("'.JText::_('RSE_GOOGLE_ERR_500',true).'");
						else if (gdir.getStatus().code == 601)
							alert("'.JText::_('RSE_GOOGLE_ERR_601',true).'");
						else if (gdir.getStatus().code == 603)
							alert("'.JText::_('RSE_GOOGLE_ERR_603',true).'");
						else if (gdir.getStatus().code == 610)
							alert("'.JText::_('RSE_GOOGLE_ERR_610',true).'");
						else if (gdir.getStatus().code == 400)
							alert("'.JText::_('RSE_GOOGLE_ERR_400',true).'");
						else alert("'.JText::_('RSE_GOOGLE_ERR_0',true).'");
					}
					
					
					function setBounds(map'.$num.',bounds)
					{
						map'.$num.'.setZoom('.$rseventsConfig['locations.gMaps.zoom'].');
						map'.$num.'.setCenter(bounds.getCenter());
					}					

					function chargement() 
					{	
						markerImage1 = new Image(); 
						markerImage1.src = "http://www.google.com/mapfiles/marker.png";
						setTimeout("initialize'.$num.'()", 500); 
					}

					addListener(window, "load", chargement);
				</script>
				<span style="clear:both; display:block;"></span>
				<div style="width: 100%;">
					<div id="google_map'.$num.'" style="width: 100%; height: 300px; overflow:hidden;"></div>
				</div>';
		
		if ($direction)
		$map .= '<div style="margin:5px 0 5px;">
			<h3>'.JText::_('RSE_GOOGLE_GET_DIRECTIONS').'</h3>
			<ul class="rse_map_directions">
				<li>
					<label for="from_direction">'.JText::_('RSE_GOOGLE_GET_DIRECTION_FROM').'</label>
					<input type="text" size="25" id="from_direction" name="from_direction" value="" onchange="setDirections(document.getElementById(\'from_direction\').value, \''.$row->LocationLat.','.$row->LocationLon.'\')" />
				</li>
				<li>
					<button type="button" onclick="setDirections(document.getElementById(\'from_direction\').value, \''.$row->LocationLat.','.$row->LocationLon.'\')">'.JText::_('RSE_GOOGLE_GET_DIRECTIONS').'</button>
				</li>
			</ul>
		</div>
		<div class="rsevents-clear"></div>
		<div id="rse_directions" style="width: 100%"></div>';
		
		} 	else $map = '';
	
		return $map;
	}
	
	//get the user id of the user if the username exists or create a new user
	function returnUser($email , $name = null)
	{
		$db 			=& JFactory::getDBO();
		$rseventsConfig = rseventsHelper::getConfig();
		
		//check if the email is attached to an account
		$db->setQuery("SELECT `id` FROM #__users WHERE `email` = '".$db->getEscaped($email)."'");
		$userid = $db->loadResult();
		
		if (!empty($userid)) return $userid;

		// Get required system objects
		$user 		= clone(JFactory::getUser());
		$authorize	=& JFactory::getACL();
		$config = JFactory::getConfig();

		// Initialize new usertype setting
		$newUsertype = 'Registered';
		
		// Bind the post array to the user object
		if (!$user->bind( JRequest::get('post'), 'usertype' ))
			JError::raiseError( 500, $user->getError());
		
		//set the username
		$name = trim($name);
		$username = strtolower(str_replace(' ','.',$name));
		$db->setQuery("SELECT id FROM #__users WHERE `username` = '".$db->getEscaped($username)."' ");
		if ( intval($db->loadResult()) > 0 )
			$username = $username.rand(0,99);
		
		// Set some initial user values
		$user->set('id', 0);
		$user->set('email',$email);
		$user->set('name',$name);
		$user->set('username',$username);
		$user->set('usertype', $newUsertype);
		if (!rseventsHelper::is16())
			$user->set('gid', $authorize->get_group_id( '', $newUsertype, 'ARO' ));

		$date =& JFactory::getDate();
		$user->set('registerDate', $date->toMySQL());
		
		jimport('joomla.user.helper');
		$password = JUserHelper::genRandomPassword(6);
		$user->set('password', md5($password));
		$password = preg_replace('/[\x00-\x1F\x7F]/', '', $password); //Disallow control chars in the email
		
		// If there was an error with registration, set the message and display form
		if ( !$user->save() )
		{
			JError::raiseWarning('', JText::_( $user->getError()));
			return false;
		}
		
		if (rseventsHelper::is16())
		{
			$db->setQuery("INSERT INTO #__user_usergroup_map SET user_id = ".$user->id." , group_id = 2 ");
			$db->query();
		}
		
		//auto approve users if CB is installed
		if ($rseventsConfig['cb.autoapprove'] == 1 && file_exists(JPATH_SITE.DS.'components'.DS.'com_comprofiler'.DS.'comprofiler.php'))
		{
			$db->setQuery("INSERT INTO #__comprofiler SET approved = 1 , user_id = ".$user->id." , id = ".$user->id." , confirmed = 1 ");
			$db->query();
		}
		
		
		$mailfrom 		= $config->getValue( 'mailfrom' );
		$fromname 		= $config->getValue( 'fromname' );
		$sitename 		= $config->getValue( 'sitename' );
		$siteURL		= JURI::base();
		$username		= $user->username;
		$name			= $user->name;
		$subject 		= sprintf ( JText::_( 'RSE_MSG_SUBJECT' ), $name, $sitename);
		$subject 		= html_entity_decode($subject, ENT_QUOTES);
		$message		= sprintf ( JText::_( 'RSE_SEND_MSG' ), $name, $sitename, $siteURL ,$username, $password );
		$message		= html_entity_decode($message, ENT_QUOTES);
		
		JUtility::sendMail($mailfrom, $fromname, $email, $subject, $message);
		
		return $user->id;
	}
	
	
	function getComments($id,$name,$columns = null)
	{
		$config = rseventsHelper::getConfig();
		
		switch ($config['events.commenting']) 
		{
			//jcomments integration
			case 1:
				if (file_exists(JPATH_SITE.DS.'components'.DS.'com_jcomments'.DS.'jcomments.php')) :
					require_once(JPATH_SITE.DS.'components'.DS.'com_jcomments'.DS.'jcomments.php');
					return JComments::showComments($id, 'com_rsevents', $name);
				endif;
			break;

			//jomcomment integration
			case 2:
				if (file_exists(JPATH_SITE.DS.'plugins'.DS.'content'.DS.'jom_comment_bot.php')) :
					require_once(JPATH_SITE.DS.'plugins'.DS.'content'.DS.'jom_comment_bot.php');
					return jomcomment($id, 'com_rsevents');
				endif;
			break;
			
			//rscomments integration
			case 3:
				if (file_exists(JPATH_SITE.DS.'components'.DS.'com_rscomments'.DS.'helpers'.DS.'rscomments.php')) :
					require_once(JPATH_SITE.DS.'components'.DS.'com_rscomments'.DS.'helpers'.DS.'rscomments.php');
					return RSCommentsHelper::showRSComments('com_rsevents',$id);
				endif;
			break;
			
			case 4:
				if ($columns == '1')
					$width = '700';
				else if ($columns == '2')
					$width = '350';
				else if ($columns == '3')
					$width = '220';
				else $width = '500';
				return '<div id="fb-root"></div><fb:comments href="'.rseventsHelper::route(JURI::root().'index.php?option=com_rsevents&view=events&layout=show&cid='.eventsHelper::sef($id,$name).'&Itemid=99999999').'" num_posts="5" width="'.$width.'"></fb:comments>';
			break;
		}
	}
	
	function getGuests($event)
	{
		$config = rseventsHelper::getConfig();
		$registeredUsers = $event->EventEnableRegistration ? rseventsModelEvents::getRegistered() : array();
		
		$html = '';
		
		if (($event->EventShowGuest == 1) && (!empty($registeredUsers['users']) || !empty($registeredUsers['guests']))) 
		{
			$html .= '<div id="rsevents-registered">';
			$html .= '<h3>'.JText::_('RSE_REGISTERED_USERS').'</h3>';
			
			foreach($registeredUsers['users'] as $user)
			{
				$html .= '<div class="register_details">';
				
				if($config['subscribers.link'] == 0)
					$html .= '<p>'.$user->avatar.'</p><p>'.$user->name.'</p>';
				
				elseif ($config['subscribers.link'] == 1 && file_exists(JPATH_SITE.DS.'components'.DS.'com_comprofiler'.DS.'comprofiler.php'))
				{
					$link = rseventsHelper::route('index.php?option=com_comprofiler&task=userProfile&user='.$user->id);
					$html .= '<p><a href="'.$link.'">'.$user->avatar.'</a></p><p><a href="'.$link.'">'.$user->name.'</a></p>';
				}
				
				elseif ($config['subscribers.link'] == 2 && file_exists(JPATH_SITE.DS.'components'.DS.'com_joomunity'.DS.'joomunity.php'))
				{
					$link = rseventsHelper::route('index.php?option=com_joomunity&cmd=Profile.View.'.$user->id);
					$html .= '<p><a href="'.$link.'">'.$user->avatar.'</a></p><p><a href="'.$link.'">'.$user->name.'</a></p>';
				}
				
				elseif($config['subscribers.link'] == 3 &&  file_exists(JPATH_SITE.DS.'components'.DS.'com_community'.DS.'community.php'))
				{
					$link = rseventsHelper::route('index.php?option=com_community&view=profile&userid='.$user->id);
					$html .= '<p><a href="'.$link.'">'.$user->avatar.'</a></p><p><a href="'.$link.'">'.$user->name.'</a></p>';
				}
				
				else $html .= '<p>'.$user->avatar.'</p><p>'.$user->name.'</p>';
				$html .= '</div>';
			}
			
			$multiple = ($registeredUsers['guests'] == 1) ? JText::_('RSE_GUEST') : JText::_('RSE_GUESTS') ;
			if(!empty($registeredUsers['guests'])) $html .= '<div class="register_details"><p><img src="'.JURI::root().'components/com_rsevents/assets/images/user.png" /></p><p>'.$registeredUsers['guests'].' '.$multiple.'</p></div>';
			
			$html .= '</div>';
		}
		
		return $html;
	}
	
	function setMessage($message, $redirect = 0 , $url = null)
	{
		$rseventsConfig = rseventsHelper::getConfig();
		
		JRequest::setVar('tmpl','component');
		
		$makeredirect = $redirect ? 'window.parent.location.reload();' : '';
		if (!is_null($url))
		{
			$u =& JFactory::getURI();
			$root = $u->toString(array('scheme','host'));
			if (strpos($url,$root) !== TRUE)
				$url = $root.$url;			
			$makeredirect = 'window.parent.location = "'.$url.'";';
		}
		
		if ($rseventsConfig['modal.type'])
		{
			if (rseventsHelper::is16())
				$close = 'window.parent.SqueezeBox.close();';
			else $close = 'window.parent.document.getElementById(\'sbox-window\').close();';
		} else $close = 'window.parent.jQuery.colorbox.close();';
		
		$return = '<div class="rse_message">'.$message.'</div>';
		$return .= '<script type="text/javascript">window.top.setTimeout(\''.$makeredirect.addslashes($close).'\',1200);</script>';
		
		return $return;
	}
}