<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' ); 

class RSGoogle
{
	/*
	*	Get the contact list of the current email address
	*
	*	Returns :
	*			0 - if the email or the password is empty
	*			1 - if there was an error connecting to the Google server
	*			2 - if there is no Authorization code
	*			3 - no contacts
	*			list of available contacts
	*
	*/
	
	function getContacts($username,$password)
	{
		if (empty($username) || empty($password)) return 0;
		$returns = array();
		$contacts = array();
		
		$username = stristr($username,'@') ? $username : $username.'@gmail.com';
		
		$login_url = "https://www.google.com/accounts/ClientLogin";
		
		$fields = array(
		'Email'       => $username,
		'Passwd'      => $password,
		'service'     => 'cp', // cp = Contact List
		'source'      => 'rsevents-google-contact-grabber',
		'accountType' => 'HOSTED_OR_GOOGLE',
		);

		$curl = curl_init();
		curl_setopt($curl, CURLOPT_URL,$login_url);
		curl_setopt($curl, CURLOPT_POST, 1);
		curl_setopt($curl, CURLOPT_POSTFIELDS,$fields);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1); 
		$result = curl_exec($curl);

		if (empty($result)) return 1;
		
		$lines = explode("\n",$result);
		
		if (!empty($lines))
			foreach ($lines as $line) 
			{
				$line = trim($line);
				if(!$line) continue;
				list($k,$v) = explode('=',$line,2);
				$returns[$k] = $v;
			}
		curl_close($curl);

		$feed_url = "http://www.google.com/m8/feeds/contacts/$username/full?alt=json&max-results=250";

		if (empty($returns['Auth'])) return 2;
		
		$header = array( 'Authorization: GoogleLogin auth=' . $returns['Auth'] );

		$curl = curl_init();
		curl_setopt($curl, CURLOPT_URL, $feed_url);
		curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1); 

		$result = curl_exec($curl);
		curl_close($curl);

		if (!function_exists('json_decode'))
		{
			//get the json class
			require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'JSON.php');
			
			$json = new Services_JSON;
			$data = $json->decode($result);
		} else $data = json_decode($result);
		
		
		if (empty($data)) return 3;
		
		foreach ($data->feed->entry as $entry)
		{
			$name = $entry->title->{'$t'};
			$email = $entry->{'gd$email'}[0]->address;
			$contacts[$name] = $email;
		}
		
		return $contacts;
	}
	
	/*
	*	Return the list of contacts
	*
	*/
	
	function results($username,$password)
	{
		$result = '';
		$contacts = RSGoogle::getContacts($username,$password);
		
		if (empty($contacts)) return '<font color="#FF0000">'.JText::_('RSE_EMPTY_USERNAME').'</font><br><br>';
		
		if ($contacts == 0 || $contacts == 1 || $contacts == 2 || $contacts == 3) return '<font color="#FF0000">'.JText::_('RSE_INVALID_LOGIN').'</font><br><br>';
		
		foreach ($contacts as $name => $email)
		{
			$result .='
		<tr> 
			<td>
				<input type=checkbox name="importedContacts[]" value="'.$email.'" checked="checked"/>
			</td>
			<td>
				'.$name.'
			</td>
			<td>
				'.$email.'
			</td>
		</tr>
		<tr> 
		<td bgcolor="#FFFFFF" height="1" colspan="3"></td>
		</tr>';
		}
		
		return $result;
	}
	
}
?>