<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

class RSEGoogleCalendar
{
	
	var $_username;
	var $_password;
	var $_errors = array();
	
	function RSEGoogleCalendar($user,$pass)
	{
		$this->_username = $user;
		$this->_password = $pass;
	}
	
	
	/*
	*	Insert events in database
	*/
	
	function parse()
	{
		$db		=& JFactory::getDBO();
		$user	=& JFactory::getUser();
		$events	= $this->getEvents();
		$config	= RSEventsHelper::getConfig();
		
		$idcategory = $config['google.category'];
		if (empty($idcategory))
		{
			$db->setQuery("INSERT INTO #__rsevents_categories SET CategoryName = 'Google Calendar' , CategoryAlias = 'google-calendar' ");
			$db->query();
			$idcategory = $db->insertid();
		}
		
		$i = 0;
		if (empty($events)) return;
		foreach ($events as $event)
		{
			$idlocation = $config['google.location'];
			
			//check if the current event was already added
			$db->setQuery("SELECT COUNT(id) FROM #__rsevents_sync WHERE id = '".$event->id."' AND `from` = 'gcalendar' ");
			$indb = $db->loadResult();
			
			if(!empty($indb)) continue;
			
			$db->setQuery("SELECT IdDesign FROM #__rsevents_designs WHERE DesignDefault = 1 AND designtype = 0 ");
			$iddesign = (int) $db->loadResult();
			
			$db->setQuery("SELECT `id` FROM `#__rsevents_themes` WHERE `default` = 1 ");
			$idtheme = (int) $db->loadResult();
			
			if (empty($idlocation))
			{
				$location = !empty($event->EventLocation) ? $event->EventLocation : 'Google calendar locations';
				$db->setQuery("INSERT INTO #__rsevents_locations SET LocationName = '".$db->getEscaped($location)."' , LocationAddress = '".$db->getEscaped($location)."' , LocationAlias = '".$db->getEscaped(JFilterOutput::stringURLSafe($location))."' ");
				$db->query();
				$idlocation = $db->insertid();
			}
			
			$db->setQuery("INSERT INTO #__rsevents_events SET IdLocation = '".$idlocation."' , IdNewDesign = '".$iddesign."' , IdTheme = '".$idtheme."' , IdUser = '".$user->id."' , EventName = '".$db->getEscaped($event->EventName)."' , EventAlias = '".$db->getEscaped(JFilterOutput::stringURLSafe($event->EventName))."', EventHost = '".$db->getEscaped($event->Host)."' , EventDescription = '".$db->getEscaped($event->EventDescription)."' , EventType = 1 , EventStartDate = '".$db->getEscaped($event->EventStartDate)."' , EventEndDate = '".$db->getEscaped($event->EventEndDate)."' , published = 1 ");
			$db->query();
			
			$idevent = $db->insertid();
			
			$db->setQuery("INSERT INTO  #__rsevents_events_cat SET IdEvent = '".$idevent."' , IdCategory = '".$idcategory."' ");
			$db->query();
			
			$db->setQuery("INSERT INTO #__rsevents_sync SET id = '".$event->id."' , IdEvent = '".$idevent."' , `from` = 'gcalendar' ");
			$db->query();
			
			$i++;
		}
		
		return $i;
	}
	
	
	
	/*
	*	Get and parse events
	*/
	
	function getEvents()
	{
		$returns = array();
		$events = array();
		
		$login_url = "https://www.google.com/accounts/ClientLogin";
		$this->_username = stristr($this->_username,'@') ? $this->_username : $this->_username.'@gmail.com';
		
		$fields = array(
		'Email'       => $this->_username,
		'Passwd'      => $this->_password,
		'service'     => 'cl', // cl = Google calendar
		'source'      => 'rsevents-google-calendar-grabber',
		'accountType' => 'HOSTED_OR_GOOGLE',
		);

		$curl = curl_init();
		curl_setopt($curl, CURLOPT_URL,$login_url);
		curl_setopt($curl, CURLOPT_POST, 1);
		curl_setopt($curl, CURLOPT_POSTFIELDS,$fields);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1); 
		$result = curl_exec($curl);
		
		
		if (empty($result))
			$this->addError('Could not connect to Google! server.');
		
		
		$lines = explode("\n",$result);
		if (!empty($lines))
			foreach ($lines as $line) 
			{
				$line = trim($line);
				if(!$line) continue;
				list($k,$v) = explode('=',$line,2);
				$returns[$k] = $v;
			}
		curl_close($curl);

		if (empty($returns['Auth']))
		{
			if (isset($returns['Error'])) 
				$this->addError($returns['Error']);
			else 
				$this->addError('Authentication failed');
			return;
		}
		
		$header = array( 'Authorization: GoogleLogin auth=' . $returns['Auth'] );
		$url = "https://www.google.com/calendar/feeds/$this->_username/private/full?alt=jsonc&max-results=250";
		$result = $this->getData($header,$url,1);
		
		if (!function_exists('json_decode'))
		{
			//get the json class
			require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'JSON.php');
			
			$json = new Services_JSON;
			$data = $json->decode($result);
		} else $data = json_decode($result);
		
		if (empty($data))
		{
			$this->addError('No data available.');
			return;
		}
		
		if (!empty($data->data->items))
		foreach ($data->data->items as $item)
		{
			$event = new stdClass();
			$event->id = $item->id;
			$event->EventName = $item->title;
			$event->EventDescription = $item->details;
			$event->EventLocation = $item->location;
			$event->Host = $item->creator->displayName;
			
			if (isset($item->when))
			{
				$dates = $item->when[0];
				$event->EventStartDate = strtotime($dates->start);
				$event->EventEndDate = strtotime($dates->end);
			}
			
			if (isset($item->recurrence))
			{
				$event->EventStartDate = time();
				$event->EventEndDate = time() + 7200;
				
				$lines = explode("\n",$item->recurrence);
				if (!empty($lines[0]))
				{
					$line = explode(':',$lines[0]);
					if (!empty($line[1]))
						$event->EventStartDate = strtotime($line[1]);
				}
				if (!empty($lines[1]))
				{
					$line = explode(':',$lines[1]);
					if (!empty($line[1]))
						$event->EventEndDate = strtotime($line[1]);
				}
			}
			$events[] = $event;
		}
		
		return $events;
	}
	
	/*
	*	Get data from server
	*/
	
	function getData($header,$url,$type='1')
	{
		$original = $header;
		$headers = $this->getHeaders($header,$url);
		
		$redirect = false;
		$redirect_url = false;
		
		$headers = explode("\n",$headers);
		foreach($headers as $header)
		{
			$header = trim($header);
			if(strpos($header,'Location:') !== FALSE)
			{
				$redirect = true;
				$redirect_url = trim(str_replace('Location: ','',$header));
			}
		}
		
		$c_url = $redirect ? $redirect_url : $url;
		
		
		$curl = curl_init();
		curl_setopt($curl, CURLOPT_URL, $c_url);
		curl_setopt($curl, CURLOPT_HTTPHEADER, $original);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1); 

		$result = curl_exec($curl);
		curl_close($curl);
		
		return $result;
	}
	
	
	/*
	*	Get data from server
	*/
	
	function getHeaders($header,$url)
	{
		$curl = curl_init();
		curl_setopt($curl, CURLOPT_URL, $url);
		curl_setopt($curl, CURLOPT_HEADER, 1);
		curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_NOBODY, true);

		$result = curl_exec($curl);
		curl_close($curl);	
		
		return $result;
	}
	
	
	/*
	*	Add errors
	*/
	
	function addError($error)
	{
		if (isset($this->_errors))
			if (in_array($error,$this->_errors)) 
				return $this->_errors;
		
		$this->_errors[] = $error;
	}
	
	/*
	*	Get errors
	*/
	
	function getErrors()
	{
		return $this->_errors;
	}
	
}