<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' ); 

// PLEASE DO NOT CHANGE HERE
define('RSE_RS_PRODUCT','RSEvents!');
define('RSE_RS_VERSION','1.2.0');
define('RSE_RS_REVISION','26');
define('RSE_RS_KEY','EV8SK739H1');
define('RSE_RS_COPYRIGHT','&copy;2007-2010 www.rsjoomla.com');
define('RSE_RS_LICENSE','GPL License');
define('RSE_RS_AUTHOR','<a href="http://www.rsjoomla.com" target="_blank">www.rsjoomla.com</a>');

class rseventsHelper
{
	
	//read configuration
	function readConfig()
	{
		static $rsevents_config;
		
		if (!is_object($rsevents_config) || $reload)
		{
			$rsevents_config = array();
			
			$db =& JFactory::getDBO();
			$db->setQuery("SELECT * FROM `#__rsevents_config`");
			$config = $db->loadObjectList();
			if (!empty($config))
				foreach ($config as $config_item)
					$rsevents_config[$config_item->ConfigName] = $config_item->ConfigValue;
		}
		
		return $rsevents_config;
	}
	
	//get the config
	function getConfig($name = null)
	{
		$config = rseventsHelper::readConfig();
		if ($name != null)
		{
			if (isset($config[$name]))
				return $config[$name];
			else
				return false;
		}
		else
			return $config;
	}
	
	function is16()
	{
		$jversion = new JVersion();
		$current_version =  $jversion->getShortVersion();
		return (version_compare('1.6.0', $current_version) <= 0);
	}
	
	function getPayments($addNone = false, $available = null)
	{
		$db  =& JFactory::getDBO();
		$app =& JFactory::getApplication();
		
		$return = array();
		
		if ($addNone)
			$return[] = JHTML::_('select.option', 'none', JText::_( 'RSE_NO_PAYMENT' ) );				
		
		$available = !is_null($available) && !empty($available) ? explode(',',$available) : '';		
		
		//payment plugins
		$payment_methods = $app->triggerEvent('rse_addOptions');
		if (!empty($payment_methods))
			foreach ($payment_methods as $i => $item)
			{
				if (empty($item->value) || $item->value == 'wire') continue;
				if (!empty($available) && !in_array($item->value,$available)) continue;
				$return[] = $item;
			}
		
		//database payments
		$db->setQuery("SELECT id as value , name as text FROM #__rsevents_payments WHERE published = 1");
		$db_payments = $db->loadObjectList();
		
		if (!empty($db_payments)) 
		foreach ($db_payments as $payment)
		{
			if (!empty($available) && !in_array($payment->value,$available)) continue;
			$return[] = $payment;
		}
		
		return $return;
	}
	
	//cron for auto-archiveing events
	function archive()
	{
		$db 	=& JFactory::getDBO();
		$config = rseventsHelper::getConfig();
		
		//archive old events
		if ($config['event.enable.autoarchive'] == 1)
		{
			$time_offset = $config['event.archive.days'] * 86400;
			$db->setQuery("SELECT IdEvent FROM #__rsevents_events WHERE ".time()." > EventEndDate + ".$time_offset." AND EventArchive = '0' ");
		
			if ($eventIds = $db->loadResultArray())
			{
				$ids = implode(',',$eventIds);
				
				$db->setQuery("UPDATE #__rsevents_events SET published = '-1' WHERE IdEvent IN (".$ids.") ");
				$db->query();

				$db->setQuery("UPDATE #__rsevents_events SET EventArchive = '0' WHERE IdEvent IN (".$ids.") ");
				$db->query();
			}
		}
	}
	
	//clean cache
	function cleancache()
	{
		// Clean the cache, if any
		$cache =& JFactory::getCache('com_rsevents');
		$cache->clean();
	}
	
	//shorten text
	function shorten($string,$max=255,$more=' ...')
	{
		$config = rseventsHelper::getConfig();
		$size   = (int) $config['descr.length'];
		
		if (!empty($size))
			$max = $size;
		
		$string_tmp = '';
		$exp = explode(' ',$string);
		for ($i=0; $i<count($exp); $i++)
		{
			if (strlen($string_tmp) + strlen($exp[$i]) < $max)
			$string_tmp .= $exp[$i].' ';
			else
			break;
		}
		return substr($string_tmp,0,-1).(strlen($string) > strlen($string_tmp) ? $more : '');
	}
	
	//shorten text javascript
	function shortenjs($string,$id,$max=255)
	{
		$config = rseventsHelper::getConfig();
		$size   = (int) $config['descr.length'];
		
		if (!empty($size)) $max = $size;
		
		$string_length = mb_strlen($string);
		
		if ($max >= $string_length) return $string;
		
		$intro = mb_substr($string,0,$max);
		$extra = mb_substr($string,$max,$string_length);
		$extra .= '<a href="javascript:void(0);" class="rse_minus" onclick="rse_description_off('.$id.')" onmouseover="document.getElementById(\'minusimg\').src=\''.JURI::root().'components/com_rsevents/assets/images/minus_02.gif\'" onmouseout="document.getElementById(\'minusimg\').src=\''.JURI::root().'components/com_rsevents/assets/images/minus_01.gif\'">';
		$extra .= '<img id="minusimg" src="'.JURI::root().'components/com_rsevents/assets/images/minus_01.gif" alt="" /></a>';
		
		$text = $intro;
		$text .= '<a id="rsehref'.$id.'" href="javascript:void(0);" class="rse_plus" onclick="rse_description_on('.$id.')" onmouseover="document.getElementById(\'plusimg\').src=\''.JURI::root().'components/com_rsevents/assets/images/plus_02.gif\'" onmouseout="document.getElementById(\'plusimg\').src=\''.JURI::root().'components/com_rsevents/assets/images/plus_01.gif\'">';
		$text .= '<img id="plusimg" src="'.JURI::root().'components/com_rsevents/assets/images/plus_01.gif" alt="" /></a>';
		$text .= '<span id="rsedescription'.$id.'" class="rse_extra_off">'.$extra.'</span>';
		
		return $text;
	}
	
	//get contents from a url
	function fopen($url)
	{
		$url_info = parse_url($url);
		$data = false;

		// cURL
		if (extension_loaded('curl'))
		{
			// Init cURL
			$ch = @curl_init();
			
			// Set options
			@curl_setopt($ch, CURLOPT_URL, $url);
			@curl_setopt($ch, CURLOPT_HEADER, 0);
			@curl_setopt($ch, CURLOPT_FAILONERROR, 1);
			@curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			
			// Set timeout
			@curl_setopt($ch, CURLOPT_TIMEOUT, 5);
			
			// Grab data
			$data = @curl_exec($ch);
			
			// Clean up
			@curl_close($ch);
			
			// Return data
			if ($data !== false)
				return $data;
		}

		// fsockopen
		if (function_exists('fsockopen'))
		{
			$errno = 0;
			$errstr = '';

			// Set timeout
			$fsock = @fsockopen($url_info['host'], 80, $errno, $errstr, 5);
		
			if ($fsock)
			{
				@fputs($fsock, 'GET '.$url_info['path'].(!empty($url_info['query']) ? '?'.$url_info['query'] : '').' HTTP/1.1'."\r\n");
				@fputs($fsock, 'HOST: '.$url_info['host']."\r\n");
				@fputs($fsock, 'Connection: close'."\r\n\r\n");
        
				// Set timeout
				@stream_set_blocking($fsock, 1);
				@stream_set_timeout($fsock, 5);
				
				$data = '';
				$passed_header = false;
				while (!@feof($fsock))
				{
					if ($passed_header)
						$data .= @fread($fsock, 1024);
					else
					{
						if (@fgets($fsock, 1024) == "\r\n")
							$passed_header = true;
					}
				}
				
				// Clean up
				@fclose($fsock);
				
				// Return data
				if ($data !== false)
					return $data;
			}
		}

	 	// fopen
		if (function_exists('fopen') && ini_get('allow_url_fopen'))
		{
			// Set timeout
			if (ini_get('default_socket_timeout') < 5)
				ini_set('default_socket_timeout', 5);
			@stream_set_blocking($handle, 1);
			@stream_set_timeout($handle, 5);
			
			$handle = @fopen ($url, 'r');
			
			$data = '';
			while (!feof($handle))
				$data .= @fread($handle, 8192);
			
			// Clean up
			@fclose($handle);
			
			// Return data
			if ($data !== false)
				return $data;
		}
						
		// file_get_contents
		if(function_exists('file_get_contents') && ini_get('allow_url_fopen'))
		{
			$data = @file_get_contents($url);
			
			// Return data
			if ($data !== false)
				return $data;
		}
		
		return $data;
	}
	
	//strip javascript vars
	function RSstripjavaVar($val)
	{
	   // remove all non-printable characters. CR(0a) and LF(0b) and TAB(9) are allowed
	   // this prevents some character re-spacing such as <java\0script>
	   // note that you have to handle splits with \n, \r, and \t later since they *are* allowed in some inputs
	   $val = preg_replace('/([\x00-\x08][\x0b-\x0c][\x0e-\x20])/', '', $val);

	   // straight replacements, the user should never need these since they're normal characters
	   // this prevents like <IMG SRC=&#X40&#X61&#X76&#X61&#X73&#X63&#X72&#X69&#X70&#X74&#X3A&#X61&#X6C&#X65&#X72&#X74&#X28&#X27&#X58&#X53&#X53&#X27&#X29>
	   $search = 'abcdefghijklmnopqrstuvwxyz';
	   $search .= 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
	   $search .= '1234567890!@#$%^&*()';
	   $search .= '~`";:?+/={}[]-_|\'\\';
	   for ($i = 0; $i < strlen($search); $i++) {
	      // ;? matches the ;, which is optional
	      // 0{0,7} matches any padded zeros, which are optional and go up to 8 chars

	      // &#x0040 @ search for the hex values
	      $val = preg_replace('/(&#[x|X]0{0,8}'.dechex(ord($search[$i])).';?)/i', $search[$i], $val); // with a ;
	      // &#00064 @ 0{0,7} matches '0' zero to seven times
	      $val = preg_replace('/(&#0{0,8}'.ord($search[$i]).';?)/', $search[$i], $val); // with a ;
	   }

	   // now the only remaining whitespace attacks are \t, \n, and \r
	   $ra1 = Array('javascript', 'vbscript', 'expression', 'applet', 'meta', 'blink', 'link',  'script', 'iframe', 'frame', 'frameset', 'ilayer', 'layer', 'bgsound');
	   $ra2 = Array('onabort', 'onactivate', 'onafterprint', 'onafterupdate', 'onbeforeactivate', 'onbeforecopy', 'onbeforecut', 'onbeforedeactivate', 'onbeforeeditfocus', 'onbeforepaste', 'onbeforeprint', 'onbeforeunload', 'onbeforeupdate', 'onblur', 'onbounce', 'oncellchange', 'onchange', 'onclick', 'oncontextmenu', 'oncontrolselect', 'oncopy', 'oncut', 'ondataavailable', 'ondatasetchanged', 'ondatasetcomplete', 'ondblclick', 'ondeactivate', 'ondrag', 'ondragend', 'ondragenter', 'ondragleave', 'ondragover', 'ondragstart', 'ondrop', 'onerror', 'onerrorupdate', 'onfilterchange', 'onfinish', 'onfocus', 'onfocusin', 'onfocusout', 'onhelp', 'onkeydown', 'onkeypress', 'onkeyup', 'onlayoutcomplete', 'onload', 'onlosecapture', 'onmousedown', 'onmouseenter', 'onmouseleave', 'onmousemove', 'onmouseout', 'onmouseover', 'onmouseup', 'onmousewheel', 'onmove', 'onmoveend', 'onmovestart', 'onpaste', 'onpropertychange', 'onreadystatechange', 'onreset', 'onresize', 'onresizeend', 'onresizestart', 'onrowenter', 'onrowexit', 'onrowsdelete', 'onrowsinserted', 'onscroll', 'onselect', 'onselectionchange', 'onselectstart', 'onstart', 'onstop', 'onsubmit', 'onunload');
	   $ra = array_merge($ra1, $ra2);

	   $found = true; // keep replacing as long as the previous round replaced something
	   while ($found == true) {
	      $val_before = $val;
	      for ($i = 0; $i < sizeof($ra); $i++) {
	         $pattern = '/';
	         for ($j = 0; $j < strlen($ra[$i]); $j++) {
	            if ($j > 0) {
	               $pattern .= '(';
	               $pattern .= '(&#[x|X]0{0,8}([9][a][b]);?)?';
	               $pattern .= '|(&#0{0,8}([9][10][13]);?)?';
	               $pattern .= ')?';
	            }
	            $pattern .= $ra[$i][$j];
	         }
	         $pattern .= '/i';
	         $replacement = substr($ra[$i], 0, 2).'<x>'.substr($ra[$i], 2); // add in <> to nerf the tag
	         $val = preg_replace($pattern, $replacement, $val); // filter out the hex tags
	         if ($val_before == $val) {
	            // no replacements were made, so exit the loop
	            $found = false;
	         }
	      }
	   }
	   return $val;
	}
	
	
	//import yahoo contacts
	function importyahoo()
	{			
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'yahoo.class.php');
		$cid = JRequest::getInt('cid','','request');
			
		$username = JRequest::getVar('username','','post');
		$password = JRequest::getVar('password','','post');
	
		$showContacts = false;
		if(isset($username) && isset($password) && $username != '' && $password != '') 
		{
			$this->assignRef('contacts',RSYahoo::results($username,$password));
			$showContacts = true;
		}
		
		$location = "";
		$cookiearr = array();
		
		$this->assignRef('cid',$cid);
		$this->assignRef('showContacts',$showContacts);
	}
	
	//import gmail contacts
	function importgmail()
	{
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'gmail.class.php');
		
		$cid = JRequest::getInt('cid','','request');
		$username = JRequest::getVar('username','','post');
		$password = JRequest::getVar('password','','post');

		$showContacts = false;
		if(isset($username) && isset($password) && $username != '' && $password != '') 
		{
			$this->assignRef('contacts',RSGoogle::results($username,$password));
			$showContacts = true;
		}
		
		$this->assignRef('showContacts',$showContacts);
		$this->assignRef('cid',$cid);
	
	}
	
	//strip html tags
	function strip_html_tags( $text )
	{
		$text = preg_replace(
			array(
			  // Remove invisible content
				'@<head[^>]*?>.*?</head>@siu',
				'@<style[^>]*?>.*?</style>@siu',
				'@<script[^>]*?.*?</script>@siu',
				'@<object[^>]*?.*?</object>@siu',
				'@<embed[^>]*?.*?</embed>@siu',
				'@<applet[^>]*?.*?</applet>@siu',
				'@<noframes[^>]*?.*?</noframes>@siu',
				'@<noscript[^>]*?.*?</noscript>@siu',
				'@<noembed[^>]*?.*?</noembed>@siu',
			  // Add line breaks before and after blocks
				'@</?((address)|(blockquote)|(center)|(del))@iu',
				'@</?((div)|(h[1-9])|(ins)|(isindex)|(p)|(pre))@iu',
				'@</?((dir)|(dl)|(dt)|(dd)|(li)|(menu)|(ol)|(ul))@iu',
				'@</?((table)|(th)|(td)|(caption))@iu',
				'@</?((form)|(button)|(fieldset)|(legend)|(input))@iu',
				'@</?((label)|(select)|(optgroup)|(option)|(textarea))@iu',
				'@</?((frameset)|(frame)|(iframe))@iu',
			),
			array(
				' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',
				"\n\$0", "\n\$0", "\n\$0", "\n\$0", "\n\$0", "\n\$0",
				"\n\$0", "\n\$0",
			),
			$text );
		return strip_tags( $text );
	}
	
	//translate the date
	function translateDate($date)
	{
		$replace = array('Monday','Tuesday','Wednesday','Thursday','Friday','Saturday','Sunday',
						 'January','February','March','April','May','June','July','August','September','October','November','December',
						 'Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec',
						 'Mon','Tue','Wed','Thu','Fri','Sat','Sun');
		
		$with	 = array(JText::_('RSE_MONTH_MONDAY'),JText::_('RSE_MONTH_TUESDAY'),JText::_('RSE_MONTH_WEDNESDAY'),JText::_('RSE_MONTH_THURSDAY'),JText::_('RSE_MONTH_FRIDAY'),JText::_('RSE_MONTH_SATURDAY'),JText::_('RSE_MONTH_SUNDAY'),
						JText::_('RSE_JANUARY'),JText::_('RSE_FEBRUARY'),JText::_('RSE_MARCH'),JText::_('RSE_APRIL'),JText::_('RSE_MAY'),JText::_('RSE_JUNE'),JText::_('RSE_JULY'),JText::_('RSE_AUGUST'),JText::_('RSE_SEPTEMBER'),JText::_('RSE_OCTOBER'),JText::_('RSE_NOVEMBER'),JText::_('RSE_DECEMBER'),
						JText::_('RSE_JAN'),JText::_('RSE_FEB'),JText::_('RSE_MAR'),JText::_('RSE_APR'),JText::_('RSE_MAY_SHORT'),JText::_('RSE_JUN'),JText::_('RSE_JUL'),JText::_('RSE_AUG'),JText::_('RSE_SEP'),JText::_('RSE_OCT'),JText::_('RSE_NOV'),JText::_('RSE_DEC'),
						JText::_('RSE_MONTH_MONDAY_3'),JText::_('RSE_MONTH_TUESDAY_3'),JText::_('RSE_MONTH_WEDNESDAY_3'),JText::_('RSE_MONTH_THURSDAY_3'),JText::_('RSE_MONTH_FRIDAY_3'),JText::_('RSE_MONTH_SATURDAY_3'),JText::_('RSE_MONTH_SUNDAY_3'));
		
		return str_replace($replace, $with, $date);
	}
	
	//return the user avatar
	function getAvatar($user_id,$useremail=null)
	{
		$config = rseventsHelper::getConfig();	
		$avatar = $config['avatar'];
		
		if (!$avatar) return '';
		$html = '';
		switch ($avatar)
		{
			// Gravatar
			case 'gravatar':
			$user = JFactory::getUser($user_id);
			$email = ($user_id == 0 && !is_null($useremail)) ? md5(strtolower(trim($useremail))) : md5(strtolower(trim($user->get('email'))));
			
			$html .= '<img src="http://www.gravatar.com/avatar/'.$email.'?d='.urlencode(JURI::root().'components/com_rsevents/assets/images/user.png').'" alt="Gravatar" class="rse_avatar" />';
			
			break;
			
			// Community Builder
			case 'comprofiler':
			$db = JFactory::getDBO();
			$db->setQuery("SELECT avatar FROM #__comprofiler WHERE user_id='".(int) $user_id."'");
			$avatar = $db->loadResult();
			if (!$avatar)
				$html .= '<img src="'.JURI::root().'components/com_comprofiler/plugin/templates/default/images/avatar/tnnophoto_n.png" alt="Community Builder Avatar" class="rse_avatar" />';
			else
				$html .= '<img src="'.JURI::root().'images/comprofiler/'.$avatar.'" alt="Community Builder Avatar" class="rse_avatar" />';
			break;
			
			// JomSocial
			case 'community':
			
			$avatar = JURI::root().'components/com_community/assets/default_thumb.jpg';
			if (file_exists(JPATH_BASE.DS.'components'.DS.'com_community'.DS.'libraries'.DS.'core.php'))
			{
				require_once JPATH_BASE.DS.'components'.DS.'com_community'.DS.'libraries'.DS.'core.php';
				$user =& CFactory::getUser($user_id);
				$avatar = $user->getThumbAvatar();
			}
				
			$html .= '<img src="'.$avatar.'" alt="JomSocial Avatar" class="rse_avatar" />';
			break;
			
			// Kunena & Fireboard
			case 'kunena':
			case 'fireboard':
			$db = JFactory::getDBO();
			$db->setQuery("SELECT avatar FROM #__fb_users WHERE userid='".(int) $user_id."'");
			$avatar = $db->loadResult();
			
			if (!$avatar)
				$avatar = 's_nophoto.jpg';
			
			$html .= '<img src="'.JURI::root().'images/fbfiles/avatars/'.$avatar.'" alt="Kunena Avatar" class="rse_avatar" />';
			break;
		}
		
		return $html;
	}
	
	//load admin scripts
	function loadAdminScripts()
	{
		jimport('joomla.plugin.helper');
		
		$doc =& JFactory::getDocument();
		$doc->addScript(JURI::root(true).'/administrator/components/com_rsevents/assets/js/rsevents.js');
		$doc->addStyleSheet(JURI::root(true).'/administrator/components/com_rsevents/assets/css/style.css');
		
		if (JPluginHelper::isEnabled('system','mtupgrade') || rseventsHelper::is16())
			$doc->addScript(JURI::root(true).'/administrator/components/com_rsevents/assets/js/rainbow12.js');
		else
			$doc->addScript(JURI::root(true).'/administrator/components/com_rsevents/assets/js/rainbow.js');
	}
	
	//load site scripts
	function loadSiteScripts()
	{		
		$doc =& JFactory::getDocument();
		$doc->addStyleSheet(JURI::root(true).'/components/com_rsevents/assets/css/style.css');
		$doc->addScript(JURI::root(true).'/components/com_rsevents/assets/js/rsevents.js');
	}
	
	
	//check for files
	function checkFiles()
	{
		jimport('joomla.filesystem.file');
		if (file_exists(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_rsevents'.DS.'designs.xml'))
			JFile::delete(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_rsevents'.DS.'designs.xml');
	}
	
	function createIcon($file, $path, $width, $id, $redirect, $external = 0)
	{
		jimport('joomla.filesystem.file');
		
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();	
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'thumbs'.DS.'phpthumb.class.php');
		
		$phpThumb = new phpThumb();		
		
		if (!$external)
			$phpThumb->src = $path.$file['name'];
		else
			$phpThumb->src = $file;
		
		$phpThumb->w = $width;
		$phpThumb->q = 75;
		
		if (!$external)
			$phpThumb->config_output_format = JFile::getExt($file['name']);
		else
			$phpThumb->config_output_format = JFile::getExt($file);
		
		$phpThumb->config_error_die_on_error = true;
		$phpThumb->config_cache_disable_warning = true;
		$phpThumb->config_allow_src_above_docroot = true;
		
		if (!$external)
			$phpThumb->cache_filename = $path.$id.'_'.$width.'.'.JFile::getExt($file['name']);
		else
			$phpThumb->cache_filename = $path.$id.'_'.$width.'.'.JFile::getExt($file);
		
		if (!$external)
			$url = $redirect == 1 ? 'index.php?option=com_rsevents&view=events&layout=addeditevent&cid='.$id : 'index.php?option=com_rsevents&task=editevent&cid='.$id;
		else 
			$url = 'index.php?option=com_rsevents&task=editsettings';
		
		if ($phpThumb->GenerateThumbnail())
		{
			$phpThumb->RenderToFile($phpThumb->cache_filename);
			
			if (!$external)
				$db->setQuery("UPDATE #__rsevents_events SET EventIcon = '".$db->getEscaped($id.'.'.JFile::getExt($file['name']))."' WHERE IdEvent = '".$id."'");
			else
				$db->setQuery("UPDATE #__rsevents_events SET EventIcon = '".$db->getEscaped($id.'.'.JFile::getExt($file))."' WHERE IdEvent = '".$id."'");
			$db->query();
		} else $app->redirect(rseventsHelper::route($url,false),$phpThumb->error);
	}
	
	//get the list of categories
	function getCategories($name,$params,$selected,$options=null,$disabled=null,$reverse=null)
	{
		$db =& JFactory::getDBO();
		
		if (rseventsHelper::is16())
			$db->setQuery("SELECT IdCategory as id , CategoryName as title , parent as parent_id FROM #__rsevents_categories WHERE published = 1 ORDER BY parent, CategoryName");
		else
			$db->setQuery("SELECT IdCategory as id , CategoryName as name , parent FROM #__rsevents_categories WHERE published = 1 ORDER BY parent, CategoryName");
		$categories = $db->loadObjectList();
		
		if (!is_array($disabled) && !is_null($disabled)) $disabled = array($disabled);
		
		$children = array();
		$categs 	= array();
		
		if ( $categories )
		{
			// first pass - collect children
			foreach ( $categories as $v )
			{
				if (rseventsHelper::is16())
					$pt 	= $v->parent_id;
				else
					$pt 	= $v->parent;
				$list 	= @$children[$pt] ? $children[$pt] : array();
				array_push( $list, $v );
				$children[$pt] = $list;
			}
		}
		$list = JHTML::_('menu.treerecurse', 0, '', array(), $children, 9999, 0, 0 );
		
		if ($options)
			$categs[] = $options;
		
		foreach ( $list as $item )
		{
			$published = false;
			if (!is_null($disabled))
			{
				$published = (!in_array($item->id,$disabled)) ? true : false;
				if ($reverse)
					$published = (in_array($item->id,$disabled)) ? true : false;
			}
			
			$categs[] = JHTML::_('select.option',  $item->id, '&nbsp;&nbsp;&nbsp;'. $item->treename, 'value' , 'text' , $published );
		}
		
		if (rseventsHelper::is16())
			JHTML::$formatOptions = array_merge(JHTML::$formatOptions,array('option.text.toHtml'=>false));
		
		return  JHTML::_('select.genericlist',   $categs, $name , $params, 'value', 'text', $selected );
	}
	
	//create rating system
	function showStars($id)
	{
		$db		 =& JFactory::getDBO();
		$ip		 = $_SERVER['REMOTE_ADDR'];
		
		$db->setQuery("SELECT CEIL(IFNULL(SUM(rating)/COUNT(id),0)) FROM #__rsevents_rating WHERE IdEvent = '".$id."'");
		$rating = $db->loadResult();
		
		//check if the user has already voted
		$db->setQuery("SELECT `id` FROM `#__rsevents_rating` WHERE `ip` = '".$ip."' AND IdEvent = '".$id."' LIMIT 1");
		$voted = $db->loadResult();		
		
		$return = '<div id="rse_rating_smallcontainer_left">'.JText::_('RSE_RATE_EVENT').'</div>';
		
		$return .= '
		<div id="rse_rating_smallcontainer_right">
		<ul class="rse_star_rating" id="rse_rating">
			<li id="rse_current_rating" class="rse_feedback_selected_'.$rating.'">&nbsp;</li>
		';

		
		if ($rating == 0 || !$voted ) 
		{
			$return .='
			<li class="hasTip" title="'.JText::_('RSE_FEEDBACK_1').'"><a href="javascript: void(0);" onclick="rse_feedback_add(1, '.$id.',\''.JURI::root().'\');" class="rse_one_star" id="rse_feedback_1">&nbsp;</a></li>
			<li class="hasTip" title="'.JText::_('RSE_FEEDBACK_2').'"><a href="javascript: void(0);" onclick="rse_feedback_add(2, '.$id.',\''.JURI::root().'\');" class="rse_two_stars" id="rse_feedback_2">&nbsp;</a></li>
			<li class="hasTip" title="'.JText::_('RSE_FEEDBACK_3').'"><a href="javascript: void(0);" onclick="rse_feedback_add(3, '.$id.',\''.JURI::root().'\');" class="rse_three_stars" id="rse_feedback_3">&nbsp;</a></li>
			<li class="hasTip" title="'.JText::_('RSE_FEEDBACK_4').'"><a href="javascript: void(0);" onclick="rse_feedback_add(4, '.$id.',\''.JURI::root().'\');" class="rse_four_stars" id="rse_feedback_4">&nbsp;</a></li>
			<li class="hasTip" title="'.JText::_('RSE_FEEDBACK_5').'"><a href="javascript: void(0);" onclick="rse_feedback_add(5, '.$id.',\''.JURI::root().'\');" class="rse_five_stars" id="rse_feedback_5">&nbsp;</a></li>';
		}
		$return .= '</ul>';
		$return .= '</div>';
		
		return $return;
	}
	
	//cleanup files
	function cleanup()
	{
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');
		
		//administrator
		if (JFolder::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'images'))
			JFolder::delete(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'images');
		
		if (JFolder::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'css'))
			JFolder::delete(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'css');
		
		if (JFolder::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'views'.DS.'categorieselement'))
			JFolder::delete(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'views'.DS.'categorieselement');
		
		if (JFolder::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'views'.DS.'eventelement'))
			JFolder::delete(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'views'.DS.'eventelement');
		
		if (JFolder::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'views'.DS.'locationselement'))
			JFolder::delete(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'views'.DS.'locationselement');
		
		if (JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'rainbow.js'))
			JFile::delete(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'rainbow.js');
		
		if (JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'rsevents.js'))
			JFile::delete(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'rsevents.js');
			
		if (JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'extras.php'))
			JFile::delete(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'extras.php');
			
		if (JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'files.php'))
			JFile::delete(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'files.php');
			
		if (JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'groupPermissions.php'))
			JFile::delete(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'groupPermissions.php');
			
		if (JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'categorieselement.php'))
			JFile::delete(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'categorieselement.php');
			
		if (JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'locationselement.php'))
			JFile::delete(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'locationselement.php');
			
		if (JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'eventelement.php'))
			JFile::delete(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'eventelement.php');
			
		if (JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'controllers'.DS.'categoriesElement.php'))
			JFile::delete(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'controllers'.DS.'categoriesElement.php');
			
		if (JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'controllers'.DS.'eventsElement.php'))
			JFile::delete(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'controllers'.DS.'eventsElement.php');
			
		if (JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'controllers'.DS.'locationElement.php'))
			JFile::delete(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsevents'.DS.'controllers'.DS.'locationElement.php');
		
		
		//frontend
		if (JFolder::exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'images'))
		{
			$fimages = JFolder::copy(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'images',JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images','',true);
			if ($fimages === true) JFolder::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'images');
		}
		
		if (JFolder::exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'files'))
		{
			$ffiles = JFolder::copy(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'files',JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'files','',true);
			if ($ffiles === true) JFolder::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'files');
		}
		
		if (JFile::exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'rsevents.js'))
			JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'rsevents.js');
		
		if (JFile::exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'style.css'))
			JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'style.css');
		
		if (JFile::exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'tables'.DS.'rsevents_categories.php'))
			JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'tables'.DS.'rsevents_categories.php');
		
		if (JFile::exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'tables'.DS.'rsevents_designs.php'))
			JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'tables'.DS.'rsevents_designs.php');
		
		if (JFile::exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'tables'.DS.'rsevents_group_permissions.php'))
			JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'tables'.DS.'rsevents_group_permissions.php');
		
		if (JFile::exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'tables'.DS.'rsevents_groups.php'))
			JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'tables'.DS.'rsevents_groups.php');
		
		if (JFile::exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'tables'.DS.'rsevents_settings.php'))
			JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'tables'.DS.'rsevents_settings.php');
		
		if (JFile::exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'designs.php'))
			JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'designs.php');
		
		if (JFile::exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'extras.php'))
			JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'extras.php');
		
		if (JFile::exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'users.php'))
			JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'users.php');
		
		if (JFile::exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'controllers'.DS.'categories.php'))
			JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'controllers'.DS.'categories.php');
		
		if (JFile::exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'views'.DS.'events'.DS.'tmpl'.DS.'featureevents.php'))
			JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'views'.DS.'events'.DS.'tmpl'.DS.'featureevents.php');
		
		if (JFile::exists(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'views'.DS.'events'.DS.'tmpl'.DS.'featureevents.xml'))
			JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'views'.DS.'events'.DS.'tmpl'.DS.'featureevents.xml');
	}
	
	//ROUTE LINKS
	function route($url, $xhtml=true, $Itemid='')
	{
		if (strpos($url, 'Itemid=') === false)
		{
			if (!$Itemid)
			{
				$Itemid = JRequest::getInt('Itemid');
				if ($Itemid)
					$Itemid = 'Itemid='.$Itemid;
			}
			elseif ((int) ($Itemid))
			$Itemid = 'Itemid='.(int) $Itemid;

			if ($Itemid)
			$url .= (strpos($url, '?') === false) ? '?'.$Itemid : '&'.$Itemid;
		}

		return JRoute::_($url, $xhtml);
	}
	
	
	function showPlaceholder($placeholder, $column, $position, $block)
	{
		echo '<div class="portlet" id="pla_'.$placeholder.'">
				<div class="portlet-header">
					'.rseventsHelper::getDetails('title',$placeholder).'
					<div class="rse_pl_tools">
						<a href="javascript: rseedit('.$placeholder.', \''.$column.'\', '.$position.');">
							<img src="'.JURI::root().'administrator/components/com_rsevents/assets/images/icons/edits.gif" />
						</a>
						<a href="javascript: rsedelete('.$placeholder.', \''.$column.'\', '.$position.');">
							<img src="'.JURI::root().'administrator/components/com_rsevents/assets/images/icons/deletes.png" />
						</a>
					</div>
				</div>
				<div class="portlet-content">
					'.rseventsHelper::getDetails('description',$placeholder).'
					<input type="hidden" class="hiddenBlock" name="position[block][]" value="'.$block.'" />
				</div>
			</div>';
	}
	
	function getDetails($type,$id)
	{
		$description[1] = JText::_('RSE_PL_EVENTNAME_DESC');				$description[2] = JText::_('RSE_PL_EVENTURL_DESC');
		$description[3] = JText::_('RSE_PL_EVENTSUBTITLE_DESC');			$description[4] = JText::_('RSE_PL_EVENTHOST_DESC');
		$description[5] = JText::_('RSE_PL_EVENTOWNER_DESC');				$description[6] = JText::_('RSE_PL_EVENTSTARTDATE_DESC');
		$description[7] = JText::_('RSE_PL_EVENTSTARTDATEONLY_DESC');		$description[8] = JText::_('RSE_PL_EVENTSTARTTIME_DESC');
		$description[9] = JText::_('RSE_PL_EVENTENDDATE_DESC');				$description[10] = JText::_('RSE_PL_EVENTENDDATEONLY_DESC');
		$description[11] = JText::_('RSE_PL_EVENTENDTIME_DESC');			$description[12] = JText::_('RSE_PL_EVENTDESCRIPTION_DESC');
		$description[13] = JText::_('RSE_PL_EVENTPHONE_DESC');				$description[14] = JText::_('RSE_PL_EVENTEMAIL_DESC');
		$description[15] = JText::_('RSE_PL_EVENTICON_DESC');				$description[16] = JText::_('RSE_PL_EVENTICONSMALL_DESC');
		$description[17] = JText::_('RSE_PL_EVENTICONBIG_DESC');			$description[18] = JText::_('RSE_PL_LOCATIONNAME_DESC');
		$description[19] = JText::_('RSE_PL_LOCATIONURL_DESC');				$description[20] = JText::_('RSE_PL_LOCATIONADDRESS_DESC');
		$description[21] = JText::_('RSE_PL_LOCATIONCITY_DESC');			$description[22] = JText::_('RSE_PL_LOCATIONSTATE_DESC');
		$description[23] = JText::_('RSE_PL_LOCATIONDESCRIPTION_DESC');		$description[24] = JText::_('RSE_PL_TICKETSAVAILABLE_DESC');
		$description[25] = JText::_('RSE_PL_EVENTSHARING_DESC');			$description[26] = JText::_('RSE_PL_EVENTFILES_DESC');
		$description[27] = JText::_('RSE_PL_EVENTYOUTUBE_DESC');			$description[28] = JText::_('RSE_PL_EVENTMP3_DESC');
		$description[29] = JText::_('RSE_PL_EVENTFLASH_DESC');				$description[30] = JText::_('RSE_PL_EVENTMEEBO_DESC');
		$description[31] = JText::_('RSE_PL_GOOGLEMAP_DESC');				$description[32] = JText::_('RSE_PL_EVENTPHOTOS_DESC');
		$description[33] = JText::_('RSE_PL_EVENTCOMMENTS_DESC');			$description[34] = JText::_('RSE_PL_EVENTRATING_DESC');
		$description[35] = JText::_('RSE_PL_EVENTGUESTS_DESC');				$description[36] = JText::_('RSE_PL_EVENTLINK_DESC');
		$description[37] = JText::_('RSE_PL_GUESTMENU_DESC');				$description[38] = JText::_('RSE_PL_HOSTMENU_DESC');
		$description[39] = JText::_('RSE_PL_LOCATIONZIP_DESC');				$description[40] = JText::_('RSE_PL_LOCATIONCOUNTRY_DESC');
		
		$title[1] = JText::_('RSE_PL_EVENTNAME');				$title[2] = JText::_('RSE_PL_EVENTURL');
		$title[3] = JText::_('RSE_PL_EVENTSUBTITLE');			$title[4] = JText::_('RSE_PL_EVENTHOST');
		$title[5] = JText::_('RSE_PL_EVENTOWNER');				$title[6] = JText::_('RSE_PL_EVENTSTARTDATE');
		$title[7] = JText::_('RSE_PL_EVENTSTARTDATEONLY');		$title[8] = JText::_('RSE_PL_EVENTSTARTTIME');
		$title[9] = JText::_('RSE_PL_EVENTENDDATE');			$title[10] = JText::_('RSE_PL_EVENTENDDATEONLY');
		$title[11] = JText::_('RSE_PL_EVENTENDTIME');			$title[12] = JText::_('RSE_PL_EVENTDESCRIPTION');
		$title[13] = JText::_('RSE_PL_EVENTPHONE');				$title[14] = JText::_('RSE_PL_EVENTEMAIL');
		$title[15] = JText::_('RSE_PL_EVENTICON');				$title[16] = JText::_('RSE_PL_EVENTICONSMALL');
		$title[17] = JText::_('RSE_PL_EVENTICONBIG');			$title[18] = JText::_('RSE_PL_LOCATIONNAME');
		$title[19] = JText::_('RSE_PL_LOCATIONURL');			$title[20] = JText::_('RSE_PL_LOCATIONADDRESS');
		$title[21] = JText::_('RSE_PL_LOCATIONCITY');			$title[22] = JText::_('RSE_PL_LOCATIONSTATE');
		$title[23] = JText::_('RSE_PL_LOCATIONDESCRIPTION');	$title[24] = JText::_('RSE_PL_TICKETSAVAILABLE');
		$title[25] = JText::_('RSE_PL_EVENTSHARING');			$title[26] = JText::_('RSE_PL_EVENTFILES');
		$title[27] = JText::_('RSE_PL_EVENTYOUTUBE');			$title[28] = JText::_('RSE_PL_EVENTMP3');
		$title[29] = JText::_('RSE_PL_EVENTFLASH');				$title[30] = JText::_('RSE_PL_EVENTMEEBO');
		$title[31] = JText::_('RSE_PL_GOOGLEMAP');				$title[32] = JText::_('RSE_PL_EVENTPHOTOS');
		$title[33] = JText::_('RSE_PL_EVENTCOMMENTS');			$title[34] = JText::_('RSE_PL_EVENTRATING');
		$title[35] = JText::_('RSE_PL_EVENTGUESTS');			$title[36] = JText::_('RSE_PL_EVENTLINK');
		$title[37] = JText::_('RSE_PL_GUESTMENU');				$title[38] = JText::_('RSE_PL_HOSTMENU');
		$title[39] = JText::_('RSE_PL_LOCATIONZIP');			$title[40] = JText::_('RSE_PL_LOCATIONCOUNTRY');
		
		
		if ($type == 'description') return isset($description[$id]) ? $description[$id] : '';
		if ($type == 'title')return isset($title[$id]) ? $title[$id] : '';
	}
	
	function getPlaceholder($id)
	{
		$placeholder[1] = '{EventName}';			$placeholder[2] = '{EventURL}';
		$placeholder[3] = '{EventSubtitle}';		$placeholder[4] = '{EventHost}';
		$placeholder[5] = '{EventOwner}';			$placeholder[6] = '{EventStartDate}';
		$placeholder[7] = '{EventStartDateOnly}';	$placeholder[8] = '{EventStartTime}';
		$placeholder[9] = '{EventEndDate}';			$placeholder[10] = '{EventEndDateOnly}';
		$placeholder[11] = '{EventEndTime}';		$placeholder[12] = '{EventDescription}';
		$placeholder[13] = '{EventPhone}';			$placeholder[14] = '{EventEmail}';
		$placeholder[15] = '{EventIcon}';			$placeholder[16] = '{EventIconSmall}';
		$placeholder[17] = '{EventIconBig}';		$placeholder[18] = '{LocationName}';
		$placeholder[19] = '{LocationURL}';			$placeholder[20] = '{LocationAddress}';
		$placeholder[21] = '{LocationCity}';		$placeholder[22] = '{LocationState}';
		$placeholder[23] = '{LocationDescription}';	$placeholder[24] = '{TicketsAvailable}';
		$placeholder[25] = '{EventSharing}';		$placeholder[26] = '{EventFiles}';
		$placeholder[27] = '{EventYoutube}';		$placeholder[28] = '{EventMp3}';
		$placeholder[29] = '{EventFlash}';			$placeholder[30] = '{EventChat}';
		$placeholder[31] = '{EventMap}';			$placeholder[32] = '{EventPhotos}';
		$placeholder[33] = '{EventComments}';		$placeholder[34] = '{EventRating}';
		$placeholder[35] = '{EventGuests}';			$placeholder[36] = '{EventLink}';
		$placeholder[37] = '{GuestMenu}';			$placeholder[38] = '{HostMenu}';
		$placeholder[39] = '{LocationZip}';			$placeholder[40] = '{LocationCountry}';
		
		return isset($placeholder[$id]) ? $placeholder[$id] : '';
	}
	
	function loadLang($admin = false)
	{
		$lang =& JFactory::getLanguage();
		$from = $admin ? JPATH_ADMINISTRATOR : JPATH_SITE;
		
		$lang->load('com_rsevents', $from, 'en-GB', true);
		$lang->load('com_rsevents', $from, $lang->getDefault(), true);
		$lang->load('com_rsevents', $from, null, true);
		
		return true;
	}
	
	function setTax($total,$type,$value)
	{
		$tax = 0;
		
		if ($value > 0)
		{
			if ($type == 1)
				$tax = $value;
			else
				$tax = $total * ($value / 100);
		}
		
		return $tax > 0 ? number_format($tax, 2, '.', '') : 0;
	}
	
	function saveLog($log, $id, $update=true)
	{
		if (!$log || !$id)
			return false;
			
		$db =& JFactory::getDBO();
		
		if (!is_array($log))
			$log = array($log);
		
		foreach ($log as $i => $item)
			$log[$i] = JHTML::date('now').' '.$item;
		
		$log = implode("\n", $log);
		
		if ($update)
			$db->setQuery("UPDATE #__rsevents_subscriptions SET `log` = CONCAT(`log`,'".$db->getEscaped("\n".$log)."') WHERE `IdSubscription`='".(int) $id."'");
		else
			$db->setQuery("UPDATE #__rsevents_subscriptions SET `log`='".$db->getEscaped($log)."' WHERE `IdSubscription`='".(int) $id."'");
			
		return $db->query();
	}
}