<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' ); 

class RseventsTheme
{
	
	/*
	*	Theme id
	*	@var int
	*/
	var $_tid = null;
	
	/*
	*	Database object
	*	@var db object
	*/
	var $_db = null;
	
	/*
	*	Event object
	*	@var event object
	*/
	var $_event = null;
	
	
	
	/*
	*	Main constructor
	*/
	
	function RseventsTheme($id = null, $event = null)
	{
		//set the database object
		$this->_db =& JFactory::getDBO();
		
		//if no id , set the default theme 
		if (is_null($id) || empty($id))
		{
			$this->_db->setQuery("SELECT `id` FROM `#__rsevents_themes` WHERE `default` = 1 ");
			$this->_tid = $this->_db->loadResult();
		}
		
		//set the theme id
		$this->_tid = (int) $id;
		
		//set the event object
		$this->_event = $event;
	}
	
	
	/*
	*	Get template positions and blocks
	*/
	
	function getBlocks($column = null)
	{
		if (!empty($column))
			$condition = " AND `column` = '".$this->_db->getEscaped($column)."' ";
		else 
			$condition = '';
		
		$this->_db->setQuery("SELECT `position`, `column`, `placeholder`, `block` FROM `#__rsevents_themes_position` WHERE `id` = ".$this->_tid." ".$condition." ORDER BY `column`,`position` ASC ");
		return $this->_db->loadObjectList();
	}
	
	
	/*
	*	Get available columns
	*/
	
	function getColumns()
	{
		$this->_db->setQuery("SELECT COUNT(DISTINCT `column`) FROM `#__rsevents_themes_position` WHERE `id` = ".$this->_tid." ORDER BY `column` ASC ");
		return (int) $this->_db->loadResult();
	}
	
	
	/*
	*	Load theme design scripts
	*/
	
	function scripts()
	{
		$doc =& JFactory::getDocument();
		
		$this->_db->setQuery("SELECT `DesignName` FROM `#__rsevents_designs` WHERE IdDesign = ".$this->_event->IdNewDesign." ");
		$design = strtolower($this->_db->loadResult());
		
		$doc->addStyleSheet(JURI::root().'components/com_rsevents/designs/rse_'.$design.'/css/'.$design.'.css');
		
		return true;
	}
	
	
	/*
	*	Render column
	*/
	
	function renderColumn($column)
	{
		if (empty($column)) return;
		
		$blocks = $this->getBlocks($column);
		
		$html = '';
		
		foreach ($blocks as $block)
		{
			$html_block = $this->replace($block->block);
			if (!empty($html_block))
			{
				$html .= '<div class="rse_box">';
				$html .= $html_block;
				$html .= '</div>';
			}
		}
		
		return $html;
	}
	
	
	/*
	*	Replace the placeholders
	*/
	
	function replace($html)
	{
		jimport('joomla.filesystem.file');
		jimport('joomla.html.parameter');
		
		$user =& JFactory::getUser();
		$dispatcher = &JDispatcher::getInstance();
		$document =& JFactory::getDocument();
		$params	= new JParameter(null);
		$limitstart = 0;
		$columns = $this->getColumns();
		
		//get the RSEvents! configuration
		$config = rseventsHelper::getConfig();
		
		//the event link
		$elink = '<a href="'.rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=show&cid='.eventsHelper::sef($this->_event->IdEvent,$this->_event->EventName),false).'">'.$this->_event->EventName.'</a>';
		
		//location link
		$llink = '<a href="'.rseventsHelper::route('index.php?option=com_rsevents&view=locations&layout=show&cid='.$this->_event->IdLocation.'&IdEvent='.$this->_event->IdEvent,false).'">'.$this->_event->LocationName.'</a>';
		
		//event name
		$eventname = '<h2><span>'.$this->_event->EventName.'</span></h2>';
		
		//dates
		$dateonly		= str_replace(array(':','H:i:s','H:i','H','h:i:s','h:i','h','g','G','a','i','g:i:a','g:ia','g :ia','gia','g : i','A','H i s','H i','h i s','h i','H/i/s','H/i','h/i/s','h/i','H-i-s','H-i','h-i-s','h-i'),'',$config['global.dateformat']);
		$timeformat		= empty($config['global.time']) ? 'H:i:s' : $config['global.time'];
		$startDateFull	= JText::_('RSE_START_EVENT').' '.rseventsHelper::translateDate(date($config['global.dateformat'],$this->_event->EventStartDate));
		$endDateFull	= JText::_('RSE_END_EVENT').' '.rseventsHelper::translateDate(date($config['global.dateformat'],$this->_event->EventEndDate));
		$startDateDate	= rseventsHelper::translateDate(date($dateonly,$this->_event->EventStartDate));
		$startDateTime	= date($timeformat,$this->_event->EventStartDate);
		$endDateDate	= rseventsHelper::translateDate(date($dateonly,$this->_event->EventEndDate));
		$endDateTime	= date($timeformat,$this->_event->EventEndDate);
		
		//get host and owner
		$theowner = $config['posted.by'] ? JFactory::getUser($this->_event->IdUser)->name : JFactory::getUser($this->_event->IdUser)->username;
		
		$host	= JText::_('RSE_HOSTED_BY').' '; 
		$host	.= $config['hostedby'] ? eventsHelper::linkprofile($this->_event->EventHost) : $this->_event->EventHost;
		$owner	= JText::_('RSE_EVENT_POSTED').' ';
		$owner	.= $config['postedby'] ? eventsHelper::linkprofile($theowner,$this->_event->IdUser) : $theowner;
		
		//Event icons
		$smallicon = str_replace('.'.JFile::getExt($this->_event->EventIcon),'_'.$config['event.icon.small'].'.'.JFile::getExt($this->_event->EventIcon),$this->_event->EventIcon);
		$bigicon = str_replace('.'.JFile::getExt($this->_event->EventIcon),'_'.$config['event.icon.big'].'.'.JFile::getExt($this->_event->EventIcon),$this->_event->EventIcon);
		
		if($config['enable.event.icon'] && $this->_event->EventIcon != '')
		{
			$eventsmallicon = '<img src="'.JURI::root().'components/com_rsevents/assets/images/thumbs/'.$smallicon.'" alt="" />';
			$eventbigicon = '<img src="'.JURI::root().'components/com_rsevents/assets/images/thumbs/'.$bigicon.'" alt="" />';
		} else $eventsmallicon = $eventbigicon = '';
		
		if (strpos($html,'{TicketsAvailable}') !== FALSE && $this->_event->EventEnableRegistration)
		{
			//get available tickets
			$this->_db->setQuery("SELECT IdTicket, TicketName, TicketPrice, TicketMaxAudience FROM #__rsevents_tickets WHERE IdEvent = '".$this->_event->IdEvent."'");
			$tickets = $this->_db->loadObjectList();
			
			if (!empty($tickets))
			{
				$ticketsavailable = '<h2><span>'.JText::_('RSE_TICKETS_AVAILABLE_TEXT').'</span></h2>';
				$ticketsavailable .= '<ul class="rse_available_tickets">';
				//check for available tickets
				foreach ($tickets as $i => $ticket)
				{
					$this->_db->setQuery("SELECT SUM(st.TicketsSubscribed) FROM #__rsevents_subscription_tickets st LEFT JOIN #__rsevents_subscriptions s ON s.IdSubscription = st.IdSubscription WHERE s.IdEvent = '".$this->_event->IdEvent."' AND s.SubscriptionState IN (0,1) AND st.IdTicket = '".$ticket->IdTicket."' ");
					$subscribedTickets = $this->_db->loadResult();
					if ($subscribedTickets >= $ticket->TicketMaxAudience && $ticket->TicketPrice > 0 && $ticket->TicketMaxAudience > 0) continue;
					
					$class = ($i % 2 == 0) ? ' class="odd"' : ' class="even"';
					
					if ($ticket->TicketMaxAudience == 0)
						$text = '<li'.$class.'>'.JText::_('RSE_UNLIMITED_TICKETS').' "'.$ticket->TicketName.'" '.JText::_('RSE_TICKETS').'</li>';
					else
						$text = '<li'.$class.'>'.($ticket->TicketMaxAudience - $subscribedTickets) . '  "' .$ticket->TicketName.'" '.JText::_('RSE_TICKETS').'</li>';
					$ticketsavailable .= $text;
				}
				$ticketsavailable .= '</ul>';
			} else $ticketsavailable = '';
		} else $ticketsavailable = '';
		
		//event sharing
		$eventsharing = '';
		if ($config['event.sharing'] == 1 && strpos($html,'{EventSharing}') !== FALSE)
		{
			$url =& JFactory::getURI();
			$event_url = $url->toString();
			
			$eventsharing .= '<table width="95%" class="rse_event_sharing"><tr>';
			
			if ($config['event.twitter'])
			{
				$eventsharing .= "<td nowrap=\"nowrap\"><script type=\"text/javascript\">
									tweetmeme_url = '".htmlentities($event_url,ENT_COMPAT,'UTF-8')."';
									tweetmeme_style = 'compact';
								</script>
				<script type=\"text/javascript\" src=\"http://tweetmeme.com/i/scripts/button.js\"></script></td>";
			}
			
			if ($config['event.gplus'])
			{
				$eventsharing .= '<td nowrap="nowrap"><g:plusone count="false" size="medium"></g:plusone></span>
					<script type="text/javascript">
					  (function() {
						var po = document.createElement(\'script\'); po.type = \'text/javascript\'; po.async = true;
						po.src = \'https://apis.google.com/js/plusone.js\';
						var s = document.getElementsByTagName(\'script\')[0]; s.parentNode.insertBefore(po, s);
					  })();
					</script></td>';
			}
			
			if ($config['event.facebook.share'])
			{
				$eventsharing .= '<td nowrap="nowrap"><a name="fb_share" type="button_count" href="http://www.facebook.com/sharer.php">'.JText::_('RSE_SHARE').'</a></td>';
			}
			
			if ($config['event.facebook.like'])
			{
				$eventsharing .= '<td nowrap="nowrap"><iframe src="http://www.facebook.com/plugins/like.php?href='.urlencode($event_url).'&amp;layout=button_count&amp;show_faces=false&amp;width=450&amp;action=like&amp;colorscheme=light&amp;height=35" scrolling="no" frameborder="0" style="border:none;overflow:hidden;height:35px;" allowTransparency="true"></iframe></td>';
			}
			
			$eventsharing .= '</tr></table>';
		}
		
		//event rating
		$rating = '';
		if (strpos($html,'{EventRating}') !== FALSE)
		{
			if ($config['event.rating'])
			{
				$rating .= '<div id="rse_rating_container">';
				$rating .= rseventsHelper::showStars($this->_event->IdEvent);
				$rating .= '</div>';
				$rating .= '<div class="rsevents-clear"></div>';
			}
		}
		
		//comments
		$comments = '';
		if (strpos($html,'{EventComments}') !== FALSE)
		{
			if ($this->_event->EventEnableComments == 1)
				$comments = eventsHelper::getComments($this->_event->IdEvent,$this->_event->EventName,$columns);
		}
		
		//event link
		$eventlink = !empty($this->_event->EventURL) ? '<a href="'.$this->_event->EventURL.'">'.$this->_event->EventURL.'</a>' : '';
		
		if (rseventsHelper::is16())
			$groups = JAccess::getGroupsByUser($user->id);
		
		//replace the Host menu
		if (strpos($html,'{HostMenu}') !== FALSE)
		{
			if ($user->usertype == 'Super Administrator' || (rseventsHelper::is16() && in_array(8,$groups)) || $this->_event->IdUser == $user->id)
			{
				$this->_event->EventEndDateToTime = $this->_event->EventEndDate;
				$hostmenu = eventsHelper::createHostMenu($this->_event);
			} else $hostmenu = '';
		} else $hostmenu = '';
		
		//replace the Guest menu
		if (strpos($html,'{GuestMenu}') !== FALSE)
			$guestmenu = eventsHelper::createGuestMenu($this->_event);
		else $guestmenu = '';
		
		//get the event description
		JPluginHelper::importPlugin ('content');
		$object = new stdClass();
		$eventdescription = $this->_event->EventDescription;
		$object->text = $eventdescription;
		
		if (!rseventsHelper::is16())
			$dispatcher->trigger ( 'onPrepareContent', array (&$object, &$params, $limitstart ) );
		else
			$dispatcher->trigger ( 'onContentPrepare', array ($eventdescription,&$object, &$params, $limitstart ) );
		
		$eventdescription = $object->text;
		
		$find		= array('{EventName}', '{EventURL}', '{EventSubtitle}', '{EventHost}', '{EventOwner}', '{EventStartDate}', '{EventStartDateOnly}', '{EventStartTime}',
							'{EventEndDate}', '{EventEndDateOnly}', '{EventEndTime}', '{EventDescription}', '{EventPhone}', '{EventEmail}', '{EventIcon}', '{EventIconSmall}',
							'{EventIconBig}', '{LocationName}', '{LocationURL}', '{LocationAddress}', '{LocationCity}', '{LocationState}', '{LocationDescription}', '{TicketsAvailable}',
							'{EventSharing}', '{EventComments}', '{EventRating}','{EventLink}','{HostMenu}','{GuestMenu}','{LocationZip}','{LocationCountry}'
							);
		
		$replace	= array($eventname, $elink, $this->_event->EventSubtitle, $host, $owner, $startDateFull, $startDateDate , $startDateTime,
							$endDateFull, $endDateDate, $endDateTime,  $eventdescription, $this->_event->EventPhone, '<a href="mailto:'.$this->_event->EventEmail.'">'.$this->_event->EventEmail.'</a>' , $eventbigicon , $eventsmallicon,
							$eventbigicon, $this->_event->LocationName, $llink, $this->_event->LocationAddress, $this->_event->LocationCity, $this->_event->LocationState, 
							$this->_event->LocationDescription, $ticketsavailable, $eventsharing, $comments, $rating, $eventlink,$hostmenu,$guestmenu,$this->_event->LocationZip,$this->_event->LocationCountry);
		
		//youtube params
		if ($columns == 1)
			$youtube = array('w'=> 560, 'h'=>349);
		else if ($columns == 2)
			$youtube = array('w'=> 300, 'h'=>200);
		else $youtube = array('w'=> 220, 'h'=>145);
		
		$this->_event->EventStartDateToTime = $this->_event->EventStartDate;
		$this->_event->EventEndDateToTime  = $this->_event->EventEndDate;
		$array 		= array('{EventYoutube}' , '{EventChat}' , '{EventPhotos}' , '{EventMp3}' , '{EventFlash}' , '{EventFiles}' , '{EventMap}');
		$html = eventsHelper::createExtras($this->_event, $html, $array,$youtube);
		
		//event full class
		$eventfull = $this->_event->EventEnableRegistration ? eventsHelper::eventisfull($this->_event->IdEvent) : 0;
		$html = str_replace('{EventFullClass}',($eventfull) ? 'class="rsevents_full"' : '',$html);
		
		//registred users
		$html = str_replace('{EventGuests}',eventsHelper::getGuests($this->_event),$html);
		
		return str_replace($find,$replace,$html);
	}
	
	
	/*
	*	Render layout
	*/
	
	function render()
	{
		//get the number of columns
		$columns	= $this->getColumns();
		//load additional scripts
		$this->scripts();
		
		$html = '';
		
		for ($i=1;$i<=$columns;$i++)
		{
			$html .= '<div class="rse_col rse_col'.$columns.'">';
			$html .= $this->renderColumn('col'.$i);
			$html .= '</div>';
		}
		
		return $html;
	}
}