<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die();
jimport( 'joomla.application.component.model' );

class rseventsModelCategories extends JModel
{
	var $_query;
	var $_data;
	var $_db;
	var $_total=null;
	var $_pagination=null;
	
	function __construct()
	{	
		$mainframe =& JFactory::getApplication();
		parent::__construct();
		$this->_db =& JFactory::getDBO();
		
		$this->_buildQuery();

		// Get pagination request variables
		$limit = JRequest::getVar('limit', $mainframe->getCfg('list_limit'), '', 'int');
		$limitstart = JRequest::getVar('limitstart', 0, '', 'int');

		// In case limit has been changed, adjust it
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
		$this->setState('com_rsevents.categories.limit', $limit);
		$this->setState('com_rsevents.categories.limitstart', $limitstart);
	}
	
	function _buildQuery()
	{
		$mainframe		=& JFactory::getApplication();
		$params			= &$mainframe->getParams();
		$ordering		= $params->get('order','DESC');

		if (rseventsHelper::is16())
			$this->_query="SELECT IdCategory as id, CategoryName as title , parent as parent_id, CategoryDescription , ordering FROM #__rsevents_categories  WHERE published = 1 ORDER BY CategoryName ".$ordering;
		else
			$this->_query="SELECT IdCategory as id, CategoryName as name , parent, CategoryDescription , ordering FROM #__rsevents_categories  WHERE published = 1 ORDER BY CategoryName ".$ordering;
		//echo $this->_query;
	}
	
	function getData()
	{
		if (empty($this->_data))
			$this->_data=$this->_getList($this->_query,$this->getState('com_rsevents.categories.limitstart'), $this->getState('com_rsevents.categories.limit'));
		return $this->_data;
	}
	
	function getTotal()
	{
		if (empty($this->_total))
			$this->_total = $this->_getListCount($this->_query);	
		return $this->_total;
	}
	
	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('com_rsevents.categories.limitstart'), $this->getState('com_rsevents.categories.limit'));
		}
		return $this->_pagination;
	}
}