<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die('Restricted access');
jimport( 'joomla.application.component.model' );

class rseventsModelEvents extends JModel
{
	var $_query;
	var $_data;
	var $_total=null;
	var $_pagination=null;
	
	//the model constructor
	function __construct($calendar=false)
	{
		$mainframe =& JFactory::getApplication();
		parent::__construct();
		$this->_db =& JFactory::getDBO();
		$this->_user =& JFactory::getUser();
		
		if ($calendar) JRequest::setVar('cid', 0);
		
		//get the query
		$this->_buildQuery();

		// Get pagination request variables
		$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');
		
		// In case limit has been changed, adjust it
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
		if ($calendar) { $limit = 0; $limitstart = 0; }
		
		$this->setState('com_rsevents.events.limit', $limit);
		$this->setState('com_rsevents.events.limitstart', $limitstart);
	}
	
	
	//buiding the display query
	function _buildQuery()
	{		
		$mainframe		=& JFactory::getApplication();
		$user			=& JFactory::getUser();
		$rseventsConfig = rseventsHelper::getConfig();
		$params			=& $mainframe->getParams();
		$layout			= JRequest::getCmd('layout','','request');
		$cid			= JRequest::getInt('cid',0,'request');
		$filter			= $mainframe->getUserStateFromRequest('rse.events.filter', 'rse_filter');
		$direction		= JRequest::getVar('direction','','request');
		$c_filter		= $mainframe->getUserStateFromRequest('rse.events.categories', 'cat_filter','','int');
		$l_filter		= $mainframe->getUserStateFromRequest('rse.events.locations', 'loc_filter','','int');
		
		
		switch($layout)
		{
			case 'listmyevents':
				$where = " AND e.IdUser=".$user->id; 
				$published = $filter = '';
			break;
			
			case 'archive':
				$where = ''; 
				$published = ' AND e.published = -1 ';
				
				if (empty($c_filter))
					$categ_filter = '';
				else
				{
					//get category children
					$this->_db->setQuery("SELECT `IdCategory` FROM `#__rsevents_categories` WHERE `parent` = '".$c_filter."'");
					$childs = $this->_db->loadResultArray();
					
					if (!empty($childs))
					{
						array_push($childs,$c_filter);
						JArrayHelper::toInteger($childs);
						$categ_filter = " AND c.IdCategory IN (".implode(',',$childs).") ";
					} else $categ_filter = " AND c.IdCategory = '".$c_filter."' ";
					
				}
				
				$loc_filter = ($l_filter == 0) ? '' : " AND l.IdLocation = '".$l_filter."' ";
				
				$filter =" AND (e.EventName LIKE '%".$this->_db->getEscaped($filter)."%' OR e.EventDescription LIKE '%".$this->_db->getEscaped($filter)."%' OR c.CategoryName LIKE '%".$this->_db->getEscaped($filter)."%' OR l.LocationName LIKE '%".$this->_db->getEscaped($filter)."%') ".$categ_filter.$loc_filter;
			break;
			
			case 'listdaysevent':
				
				$startDate = $params->get('startDate','01/01/1999');
				$endDate = $params->get('endDate','01/01/2037');
				$startTime = $params->get('startTime','00');
				$endTime = $params->get('endTime','00');
				$start = strtotime($startDate.' '.$startTime.':00');
				$end = strtotime($endDate.' '.$endTime.':00');
				$published = " AND e.published = 1 ";
				
				$q1 = ' AND e.EventStartDate >= '.$start;
				$q2 = ' AND e.EventEndDate <= '.$end;
				$q3 = ' AND e.EventType = 1 ';
				$where = $q1 . $q2 . $q3;
				$filter ='';
			break;
			
			case 'listcategoryevents':
				
				if(empty($cid))
				{
					$categories = $params->get('categories',0);
					$includechildrens = $params->get('subcategs',0);
					
					if(empty($categories)) $mainframe->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events',false));
					$categories = explode(',',$categories);
					JArrayHelper::toInteger($categories);

					if ($includechildrens)
					{
						foreach ($categories as $cat)
							$this->_addChildren($cat, $categories);
						
						$catids = implode(',',$categories);
					} else 
					{
						$catids = implode(',',$categories);
					}
					
					
					$where = " AND c.IdCategory IN (".$catids.") ";
				} else $where = " AND c.IdCategory = '".$cid."' "; 
				$published = " AND e.published = 1 ";
				$where .= " AND e.EventType = 1 ";
				$filter ='';
			break;
			
			case 'listlocationevents':
				
				
				if(empty($cid))
				{
					$locations = $params->get('locations',0);
					if(empty($locations)) $mainframe->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events',false));
					
					$locations = explode(',',$locations);
					JArrayHelper::toInteger($locations);
					$locations = implode(',',$locations);
					
					$where = " AND l.IdLocation IN (".$locations.") ";
					
					
				} else $where = " AND l.IdLocation = '".$cid."'";
				
				
				$published = " AND e.published = '1' ";
				$where .= " AND e.EventType = '1' ";
				$filter ='';
			break;
			
			case 'futureevents':
				$days = intval($params->get('days','3'));
				
				//if days equals to 0 then we show the events from today
				if ($days > 0)
				{
					$sTime = time() + ( $days * 86400);
					$where = " AND e.EventStartDate >= '".$sTime."' ";
				} else 
				{
					$sTime = mktime(0,0,0,date('n'),date('j'),date('Y'));
					$eTime = mktime(23,59,59,date('n'),date('j'),date('Y'));
					$where = " AND ((e.EventStartDate <= '".$sTime."' AND e.EventEndDate >= '".$sTime."') OR (e.EventStartDate >= '".$sTime."' AND e.EventStartDate <= '".$eTime."')) ";
				}
				
				$published = " AND e.published = '1' ";
				
				if (empty($c_filter))
					$categ_filter = '';
				else
				{
					//get category children
					$this->_db->setQuery("SELECT `IdCategory` FROM `#__rsevents_categories` WHERE `parent` = '".$c_filter."'");
					$childs = $this->_db->loadResultArray();
					
					if (!empty($childs))
					{
						array_push($childs,$c_filter);
						JArrayHelper::toInteger($childs);
						$categ_filter = " AND c.IdCategory IN (".implode(',',$childs).") ";
					} else $categ_filter = " AND c.IdCategory = '".$c_filter."' ";
					
				}
				
				$loc_filter = ($l_filter == 0) ? '' : " AND l.IdLocation = '".$l_filter."' ";
				
				$filter =" AND (e.EventName LIKE '%".$this->_db->getEscaped($filter)."%' OR e.EventDescription LIKE '%".$this->_db->getEscaped($filter)."%' OR c.CategoryName LIKE '%".$this->_db->getEscaped($filter)."%' OR l.LocationName LIKE '%".$this->_db->getEscaped($filter)."%') ".$categ_filter.$loc_filter;
			break;
			
			case 'search':
				$where = $filter = '';
				$published = " AND e.published = 1 ";
				
				$archive_search = $mainframe->getUserStateFromRequest('rse.search.archive', 'rse_archive');
				if (isset($archive_search) && $archive_search) $published = " AND e.published IN (-1,1) ";
				
				
				$idcats = $mainframe->getUserStateFromRequest('rse.search.categories', 'IdCategory');
				if(isset($idcats))
				{
					if (!empty($idcats) && is_array($idcats))
					{
						if (count($idcats) == 1 && $idcats[0] == 0)
						{
							$this->_db->setQuery("SELECT IdCategory FROM #__rsevents_categories WHERE published = 1");
							$categories = $this->_db->loadResultArray();
							
							if (!empty($categories))
							{
								$categories = implode(',',$categories);
								$where .= " AND c.IdCategory IN (".$categories.") ";
							}
						} else
						{
							foreach ($idcats as $i => $idcat)
								if (empty($idcat)) unset($idcats[$i]);
								
							if (!empty($idcats))
							{
								$categIds = implode(',',$idcats);
								$where .= " AND c.IdCategory IN (".$categIds.") ";
							}
						}
					}
					
				}
				
				$idlocs = $mainframe->getUserStateFromRequest('rse.search.locations', 'IdLocation');
				if(isset($idlocs))
				{
					if (count($idlocs) == 1 && $idlocs[0] == 0)
					{
						$this->_db->setQuery("SELECT IdLocation FROM #__rsevents_locations WHERE published = 1");
						$locations = $this->_db->loadResultArray();
						
						if (!empty($locations))
						{
							$locations = implode(',',$locations);
							$where .= " AND l.IdLocation IN (".$locations.") ";
						}
					} else
					{
						foreach ($idlocs as $i => $idloc)
							if (empty($idloc)) unset($idlocs[$i]);
							
						if (!empty($idlocs))
						{
							$locIds = implode(',',$idlocs);
							$where .= " AND l.IdLocation IN (".$locIds.") ";
						}
					}					
				}
				
				$check1 = $mainframe->getUserStateFromRequest('rse.search.check1', 'enablestart');
				$s_date = $mainframe->getUserStateFromRequest('rse.search.startdate', 'rseStartDate');
				if(isset($s_date) && isset($check1))
				{
					$sdate = strtotime($s_date);
					$where .= " AND e.EventStartDate >= ".$sdate." ";
				}
				
				$check2 = $mainframe->getUserStateFromRequest('rse.search.check2', 'enableend');
				$e_date = $mainframe->getUserStateFromRequest('rse.search.enddate', 'rseEndDate');
				if(isset($e_date) && isset($check2))
				{
					$edate = strtotime($e_date);
					$where .= " AND e.EventEndDate <= ".$edate." ";
				}
				
				$keyword = $mainframe->getUserStateFromRequest('rse.search.keyword', 'rse_keyword');
				if(isset($keyword))
					$filter = " AND (e.EventName LIKE '%".$this->_db->getEscaped($keyword)."%' OR e.EventDescription LIKE '%".$this->_db->getEscaped($keyword)."%' OR c.CategoryName LIKE '%".$this->_db->getEscaped($keyword)."%' OR l.LocationName LIKE '%".$this->_db->getEscaped($keyword)."%') ";
			break;
			
			default:
			{
				$published = ($params->get('expired','0') == 1) ? " AND e.published IN ('-1','1') " : " AND e.published = '1' ";				
				$where = " AND e.EventType = '1' ";
				
				if (empty($c_filter))
					$categ_filter = '';
				else
				{
					//get category children
					$this->_db->setQuery("SELECT `IdCategory` FROM `#__rsevents_categories` WHERE `parent` = '".$c_filter."'");
					$childs = $this->_db->loadResultArray();
					
					if (!empty($childs))
					{
						array_push($childs,$c_filter);
						JArrayHelper::toInteger($childs);
						$categ_filter = " AND c.IdCategory IN (".implode(',',$childs).") ";
					} else $categ_filter = " AND c.IdCategory = '".$c_filter."' ";
					
				}
				
				$loc_filter = ($l_filter == 0) ? '' : " AND l.IdLocation = '".$l_filter."' ";
				
				$filter =" AND (e.EventName LIKE '%".$this->_db->getEscaped($filter)."%' OR e.EventDescription LIKE '%".$this->_db->getEscaped($filter)."%' OR c.CategoryName LIKE '%".$this->_db->getEscaped($filter)."%' OR l.LocationName LIKE '%".$this->_db->getEscaped($filter)."%') ".$categ_filter.$loc_filter;
			} break;
		}
		$direction = !empty($direction) ? $direction : $params->get('order','DESC');
		$ordering  = strtolower(trim($direction)) == 'asc' ? 'ASC' : 'DESC';
		
		$columns[] = 'e.IdEvent';
		$columns[] = 'e.EventName';
		$columns[] ='e.EventSubtitle';
		$columns[] ='e.EventDescription';
		$columns[] ='l.LocationName';
		$columns[] ='e.EventStartDate';
		$columns[] ='e.EventEndDate';
		$columns[] ='e.EventHost';
		$columns[] ='l.IdLocation';
		$columns[] ='e.EventIcon';
		$columns[] ='e.EventCreation';
		$columns[] ='l.LocationCity';
		$columns[] ='l.LocationAddress';
		$columns[] ='l.LocationCountry';
		$columns = implode(',',$columns);
		
		$this->_query = "SELECT ".$columns." FROM #__rsevents_events e "
					  ."LEFT JOIN #__rsevents_locations l ON e.IdLocation=l.IdLocation "
					  ."LEFT JOIN #__rsevents_events_cat ec ON ec.IdEvent = e.IdEvent "
					  ."LEFT JOIN #__rsevents_categories c ON c.IdCategory = ec.IdCategory "
					  ."WHERE 1=1 ".$published.$where.$filter." GROUP BY e.IdEvent  ORDER BY e.EventStartDate ".$ordering;
		
		
		//echo $this->_query;
	}
	
	//get childs
	function _addChildren($id, &$list)
	{
		$db =& JFactory::getDBO();
		
		// Initialize variables
		$return = true;

		// Get all rows with parent of $id
		$query = 'SELECT IdCategory as id' .
				' FROM #__rsevents_categories' .
				' WHERE parent = '.(int) $id;
		$db->setQuery( $query );
		$rows = $db->loadObjectList();

		// Make sure there aren't any errors
		if ($db->getErrorNum()) {
			$this->setError($db->getErrorMsg());
			return false;
		}

		// Recursively iterate through all children... kinda messy
		// TODO: Cleanup this method
		foreach ($rows as $row)
		{
			$found = false;
			foreach ($list as $idx)
			{
				if ($idx == $row->id) {
					$found = true;
					break;
				}
			}
			if (!$found) {
				$list[] = $row->id;
			}
			$return = $this->_addChildren($row->id, $list);
		}
		return $return;
	}
	
	//fetch data 
	function getData()
	{
		if (empty($this->_data))
			$this->_data=$this->_getList($this->_query,$this->getState('com_rsevents.events.limitstart'), $this->getState('com_rsevents.events.limit'));
		return $this->_data;
	}
	
	function getTotal()
	{
		if (empty($this->_total))
			$this->_total = $this->_getListCount($this->_query);
		return $this->_total;
	}
	
	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('com_rsevents.events.limitstart'), $this->getState('com_rsevents.events.limit'));
		}
		return $this->_pagination;
	}
	
	//load the event
	function getEvent($cid=null)
	{
		$db =& JFactory::getDBO();
		$rseventsConfig = rseventsHelper::getConfig();
		$cid = is_null($cid) ? JRequest::getInt('cid',0) : $cid;
		$idevent = JRequest::getInt('IdEvent');
		if (empty($cid) && !empty($idevent)) $cid = $idevent;
		
		$db->setQuery("SELECT e.*, "
					  ."l.IdLocation, l.LocationName, l.LocationDescription, l.LocationAlias, l.LocationURL, l.LocationCity, l.LocationAddress, l.LocationZip, l.LocationState, l.LocationCountry, l.LocationLat, l.LocationLon,"
					  ." f.FileName, f.FileLocation , u.username AS EventOwner "
					  ."FROM #__rsevents_events e "
					  ."LEFT JOIN #__rsevents_locations l ON e.IdLocation = l.IdLocation   "
					  ."LEFT JOIN #__rsevents_events_cat ec ON ec.IdEvent = e.IdEvent "
					  ."LEFT JOIN #__rsevents_categories c ON c.IdCategory = ec.IdCategory "
					  ."LEFT JOIN #__users u ON e.IdUser = u.id "
					  ."LEFT JOIN #__rsevents_files f ON f.IdEvent=e.IdEvent "
					  ."WHERE e.IdEvent='".(int) $cid."'");
		
		$row = $db->loadObject();
		
		if(empty($row)) $row = rseventsModelEvents::initEvent();
		
		if(empty($row->EventStartDate))
		{
			$row->EventStartDate = time();
			if($rseventsConfig['enable.12format'] == 1)
			{
				$row->EventStartDateH='11';
				$row->EventStartDateM='00';
			} else 
			{
				$row->EventStartDateH='20';
				$row->EventStartDateM='00';
			}
		} else 
		{
			if($rseventsConfig['enable.12format'] == 1)
				$row->EventStartDateH = date('g',$row->EventStartDate);
			else
				$row->EventStartDateH = date('H',$row->EventStartDate);
			$row->EventStartDateM = date('i',$row->EventStartDate);
		}
		
		if(empty($row->EventEndDate)) 
		{
			$row->EventEndDate = $row->EventStartDate;
			if($rseventsConfig['enable.12format'] == 1)
			{
				$row->EventEndDateH = '12';
				$row->EventEndDateM = '00';
			} else 
			{
				$row->EventEndDateH = '22';
				$row->EventEndDateM = '00';
			}
		} else 
		{
			if($rseventsConfig['enable.12format'] == 1)
				$row->EventEndDateH = date('g',$row->EventEndDate);
			else
				$row->EventEndDateH = date('H',$row->EventEndDate);
			$row->EventEndDateM = date('i',$row->EventEndDate);
		}

		return $row;
	}
	
	//initialize the event if the cid is 0
	function initEvent()
	{
		$cid = JRequest::getInt('cid',0,'request');
		$row = & JTable::getInstance('Rsevents_Events','Table');
		$row->load($cid);
		$row->IdEvent = 0;
		$row->DesignName = 'default';
		$row->LocationName = '';
		$row->LocationAddress = '';
		$row->FileName = '';
		$row->FileLocation = '';
		$row->EventOwner = '';
		
		return $row;
	}
	
	//return if an user is alredy subscribed to the event
	function getSubscriber()
	{
		$db =& JFactory::getDBO();
		$user =& JFactory::getUser();
		$rseventsConfig = rseventsHelper::getConfig();
		$cid = JRequest::getInt('cid',0,'request');
		
		if(($rseventsConfig['event.enable.guests'] == 1 && $user->id > 0) || $user->id > 0)
		{
			$db->setQuery("SELECT COUNT(IdSubscription) FROM #__rsevents_subscriptions WHERE IdEvent='".$cid."' AND IdUser='".$user->id."'");
			$row = $db->loadResult();
			if( $row == 0 ) return 0; else return 1;
		} else return 0;
	}
	
	//get permissions for user groups
	function getPermissions()
	{
		$db =& JFactory::getDBO();
		$user =& JFactory::getUser();
		
		$permissions = array('enableLocationModeration' => 0, 'enableEditLocation' => 0, 'allowLocations' => 0, 'allowUpload' => 0, 'allowDownload' => 1, 'allowRegistration' => 1, 
            'allowRegistrationCancel' => 1, 'canDelete' => 0, 'canEdit' => 0, 'enableModeration' => 0, 'enablePosts' => 0);
		
		if (rseventsHelper::is16())
		{
			$tmp = array();
			$groups = JAccess::getGroupsByUser($user->id);
			if (!$user->guest)
				foreach ($groups as $key => $group)
					if ($group == 1) unset($groups[$key]);
			
			if (!empty($groups))
			foreach ($groups as $group)
			{
				$db->setQuery("SELECT gp.PermissionValue, gp.PermissionName FROM #__rsevents_groups g LEFT JOIN #__rsevents_groups_acl ga ON g.IdGroup = ga.IdGroup "
						."LEFT JOIN #__rsevents_group_permissions gp ON g.IdGroup = gp.IdGroup WHERE ga.GroupAcl = ".$group);
				$permissionRows = $db->loadObjectList();
				
				if(!empty($permissionRows))
					foreach($permissionRows as $permissionObj)
						$tmp[$group][$permissionObj->PermissionName] = $permissionObj->PermissionValue;
			}
			
			if (!empty($tmp))
				foreach ($tmp as $group)
					foreach ($group as $key => $value)
						if (isset($value)) $permissions[$key] = $value;
			
			
		} else 
		{
			$gid = $user->gid;
			if($gid == 0) $gid = 29;
			$db->setQuery("SELECT gp.PermissionValue, gp.PermissionName FROM #__rsevents_groups g LEFT JOIN #__rsevents_groups_acl ga ON g.IdGroup = ga.IdGroup "
						."LEFT JOIN #__rsevents_group_permissions gp ON g.IdGroup = gp.IdGroup WHERE ga.GroupAcl = ".$gid);
			$permissionRows = $db->loadObjectList();
			
			if(!empty($permissionRows))
				foreach($permissionRows as $permissionObj)
					$permissions[$permissionObj->PermissionName] = $permissionObj->PermissionValue;
		}
		
		return $permissions;
	}
	
	function getRegistered()
	{
		$db			=& JFactory::getDBO();
		$cid 		= JRequest::getInt('cid',0,'request');
		$config		= rseventsHelper::getConfig();
		
		settype($details,'array');
		settype($users,'array');
		
		//Get userids that are registered to the event
		$db->setQuery("SELECT u.id FROM #__rsevents_subscriptions s LEFT JOIN #__users u ON s.IdUser=u.id WHERE s.IdEvent='".$cid."' AND s.SubscriptionState = '1' AND s.IdUser != '' ");
		$ids = $db->loadResultArray();
		
		//Get the number of guests
		$db->setQuery("SELECT COUNT(IdSubscription) FROM #__rsevents_subscriptions WHERE IdEvent='".$cid."' AND SubscriptionState = '1' AND IdUser = 0 ");
		$guests = $db->loadResult();
		
		foreach($ids as $id)
		{
			$user =& JFactory::getUser($id);
			
			switch($config['user.details'])
			{
				case 'username':
					$obj = new stdClass();
					$obj->id = $user->id;
					$obj->name = $user->username;
					$obj->avatar = rseventsHelper::getAvatar($user->id,$user->email);
					$users[] = $obj;
				break;
				
				case 'name':
					$obj = new stdClass();
					$obj->id = $user->id;
					$obj->name = $user->name;
					$obj->avatar = rseventsHelper::getAvatar($user->id,$user->email);
					$users[] = $obj;
				break;
				
				case 'cb':
					$obj = new stdClass();
					$obj->id = $user->id;
					$db->setQuery("SELECT CONCAT_WS(' ',firstname,lastname) FROM #__comprofiler WHERE user_id =".$user->id);
					$fullname = $db->loadResult();
					$fullname = empty($fullname) ? $user->name : $fullname;					
					$obj->name = $fullname;
					$obj->avatar = rseventsHelper::getAvatar($user->id,$user->email);
					$users[] = $obj;
				break;
			}
		}
		
		$details['users'] = $users; 
		$details['guests'] = $guests; 
		
		return $details;
	}
	
	function getEventDays($start , $end=0,$order)
	{
		//get variables
		$db		 =& JFactory::getDBO();
		$app	 =& JFactory::getApplication();
		$session =& JFactory::getSession();
		$idcateg = $session->get('rsevents.idcateg');
		$params	 =& $app->getParams();
		$catids	 = $params->get('catids','');
		
		if($end == 0)
			$where = " AND ((e.EventStartDate <= '".$start."' AND e.EventEndDate >= '".$start."') OR (e.EventStartDate >= '".$start."' AND e.EventStartDate <= '".($start+86400)."')) ";
		else
			$where = " AND ((e.EventStartDate <= '".$start."' AND e.EventEndDate >= '".$start."') OR (e.EventStartDate >= '".$start."' AND e.EventStartDate <= '".($end)."')) ";
		
		
		if (!empty($catids))
		{
			//check if the categories have childrens
			$childcategs = array();
			if (!is_array($catids) && $catids != '')
			{
				$db->setQuery("SELECT `IdCategory` FROM `#__rsevents_categories` WHERE `parent` = '".$catids."' ");
				$childcategs = array_merge($childcategs,$db->loadResultArray());
			} else 
			{
				foreach ($catids as $cat)
				{
					$db->setQuery("SELECT `IdCategory` FROM `#__rsevents_categories` WHERE `parent` = '".$cat."' ");
					$childcategs = array_merge($childcategs,$db->loadResultArray());
				}
			}
			
			//create categories
			if (!is_array($catids) && $catids != '')
			{
				if (!empty($childcategs))
					$categories = $catids.','.implode($childcategs);
				else $categories = $catids;
			}
			else
			{
				$catids = array_merge($catids,$childcategs);
				$categories = implode(',',$catids);
			}
		}
		
		if (!empty($categories) && empty($idcateg))
			$where .= ' AND c.IdCategory IN ('.$categories.') '; 
		
		if (!empty($idcateg))
			$where .= ' AND c.IdCategory = '.$idcateg.' '; 
		
		$db->setQuery("SELECT e.IdEvent , e.EventName , e.EventSubtitle , e.EventDescription , e.EventStartDate , e.EventEndDate , e.EventHost , l.LocationName , c.CategoryName , l.LocationCity , e.EventIcon , l.IdLocation , c.IdCategory FROM #__rsevents_events e LEFT JOIN #__rsevents_locations l ON e.IdLocation=l.IdLocation LEFT JOIN #__rsevents_events_cat ec ON ec.IdEvent = e.IdEvent LEFT JOIN #__rsevents_categories c ON c.IdCategory = ec.IdCategory WHERE 1=1 AND e.published = 1 AND e.EventType = 1 ".$where." GROUP BY e.IdEvent ORDER BY e.EventStartDate $order ");
		
		return $db->loadObjectList();
	}
	
	function getEventCalendar($params)
	{
		$title = $params->get('page_title','calendar');
		$title = str_replace(' ','',$title);
		
		$db			=& JFactory::getDBO();
		$app		=& JFactory::getApplication();
		$user		=& JFactory::getUser();
		$fromcal	= JRequest::getInt('fromcalendar',0);
		$idcat		= $app->getUserStateFromRequest('calendaridcat'.$title, 'idcat', 0, 'int');
		$catids		= $params->get('catids','');
		$locids 	= $params->get('locids','');
		$userev 	= $params->get('userev','');
		$arhive 	= $params->get('arhive','0');
		$order  	= $params->get('order','DESC');
		$where 		= '';
		
		$catfromcal = $app->getUserState('calendaridcat'.$title);
		if (!empty($catfromcal)) $fromcal = 1;
		
		if($arhive == 1)
			$where .= " AND e.published IN ('-1','1') ";
		elseif($arhive == 0) $where .= " AND e.published = 1 ";
		
		if (!empty($catids))
		{
			//check if the categories have childrens
			$childcategs = array();
			if (!is_array($catids) && $catids != '')
			{
				$db->setQuery("SELECT `IdCategory` FROM `#__rsevents_categories` WHERE `parent` = '".$catids."' ");
				$childcategs = array_merge($childcategs,$db->loadResultArray());
			} else 
			{
				foreach ($catids as $cat)
				{
					$db->setQuery("SELECT `IdCategory` FROM `#__rsevents_categories` WHERE `parent` = '".$cat."' ");
					$childcategs = array_merge($childcategs,$db->loadResultArray());
				}
			}
			
			//create categories
			if (!is_array($catids) && $catids != '')
			{
				if (!empty($childcategs))
					$categories = $catids.','.implode($childcategs);
				else $categories = $catids;
			}
			else
			{
				$catids = array_merge($catids,$childcategs);
				$categories = implode(',',$catids);
			}
		}
		
		//create locations
		$locations = is_array($locids) ? implode(',',$locids) : $locids;
	
		//show user events
		if ($userev && $user->id != 0) $where .= " AND e.IdUser = ".$user->id." ";
		
		if(isset($fromcal) && $fromcal == 1 )
		{
			$db->setQuery("SELECT `IdCategory` FROM `#__rsevents_categories` WHERE `parent` = '".$idcat."' ");
			$childs = $db->loadResultArray();
			
			if (!empty($childs))
			{
				array_push($childs,$idcat);
				$condition = " c.IdCategory IN (".implode(',',$childs).") ";
			} else $condition = " c.IdCategory = '".$idcat."' ";
			
			if ($idcat == 0) $where .= ''; else $where .= " AND ".$condition." ";
		} else
		{
			if(!$userev)
			{
				if(!empty($catids) && !empty($locids)) $where .=" AND (c.IdCategory IN (".$categories.") OR l.IdLocation IN (".$locations.")) ";
				if(!empty($catids) && empty($locids)) $where .= " AND c.IdCategory IN (".$categories.") ";
				if(!empty($locids) && empty($catids)) $where .= " AND l.IdLocation IN (".$locations.") ";
			}
		}
		$where .= " AND e.EventType = '1' ";
		$ordering = " ORDER BY e.EventStartDate $order ";
		
		
		$db->setQuery("SELECT e.IdEvent , e.EventName , e.EventStartDate , e.EventEndDate , l.LocationName FROM #__rsevents_events e LEFT JOIN #__rsevents_locations l ON l.IdLocation = e.IdLocation LEFT JOIN #__rsevents_events_cat ec ON ec.IdEvent = e.IdEvent LEFT JOIN #__rsevents_categories c ON c.IdCategory = ec.IdCategory WHERE 1=1 ".$where.$ordering);
		
		return $db->loadObjectList();
	}
	
	function getWireDetails()
	{
		$db		=& JFactory::getDBO();
		$cid	= JRequest::getInt('subscription',0);
		$pid	= JRequest::getInt('pid',0);
		
		//get the tickets
		$db->setQuery("SELECT st.TicketsSubscribed , t.TicketName , t.TicketPrice FROM #__rsevents_subscription_tickets st LEFT JOIN #__rsevents_tickets t ON t.IdTicket = st.IdTicket WHERE st.IdSubscription = ".$cid." ");
		$tickets = $db->loadObjectList();
		
		//get the discount if any
		$db->setQuery("SELECT Discount, early_fee, late_fee, tax FROM #__rsevents_subscriptions WHERE IdSubscription = ".$cid." ");
		$subscription = $db->loadObject();
		
		//get wire details
		$db->setQuery("SELECT * FROM #__rsevents_payments WHERE id = ".$pid." ");
		$wire = $db->loadObject();
		
		$return = new stdClass();
		$return->tickets = $tickets;
		$return->discount = !empty($subscription->Discount) ? $subscription->Discount : 0;
		$return->name = @$wire->name;
		$return->details = @$wire->details;
		$return->tax_type = @$wire->tax_type;
		$return->tax_value = @$wire->tax_value;
		$return->redirect = @$wire->redirect;
		$return->early_fee = !empty($subscription->early_fee) ? $subscription->early_fee : 0;
		$return->late_fee = !empty($subscription->late_fee) ? $subscription->late_fee : 0;
		$return->tax = !empty($subscription->tax) ? $subscription->tax : 0;
		
		return $return;
	}
	
	//generate a new private url
	function generate()
	{
		$app =& JFactory::getApplication();
		$cid = JRequest::getInt('cid',0,'request');
		$row = & JTable::getInstance('Rsevents_Events','Table');
		$row->load($cid);
		$row->EventPrivateUrl = uniqid('',FALSE);
		$row->store();
		
		$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=addeditevent&cid='.eventsHelper::sef($row->IdEvent,$row->EventName),false));
	}
	
	//export the event
	function export()
	{		
		$db		=& JFactory::getDBO();
		$cid 	= JRequest::getInt('cid',0,'request');
		$row	=& JTable::getInstance('Rsevents_Events','Table');
		$row->load($cid);
		
		$start = JFactory::getDate($row->EventStartDate)->toUnix();
		$end   = JFactory::getDate($row->EventEndDate)->toUnix();
		
		//get the location details
		$db->setQuery("SELECT LocationName, LocationCity , LocationAddress FROM #__rsevents_locations WHERE IdLocation='".$row->IdLocation."'");
		$location = $db->loadObject();
		
		require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'helpers'.DS.'iCalcreator.class.php');
		$config = array("unique_id" => JURI::root(), 'filename' => 'Event-'.$row->IdEvent.'.ics');
		$v = new vcalendar( $config );
		$v->setProperty( "method", "PUBLISH" );
		
		$vevent = & $v->newComponent( "vevent" );
		$vevent->setProperty( "dtstart", array("timestamp" => $start) ); 
		$vevent->setProperty( "dtend", array("timestamp" => $end) ); 
		$vevent->setProperty( "LOCATION", $location->LocationName. ' (' .$location->LocationAddress . ' , ' . $location->LocationCity . ')' );
		$vevent->setProperty( "summary", $row->EventName ); 
		$vevent->setProperty( "description", strip_tags($row->EventDescription)); 
		$v->returnCalendar();
	}
	
	//export guests
	function exportGuests()
	{		
		$db 	=& JFactory::getDBO();
		$app 	=& JFactory::getApplication();
		$user 	=& JFactory::getUser();
		$cid 	= JRequest::getInt('cid',0,'request');
		$row	=& JTable::getInstance('Rsevents_Events','Table');
		$row->load($cid);
		
		if (rseventsHelper::is16())
			$groups = JAccess::getGroupsByUser($user->id);
		
		if($user->usertype == 'Super Administrator' || (rseventsHelper::is16() && in_array(8,$groups)) || $user->id == $row->IdUser)
		{
			//get the name of the subscribers
			$db->setQuery("SELECT IdSubscription, FirstName , LastName , Email FROM #__rsevents_subscriptions WHERE IdEvent='".$cid."'");
			$results = $db->loadObjectList();
			
			$filename = 'Event'.$row->IdEvent.'.csv';
			header("Content-type: application/octet-stream");
			header("Content-Disposition: attachment; filename=$filename");
			$csv = "First Name,Last Name,E-mail,Ticket \n";
			if(!empty($results))
			foreach($results as $obj)
			{
				$db->setQuery("SELECT st.TicketsSubscribed, t.TicketName FROM #__rsevents_subscription_tickets st LEFT JOIN #__rsevents_tickets t ON t.IdTicket = st.IdTicket WHERE st.IdSubscription = '".$obj->IdSubscription."' ");
				$details = $db->loadObjectList();
				
				$ticket = '';
				if (!empty($details))
					foreach ($details as $object)
						$ticket .= $object->TicketsSubscribed.' x '.$object->TicketName. '; ';
				
				$csv .= $obj->FirstName.",".$obj->LastName.",".$obj->Email.",".rtrim($ticket, '; ')."\n";
			}
			echo rtrim($csv,"\n");
			exit();
		} else $app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events',false),JText::_('RSE_ACCESS_DENIED'));
	}
	
	//invite people to the event
	function invite()
	{
		jimport('joomla.mail.helper');
		
		$db = & JFactory::getDBO();
		$app = & JFactory::getApplication();
		$row= & JTable::getInstance('Rsevents_Events','Table');
		$cid = JRequest::getInt('cid',0);
		$config = rseventsHelper::getConfig();
		
		$peoples = explode("\n",JRequest::getVar('emails'));
		$row->load($cid);
		
		$from = (JRequest::getVar('rse_from','') != '' && JMailHelper::isEmailAddress(JRequest::getVar('rse_from',''))) ? JRequest::getVar('rse_from') : $config['emails.from'];
		
		foreach($peoples as $people)
		{
			$people = trim($people);
			$to = JMailHelper::isEmailAddress($people) ? $people : '';
			if($from!='') rseventsEmails::invite($from,$people,$row->IdEvent);
		}
		echo eventsHelper::setMessage(JText::_('RSE_INVITE_SENT'));
	}
	
	//send email to guests
	function guestsendmessage()
	{
		//get variables
		$db = & JFactory::getDBO();
		$app = & JFactory::getApplication();
		$cid = JRequest::getInt('cid',0,'request');
		$rseventsConfig = rseventsHelper::getConfig();
		$row= & JTable::getInstance('Rsevents_Events','Table');
		$row->load($cid);
		$post = JRequest::get('post');
		
		//code for sending emails to guests
		if(!empty($post['SubscriptionState'])) 
		{
			$state = implode(',',$post['SubscriptionState']);
			$db->setQuery("SELECT e.EventName ,e.EventDescription ,e.EventStartDate , e.EventEndDate , e.EventHost , l.LocationName, l.LocationCity , u.username, s.Email FROM #__rsevents_events e LEFT JOIN #__rsevents_subscriptions s ON s.IdEvent = e.IdEvent LEFT JOIN #__users u ON u.id=s.IdUser LEFT JOIN #__rsevents_locations l ON e.IdLocation=l.IdLocation WHERE s.SubscriptionState IN (".$state.") AND e.IdEvent = '".$row->IdEvent."'");
			$subscriptionDetails = $db->loadObjectList();
			foreach($subscriptionDetails as $subscriptionDetailsObj)
			{					
				$from		= $rseventsConfig['emails.from'];
				$fromName	= $rseventsConfig['emails.from.name'];
				$to			= $subscriptionDetailsObj->Email;
				$subject	= $post['subject'];
				$body		= JRequest::getVar('message', '', 'post', 'none', JREQUEST_ALLOWRAW);
				$mode		= 1;
				$replyto	= $rseventsConfig['emails.reply'];
				$cc			= !empty($rseventsConfig['emails.cc']) ? $rseventsConfig['emails.cc'] : null;
				$bcc		= !empty($rseventsConfig['emails.bcc']) ? $rseventsConfig['emails.bcc'] : null;
				
				JUtility::sendMail($from , $fromName , $to , $subject , $body , $mode , $cc , $bcc , null , $replyto);
			}
			
			echo eventsHelper::setMessage(JText::_('RSE_MESSAGE_SENT'));
		}
		else 
			$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=guestssendmessage&cid='.eventsHelper::sef($cid,$row->EventName),false), JText::_('RSE_MESSAGE_RECIEVER_ERROR'));
	}
	
	//remove an event
	function cancelEvent()
	{
		jimport('joomla.filesystem.files');
		$db = & JFactory::getDBO();
		$user =& JFactory::getUser();
		$row =& JTable::getInstance('Rsevents_Events','Table');
		$cid = JRequest::getInt('cid',0,'request');
		
		$permissions = rseventsModelEvents::getPermissions();
		
		//can delete event
		$candelete = isset($permissions['canDelete']) ? $permissions['canDelete'] : 0;
		
		//get the owner
		$db->setQuery("SELECT IdUser FROM #__rsevents_events WHERE IdEvent='".$cid."'");
		$owner = $db->loadResult();
		
		if (rseventsHelper::is16())
			$groups = JAccess::getGroupsByUser($user->id);
		
		if($user->usertype == 'Super Administrator' || (rseventsHelper::is16() && in_array(8,$groups)) || $user->id == $owner || $candelete)
		{
			if(!$row->delete($cid)) 
				$msg = JText::_( 'RSE_EVENT_DELETE_ERROR' );
			else 
			{					
				//get files
				$db->setQuery("SELECT FileLocation FROM #__rsevents_files WHERE IdEvent='".$cid."'");
				$arrayLocations = $db->loadObjectList();
				
				foreach ($arrayLocations as $obj)
					JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'files'.DS.$obj->FileLocation);
				
				
				$db->setQuery("DELETE FROM #__rsevents_files WHERE IdEvent=".$cid);
				$db->query();
				$db->setQuery("DELETE FROM #__rsevents_tickets WHERE IdEvent='".$cid."'");
				$db->query();
				$db->setQuery("SELECT IdSubscription FROM #__rsevents_subscriptions WHERE IdEvent='".$cid."'");
				
				//delete subscribers
				$idSubscriptions = $db->loadObjectList();
				foreach($idSubscriptions as $i => $idSubscription)
				{
					$db->setQuery("DELETE FROM #__rsevents_subscription_tickets WHERE IdSubscription='".$idSubscription->IdSubscription."'");
					$db->query();
				}
				$db->setQuery("DELETE FROM #__rsevents_subscriptions WHERE IdEvent='".$cid."'");
				$db->query();
				
				//delete syncs
				$db->setQuery("DELETE FROM #__rsevents_sync WHERE IdEvent='".$cid."'");
				$db->query();
				
				$msg = JText::_( 'RSE_EVENT_DELETE' );
			}
		} else $msg = JText::_('RSE_ACCESS_DENIED');
		
		return $msg;
	}
	
	//save youtube extra
	function saveYoutube()
	{
		$app =& JFactory::getApplication();
		$db = & JFactory::getDBO();
		$post = JRequest::get('post',JREQUEST_ALLOWRAW);
		$url = $post['youtubeURL'];
		
		$idevent = JRequest::getInt('IdEvent',0,'request');
		$cid = JRequest::getInt('cid',0,'request');

		//get the event name
		$db->setQuery("SELECT EventName FROM #__rsevents_events WHERE IdEvent='".$idevent."'");
		$eventname = $db->loadResult();
		
		if ($cid > 0)
			$db->setQuery("UPDATE #__rsevents_extras SET ExtraValue = '".$db->getEscaped($url)."' WHERE IdExtra = ".$cid);
		else 
			$db->setQuery("INSERT INTO #__rsevents_extras SET IdExtra = '".$cid."' , IdEvent = '".$idevent."' , ExtraName = 'youtube' , ExtraValue = '".$db->getEscaped($url)."' ");
		$result = $db->query();
		
		if($result)
			$msg=JText::_('RSE_EXTRA_YOUTUBE_SAVE');
		else
			$msg=JText::_('RSE_EXTRA_YOUTUBE_SAVE_ERROR');
		
		if (rseventsHelper::is16())
			echo '<script type="text/javascript">window.parent.location.reload();window.parent.SqueezeBox.close();</script>';
		else
			$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=addeditevent&cid='.eventsHelper::sef($idevent,$eventname).'&tab=4',false) , $msg);
	}
	
	//save flickr extra
	function saveFlickr()
	{
		$db = & JFactory::getDBO();
		$app =& JFactory::getApplication();
		$post = JRequest::get('post',JREQUEST_ALLOWRAW);
		$url = $post['flickr'];
		$idevent = JRequest::getInt('IdEvent',0,'request');
		$cid = JRequest::getInt('cid',0,'request');
		
		$db->setQuery("SELECT EventName FROM #__rsevents_events WHERE IdEvent='".$idevent."'");
		$eventname = $db->loadResult();
		
		$pattern = '/http:\/\/www.flickr.com\/photos\/(.*)\/sets\/([0-9]+)/';
		preg_match($pattern, $post['flickr'], $matches);
		
		if(!empty($matches))
		{
			if ($cid > 0)
				$db->setQuery("UPDATE #__rsevents_extras SET ExtraValue = '".$db->getEscaped($url)."' WHERE IdExtra = ".$cid);
			else 
				$db->setQuery("INSERT INTO #__rsevents_extras SET IdExtra = '".$cid."' , IdEvent = '".$idevent."' , ExtraName = 'flickr' , ExtraValue = '".$db->getEscaped($url)."' ");
			$result = $db->query();
			
			
			if($result) $msg=JText::_('RSE_EXTRA_FLICKR_SAVE'); else $msg=JText::_('RSE_EXTRA_FLICKR_SAVE_ERROR');
			
			if (rseventsHelper::is16())
				echo '<script type="text/javascript">window.parent.location.reload();window.parent.SqueezeBox.close();</script>';
			else
				$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=addeditevent&cid='.eventsHelper::sef($idevent,$eventname).'&tab=4',false) , $msg);
		} else 
		{
			if (rseventsHelper::is16())
				$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=flickr&tmpl=component&cid=0&IdEvent='.$idevent.'&tab=4',false) , JText::_('RSE_EXTRA_FLICKR_INVALID_URL'));
			else
				$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=addeditevent&cid='.eventsHelper::sef($idevent,$eventname).'&tab=4',false) , JText::_('RSE_EXTRA_FLICKR_INVALID_URL'));
		}
	}
	
	//saving the meebo code
	function saveMeebo()
	{
		$db = &JFactory::getDBO();
		$app =& JFactory::getApplication();
		$post = JRequest::get('post',JREQUEST_ALLOWRAW);
		$url = stripslashes(rseventsHelper::RSstripjavaVar($post['meeboCode']));
		$idevent = JRequest::getInt('IdEvent',0,'request');
		$cid = JRequest::getInt('cid',0,'request');
		
		$db->setQuery("SELECT EventName FROM #__rsevents_events WHERE IdEvent='".$idevent."'");
		$eventname = $db->loadResult();
		
		if ($cid > 0)
			$db->setQuery("UPDATE #__rsevents_extras SET ExtraValue = '".$db->getEscaped($url)."' WHERE IdExtra = ".$cid);
		else 
			$db->setQuery("INSERT INTO #__rsevents_extras SET IdExtra = '".$cid."' , IdEvent = '".$idevent."' , ExtraName = 'meebo' , ExtraValue = '".$db->getEscaped($url)."' ");
		$result = $db->query();
		
		if($result) $msg=JText::_('RSE_EXTRA_MEEBO_SAVE'); else $msg=JText::_('RSE_EXTRA_MEEBO_SAVE_ERROR');
		
		if (rseventsHelper::is16())
			echo '<script type="text/javascript">window.parent.location.reload();window.parent.SqueezeBox.close();</script>';
		else
			$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=addeditevent&cid='.eventsHelper::sef($idevent,$eventname).'&tab=4',false) , $msg);
	}
	
	//saving the flash extra
	function saveFlash()
	{
		$db = & JFactory::getDBO();
		$app =& JFactory::getApplication();
		$post = JRequest::get('post',JREQUEST_ALLOWRAW);
		$url = stripslashes(rseventsHelper::RSstripjavaVar($post['flashCode']));
		$idevent = JRequest::getInt('IdEvent',0,'request');
		$cid = JRequest::getInt('cid',0,'request');

		$db->setQuery("SELECT EventName FROM #__rsevents_events WHERE IdEvent='".$idevent."'");
		$eventname = $db->loadResult();
		
		if ($cid > 0)
			$db->setQuery("UPDATE #__rsevents_extras SET ExtraValue = '".$db->getEscaped($url)."' WHERE IdExtra = ".$cid);
		else 
			$db->setQuery("INSERT INTO #__rsevents_extras SET IdExtra = '".$cid."' , IdEvent = '".$idevent."' , ExtraName = 'flash' , ExtraValue = '".$db->getEscaped($url)."' ");
		$result = $db->query();
		
		if($result) $msg=JText::_('RSE_EXTRA_FLASH_SAVE'); else $msg=JText::_('RSE_EXTRA_FLASH_SAVE_ERROR');
		
		if (rseventsHelper::is16())
			echo '<script type="text/javascript">window.parent.location.reload();window.parent.SqueezeBox.close();</script>';
		else
			$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=addeditevent&cid='.eventsHelper::sef($idevent,$eventname).'&tab=4',false) , $msg);
	}
	
	//saving the mp3 Ieemem extra
	function saveMp3()
	{
		//get variables
		$db = & JFactory::getDBO();
		$app =& JFactory::getApplication();
		$post = JRequest::get('post',JREQUEST_ALLOWRAW);
		$url = stripslashes(str_replace(array("\r","\n","\t"),"",$_POST['mp3Code']));
		$idevent = JRequest::getInt('IdEvent',0,'request');
		$cid = JRequest::getInt('cid',0,'request');
		
		$db->setQuery("SELECT EventName FROM #__rsevents_events WHERE IdEvent='".$idevent."'");
		$eventname = $db->loadResult();
		
		$pattern = '/<param name="movie" value="(.*?)"/';
		$matches = array();
		preg_match($pattern,$url,$matches);
		
		if(count($matches)<2)
		{ 
			if (rseventsHelper::is16())
					$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=mp3&tmpl=component&cid=0&IdEvent='.$idevent,false) , JText::_('RSE_EXTRA_MP3_NAME'));
				else			
					$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=addeditevent&cid='.eventsHelper::sef($idevent,$eventname).'&tab=4',false) , JText::_('RSE_EXTRA_MP3_NAME'));
		}
		
		if ($cid > 0)
			$db->setQuery("UPDATE #__rsevents_extras SET ExtraValue = '".$db->getEscaped($matches[1])."' WHERE IdExtra = ".$cid);
		else 
			$db->setQuery("INSERT INTO #__rsevents_extras SET IdExtra = '".$cid."' , IdEvent = '".$idevent."' , ExtraName = 'mp3' , ExtraValue = '".$db->getEscaped($matches[1])."' ");
		$result = $db->query();
		
		if($result) $msg=JText::_('RSE_EXTRA_MP3_SAVE'); else $msg=JText::_('RSE_EXTRA_MP3_SAVE_ERROR');
		
		if (rseventsHelper::is16())
			echo '<script type="text/javascript">window.parent.location.reload();window.parent.SqueezeBox.close();</script>';
		else
			$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=addeditevent&cid='.eventsHelper::sef($idevent,$eventname).'&tab=4',false) , $msg);
	}
	
	//delete  extra 
	function deleteExtra()
	{
		//get variables
		$db = & JFactory::getDBO();
		$app =& JFactory::getApplication();
		$user =& JFactory::getUser();
		$cid= JRequest::getInt('cid',0,'request');
		$idevent = JRequest::getInt('IdEvent',0);
		
		$db->setQuery("SELECT IdUser,EventName FROM #__rsevents_events WHERE IdEvent='".$idevent."'");
		$details = $db->loadObject();
		
		if (rseventsHelper::is16())
			$groups = JAccess::getGroupsByUser($user->id);
		
		if($user->usertype == 'Super Administrator' || (rseventsHelper::is16() && in_array(8,$groups)) || $user->id == $details->IdUser)
		{
			$db->setQuery("DELETE FROM #__rsevents_extras WHERE IdExtra = ".$cid);
			$result = $db->query();
			
			if($result) $msg=JText::_('RSE_EXTRA_DELETE'); else $msg=JText::_('RSE_EXTRA_DELETE_ERROR');
			$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=addeditevent&cid='.eventsHelper::sef($idevent,$details->EventName).'&tab=4',false) , $msg);
		}
		$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=show&cid='.eventsHelper::sef($idevent,$details->EventName),false) , JText::_('RSE_ACCESS_DENIED'));
 	}
	
	function eventUnsubscribe()
	{
		$db = & JFactory::getDBO();
		$app =& JFactory::getApplication();
		$user = & JFactory::getUser();
		$rseventsConfig = rseventsHelper::getConfig();
		$cid = JRequest::getInt('cid',0,'request');
		
		$row = & JTable::getInstance('Rsevents_Events','Table');
		$row->load($cid);
		
		$app->triggerEvent('rse_onBeforeUnsubscribe',array(array('data'=>&$row)));
		
		//get the group id
		if (rseventsHelper::is16())
		{
			$groups = JAccess::getGroupsByUser($user->id);
			$db->setQuery("SELECT IdGroup FROM #__rsevents_groups_acl WHERE GroupAcl IN (".implode(',',$groups).")");
			$groupid = $db->loadResult();
		} else 
		{
			$db->setQuery("SELECT IdGroup FROM #__rsevents_groups_acl WHERE GroupAcl = ".$user->gid);
			$groupid = $db->loadResult();
		}
		
		$permissions = rseventsModelEvents::getPermissions();
		$cancelation = $permissions['allowRegistrationCancel'];
		
		if($cancelation == 1 || $user->usertype == "Super Administrator" || (rseventsHelper::is16() && in_array(8,$groups)) || ($user->id > 0 && empty($groupid)) )
		{
			if($row->EventEnableRegistration == '1')
			{
				$db->setQuery("SELECT IdSubscription FROM #__rsevents_subscriptions WHERE IdUser='".$user->id."' AND IdEvent='".$cid."'");
				$idsubscription = $db->loadResult();
				
				if($idsubscription != '')
				{
					rseventsEmails::unsubscribe($user->email,$user->id,$row->IdEvent,$idsubscription);					
					
					$db->setQuery("DELETE FROM #__rsevents_subscription_tickets WHERE IdSubscription=".$idsubscription);
					$db->query();
					$db->setQuery("DELETE FROM #__rsevents_subscriptions WHERE IdUser='".$user->id."' AND IdEvent='".$cid."'");
					$db->query();
					$msg =  JText::_('RSE_SUBSCRIBER_UNSUBSCRIBE');					
					
				} else 	$msg =  JText::_('RSE_SUBSCRIBER_LOGIN_UNSUBSCRIBE');
			} else $msg =  JText::_('RSE_SUBSCRIBER_NO_REGISTRATION');
		} else $msg = JText::_('RSE_SUBSCRIBER_CANNOT_UNSUBSCRIBE');
		
		$app->triggerEvent('rse_onAfterUnsubscribe',array(array('IdEvent'=>&$cid,'IdSubscription'=>&$idsubscription)));
		
		$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=show&cid='.eventsHelper::sef($row->IdEvent,$row->EventName),false) , $msg);
	}
	
	//send post reminder emails 
	function postreminder()
	{
		$db =& JFactory::getDBO();
		$app =& JFactory::getApplication();
		$user =& JFactory::getUser();
		$cid = JRequest::getInt('cid',0,'request');
		$row = & JTable::getInstance('Rsevents_Events','Table');
		$row->load($cid);
		$rseventsConfig = rseventsHelper::getConfig();
		
		if (rseventsHelper::is16())
			$groups = JAccess::getGroupsByUser($user->id);
		
		if($row->EventEndDate < time() && ($user->usertype == 'Super Administrator' || (rseventsHelper::is16() && in_array(8,$groups)) || $row->IdUser == $user->id))
		{
			//get subscribers 
			$db->setQuery("SELECT IdUser, Email FROM #__rsevents_subscriptions WHERE IdEvent = '".$row->IdEvent."' AND SubscriptionState = 1 ");
			$subscribers = $db->loadObjectList();
			
			foreach ($subscribers as $subscriber)
				rseventsEmails::postreminder($subscriber->Email,$subscriber->IdUser,$row->IdEvent);
			
				$msg = JText::_('RSE_POST_REMINDER_SENT');
		} else $msg = JText::_('RSE_ACCESS_DENIED');
		$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=show&cid='.eventsHelper::sef($row->IdEvent,$row->EventName),false) , $msg);
	}
	
	//send reminder email
	function reminder()
	{
		$db =& JFactory::getDBO();
		$app =& JFactory::getApplication();
		$user =& JFactory::getUser();
		$cid = JRequest::getInt('cid',0,'request');
		$row = & JTable::getInstance('Rsevents_Events','Table');
		$row->load($cid);
		$rseventsConfig = rseventsHelper::getConfig();
		
		if (rseventsHelper::is16())
			$groups = JAccess::getGroupsByUser($user->id);
		
		if($user->usertype == 'Super Administrator' || (rseventsHelper::is16() && in_array(8,$groups)) || $row->IdUser == $user->id)
		{
			//get subscribers 
			$db->setQuery("SELECT IdUser, Email FROM #__rsevents_subscriptions WHERE IdEvent = '".$row->IdEvent."' AND SubscriptionState IN (0,1) ");
			$subscribers = $db->loadObjectList();
			
			foreach ($subscribers as $subscriber)
				rseventsEmails::reminder($subscriber->Email,$subscriber->IdUser,$row->IdEvent);
			
			$msg = JText::_('RSE_REMINDER_SENT');
		} else $msg = JText::_('RSE_ACCESS_DENIED');
		$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=show&cid='.eventsHelper::sef($row->IdEvent,$row->EventName),false) , $msg);
	}
	
	function savePhotos()
	{
		$db = & JFactory::getDBO();
		$app =& JFactory::getApplication();
		$post = JRequest::get('post');
		$url = $post['photos'];
		$cid = JRequest::getInt('cid',0,'request');
		$privateUrl = (JRequest::getCmd('privateUrl','','request') != '') ? '&privateUrl='.JRequest::getCmd('privateUrl','','request') : '';
		
		$db->setQuery("SELECT EventName FROM #__rsevents_events WHERE IdEvent='".$cid."'");
		$eventname = $db->loadResult();
		
		$pattern = '/http:\/\/www.flickr.com\/photos\/(.*)\/sets\/([0-9]+)/';
		preg_match($pattern, $url, $matches);
		
		if(!empty($matches))
		{
			$db->setQuery("INSERT INTO #__rsevents_extras SET IdEvent = '".$cid."' , ExtraName = 'flickr' , ExtraValue = '".$db->getEscaped($url)."' ");
			$result = $db->query();
			$idextra = $db->insertid();
			
			
			if($result) $msg=JText::_('RSE_PHOTOS_SAVED'); else $msg=JText::_('RSE_PHOTOS_SAVED_ERROR');
			echo eventsHelper::setMessage($msg,1);
		} else $app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=photos&cid='.eventsHelper::sef($cid,$eventname).$privateUrl,false) , JText::_('RSE_EXTRA_FLICKR_INVALID_URL'));
	}
	
	function deleteicon()
	{
		jimport('joomla.filesystem.file');
		$db =& JFactory::getDBO();
		$app =& JFactory::getApplication();
		$rseventsConfig = rseventsHelper::getConfig();
		$cid = JRequest::getInt('cid','','request');

		$db->setQuery("SELECT EventName,EventIcon FROM #__rsevents_events WHERE IdEvent = '".$cid."'");
		$details = $db->loadObject();
		$ext = JFile::getExt($details->EventIcon);
		
		$small_icon = str_replace('.'.$ext,'_'.$rseventsConfig['event.icon.small'].'.'.$ext,$details->EventIcon);
		$big_icon = str_replace('.'.$ext,'_'.$rseventsConfig['event.icon.big'].'.'.$ext,$details->EventIcon);
		
		JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$small_icon);
		JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$big_icon);
		
		$db->setQuery("UPDATE #__rsevents_events SET EventIcon = '' WHERE IdEvent = '".$cid."'");
		$db->query();
		
		$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=addeditevent&cid='.eventsHelper::sef($cid,$details->EventName),false) , JText::_('RSE_ICON_DELETED'));
	}
	
	//save event function
	function save()
	{
		jimport('joomla.filesystem.file');
		
		$db				=& JFactory::getDBO();
		$app			=& JFactory::getApplication();
		$user		 	=& JFactory::getUser();
		$post			= JRequest::get('post',JREQUEST_ALLOWHTML);
		$task 			= JRequest::getVar('task');
		$tab			= JRequest::getInt('tab',1);
		$files			= JRequest::get('files');
		$cid 			= JRequest::getInt('cid');
		$rseventsConfig = rseventsHelper::getConfig();
		$row			=& JTable::getInstance('Rsevents_Events','Table');
		$config 		= new JConfig();
		$pathToThumbs 	= JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS;
		
		$permissions = rseventsModelEvents::getPermissions();
		$permissionModeration = isset($permissions['enableModeration']) ? $permissions['enableModeration'] : 0;
		
		//get the icon
		$icon = $files['icon'];
		//get the files
		$files = $files['files'];
		
		//verify if the default ticket exist
		$db->setQuery("SELECT COUNT(*) FROM #__rsevents_tickets WHERE IdEvent = '".$cid."'");
		$defaultticket = $db->loadResult();
		
		if(!$row->bind($post)) 
			return JError::raiseWarning(500, $row->getError());
		
		if($row->EventURL == 'http://') $row->EventURL = '';
		
		//loads the time in unix timestamp
		if($rseventsConfig['enable.12format'] == 1)
		{
			if($row->EventAmPm1 == 0)
				$startH = $post['EventStartDateH'].':'.$post['EventStartDateM'].':00 am';
			else 
				$startH = $post['EventStartDateH'].':'.$post['EventStartDateM'].':00 pm';
			
			if($row->EventAmPm2 == 0)
				$endH = $post['EventEndDateH'].':'.$post['EventEndDateM'].':00 am';
			else 
				$endH = $post['EventEndDateH'].':'.$post['EventEndDateM'].':00 pm';
		} else 
		{
			$startH = $post['EventStartDateH'].':'.$post['EventStartDateM'].':00';
			$endH = $post['EventEndDateH'].':'.$post['EventEndDateM'].':00';
		}
		$row->EventStartDate=strtotime($post['EventStartDate'].' '.$startH);
		$row->EventEndDate=strtotime($post['EventEndDate'].' '.$endH);
		$row->EventStartRegistration = empty($row->EventStartRegistration) ? 0 : strtotime($row->EventStartRegistration);
		$row->EventEndRegistration = empty($row->EventEndRegistration) ? 0 : strtotime($row->EventEndRegistration);
		
		if($row->EventStartDate > $row->EventEndDate) $row->EventStartDate = $row->EventEndDate - 3600;
		$row->EventAlias = JFilterOutput::stringURLSafe($row->EventName);
		
		if($row->EventEndDate < $row->EventStartDate) 
		if(empty($row->IdEvent))
			$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=addeditevent',false),JText::_('RSE_INVALID_DATE'));
		else
			$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=addeditevent&cid='.$row->IdEvent,false),JText::_('RSE_INVALID_DATE'));
		
		$row->published = isset($row->published) ? $row->published : 1;
		//set unpublished if the users group has event moderation on
		if($permissionModeration == 1 && $user->usertype != "Super Administrator")
		{
			$row->published = 0;
			$from		= $config->mailfrom;
			$fromName	= $config->fromname;
			$to 		= $rseventsConfig['moderation.email'];
			$subject	= JText::sprintf('RSE_SUBJECT_REQUIRE_MODERATION',$user->name);
			$body		= JText::_('RSE_BODY_REQUIRE_MODERATION');

			$to = explode(',',$to);
			
			if (!empty($to))
				foreach ($to as $email)
					if(!empty($email)) 
						JUtility::sendMail($from , $fromName , $email , $subject , $body , 1 , null , null , null , null);
		}
		
		//set the default registration form
		if(empty($row->EventRegistrationForm))
			$row->EventRegistrationForm = $rseventsConfig['event.registration.form'];
		
		//verify if the event requires registration
		$permissionRegistration = isset($permissions['allowRegistration']) ? $permissions['allowRegistration'] : 0;			
		if($permissionRegistration == 0 && $user->usertype != "Super Administrator" ) $row->EventEnableRegistration = 0;
		
		//create the private Url
		$db->setQuery("SELECT EventPrivateUrl FROM #__rsevents_events WHERE IdEvent = '".$cid."' ");
		$EventPrivateUrl = $db->loadResult();
		if(empty($EventPrivateUrl) && $row->EventType == 0)
			$row->EventPrivateUrl = uniqid('',FALSE);
		
		//set the owner
		if($cid == 0) $row->IdUser = $user->id;
		if(empty($row->IdEvent) || $row->IdEvent == 0) $row->EventCreation = time();
		
		if (!empty($row->IdEvent))
		{
			$db->setQuery("SELECT designtype FROM #__rsevents_events WHERE IdEvent = '".$row->IdEvent."'");
			$designtype = $db->loadResult();
			
			if ($designtype && $row->IdNewDesign)
			{
				$row->IdDesign = 0;
				$row->designtype = 0;
			}
		}
		
		$row->payments = !empty($post['payments']) ? implode(',',$row->payments) : '';
		$row->early_discount_deadline = empty($row->early_discount_deadline) ? '' : strtotime($row->early_discount_deadline);
		$row->late_fee_date = empty($row->late_fee_date) ? '' : strtotime($row->late_fee_date);
		
		if($row->store())
		{
			//if the default ticket is not created , we create it
			if($defaultticket == '0')
			if($row->EventEnableRegistration) 
			{
				$db->setQuery("INSERT INTO #__rsevents_tickets (IdEvent,TicketName,TicketPrice,TicketMaxAudience,ordering) VALUES ('$row->IdEvent','".JText::_('RSE_TICKET_DEFAULT')."',0,'0','1')");
				$db->query();
			}
			
			if($rseventsConfig['enable.event.icon'] == 1 && !empty($icon['name']))
			{
				if (!in_array(strtolower(JFile::getExt($icon['name'])),array('jpg','jpeg','png','gif'))) 
					$app->enqueueMessage(JText::_('RSE_ICON_ERROR'));
				JFile::upload($icon['tmp_name'],$pathToThumbs.$icon['name']);
				rseventsHelper::createIcon($icon , $pathToThumbs , $rseventsConfig['event.icon.small'] , $row->IdEvent,1);
				rseventsHelper::createIcon($icon , $pathToThumbs , $rseventsConfig['event.icon.big'] , $row->IdEvent,1);
				JFile::delete($pathToThumbs.$icon['name']);
			}
			
			$db->setQuery("DELETE FROM #__rsevents_events_cat WHERE IdEvent = ".$row->IdEvent);
			$db->query();
			
			//insert categories
			foreach($post['IdCategory'] as $catid)
			{
				$db->setQuery("INSERT INTO #__rsevents_events_cat SET IdEvent = ".$row->IdEvent." , IdCategory = ".intval($catid));
				$db->query();
			}			
			
			//get allowed extensions
			$allowedExtensions = str_replace(array("\r"," "),"",$rseventsConfig['event.files']);
			$allowedExtensions = explode("\n",$allowedExtensions);
			
			$target= JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'files'.DS;
			$uploadPermission = $permissions['allowUpload'];
			
			if (rseventsHelper::is16())
				$groups = JAccess::getGroupsByUser($user->id);
			
			if($uploadPermission ==1 || $user->usertype == 'Super Administrator' || (rseventsHelper::is16() && in_array(8,$groups)) || empty($files['name'][0]))
			{
				for($i=0;$i<10;$i++)
				{
					if(!empty($files['tmp_name'][$i]))
					{
						$extension = end(explode('.', $files['name'][$i]));
						if($extension != '' && array_search($extension,$allowedExtensions) !== false )
						{
							if($files['tmp_name'][$i]!='')
							{
								$fileLocation = uniqid('',FALSE)."_". basename( $files['name'][$i]);
								$file = $target . $fileLocation;
								JFile::upload($files['tmp_name'][$i], $file);
								
								$db->setQuery("INSERT INTO #__rsevents_files (IdEvent,FileName,FileLocation,FilePermission) VALUES ('".$row->IdEvent."','".JFile::getName($files['name'][$i])."','".$db->getEscaped($fileLocation)."','111111') "); 
								$db->query();
							}
						}
					}
				}
				
			} else $app->enqueueMessage(JText::_('RSE_FILE_CANNOT_UPLOAD'));
			
			
			if ($cid == 0 && $permissionModeration == 1)
				$msg = JText::_('RSE_EVENT_SAVED_WITH_MODERATION');
			else if ($cid != 0 && $permissionModeration == 1)
				$msg = JText::_('RSE_EVENT_EDITED_WITH_MODERATION');
			else $msg = JText::_('RSE_EVENT_SAVED');
			
			$app->enqueueMessage($msg);
			
			if($task == 'save')
				$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=show&cid='.eventsHelper::sef($row->IdEvent,$row->EventName),false));
			if($task == 'apply')
				$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=addeditevent&cid='.eventsHelper::sef($row->IdEvent,$row->EventName).'&tab='.$tab,false));
			
		} else
		{
			if ($cid)
				$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=addeditevent&cid='.eventsHelper::sef($row->IdEvent,$row->EventName),false),JText::_( 'RSE_EVENT_SAVE_ERROR' ));
			else
				$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events',false),JText::_( 'RSE_EVENT_SAVE_ERROR' ));
		}
	}
	
	
	//copy event
	function copy()
	{
		jimport('joomla.filesystem.file');
		
		$app	=& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$user	=& JFactory::getUser();
		$cid	= JRequest::getInt('cid',0);
		$row	=& JTable::getInstance('Rsevents_Events','Table');
		$config = rseventsHelper::getConfig();
		
		if (empty($cid)) $app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events',false) , JText::_('RSE_INVALID_ID'));
		
		$row->load($cid);
		$hasicon = $row->EventIcon;
		$permissions = rseventsModelEvents::getPermissions();
		$eventPermission = @$permissions['enablePosts'];
		$canEdit = @$permissions['canEdit'];
		
		if (rseventsHelper::is16())
			$groups = JAccess::getGroupsByUser($user->id);
		
		if ($user->usertype == 'Super Administrator' || (rseventsHelper::is16() && in_array(8,$groups)) || (empty($row->IdEvent) && $eventPermission == 1 ) || (!empty($row->IdEvent) && $canEdit == 1) || ($user->id === $row->IdUser) || $eventPermission == 1)
		{
			$row->published=0;
			$row->EventName=JText::_('RSE_COPY_OF').' '.$row->EventName;
			$row->IdEvent=null;
			$ext = JFile::getExt($row->EventIcon);
			$row->store();
			
			if ($hasicon != '')
			{
				$row->EventIcon = $row->IdEvent.'.'.$ext;
				$row->store();
			}
			
			//copy icon
			if ($hasicon != '')
			{
				JFile::copy(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$cid.'_'.$config['event.icon.small'].'.'.$ext , JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$row->IdEvent.'_'.$config['event.icon.small'].'.'.$ext);
				JFile::copy(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$cid.'_'.$config['event.icon.big'].'.'.$ext , JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$row->IdEvent.'_'.$config['event.icon.big'].'.'.$ext);
			}
			
			//copy categories
			$db->setQuery("SELECT IdCategory FROM #__rsevents_events_cat WHERE IdEvent = '".$cid."'");
			$catids = $db->loadObjectList();
			
			foreach($catids as $cat)
			{
				$db->setQuery("INSERT INTO #__rsevents_events_cat SET IdEvent = ".$row->IdEvent." , IdCategory = ".$cat->IdCategory);
				$db->query();
			}
			
			//copy files
			$db->setQuery("SELECT FileName, FileDescription, FileLocation, FilePermission FROM #__rsevents_files WHERE IdEvent = '".$cid."'");
			$files = $db->loadObjectList();
			
			if (!empty($files))
				foreach ($files as $file)
				{
					$fileext = JFile::getExt($file->FileLocation);
					$newfile = uniqid('',false).'.'.$fileext;
					JFile::copy(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'files'.DS.$file->FileLocation , JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'files'.DS.$newfile);
					$db->setQuery("INSERT INTO #__rsevents_files SET FileName = '".$file->FileName."' , FileDescription = '".$file->FileDescription."' , FileLocation = '".$newfile."' , FilePermission = '".$file->FilePermission."' , IdEvent = '".$row->IdEvent."' ");
					$db->query();
				}
			
			//copy extras
			$db->setQuery("SELECT ExtraName ,ExtraValue FROM #__rsevents_extras WHERE IdEvent = '".$cid."'");
			$extras = $db->loadObjectList();
			
			if (!empty($extras))
				foreach ($extras as $extra)
				{
					$db->setQuery("INSERT INTO #__rsevents_extras SET ExtraName = '".$extra->ExtraName."' , ExtraValue = '".$db->getEscaped($extra->ExtraValue)."' , IdEvent = '".$row->IdEvent."' ");
					$db->query();
				}
			
			//copy tickets
			$db->setQuery("SELECT TicketName, TicketPrice, TicketMaxAudience, TicketsPerUser, TicketDescription FROM #__rsevents_tickets WHERE IdEvent = '".$cid."' ");
			$tickets = $db->loadObjectList();
			
			if (!empty($tickets))
				foreach ($tickets as $ticket)
				{
					$db->setQuery("INSERT INTO #__rsevents_tickets SET TicketName = '".$ticket->TicketName."' , TicketPrice = '".$ticket->TicketPrice."' , TicketMaxAudience = '".$ticket->TicketMaxAudience."' , TicketsPerUser = '".$ticket->TicketsPerUser."' , TicketDescription = '".$ticket->TicketDescription."' , IdEvent = '".$row->IdEvent."' ");
					$db->query();
				}
			
			//copy coupons
			$db->setQuery("SELECT CuponName, CuponCode, CuponType, CuponValue FROM #__rsevents_cupons WHERE IdEvent = '".$cid."' ");
			$coupons = $db->loadObjectList();
			
			if (!empty($coupons))
				foreach ($coupons as $coupon)
				{
					$db->setQuery("INSERT INTO #__rsevents_cupons SET CuponName = '".$coupon->CuponName."' , CuponCode = '".$coupon->CuponCode."' , CuponType = '".$coupon->CuponType."' , CuponValue = '".$coupon->CuponValue."' , IdEvent = '".$row->IdEvent."' ");
					$db->query();
				}
			
			$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=show&cid='.eventsHelper::sef($row->IdEvent,$row->EventName),false) , JText::_('RSE_EVENT_COPY'));
		} else $app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=show&cid='.eventsHelper::sef($row->IdEvent,$row->EventName),false) , JText::_('RSE_ACCESS_DENIED'));
	}
	
	//repeat event
	function repeat()
	{
		jimport('joomla.filesystem.file');
		
		$db 	=& JFactory::getDBO();
		$app	=& JFactory::getApplication();
		$post	= JRequest::get('post',JREQUEST_ALLOWRAW);
		$cid 	= JRequest::getInt('cid','0','request');
		$row	=& JTable::getInstance('Rsevents_Events','Table');
		$config	= rseventsHelper::getConfig();
		
		//load parent event
		$row->load($cid);
		if(!$row->bind($post)) return JError::raiseWarning(500, $row->getError()); 
		
		//prepare values
		if (!empty($row->EventRepeatDays))
		$row->EventRepeatDays = serialize($row->EventRepeatDays);
		if(!isset($post['EventRepeatDays'])) $row->EventRepeatDays = '';
		$row->EventRepeatUntil = strtotime($row->EventRepeatUntil);
		if (is_array($row->EventRepeatAlso))
		{
			$dates = array_unique($row->EventRepeatAlso);
			$dates = array_merge($dates,array());
			foreach($dates as $i => $date)
			{
				$datetounix = strtotime($date);
				$datetounix = $datetounix + (((date('H',$row->EventStartDate) * 60) + date('i',$row->EventStartDate)) * 60);
				$dates[$i] = $datetounix;
			}
			
			$row->EventRepeatAlso = serialize($dates);
		}
		if (!isset($post['EventRepeatAlso'])) $row->EventRepeatAlso = '';
		
		//save details
		$row->store();
		
		if ($row->EventEnableRepeat == 1)
		{
			//create a clone of the parent
			$new = clone($row);
			
			//get the parent id
			$parentid = $row->IdEvent;
			
			//get categories
			$db->setQuery("SELECT IdCategory FROM #__rsevents_events_cat WHERE IdEvent = '".$parentid."'");
			$categories = $db->loadResultArray();
			
			//get tickets
			$db->setQuery("SELECT * FROM #__rsevents_tickets WHERE IdEvent = '".$parentid."'");
			$tickets = $db->loadObjectList();
			
			//get coupons
			$db->setQuery("SELECT * FROM #__rsevents_cupons WHERE IdEvent = '".$parentid."'");
			$coupons = $db->loadObjectList();
			
			//get extras
			$db->setQuery("SELECT ExtraName,ExtraValue FROM #__rsevents_extras WHERE IdEvent = '".$parentid."'");
			$extras = $db->loadObjectList();
			
			//get files
			$db->setQuery("SELECT FileName,FileDescription,FileLocation,FilePermission FROM #__rsevents_files WHERE IdEvent='".$parentid."'");
			$dbfiles = $db->loadObjectList();
			
			//load icon extension
			$extension = JFile::getExt($row->EventIcon);
			
			//delete data first
			$db->setQuery("SELECT IdEvent FROM #__rsevents_events WHERE IdParent = '".$parentid."'");
			$ids = $db->loadResultArray();
			
			if (!empty($ids))
				foreach ($ids as $id)
				{
					//delete categories
					$db->setQuery("DELETE FROM #__rsevents_events_cat WHERE IdEvent = '".$id."'");
					$db->query();
					
					//delete tickets 
					$db->setQuery("DELETE FROM #__rsevents_tickets WHERE IdEvent = '".$id."'");
					$db->query();
					
					//delete coupons
					$db->setQuery("DELETE FROM #__rsevents_cupons WHERE IdEvent = '".$id."'");
					$db->query();
					
					//delete extras
					$db->setQuery("DELETE FROM #__rsevents_extras WHERE IdEvent = '".$id."'");
					$db->query();
					
					//delete subscription tickets
					$db->setQuery("SELECT IdSubscription FROM #__rsevents_subscriptions WHERE IdEvent = '".$id."'");
					$subscriptions = $db->loadObjectList();
					
					foreach($subscriptions as $sid)
					{
						$db->setQuery("DELETE FROM #__rsevents_subscription_tickets WHERE IdSubscription='".$sid->IdSubscription."'");
						$db->query();
					}
					
					//delete subscriptions
					$db->setQuery("DELETE FROM #__rsevents_subscriptions WHERE IdEvent='".$id."'");
					$db->query();
					
					//delete files
					$db->setQuery("SELECT FileLocation FROM #__rsevents_files WHERE IdEvent='".$id."'");
					$files = $db->loadObjectList();
					
					if (!empty($files))
					foreach ($files as $file)
						JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'files'.DS.$file->FileLocation);
					
					$db->setQuery("DELETE FROM #__rsevents_files WHERE IdEvent='".$id."'");
					$db->query();
					
					//delete icon if exists					
					if ($row->EventIcon != '')
					{
						$ext = JFile::getExt($row->EventIcon);
						$name = JFile::getName(JFile::stripExt($row->EventIcon));
						$big = $name.'_'.$config['event.icon.big'].'.'.$ext;
						$small = $name.'_'.$config['event.icon.small'].'.'.$ext;
						JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$big);
						JFile::delete(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$small);
					}
					
					//delete event 
					$db->setQuery("DELETE FROM #__rsevents_events WHERE IdEvent = '".$id."'");
					$db->query();
				}
			
			//get dates
			$startdates = array();
			$startdate 	= $row->EventStartDate;
			$repeatnr 	= $row->EventRepeatNumber;
			$duration 	= $row->EventEndDate - $row->EventStartDate;
			$repeatalso = unserialize($row->EventRepeatAlso);
			$days		= unserialize($row->EventRepeatDays);
			$repeatnr	= empty($repeatnr) ? 0 : $repeatnr;
			
			//switch on the type of the repetition
			if ($repeatnr > 0)
			switch($row->EventRepeatType)
			{
				//Days
				case 1:
					while ($startdate <= $row->EventRepeatUntil)
					{
						$startdate = strtotime('+'.$repeatnr.' days',  $startdate);
						if (!in_array(date('w',$startdate),$days)) continue;
						if($startdate > $row->EventRepeatUntil) break;
						$startdates[] = $startdate;
						
					}
				break;
				
				//Weeks
				case 2:
					while ($startdate <= $row->EventRepeatUntil)
					{
						$startdate = strtotime('+'.$repeatnr.' weeks',  $startdate);
						if (!in_array(date('w',$startdate),$days)) continue;
						if($startdate > $row->EventRepeatUntil) break;
						$startdates[] = $startdate;
						
					}
				break;
				
				//Months
				case 3:
					while ($startdate <= $row->EventRepeatUntil)
					{
						$startdate = strtotime('+'.$repeatnr.' months',  $startdate);
						if($startdate > $row->EventRepeatUntil) break;
						$startdates[] = $startdate;
						
					}
				break;
				
				//Years
				case 4:
					while ($startdate <= $row->EventRepeatUntil)
					{
						$startdate = strtotime('+'.$repeatnr.' year',  $startdate);
						if($startdate > $row->EventRepeatUntil) break;
						$startdates[] = $startdate;
						
					}
				break;
			}
			
			
			if (!empty($repeatalso))
				$startdates = array_merge($startdates,$repeatalso);
			
			//create new events
			if (!empty($startdates))
			foreach ($startdates as $newdate)
			{
				$new->EventStartDate = $newdate;
				$new->EventEndDate = $newdate + $duration;
				$new->IdParent = $parentid;
				$new->IdEvent = null;
				$new->EventEnableRepeat = 0;
				$new->EventRepeatAlso = '';
				$new->EventRepeatDays = '';
				$new->EventRepeatNumber = '';
				$new->EventRepeatType = '';
				$new->EventRepeatUntil = '';
				$new->EventIcon = '';
				$new->EventArchive = 0;
				$new->store();
				
				//load categories
				foreach ($categories as $category)
				{
					$db->setQuery("INSERT INTO #__rsevents_events_cat SET IdEvent = '".$new->IdEvent."' , IdCategory = '".$category."' ");
					$db->query();
				}
				
				//load tickets
				if (!empty($tickets))
					foreach ($tickets as $ticket)
					{
						$db->setQuery("INSERT INTO #__rsevents_tickets SET IdEvent = '".$new->IdEvent."' , TicketName = '".$db->getEscaped($ticket->TicketName)."' , TicketPrice = '".$ticket->TicketPrice."' ,TicketMaxAudience = '".$ticket->TicketMaxAudience."' , TicketsPerUser = '".$ticket->TicketsPerUser."' ,TicketDescription = '".$db->getEscaped($ticket->TicketDescription)."' , ordering = '".$ticket->ordering."' ");
						$db->query();
					}
				
				//load coupons
				if (!empty($coupons))
					foreach ($coupons as $coupon)
					{
						$db->setQuery("INSERT INTO #__rsevents_cupons SET IdEvent = '".$new->IdEvent."', CuponName = '".$db->getEscaped($coupon->CuponName)."', CuponCode = '".$db->getEscaped($coupon->CuponCode)."', CuponType = '".$coupon->CuponType."', CuponValue = '".$coupon->CuponValue."' ");
						$db->query();
					}
				
				//load extras
				if (!empty($extras))
					foreach ($extras as $extra)
					{
						$db->setQuery("INSERT INTO #__rsevents_extras SET IdEvent = '".$new->IdEvent."', ExtraName = '".$db->getEscaped($extra->ExtraName)."' , ExtraValue = '".$extra->ExtraValue."' ");
						$db->query();
					}
				
				//load files
				if (!empty($dbfiles))
					foreach ($dbfiles as $file)
					{
						$fileext = JFile::getExt($file->FileLocation);
						$newfile = uniqid('',false).'.'.$fileext;
						JFile::copy(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'files'.DS.$file->FileLocation , JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'files'.DS.$newfile);
						$db->setQuery("INSERT INTO #__rsevents_files SET FileName = '".$db->getEscaped($file->FileName)."' , FileDescription = '".$db->getEscaped($file->FileDescription)."' , FileLocation = '".$newfile."' , FilePermission = '".$file->FilePermission."' , IdEvent = '".$new->IdEvent."' ");
						$db->query();
					}
				
				//load the icon
				if ($row->EventIcon != '')
				{
					$db->setQuery("UPDATE #__rsevents_events SET EventIcon = '".$db->getEscaped($new->IdEvent.'.'.$extension)."' WHERE IdEvent = '".$new->IdEvent."' ");
					$db->query();
					
					JFile::copy(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$parentid.'_'.$config['event.icon.small'].'.'.$extension , JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$new->IdEvent.'_'.$config['event.icon.small'].'.'.$extension);
				JFile::copy(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$parentid.'_'.$config['event.icon.big'].'.'.$extension , JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'assets'.DS.'images'.DS.'thumbs'.DS.$new->IdEvent.'_'.$config['event.icon.big'].'.'.$extension);
				}
			}
			
		}
		
		echo eventsHelper::setMessage(JText::_('RSE_REPEAT_SAVE'));
	}
	
	function getMapEvents()
	{
		$db		=& JFactory::getDBO();
		$app	=& JFactory::getApplication();
		$params	=& $app->getParams();
		
		$catids = $params->get('catids','');
		$locids = $params->get('locids','');
		
		if (!empty($catids))
		{
			//check if the categories have childrens
			$childcategs = array();
			if (!is_array($catids) && $catids != '')
			{
				$db->setQuery("SELECT `IdCategory` FROM `#__rsevents_categories` WHERE `parent` = '".$catids."' ");
				$childcategs = array_merge($childcategs,$db->loadResultArray());
			} else 
			{
				foreach ($catids as $cat)
				{
					$db->setQuery("SELECT `IdCategory` FROM `#__rsevents_categories` WHERE `parent` = '".$cat."' ");
					$childcategs = array_merge($childcategs,$db->loadResultArray());
				}
			}
			
			//create categories
			if (!is_array($catids) && $catids != '')
			{
				if (!empty($childcategs))
					$categories = $catids.','.implode($childcategs);
				else $categories = $catids;
			}
			else
			{
				$catids = array_merge($catids,$childcategs);
				$categories = implode(',',$catids);
			}
		}
		
		//create locations
		$locations = is_array($locids) ? implode(',',$locids) : $locids;
		
		$where = '';
		if(!empty($catids) && !empty($locids)) $where .=" AND (c.IdCategory IN (".$categories.") OR l.IdLocation IN (".$locations.")) ";
		if(!empty($catids) && empty($locids)) $where .= " AND c.IdCategory IN (".$categories.") ";
		if(!empty($locids) && empty($catids)) $where .= " AND l.IdLocation IN (".$locations.") ";
		
		$db->setQuery("SELECT e.IdEvent , e.EventName , e.EventStartDate , e.EventEndDate , l.LocationAddress , l.IdLocation , l.LocationName , l.LocationCity , l.LocationLat , l.LocationLon FROM #__rsevents_events e LEFT JOIN #__rsevents_locations l ON l.IdLocation = e.IdLocation LEFT JOIN #__rsevents_events_cat ec ON ec.IdEvent = e.IdEvent LEFT JOIN #__rsevents_categories c ON c.IdCategory = ec.IdCategory WHERE e.EventType = 1 AND e.published = 1 $where ");
		$events = $db->loadObjectList();
		
		$data = array();
		
		if (!empty($events))
		foreach ($events as $event)
			$data[$event->IdLocation][] = $event;
		
		return $data;
	}
}