<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die();
 
jimport( 'joomla.application.component.model' );

class rseventsModelLocations extends JModel
{
	var $_query;
	var $_data;
	var $_total=null;
	var $_pagination=null;
	
	function __construct()
	{
		parent::__construct();
		$this->_buildQuery();	
		
		// Get pagination request variables
		$limit = JRequest::getVar('limit', JFactory::getConfig()->getValue('list_limit'), '', 'int');
		$limitstart = JRequest::getVar('limitstart', 0, '', 'int');

		// In case limit has been changed, adjust it
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('com_rsevents.locations.limit', $limit);
		$this->setState('com_rsevents.locations.limitstart', $limitstart);
	}
	
	function _buildQuery()
	{
		$mainframe 		=& JFactory::getApplication();
		$params			=& $mainframe->getParams();
		$db				=& JFactory::getDBO();
		$filter			= JRequest::getVar('rs_filter');
		$ordering		= $params->get('order','DESC');
		
		$this->_query="SELECT IdLocation as RecordId, LocationName , LocationDescription,  published  FROM #__rsevents_locations WHERE LocationName LIKE '%".$db->getEscaped($filter)."%' ORDER BY LocationName $ordering";
		//echo $this->_query;
	}
	
	function getData()
	{
		if (empty($this->_data))
			$this->_data=$this->_getList($this->_query,$this->getState('com_rsevents.locations.limitstart'), $this->getState('com_rsevents.locations.limit'));
		return $this->_data;
	}
	
	function getTotal()
	{
		if (empty($this->_total))
			$this->_total = $this->_getListCount($this->_query);	
		return $this->_total;
	}
	
	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('com_rsevents.locations.limitstart'), $this->getState('com_rsevents.locations.limit'));
		}
		return $this->_pagination;
	}
	
	function getLocation()
	{
		$cid= JRequest::getInt('cid',0,'request');
		$row= & JTable::getInstance('Rsevents_Locations','Table');
		$row->load($cid);
		return $row;
	}
	
	function save()
	{
		$db =& JFactory::getDBO();
		$app =& JFactory::getApplication();
		$user =& JFactory::getUser();
		$post = JRequest::get('post',JREQUEST_ALLOWHTML);
		$rseventsConfig = rseventsHelper::getConfig();
		$row= & JTable::getInstance('Rsevents_Locations','Table');
		$cid = JRequest::getInt('cid',0);
		$ismodal = JRequest::getInt('ismodal',0);
		$config = new JConfig();
		
		$permissions = rseventsModelEvents::getPermissions();
		
		//verify if the location requires moderation
		$moderation = @$permissions['enableLocationModeration'];
		
		//can edit?
		$canedit = @$permissions['enableEditLocation'];
		
		if ($canedit)
			$row->load($cid);
		
		if (rseventsHelper::is16())
			$groups = JAccess::getGroupsByUser($user->id);
		
		if ($moderation == 0 || $user->usertype == "Super Administrator" || (rseventsHelper::is16() && in_array(8,$groups)))
			$row->published = 1;
		else
		{
			$row->published = 0;
			$from		= $config->mailfrom;
			$fromName	= $config->fromname;
			$to 		= $rseventsConfig['moderation.location.email'];
			$subject	= JText::sprintf('RSE_SUBJECT_REQUIRE_MODERATION_LOCATION',$user->name);
			$body		= JText::_('RSE_BODY_REQUIRE_MODERATION_LOCATION');

			$to = explode(',',$to);
			
			if (!empty($to))
				foreach ($to as $email)
					if(!empty($email)) 
						JUtility::sendMail($from , $fromName , $email, $subject , $body , 1 , null , null , null , null);
		}
		
		if(!$row->bind($post))
			return JError::raiseWarning(500, $row->getError());
		
		$published = $row->published; 
		
		$row->LocationAlias = JFilterOutput::stringURLSafe($row->LocationName);
		
		if (!$row->store())
			JError::raiseWarning(500, $row->getError());
		
		$msg = ($moderation == 1)  ? JText::_( 'RSE_LOCATION_SAVE_WITH_MODERATION' ) : JText::_( 'RSE_LOCATION_SAVE' );
		if ($canedit == 1 && $published == 1) $msg = JText::_( 'RSE_LOCATION_SAVE' );
		
		if ($ismodal)
		{
			echo '<script type="text/javascript">'."\n";
			echo 'window.parent.rse_refresh_locations(\''.JURI::root().'\');';
			if (rseventsHelper::is16()) echo 'window.parent.SqueezeBox.close();'; else echo "window.parent.document.getElementById('sbox-window').close();";
			echo '</script>'."\n";
			die();
		}
		
		$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=locations',false), $msg);
	}
}