<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die();
jimport( 'joomla.application.component.model' );

class rseventsModelSubscriptions extends JModel
{
	var $_query;
	var $_data;
	var $_total=null;
	var $_pagination=null;
	
	function __construct()
	{	
		parent::__construct();
		$this->_buildQuery();

		$config =& JFactory::getConfig();
		// Get pagination request variables
		$limit		= JRequest::getVar('limit', $config->getValue('list_limit'), '', 'int');
		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');
		
		// In case limit has been changed, adjust it
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
		$this->setState('com_rsevents.fsubscriptions.limit', $limit);
		$this->setState('com_rsevents.fsubscriptions.limitstart', $limitstart);
	}
	
	function _buildQuery()
	{
		$mainframe 			=& JFactory::getApplication();
		$event_filter		= JRequest::getVar('rs_evn_filter',$mainframe->getUserState('com_rsevents.subscriptions.rs_evn_filter'));
		$sortOrder			= JRequest::getVar('filter_order_Dir','desc');
		$sortColumn			= JRequest::getCmd('filter_order','s.SubscriptionDate');
		$cid				= JRequest::getInt('IdEvent',0,'request');
		$state_filter		= $mainframe->getUserStateFromRequest('com_rsevents.sf', 'state_filter', '');
		$ticket_filter		= $mainframe->getUserStateFromRequest('com_rsevents.tf', 'ticket_filter', 0);
		$db	=& JFactory::getDBO();
		$sortOrder = strtolower(trim($sortOrder)) == 'asc' ? 'ASC' : 'DESC';
		
		$mainframe->setUserState('com_rsevents.subscriptions.rs_evn_filter',$event_filter);
		$mainframe->setUserState('com_rsevents.subscriptions.sortColumn',$sortColumn);
		$mainframe->setUserState('com_rsevents.subscriptions.sortOrder',$sortOrder);
		
		if($state_filter !== '') $state_filter="AND s.SubscriptionState='$state_filter'"; else $state_filter="";
		if($ticket_filter) $ticket_filter="AND st.IdTicket='$ticket_filter'"; else $ticket_filter="";
		
		$query="SELECT s.IdSubscription as RecordId, s.IdEvent , s.FirstName , s.IdUser, s.LastName , s.Email , s.SubscriptionState , s.SubscriptionDate , e.IdEvent , e.EventName , u.username 
		FROM #__rsevents_subscriptions s "
		."LEFT JOIN #__rsevents_events e ON e.IdEvent = s.IdEvent "
		."LEFT JOIN #__users u ON s.IdUser = u.id ";
		
		if($ticket_filter)
		{
			$query .= "LEFT JOIN #__rsevents_subscription_tickets st ON st.IdSubscription = s.IdSubscription ";
			$query .= "LEFT JOIN #__rsevents_tickets t ON st.IdTicket=t.IdTicket ";
		}
		
		$query .= "WHERE 1=1 AND e.IdEvent='".$cid."' $ticket_filter $state_filter";
		$query .= "ORDER BY $sortColumn $sortOrder ";
		
		$this->_query = $query;
		
		//echo $this->_query;
	}
	
	function getData()
	{
		if (empty($this->_data))
			$this->_data=$this->_getList($this->_query,$this->getState('com_rsevents.fsubscriptions.limitstart'), $this->getState('com_rsevents.fsubscriptions.limit'));
		return $this->_data;
	}
	
	function getTotal()
	{
		if (empty($this->_total))
			$this->_total = $this->_getListCount($this->_query);
		return $this->_total;
	}
	
	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('com_rsevents.fsubscriptions.limitstart'), $this->getState('com_rsevents.fsubscriptions.limit'));
		}
		return $this->_pagination;
	}
	
	function getSubscription()
	{
		$db = & JFactory::getDBO();
		$row = & JTable::getInstance('Rsevents_Subscriptions','Table');
		$cid = JRequest::getInt('cid',0,'request');
		$row->load($cid);
		$db->setQuery("SELECT st.TicketsSubscribed , t.TicketName FROM #__rsevents_subscription_tickets st LEFT JOIN #__rsevents_tickets t ON t.IdTicket=st.IdTicket WHERE IdSubscription=".$cid);
		$details = $db->loadObjectList();
		$row->tickets = $details;
		return $row;
	}
	
	function getSubscriptionUser()
	{
		$db =& JFactory::getDBO();
		$cid = JRequest::getInt('IdEvent',0,'request');
		$db->setQuery("SELECT IdUser FROM #__rsevents_events WHERE IdEvent='".$cid."'");
		$row = $db->loadResult();
		return $row;
	}
	
	function getUserSubscriptions()
	{
		$db		=& JFactory::getDBO();
		$user	=& JFactory::getUser();
		
		if($user->id != 0)
		{
			$db->setQuery("SELECT e.IdEvent , e.EventName , s.SubscriptionState , s.SubscriptionDate , s.PaymentUrl FROM #__rsevents_subscriptions s LEFT JOIN #__rsevents_events e ON e.IdEvent=s.IdEvent WHERE s.IdUser='".$user->id."'");
			$row = $db->loadObjectList();
		} else $row = '';
		
		return $row;
	}
	
	//save subscriber
	function save()
	{
		$app 			=& JFactory::getApplication();
		$db				=& JFactory::getDBO();
		$post			= JRequest::get('post',JREQUEST_ALLOWRAW);
		$cid 			= JRequest::getInt('cid');
		$row			=& JTable::getInstance('Rsevents_Subscriptions','Table');
		$idEvent 		= JRequest::getInt('IdEvent',0,'request');
		$rseventsConfig = rseventsHelper::getConfig();
		
		//get current status
		$db->setQuery("SELECT SubscriptionState FROM #__rsevents_subscriptions WHERE IdSubscription='".$cid."'");
		$SubscriptionState = $db->loadResult();
		
		$row->load($cid);
		
		if(!$row->bind($post))
			return JError::raiseWarning(500, $row->getError());
		
		$db->setQuery("SELECT EventName FROM #__rsevents_events WHERE IdEvent='".$idEvent."'");
		$eventname = $db->loadResult();
		
		$app->triggerEvent('rse_onBeforeStoreSubscriber',array(array('data'=>&$row)));
		
		if ($row->store()) 
		{
			if($post['SubscriptionState'] == 1)
			{
				$db->setQuery("SELECT t.TicketName , t.TicketPrice , st.TicketsSubscribed FROM #__rsevents_subscription_tickets st LEFT JOIN #__rsevents_tickets t ON t.IdTicket = st.IdTicket WHERE st.IdSubscription = ".$row->IdSubscription." ");
				$tickets = $db->loadObjectList();
				
				$ticketinfo = '';
				$total		= 0;
				
				if (!empty($tickets))
				{
					foreach ($tickets as $ticket)
					{
						$ticketinfo .= $ticket->TicketsSubscribed . ' '.JText::_('RSE_TICKET_SEPARATOR').' '.$ticket->TicketName. '<br />';
						
						if ($ticket->TicketPrice > 0)
							$total += ($ticket->TicketsSubscribed * $ticket->TicketPrice);
					}
				}
				
				if (!empty($row->Discount))
					$total = $total - $row->Discount;
				
				if (!empty($row->early_fee))
					$total = $total - $row->early_fee;
				
				if (!empty($row->late_fee))
					$total = $total + $row->late_fee;
				
				if (!empty($row->tax))
					$total = $total + $row->tax;
				
				if (count($tickets) == 1)
				{
					$ticketprice = $total > 0 ? number_format($total,$rseventsConfig['payment.nrdecimals'], $rseventsConfig['payment.decimal'], $rseventsConfig['payment.thousands']) . ' '.$rseventsConfig['payment.currency'] : JText::_('RSE_TICKET_FREE');
				} else $ticketprice = '';
				
				$ticketstotal = $total > 0 ? number_format($total,$rseventsConfig['payment.nrdecimals'], $rseventsConfig['payment.decimal'], $rseventsConfig['payment.thousands']) . ' '.$rseventsConfig['payment.currency'] : JText::_('RSE_TICKET_FREE');
				
				$ticketsdiscount = $row->Discount > 0 ? $row->Discount. ' '.$rseventsConfig['payment.currency'] : '';
				
				$optionals = array($ticketinfo,$ticketprice,$ticketstotal,$ticketsdiscount);
				if ($SubscriptionState != 1)
					rseventsEmails::activation($row->Email,$row->IdUser,$idEvent,$optionals,$row->IdSubscription);
			}
			$msg = JText::_( 'RSE_SUBSCRIBER_SAVE' );
		} else
			$msg = JText::_( 'RSE_SUBSCRIBER_SAVE_ERROR' );
		
		$app->triggerEvent('rse_onAfterStoreSubscriber',array(array('data'=>&$row)));
		$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=subscriptions&IdEvent='.eventsHelper::sef($idEvent,$eventname),false), $msg);
	}
	
	
	//delete subscription
	function delete()
	{
		$app		=& JFactory::getApplication();
		$db 		=& JFactory::getDBO();
		$user		=& JFactory::getUser();
		$cid 		= JRequest::getInt('cid',0,'request');
		$row 		=& JTable::getInstance('Rsevents_Subscriptions','Table');
		$idEvent	= JRequest::getInt( 'IdEvent', 0, 'request');
		$userId 	= rseventsModelSubscriptions::getSubscriptionUser();
		$row->load($cid);
		
		//get event name
		$db->setQuery("SELECT EventName FROM #__rsevents_events WHERE IdEvent = ".$idEvent);
		$eventname = $db->loadResult(); 
		
		if (rseventsHelper::is16())
			$groups = JAccess::getGroupsByUser($user->id);
		
		if($user->usertype == 'Super Administrator' || (rseventsHelper::is16() && in_array(8,$groups)) || $user->id == $userId)
		{	
			if(!$row->delete($cid)) 
				$msg = JText::_( 'RSE_SUBSCRIBER_DELETE_ERROR' );
			else
			{
				$db->setQuery("DELETE FROM #__rsevents_subscription_tickets WHERE IdSubscription=".$cid);
				$db->query();
				$msg = JText::_( 'RSE_SUBSCRIBER_DELETE1' );
			}
			$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=subscriptions&IdEvent='.eventsHelper::sef($idEvent,$eventname),false), $msg );
		} else $app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=show&cid='.eventsHelper::sef($idEvent,$eventname),false), JText::_('RSE_ACCESS_DENIED') );
	}
	
	//set status to pending
	function pending()
	{		
		$app 			=& JFactory::getApplication();
		$db 			=& JFactory::getDBO();
		$user			=& JFactory::getUser();
		$userId 		= rseventsModelSubscriptions::getSubscriptionUser();
		$cid			= JRequest::getInt( 'cid', 0, 'request');
		$idEvent		= JRequest::getInt( 'IdEvent', 0, 'request');
		
		//get event name
		$db->setQuery("SELECT EventName FROM #__rsevents_events WHERE IdEvent = ".$idEvent);
		$eventname = $db->loadResult(); 
		
		if (rseventsHelper::is16())
			$groups = JAccess::getGroupsByUser($user->id);
		
		if($user->usertype == 'Super Administrator' || (rseventsHelper::is16() && in_array(8,$groups)) || $userId == $user->id)
		{
			$state = 0;
			$db->setQuery("UPDATE #__rsevents_subscriptions SET SubscriptionState = '".$state."' WHERE IdSubscription = '". $cid ."'");
			$db->query();
			
			$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=subscriptions&IdEvent='.eventsHelper::sef($idEvent,$eventname),false) );
		} else $app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events',false) , JText::_('RSE_ACCESS_DENIED') );
	}
	
	//set status to denied
	function denied()
	{
		$app 			=& JFactory::getApplication();
		$db 			=& JFactory::getDBO();
		$user			=& JFactory::getUser();
		$userId 		= rseventsModelSubscriptions::getSubscriptionUser();
		$cid			= JRequest::getInt( 'cid', 0, 'request');
		$idEvent		= JRequest::getInt( 'IdEvent', 0, 'request');
		
		//get event name
		$db->setQuery("SELECT EventName FROM #__rsevents_events WHERE IdEvent = ".$idEvent);
		$eventname = $db->loadResult(); 
		
		if (rseventsHelper::is16())
			$groups = JAccess::getGroupsByUser($user->id);
		
		if($user->usertype == 'Super Administrator' || (rseventsHelper::is16() && in_array(8,$groups)) || $userId == $user->id)
		{
			$state = -1;
			$db->setQuery("UPDATE #__rsevents_subscriptions SET SubscriptionState = '".$state."' WHERE IdSubscription = '". $cid ."'");
			$db->query();
			
			$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=subscriptions&IdEvent='.eventsHelper::sef($idEvent,$eventname),false));
		} else $app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events',false) , JText::_('RSE_ACCESS_DENIED') );
	}
	
	//set status to accepted
	function accepted()
	{
		$app 			=& JFactory::getApplication();
		$db 			=& JFactory::getDBO();
		$user			=& JFactory::getUser();
		$userId 		= rseventsModelSubscriptions::getSubscriptionUser();
		$rseventsConfig = rseventsHelper::getConfig();
		$cid			= JRequest::getInt( 'cid', 0, 'request');
		$idEvent		= JRequest::getInt( 'IdEvent', 0, 'request');
		
		//get event name
		$db->setQuery("SELECT EventName FROM #__rsevents_events WHERE IdEvent = ".$idEvent);
		$eventname = $db->loadResult();

		if (rseventsHelper::is16())
			$groups = JAccess::getGroupsByUser($user->id);
		
		if($user->usertype == 'Super Administrator' || (rseventsHelper::is16() && in_array(8,$groups)) || $userId == $user->id)
		{
			$db->setQuery("UPDATE #__rsevents_subscriptions SET SubscriptionState = '1' WHERE IdSubscription = '". $cid ."'");
			$db->query();
			
			// Send mail if the status of the subscription is accepted
			$db->setQuery("SELECT Email, IdUser, Discount, early_fee, late_fee, tax FROM #__rsevents_subscriptions WHERE IdSubscription = '".$cid."' ");
			$subscriber = $db->loadObject();
			
			$db->setQuery("SELECT t.TicketName , t.TicketPrice , st.TicketsSubscribed FROM #__rsevents_subscription_tickets st LEFT JOIN #__rsevents_tickets t ON t.IdTicket = st.IdTicket WHERE st.IdSubscription = ".$cid." ");
			$tickets = $db->loadObjectList();
			
			$ticketinfo = '';
			$total		= 0;
			
			if (!empty($tickets))
			{
				foreach ($tickets as $ticket)
				{
					$ticketinfo .= $ticket->TicketsSubscribed . ' '.JText::_('RSE_TICKET_SEPARATOR').' '.$ticket->TicketName. '<br />';
					
					if ($ticket->TicketPrice > 0)
						$total += ($ticket->TicketsSubscribed * $ticket->TicketPrice);
				}
			}
			
			if (!empty($subscriber->Discount))
				$total = $total - $subscriber->Discount;
			
			if (!empty($subscriber->early_fee))
				$total = $total - $subscriber->early_fee;
			
			if (!empty($subscriber->late_fee))
				$total = $total + $subscriber->late_fee;
			
			if (!empty($subscriber->tax))
				$total = $total + $subscriber->tax;
			
			if (count($tickets) == 1)
			{
				$ticketprice = $total > 0 ? number_format($total,$rseventsConfig['payment.nrdecimals'], $rseventsConfig['payment.decimal'], $rseventsConfig['payment.thousands']) . ' '.$rseventsConfig['payment.currency'] : JText::_('RSE_TICKET_FREE');
			} else $ticketprice = '';
			
			$ticketstotal = $total > 0 ? number_format($total,$rseventsConfig['payment.nrdecimals'], $rseventsConfig['payment.decimal'], $rseventsConfig['payment.thousands']) . ' '.$rseventsConfig['payment.currency'] : JText::_('RSE_TICKET_FREE');
			
			$ticketsdiscount = $subscriber->Discount > 0 ? $subscriber->Discount. ' '.$rseventsConfig['payment.currency'] : '';
			
			$optionals = array($ticketinfo,$ticketprice,$ticketstotal,$ticketsdiscount);
			rseventsEmails::activation($subscriber->Email,$subscriber->IdUser,$idEvent,$optionals,$cid);

			$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=subscriptions&IdEvent='.eventsHelper::sef($idEvent,$eventname),false));
		} else $app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events',false) , JText::_('RSE_ACCESS_DENIED') );
	}
	
}