<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die();
 
jimport( 'joomla.application.component.model' );

class rseventsModelTickets extends JModel
{
	var $_query;
	var $_data;
	var $_total=null;
	var $_pagination=null;
	
	function __construct()
	{	
		$mainframe =& JFactory::getApplication();
		parent::__construct();
		$this->_buildQuery();

		// Get pagination request variables
		$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = $mainframe->getUserStateFromRequest('com_rsevents.tickets.limitstart', 'limitstart', 0, 'int');

		// In case limit has been changed, adjust it
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
		$this->setState('com_rsevents.tickets.limit', $limit);
		$this->setState('com_rsevents.tickets.limitstart', $limitstart);
	}
	
	function _buildQuery()
	{
		$cid = JRequest::getInt('cid',0);	
		$this->_query="SELECT IdTicket as RecordId, IdEvent , TicketName , TicketPrice , TicketMaxAudience , TicketDescription , ordering FROM #__rsevents_tickets WHERE IdEvent='".$cid."' ORDER BY ordering ASC";
		//echo $this->_query;
	}
	
	function getData()
	{
		if (empty($this->_data))
			$this->_data=$this->_getList($this->_query,$this->getState('com_rsevents.tickets.limitstart'), $this->getState('com_rsevents.tickets.limit'));
		return $this->_data;
	}
	
	function getTotal()
	{
		if (empty($this->_total))
			$this->_total = $this->_getListCount($this->_query);	
		return $this->_total;
	}
	
	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('com_rsevents.tickets.limitstart'), $this->getState('com_rsevents.tickets.limit'));
		}
		return $this->_pagination;
	}
	
	//get thicket details
	function getTicket()
	{
		$db =& JFactory::getDBO();
		$cid = JRequest::getInt('cid',0,'request');
		$row = & JTable::getInstance('Rsevents_Tickets','Table');
		$row->load($cid);
		return $row;
	}
	
	//get owner
	function getUserId()
	{
		$db =& JFactory::getDBO();
		$cid = JRequest::getInt('cid',0,'request');
		$idevent = JRequest::getInt('IdEvent',0,'request');
		$layout = JRequest::getCmd('layout','','request');
		
		switch ($layout)
		{
			default: $eventid = $cid; break;
			case 'edit': $eventid = $idevent; break;
			case 'coupons': $eventid = $cid; break;
			case 'editcoupon': $eventid = $idevent; break;
		}
		
		$db->setQuery("SELECT IdUser FROM #__rsevents_events WHERE IdEvent='".$eventid."'");
		$row = $db->loadResult();
		return $row;
	}
	
	//get coupons
	function getCoupons()
	{
		$db =& JFactory::getDBO();
		$cid = JRequest::getInt('cid');
		$db->setQuery("SELECT IdCupon ,IdEvent, CuponName FROM #__rsevents_cupons WHERE IdEvent = ".$cid); 	
		return $db->loadObjectList();
	}
	
	//get coupon
	function getCoupon()
	{
		$db 		=& JFactory::getDBO();
		$cid		= JRequest::getInt('cid',0);
		$idevent 	= JRequest::getInt('IdEvent',0);
		$row		=& JTable::getInstance('Rsevents_Cupons','Table');
		
		$row->load($cid);
		$row->IdEvent = $idevent;
		
		return $row;
	}
	
	
	//save ticket
	function save()
	{
		$db 		=& JFactory::getDBO();
		$app		=& JFactory::getApplication();
		$post		= JRequest::get('post');
		$idevent 	= JRequest::getInt('IdEvent','','request');		 
		$id 		= JRequest::getInt('cid');
		$row		=& JTable::getInstance('Rsevents_Tickets','Table');

		//get event name
		$db->setQuery("SELECT EventName FROM #__rsevents_events WHERE IdEvent = ".$idevent);
		$eventname = $db->loadResult();
		
		$post['TicketDescription'] = JRequest::getVar('TicketDescription', '', 'post', 'none', JREQUEST_ALLOWRAW);
		if(!$row->bind($post)) return JError::raiseWarning(500, $row->getError());
		
		if($row->TicketsPerUser == 0 || $row->TicketsPerUser == '') $row->TicketsPerUser = 1;
		if(empty($row->ordering)) $row->ordering = 9999999;
		//if ($row->TicketsPerUser > $row->TicketMaxAudience) $row->TicketsPerUser = $row->TicketMaxAudience;
		
		if ($row->store()) 
		{
			$msg = JText::_( 'RSE_TICKETS_SAVE' );
			$row->reorder();
		} else 
			$msg = JText::_( 'RSE_TICKETS_SAVE_ERROR' );
		
		$row->reorder('IdEvent='.$idevent);

		$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=tickets&cid='.eventsHelper::sef($idevent,$eventname),false), $msg);
	}
	
	//delete ticket
	function delete()
	{
		$app 		=& JFactory::getApplication();
		$db			=& JFactory::getDBO();
		$user		=& JFactory::getUser();
		$cid		= JRequest::getInt('cid');
		$idevent 	= JRequest::getInt('IdEvent',0,'request');
		
		//get the user id for obtaining the permission to delete
		$db->setQuery("SELECT EventName, IdUser FROM #__rsevents_events WHERE IdEvent='".$idevent."'");
		$details = $db->loadObject();
		
		//see if the ticket has subscribers 
		$db->setQuery("SELECT COUNT(st.IdTicket) FROM #__rsevents_subscription_tickets st LEFT JOIN #__rsevents_subscriptions s ON s.IdSubscription=st.IdSubscription WHERE st.IdTicket ='".$cid."'");
		$subscribers = $db->loadResult();
		
		if (rseventsHelper::is16())
			$groups = JAccess::getGroupsByUser($user->id);
		
		if(!empty($cid))
		{
			if($user->usertype == 'Super Administrator' || (rseventsHelper::is16() && in_array(8,$groups)) || $user->id == $details->IdUser)
			{
				if ($subscribers == 0)
				{
					$db->setQuery("DELETE FROM #__rsevents_tickets WHERE IdTicket = ".$cid);
					if ($db->query())
						$msg = JText::_( 'RSE_TICKETS_DELETE1' );
					else
						$msg = JText::_( 'RSE_TICKETS_DELETE_ERROR' );
				} else $msg = JText::_('RSE_TICKET_CONTAINS_SUBSCRIBERS');
			} else $app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=show&cid='.eventsHelper::sef($idevent,$details->EventName),false),JText::_('RSE_ACCESS_DENIED'));
		} else
			$msg = JText::_( 'RSE_TICKETS_DELETE_ERROR1' );
		
		$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=tickets&cid='.eventsHelper::sef($idevent,$details->EventName),false), $msg );
	}
	
	//save ordering
	function saveOrder()
	{
		$db			=& JFactory::getDBO();
		$app		=& JFactory::getApplication();
		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$idevent 	= JRequest::getInt('IdEvent',0,'request');
		$order		= JRequest::getVar( 'order', array (0), 'post', 'array' );

		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toInteger($order, array(0));

		$db->setQuery("SELECT EventName FROM #__rsevents_events WHERE IdEvent='".$idevent."'");
		$eventname = $db->loadResult();
		
		// Instantiate an table object
		$row = & JTable::getInstance('Rsevents_Tickets','Table');
		
		for( $i=0; $i < count($cid); $i++ )
		{
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $order[$i])
			{
				$row->ordering = $order[$i];
				if (!$row->store()) 
					return false;
			}
		}
		
		$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=tickets&cid='.eventsHelper::sef($idevent,$eventname),false), JText::_('RSE_TICKETS_ORDER_SAVE') );
	}
	
	//save coupon
	function savecoupon()
	{
		$db		=& JFactory::getDBO();
		$app 	=& JFactory::getApplication();
		$post	= JRequest::get('post');
		$row	=& JTable::getInstance('Rsevents_Cupons','Table');
		$idevent= JRequest::getInt('IdEvent',0);
		
		$db->setQuery("SELECT EventName FROM #__rsevents_events WHERE IdEvent='".$idevent."'");
		$eventname = $db->loadResult();
		
		if(!$row->bind($post))
			return JError::raiseWarning(500, $row->getError());
		
		$row->CouponStart = empty($row->CouponStart) ? 0 : strtotime($row->CouponStart); 
		$row->CouponEnd = empty($row->CouponEnd) ? 0 : strtotime($row->CouponEnd);
		
		if ($row->store())
			$msg = JText::_('RSE_COUPON_SAVE' );	
		else
			$msg = JText::_('RSE_COUPON_SAVE_ERROR' );
		
		$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=tickets&layout=coupons&cid='.eventsHelper::sef($row->IdEvent,$eventname),false), $msg);
	}
	
	
	//delete coupon
	function deletecoupon()
	{
		$db			=& JFactory::getDBO();
		$app		=& JFactory::getApplication();
		$cid		= JRequest::getInt('cid',0);
		$idevent 	= JRequest::getInt('IdEvent',0);
		
		$db->setQuery("SELECT EventName FROM #__rsevents_events WHERE IdEvent='".$idevent."'");
		$eventname = $db->loadResult();
		
		$db->setQuery("DELETE FROM #__rsevents_cupons WHERE IdCupon = '".$cid."'");
		$db->query();
		
		$app->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=tickets&layout=coupons&cid='.eventsHelper::sef($idevent,$eventname),false),JText::_('RSE_COUPON_DELETED'));
	}
	
}