<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' ); 
jimport( 'joomla.application.component.view');

require_once(JPATH_SITE.DS.'components'.DS.'com_rsevents'.DS.'models'.DS.'events.php');

class rseventsViewCalendar extends JView
{
	function display($tpl = null)
	{
		jimport('joomla.filesystem.file');
		$mainframe =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		
		JHTML::_('behavior.tooltip');
		$calendar = new RSEventsCalendar;
		
		//get page parameters
		$parameters = clone($mainframe->getParams('com_rsevents'));
		$this->assignRef('parameters', $parameters);
		
		$document =& JFactory::getDocument();
		
		if (rseventsHelper::is16())
		{
			if ($this->parameters->get('menu-meta_description'))
				$document->setDescription($this->parameters->get('menu-meta_description'));

			if ($this->parameters->get('menu-meta_keywords'))
				$document->setMetadata('keywords', $this->parameters->get('menu-meta_keywords'));

			if ($this->parameters->get('robots'))
				$document->setMetadata('robots', $this->parameters->get('robots'));
		}
		
		if (JRequest::getVar('tmpl') == 'component')
			$calendar->is_module = true;
		
		$month = JRequest::getInt('month', '0');
		$year = JRequest::getInt('year', '0');
		$calendar->setDate($month, $year);

		$params = &$mainframe->getParams();
		$order = $params->get('order','DESC');
		$this->assignRef('calendar', $calendar);
		
		$layout = JRequest::getVar('layout','','request');
		$rseventsConfig = rseventsHelper::getConfig();
		$this->assignRef('rseventsConfig',$rseventsConfig);	
		
		switch($layout)
		{
			case 'day':
				$date = strtotime(JRequest::getVar('date','','request'));
				$events = rseventsModelEvents::getEventDays($date,0,$order);
				
				$design = new EventDesign($rseventsConfig['events.layout'],$rseventsConfig['layouts.eventintro'],$events);
				$layout = $design->render();
				$this->assignRef('layout',$layout);
			break;
			
			case 'week':
				$date = JRequest::getVar('date','','request');
				$startweek = strtotime($date);
				$endweek = $startweek+(6*86400);
				$events = rseventsModelEvents::getEventDays($startweek,$endweek,$order);
				
				$design = new EventDesign($rseventsConfig['events.layout'],$rseventsConfig['layouts.eventintro'],$events);
				$layout = $design->render();
				$this->assignRef('layout',$layout);
				$this->assignRef('startdate',$date);
				$this->assignRef('enddate',date('m/d/Y',$endweek));
			break;
		}	
		parent::display($tpl);
	}
}