<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' ); 
jimport( 'joomla.application.component.view');
jimport('joomla.utilities.simplexml');
jimport('joomla.filesystem.file');

class rseventsViewEvents extends JView
{
	function display($tpl = null)
	{	
		//initialize main variables
		$mainframe =& JFactory::getApplication();
		$document = & JFactory::getDocument();
		$db = & JFactory::getDBO();
		$user =& JFactory::getUser();
		$editor =& JFactory::getEditor();
		$pathway = & $mainframe->getPathWay();
		$this->assignRef('db',$db);
		$this->assignRef('editor',$editor);
		
		$menus = &JSite::getMenu();
		$menu  = $menus->getActive();
		
		if (rseventsHelper::is16())
			$groups = JAccess::getGroupsByUser($user->id);
		
		//is the user admin?
		$isAdmin = ($user->usertype == 'Super Administrator' || (rseventsHelper::is16() && in_array(8,$groups))) ? 1 : 0;
		$this->assignRef('isAdmin',$isAdmin);
		
		//get page parameters
		$parameters = clone($mainframe->getParams('com_rsevents'));
		$this->assignRef('parameters', $parameters);
		
		//adds the main rsevents config
		$rseventsConfig = rseventsHelper::getConfig();
		$this->assignRef('rseventsConfig',$rseventsConfig);
		
		$direction = JRequest::getVar('direction');
		if(empty($direction)) $direction =  $parameters->get('order');
		
		$direction = strtolower(trim($direction)) == 'asc' ? 'asc' : 'desc';
		
		$this->assignRef('direction',$direction);
		
		if (rseventsHelper::is16())
		{
			if ($this->parameters->get('menu-meta_description'))
				$document->setDescription($this->parameters->get('menu-meta_description'));

			if ($this->parameters->get('menu-meta_keywords'))
				$document->setMetadata('keywords', $this->parameters->get('menu-meta_keywords'));

			if ($this->parameters->get('robots'))
				$document->setMetadata('robots', $this->parameters->get('robots'));
		}		
		
		//switch on layout
		$layout = JRequest::getVar('layout','','request');
		switch($layout)
		{
			case 'archive':
			case 'listmyevents':
			case 'listdaysevents':
			case 'listcategoryevents':
			case 'listlocationevents':
			case 'futureevents':
			case 'search':
			default:
			{
				//get id
				$cid = JRequest::getInt('cid',0,'request');
				
				// Get the page/component parameters
				$params = &$mainframe->getParams();
				
				//set the pathway
				if (!$menu)
					$pathway->addItem(JText::_('RSE_BC_'.strtoupper($layout)), '');
				
				//add alternate feed link
				if($rseventsConfig['enable.rss'] == 1)
				{
					$link	= '&format=feed&limitstart=';
					$attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0');
					$document->addHeadLink(JRoute::_($link.'&type=rss'), 'alternate', 'rel', $attribs);
					$attribs = array('type' => 'application/atom+xml', 'title' => 'Atom 1.0');
					$document->addHeadLink(JRoute::_($link.'&type=atom'), 'alternate', 'rel', $attribs);
				}
				
				if ($layout == 'listcategoryevents')
				{
					$catName = '';
					
					if (empty($cid))
					{
						$categs = $params->get('categories',0);
						$includechildrens = $params->get('subcategs',0);
						
						if (!empty($categs) && !$includechildrens)
						{
							$categs = explode(',',$categs);
							if (count($categs) == 1 && !empty($categs[0]))
							{
								$db->setQuery("SELECT CategoryName FROM #__rsevents_categories WHERE IdCategory = '".$categs[0]."'");
								$catName = $db->loadResult();
								$title = $document->getTitle();
								$document->setTitle($title.' - '.$catName);
							}						
						}
					} else
					{
						$db->setQuery("SELECT CategoryName FROM #__rsevents_categories WHERE IdCategory = '".$cid."'");
						$catName = $db->loadResult();
						$title = $document->getTitle();
						$document->setTitle($title.' - '.$catName);
					}
					$this->assignRef('catName',$catName);
				}
			
				
				//load data and pagination
				$events = $this->get('data');
				$pagination = $this->get('Pagination');
				
				//get parameters
				$startDate			= $params->get('startDate','01/01/1999');
				$endDate 			= $params->get('endDate','01/01/2037');
				$startTime 			= $params->get('startTime','00:00');
				$endTime 			= $params->get('endTime','00:00');
				$search_location 	= $params->get('searchloc','1');
				$archive_search 	= $params->get('enablesearch','0');
				$search_filter 		= JRequest::getVar('rse_search_archive','','request');
				$viewDesign			= $params->get('design','none');
				
				JHTML::_('behavior.tooltip'); 
				JHTML::_('behavior.modal'); 
				
				
				$eventDesign = $viewDesign == 'none' ? $rseventsConfig['events.layout'] : $viewDesign;
				$design = new EventDesign($eventDesign,$rseventsConfig['layouts.eventintro'],$events);
				$layout = $design->render();
				$this->assignRef('layout',$layout);
				
				$rss = rseventsHelper::is16() ? 'media/system/images/livemarks.png' : 'images/M_images/livemarks.png';
				$edit = rseventsHelper::is16() ? 'media/system/images/edit.png' : 'images/M_images/edit.png';
	
				$this->assignRef('search_filter',$search_filter);
				$this->assignRef('archive_search',$archive_search);
				$this->assignRef('search_location',$search_location);
				$this->assignRef('lists',$lists);
				$this->assignRef('pagination',$pagination);
				$this->assignRef('cid',$cid);
				$this->assignRef('startDate',$startDate);
				$this->assignRef('endDate',$endDate);
				$this->assignRef('startTime',$startTime);
				$this->assignRef('endTime',$endTime);
				$this->assignRef('rss',$rss);
				$this->assignRef('edit',$edit);
			} break;
			
			case 'show':
			{
				if (!$rseventsConfig['modal.type'])
				{
					$document->addCustomTag('<script type="text/javascript" src="'.JURI::root().'components/com_rsevents/assets/colorbox/jquery-1.5.1.min.js"></script>');
					$document->addCustomTag('<script type="text/javascript" src="'.JURI::root().'components/com_rsevents/assets/colorbox/jquery.colorbox-min.js"></script>');
					$document->addStyleSheet(JURI::root().'components/com_rsevents/assets/colorbox/colorbox.css');
					if ($rseventsConfig['no.conflict'])
						$document->addCustomTag('<script type="text/javascript">jQuery.noConflict();</script>');
				}	
				
				$event = $this->get('Event');
				if (($rseventsConfig['event.sharing'] && ($rseventsConfig['event.facebook.share'] || $rseventsConfig['event.facebook.like'])) || $rseventsConfig['events.commenting'] == '4')
				{
					
					if ($rseventsConfig['events.commenting'] == '4')
						$document->addScript('http://connect.facebook.net/en_US/all.js#xfbml=1');
					
					if (!empty($event->EventDescription))
					{
						$content = strip_tags($event->EventDescription);
						$content = trim(substr($content,0,255));
						$content .= ' [...]';
						$content = str_replace(array("\r","\n"),' ',$content);
						$document->addCustomTag('<meta property="og:description" content="'.$this->escape($content).'" />');
					}
					$document->addCustomTag('<meta property="og:title" content="'.trim($this->escape($event->EventName)).'" />');
					$document->addCustomTag('<meta property="og:type" content="article" />');
					
					if (!empty($event->EventIcon))
					{
						$smallicon = str_replace('.'.JFile::getExt($event->EventIcon),'_'.$rseventsConfig['event.icon.small'].'.'.JFile::getExt($event->EventIcon),$event->EventIcon);
						$document->addCustomTag('<meta property="og:image" content="'.JURI::root().'components/com_rsevents/assets/images/thumbs/'.$smallicon.'" />');
					}
					
					if ($rseventsConfig['event.facebook.share'])
						$document->addScript('http://static.ak.fbcdn.net/connect.php/js/FB.Share');
				}
				
				if ($event->designtype)
					eventsHelper::showEvent();
				else
				{
					//get private url
					$privateUrl = JRequest::getCmd('privateUrl','','request');
					
					if (rseventsHelper::is16()) $groups = JAccess::getGroupsByUser($user->id);
					
					//Is event viewable (public=1 OR (private=0 AND (PrivateUrl == EventPrivateUrl OR I'm the event owner)) check)
					$EventPublicPrivate = ($event->EventType || (!$event->EventType && ($privateUrl == $event->EventPrivateUrl || $event->IdUser == $user->id))) ? 1:0;
					
					//If IdEvent exists AND (Event is published OR (Event is unpublished AND I am the owner)) AND Event is public/private viewable
					if($event->IdEvent != 0 && ($event->published || (!$event->published && ($event->IdUser == $user->id || $user->usertype =='Super Administrator')) || (!$event->published && ($event->IdUser == $user->id || (rseventsHelper::is16() && in_array(8,$groups)))) ) && $EventPublicPrivate)
					{					
						$theme = new RseventsTheme($event->IdTheme,$event);
						$layout = $theme->render();
						
						//set pathway
						$pathway->addItem($event->EventName, rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=show&cid='.eventsHelper::sef($event->IdEvent,$event->EventName),false,JRequest::getInt('Itemid')));
						
						//set the page title and metas
						$document->setTitle($document->getTitle().' - '.$event->EventName);
						if (trim($event->EventPageTitle) != '')
						{
							$event->EventPageTitle = str_replace('{eventname}',$event->EventName,$event->EventPageTitle);
							$document->setTitle($event->EventPageTitle);
						}
						
						if(trim($event->EventKeywords) !='') $document->setMetaData('keywords',$event->EventKeywords);
						if(trim($event->EventMetaDescription) !='') $document->setDescription($event->EventMetaDescription);
						
						$this->assignRef('layout',$layout);
						$this->assignRef('data',$event);
					} else $mainframe->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events',false),JText::_('RSE_EVENT_INVALID'));
				}
				
			} break;
			
			case 'addeditevent':
			case 'duplicateevent':
			{
				JHTML::_('behavior.tooltip');
				JHTML::_('behavior.modal');
				
				//get the id of the event , the task and the page
				$cid  = JRequest::getInt('cid',0,'request');
				$task = JRequest::getVar('task','','request');
				
				//get the event details
				$event = $this->get('Event');
				
				if ($event->designtype)
					JError::raiseNotice('200',JText::_('RSE_EVENT_DESIGN_NOTICE'));
				
				//set http:// for the event link
				if(empty($event->EventURL) && $event->IdEvent == 0) $event->EventURL = 'http://';
				
				//set pathway
				if($task == 'duplicateevent') 
					$pathway->addItem(JText::_('RSE_BC_DUPLICATE'), ''); 
				else
				{
					if (!$menu)
						$pathway->addItem(JText::_('RSE_BC_ADDEDIT'), '');
				}
				
				//get permissions
				$permissions = $this->get('Permissions');
				$locationPermission = @$permissions['allowLocations'];
				$eventPermission = @$permissions['enablePosts'];
				$canEdit = @$permissions['canEdit'];
				
				if($task == 'duplicateevent')
				{
					$event->IdEvent = 0;
					$event->EventName = JText::_('RSE_COPY_OF').' '.$event->EventName;
					$event->EventAlias = JText::_('RSE_COPY_OF').' '.$event->EventName;
				}
				
				//get files and extras
				$files =  eventsHelper::getFiles();
				$extras = eventsHelper::getExtras();
				
				//IF ( I am the Administrator OR (Event Exists AND You have permission for editing) OR You are the OWNER )
				if ($isAdmin || (empty($event->IdEvent) && $eventPermission == 1 ) || (!empty($event->IdEvent) && $canEdit == 1) || ($user->id === $event->IdUser) || $eventPermission == 1) 
				{ 
					
					//do we have payment on this event?
					$db->setQuery("SELECT SUM(TicketPrice) as Price, COUNT(*) as Cnt FROM `#__rsevents_tickets` WHERE `IdEvent` = '".$cid."'");
					$ticketProperties = $db->loadObject();
				
					$pieces = array(16=>16,17=>17,18=>18,19=>19,20=>20,26=>26);
					if(!$ticketProperties->Price) 
					{
						unset($pieces[20]);
						unset($pieces[26]);
						if($ticketProperties->Cnt == 1) unset($pieces[19]);
					}
					
					if (file_exists(JPATH_SITE.DS.'components'.DS.'com_rsform'.DS.'rsform.php'))
					{
						$db->setQuery("SELECT DISTINCT f.FormId ,f.FormName FROM #__rsform_forms f WHERE f.Published = 1 ORDER BY FormId DESC");
						$forms = $db->loadObjectList();
					}
					
					$flist[]         = JHTML::_('select.option',  '0', JText::_( 'RSE_DEFAULT_FORM' ), 'FormId', 'FormName' );
					
					if (file_exists(JPATH_SITE.DS.'components'.DS.'com_rsform'.DS.'rsform.php'))
					{
						if(!empty($forms))
							foreach($forms as $i=>$form)
							{
								//Check what items does it have
								$db->setQuery("SELECT COUNT(*) Cnt FROM #__rsform_components WHERE FormId = '".$form->FormId."' AND Published=1 AND ComponentTypeId IN ('".implode("','",$pieces)."')");

								if(count($pieces)!=$db->loadResult()) 
								{
									$forms[$i]->disable = true;
									$forms[$i]->FormName .= ' ('.JText::_('RSE_ADD_RSEVENTS_COMPONENTS').')';
								}
								
							}
						if(!empty($forms))
						$flist = array_merge($flist , $forms);
					}
					
					$lists['forms']      = JHTML::_('select.genericlist', $flist, 'EventRegistrationForm', 'class="inputbox" size="1"','FormId', 'FormName', empty($event->EventRegistrationForm) ? $rseventsConfig['event.registration.form'] : $event->EventRegistrationForm);
					
					
					// set default permission to the files	
					$on = JURI::root().'administrator/components/com_rsevents/assets/images/icons/tick.png';
					$off = JURI::root().'administrator/components/com_rsevents/assets/images/icons/delete.png';
						if(!empty($files))
						foreach($files as $i=>$file)
						{
							if(empty($file->FilePermission))
							$file->FilePermission = '111111';
							
							$files[$i]->fp0 = ($file->FilePermission[0]==0 ? '<img src="'.$off.'">' : '<img src="'.$on.'">');		
							$files[$i]->fp1 = ($file->FilePermission[1]==0 ? '<img src="'.$off.'">' : '<img src="'.$on.'">');		
							$files[$i]->fp2 = ($file->FilePermission[2]==0 ? '<img src="'.$off.'">' : '<img src="'.$on.'">');			
							$files[$i]->fp3 = ($file->FilePermission[3]==0 ? '<img src="'.$off.'">' : '<img src="'.$on.'">');			
							$files[$i]->fp4 = ($file->FilePermission[4]==0 ? '<img src="'.$off.'">' : '<img src="'.$on.'">');			
							$files[$i]->fp5 = ($file->FilePermission[5]==0 ? '<img src="'.$off.'">' : '<img src="'.$on.'">');					
						}
					
					//prepare the category dropdown
					if($task == 'duplicateevent')
						$db->setQuery("SELECT IdCategory FROM #__rsevents_events_cat WHERE IdEvent = ".$cid);
					else
						$db->setQuery("SELECT IdCategory FROM #__rsevents_events_cat WHERE IdEvent = ".$event->IdEvent);
					$categ_selected = $db->loadResultArray();
					
					
					$db->setQuery("SELECT IdCategory,CategoryName FROM #__rsevents_categories WHERE published = 1 ORDER BY CategoryName ASC");
					$categoryNumber = count($db->loadObjectList());
					$res =$db->loadObjectList();
					if($categoryNumber == 1) $idCat = $res[0]->IdCategory; else $idCat='';
					
					$default = JHTML::_('select.option',  '0', JText::_( 'RSE_EVENT_SELECT_CATEGORY' ), 'value', 'text' );
					$lists['categories'] = rseventsHelper::getCategories('IdCategory[]','class="inputbox" size="7" multiple="multiple" style="vertical-align:middle;"',empty($categ_selected) ? 0 : $categ_selected,$default);
				
					//prepare the location dropdown
					$db->setQuery("SELECT IdLocation,LocationName FROM #__rsevents_locations WHERE published = 1 ORDER BY LocationName ASC");
					$locationsList = $db->loadObjectList();
					$loclist[]         = JHTML::_('select.option',  '0', JText::_( 'RSE_EVENT_SELECT_LOCATION' ), 'IdLocation', 'LocationName' );
					$loclist         = array_merge( $loclist,$locationsList  );
					$lists['locations']      = JHTML::_('select.genericlist', $loclist, 'IdLocation', 'class="inputbox" size="1"','IdLocation', 'LocationName', intval( $event->IdLocation ) );
					
					$db->setQuery("SELECT IdDesign,DesignName FROM #__rsevents_designs WHERE designtype = 0");
					if ($event->designtype)
						$designs[]				= JHTML::_('select.option',  '0', JText::_( 'RSE_EVENT_OLD_DESIGN_OPTION' ), 'IdDesign', 'DesignName' );
					else
						$designs[]				= JHTML::_('select.option',  '0', JText::_( 'RSE_EVENT_SELECT_DESIGN' ), 'IdDesign', 'DesignName' );
					$designs				= array_merge( $designs, $db->loadObjectList() );
					$lists['designs']      = JHTML::_('select.genericlist', $designs, 'IdNewDesign', 'class="inputbox" size="1"','IdDesign', 'DesignName', intval( $event->IdNewDesign ) );
					
					$db->setQuery("SELECT id,name FROM #__rsevents_themes");
					$lists['themes']		= JHTML::_('select.genericlist', $db->loadObjectList(), 'IdTheme', 'class="inputbox" size="1"','id', 'name', intval( $event->IdTheme ) );
					
					$selectedp = !empty($event->payments) ? explode(',',$event->payments) : '';
					$payments = rseventsHelper::getPayments();
					$lists['payments']		= JHTML::_('select.genericlist', $payments, 'payments[]', 'class="inputbox" size="5" multiple="multiple"','value', 'text', $selectedp);
					
					$lists['early_discount'] = JHTML::_('select.booleanlist','early_discount_type','class="inputbox"',$event->early_discount_type,JText::_('RSE_VALUE'),JText::_('RSE_PERCENTAGE'));
					$lists['late_fee'] = JHTML::_('select.booleanlist','late_fee_type','class="inputbox"',$event->late_fee_type,JText::_('RSE_VALUE'),JText::_('RSE_PERCENTAGE'));
					
					$this->assignRef('data',$event);
					$this->assignRef('extras',$extras);
					$this->assignRef('isAdmin',$isAdmin);
					$this->assignRef('files',$files);
					$this->assignRef('lists',$lists);
					$this->assignRef('numCat',$categoryNumber);
					$this->assignRef('idCat',$idCat);
					$this->assignRef('locationPermission',$locationPermission);
					$this->assignRef('eventPermission',$eventPermission);
					$this->assignRef('userid',$user->id);
					$this->assignRef('locationsList',$locationsList);
				} else 
					$mainframe->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events',false),JText::_('RSE_ACCESS_DENIED'));
				
			} break;
			
			case 'printevent':
			{
				jimport('joomla.html.parameter');
				$dispatcher = &JDispatcher::getInstance();
				JPluginHelper::importPlugin ('content');
				$event = $this->get('Event');
				$params = &$mainframe->getParams();
				$limitstart = 0;
				
				$object = new stdClass();
				$eventdescription = $event->EventDescription;
				$object->text = $eventdescription;

				if (!rseventsHelper::is16())
					$dispatcher->trigger ( 'onPrepareContent', array (&$object, &$params, $limitstart ) );
				else
					$dispatcher->trigger ( 'onContentPrepare', array ($eventdescription,&$object, &$params, $limitstart ));
				$eventdescription = $object->text;
				
				$this->assignRef('data',$event);
				$this->assignRef('eventdescription',$eventdescription);
			} break;

			case 'guestssendmessage':
			{
				JRequest::setVar('tmpl','component');
				//get event details
				$event = $this->get('Event');
				
				if ($user->usertype == 'Super Administrator' || (rseventsHelper::is16() && in_array(8,$groups)) || $user->id == $event->IdUser)
				{
					$this->assignRef('data',$event);
				} else 
				{
					echo eventsHelper::setMessage(JText::_('RSE_ACCESS_DENIED'));
					return;
				}
				$pathway->addItem(JText::_('RSE_BC_SENDMESSAGE'), '');
				
			} break;
			
			case 'invite':
			{
				JRequest::setVar('tmpl','component');
				$event = $this->get('Event');
				$pathway->addItem(JText::_('RSE_BC_INVITE'), '');	
				$importedContacts = JRequest::getVar('importedContacts',array(),'post');
				$this->assignRef('importedContacts',implode(',',$importedContacts));
				$this->assignRef('data',$event);
			} break;
			
			case 'photos':
			{
				JRequest::setVar('tmpl','component');
				$cid = JRequest::getInt('cid',0,'request');
				$event = $this->get('Event');
				if($rseventsConfig['events.extras.flickr'])
					$this->assignRef('data',$event);
				else
				{
					echo eventsHelper::setMessage(JText::_('RSE_ACCESS_DENIED'));
					return;
				}
			} break;
			
			case 'youtube':
			case 'flash':
			case 'mp3':
			case 'chat':
			case 'flickr':
			{
				$cid = JRequest::getInt('IdEvent',0,'request');
				$event = $this->get('Event');
				
				if($user->usertype == 'Super Administrator' || (rseventsHelper::is16() && in_array(8,$groups)) || $user->id == $event->IdUser )
				{
					$data = eventsHelper::getExtra();
					$this->assignRef('data',$data);
				} else $mainframe->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=show&cid='.eventsHelper::sef($event->IdEvent,$event->EventName),false),JText::_('RSE_ACCESS_DENIED'));
			} break;
			
			case 'subscribe':
			{
				JRequest::setVar('tmpl','component');
				$pathway->addItem(JText::_('RSE_BC_SUBSCRIBE'), '');
				
				$cid = JRequest::getInt('cid',0,'request');
				$privateUrl = JRequest::getCmd('privateUrl','','request');
				$post = JRequest::get('post');
				
				//load the event
				$event =  $this->get('Event');
				$this->assignRef('data',$event);
				
				//if the event end date passed we do not want any new registration
				if (time() > $event->EventEndDate)
				{
					echo eventsHelper::setMessage(JText::_('RSE_EVENT_REGISTRATION_EXPIRED'));
					return;
				}
				
				$show = true;
				if (!empty($event->EventStartRegistration) && !empty($event->EventEndRegistration))
				{
					if ($event->EventStartRegistration <= time() && $event->EventEndRegistration >= time() || $event->EventStartRegistration >= time() && $event->EventEndRegistration <= time())
						$show = true;
					else $show = false;
					
				} elseif (empty($event->EventStartRegistration) && !empty($event->EventEndRegistration))
				{
					if ($event->EventEndRegistration >= time())
						$show = true;
					else $show = false;
					
				} elseif (!empty($event->EventStartRegistration) && empty($event->EventEndRegistration))
				{
					if ($event->EventStartRegistration <= time())
						$show = true;
					else $show = false;
					
				} elseif (empty($event->EventStartRegistration) && empty($event->EventEndRegistration))
				{
					$show = true;
				}
				
				$permissions = $this->get('Permissions');
				$cansubscribe = isset($permissions['allowRegistration']) ? $permissions['allowRegistration'] : 0;
				
				if (!$cansubscribe) $show = false;
				
				if (!$show) 
				{
					echo eventsHelper::setMessage(JText::_('RSE_EVENT_NO_REGISTRATION'));
					return;
				}
				
				//populate the First Name and the Last Name				
				$info = $user->name;
				$name = explode(' ',$info);
				$firstname = isset($name[0]) ? $name[0] : '';
				$lastname = ''; 
				if (count($name) > 1)
				{
					unset($name[0]);
					$lastname = implode(' ',$name);
				}
				$email = $user->email;
				
				$this->assignRef('fName',$firstname);	
				$this->assignRef('lName',$lastname);	
				$this->assignRef('Email',$email);	
					
				//see if the user is allready registered at this event
				$isRegistered = $this->get('Subscriber');
				
				$session = JFactory::getSession();
				if ($session->get('rsevents.redirect'.$event->IdEvent))
				{
				   $isRegistered = 0;
				   $session->clear('rsevents.redirect'.$event->IdEvent);
				}
				
				if($isRegistered && $rseventsConfig['event.multiple.reg']==0)
				{
					echo eventsHelper::setMessage(JText::_('RSE_EVENT_ALLREADY_REGISTERED'));
					return;
				}
				
				// IF the event allows registration AND ( Event is public OR (Event is private AND privateURL == EventPrivateUrl) )
				if($event->EventEnableRegistration && ( $event->EventType || (!$event->EventType && $privateUrl == $event->EventPrivateUrl)))
				{
					if($rseventsConfig['event.redirect.registration']==0 && $user->id == 0)
					{ 
						if($rseventsConfig['event.enable.guests'] == 0)
						if ($rseventsConfig['cb.redirect'] == 1 && file_exists(JPATH_SITE.DS.'components'.DS.'com_comprofiler'.DS.'comprofiler.php'))
						{
							echo eventsHelper::setMessage(JText::_('RSE_REDIRECTING'),1,rseventsHelper::route('index.php?option=com_comprofiler&task=registers',false));
							return;
						}
						else
						{
							if (rseventsHelper::is16())
							{
								echo eventsHelper::setMessage(JText::_('RSE_REDIRECTING'),1,rseventsHelper::route('index.php?option=com_users&view=registration',false));
								return;
							}
							else
							{
								echo eventsHelper::setMessage(JText::_('RSE_REDIRECTING'),1,rseventsHelper::route('index.php?option=com_user&task=register',false));
								return;
							}
						}
					}

					$formids = array();					
					//Trigger Event - rse_f_onAfterLoadRegistrationForm
					$mainframe->triggerEvent('rse_f_onAfterLoadRegistrationForm',array(array('formids'=>&$formids,'event'=>&$event)));
					
					//get a list of all tickets
					$db->setQuery("SELECT IdTicket,  TicketName, TicketPrice, TicketMaxAudience, TicketDescription FROM #__rsevents_tickets WHERE IdEvent='".$cid."' ORDER BY ordering ASC");
					$tickets =  $db->loadObjectList();
					$ticketcounter = count($tickets);
					
					//if the event has no tickets than we redirect the user
					if ($ticketcounter <= 0)
					{
						echo eventsHelper::setMessage(JText::_('RSE_EVENT_NO_TICKETS'));
						return;
					}
					
					//prepare tickets 
					if ($event->EventOverbooking == 0)
					{
						foreach ($tickets as $i => $ticket)
						{
							$db->setQuery("SELECT SUM(st.TicketsSubscribed) FROM #__rsevents_subscription_tickets st LEFT JOIN #__rsevents_subscriptions s ON s.IdSubscription=st.IdSubscription WHERE st.IdTicket='".$ticket->IdTicket."' AND s.SubscriptionState IN (1,0)");
							$numberoftickets = $db->loadResult();
							
							if ($ticket->TicketMaxAudience > 0 && $numberoftickets >= $ticket->TicketMaxAudience) unset($tickets[$i]);
						}
					}
					
					//if the tickets are fully booked set the full booking message
					if ($session->get('rsevents.redirect.rsformpro'.$cid) == 0)
					{
						if (empty($tickets) && $ticketcounter > 0 && $event->EventOverbooking == 0)
						{
							echo eventsHelper::setMessage(JText::_($rseventsConfig['event.full.booking']));
							return;
						}
					} else $session->clear('rsevents.redirect.rsformpro'.$cid);
					
					//create variables
					$ticketdescriptions = '';
					$ticketslist = array();
					
					$showForm = false;
					
					//create tickets
					foreach ($tickets as $i => $ticket)
					{
						if ($ticket->TicketPrice > 0) $showForm = true;
						
						$object = new stdClass();
						if ($ticket->TicketPrice == '0')
							$object->text = $ticket->TicketName . ' ' . JText::_('RSE_TICKETS_FREE').' ';
						else 
							$object->text = $ticket->TicketName . ' (' . number_format($ticket->TicketPrice,$rseventsConfig['payment.nrdecimals'], $rseventsConfig['payment.decimal'], $rseventsConfig['payment.thousands']).' '.$rseventsConfig['payment.currency'].')';
						$object->value = $ticket->IdTicket;
						$ticketslist[] = $object;
						$ticketdescriptions .= '<div id="rsevents_ticket_'.$ticket->IdTicket.'" style="display:'.($i==0 ? 'inline':'none').';">'.$ticket->TicketDescription.'</div>';
					}
					
					$lists['tickets']  = JHTML::_('select.genericlist', $ticketslist, 'IdTicket', 'class="inputbox" size="1" onchange="rse_hidePayment(this.value,0);rse_change_ticket(this.value);"','value', 'text');
					
					$payment_items = rseventsHelper::getPayments(false,$event->payments);
					
					if ($rseventsConfig['payment.type'])
						$lists['payments']      = JHTML::_('select.genericlist', $payment_items, 'payment', 'class="inputbox"', 'value' ,'text',$rseventsConfig['payment.default']);
					else
						$lists['payments']      = JHTML::_('select.radiolist', $payment_items, 'payment', 'class="inputbox"', 'value' ,'text',$rseventsConfig['payment.default']);
					
					//if all the tickets have the price 0 we will not show the payment options
					$this->assignRef('showForm',$showForm);
					
					//check for coupons
					$db->setQuery("SELECT COUNT(IdCupon) FROM #__rsevents_cupons WHERE IdEvent = '".$event->IdEvent."' ");
					$coupons = $db->loadResult();
					
					
					$this->assignRef('lists',$lists);
					$this->assignRef('formids',$formids);
					$this->assignRef('ticketList',$ticketslist);
					$this->assignRef('ticket_descriptions',$ticketdescriptions);
					$this->assignRef('coupons',$coupons);
				} else
				{
					echo eventsHelper::setMessage(JText::_('RSE_ACCESS_DENIED'),1,rseventsHelper::route('index.php?option=com_rsevents',false));
					return;
				}
			} break;
			
			case 'importyahoo':
			{
				$cid = JRequest::getInt('cid');
				if(extension_loaded('curl'))
				{
					JRequest::setVar('tmpl','component');
					$event = $this->get('Event');
					$this->assignRef('data',$event);
					rseventsHelper::importyahoo();
				} else $mainframe->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=invite&cid='.$cid,false),JText::_('RSE_NO_CURL'));
			}
			break;

			case 'importgmail':
			{				
				$cid = JRequest::getInt('cid');
				if(extension_loaded('curl'))
				{
					JRequest::setVar('tmpl','component');
					$event = $this->get('Event');
					$this->assignRef('data',$event);
					rseventsHelper::importgmail();
				} else $mainframe->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=invite&cid='.$cid,false),JText::_('RSE_NO_CURL'));
			}	break;
				
			case 'album':
			{
				$extras = eventsHelper::getExtraPhotos();
				if($rseventsConfig['events.extras.flickr'] && !empty($extras->ExtraValue))
				$this->assignRef('data',$extras);
				else $mainframe->redirect(rseventsHelper::route('index.php?option=com_rsevents',false));
			}	break;
				
			case 'wire':
			{
				jimport('joomla.html.parameter');
				$cid = JRequest::getInt('cid',0,'request');
				$pid = JRequest::getInt('pid',0,'request');
				
				$wire = $this->get('WireDetails');
				$wire_details = $wire->details;
				$tax_value = $wire->tax_value;
				$tax_type = $wire->tax_type;
				
				$db->setQuery("SELECT EventName FROM #__rsevents_events WHERE IdEvent = ".$cid." ");
				$eventname = $db->loadResult();
				
				$this->assignRef('redirect',$wire->redirect);
				$this->assignRef('details',$wire);
				$this->assignRef('wireDetails',$wire_details);
				$this->assignRef('tax_type',$tax_type);
				$this->assignRef('tax_value',$tax_value);
				$this->assignRef('cid',$cid);
				$this->assignRef('eventname',$eventname);
			} break;
			
			case 'repeat':
			{
				JRequest::setVar('tmpl','component');
				//get event details
				$event = $this->get('Event');
				
				if($event->IdParent != 0 || $event->IdParent == '' )
				{
					echo eventsHelper::setMessage(JText::_('RSE_REPEAT_ERROR1'));
					return;
				}
				
				if ($user->usertype == 'Super Administrator' || (rseventsHelper::is16() && in_array(8,$groups)) || $user->id == $event->IdUser)
				{					
					$type[] = JHTML::_('select.option', '1', JText::_( 'RSE_REPEAT_TYPE_DAYS' ) );
					$type[] = JHTML::_('select.option', '2', JText::_( 'RSE_REPEAT_TYPE_WEEKS' ) );
					$type[] = JHTML::_('select.option', '3', JText::_( 'RSE_REPEAT_TYPE_MONTHS' ) );
					$type[] = JHTML::_('select.option', '4', JText::_( 'RSE_REPEAT_TYPE_YEARS' ) );
					$lists['type'] = JHTML::_('select.radiolist', $type, 'EventRepeatType', 'size="1" class="inputbox" onclick="rse_set_type(this.value)"', 'value', 'text',empty($event->EventRepeatType) ? 1 : $event->EventRepeatType);
					
					$db->setQuery("SELECT EventRepeatAlso FROM #__rsevents_events WHERE IdEvent='".$event->IdEvent."'");
					$repeats = $db->loadResult();

					
					$repeatAlso = array();
					$getSelected = array();
					if (!empty($repeats))
					{
						$dates = unserialize($repeats);
						foreach($dates as $date)
						{
							$date = date('Y-m-d',$date);
							$repeatAlso[] = JHTML::_('select.option', $date, $date);
							$getSelected[] = $date;
						}
					}
					
					$lists['repeatalso'] = JHTML::_('select.genericlist', $repeatAlso, 'EventRepeatAlso[]', 'size="10" class="inputbox" multiple="multiple"', 'value', 'text', $getSelected );
					
					$repeatdays = empty($event->EventRepeatDays) ? array() : unserialize($event->EventRepeatDays);
					
					$this->assignRef('lists',$lists);
					$this->assignRef('repeatdays',$repeatdays);
					$this->assignRef('data',$event);
					
				} else  
				{
					echo eventsHelper::setMessage(JText::_('RSE_ACCESS_DENIED'));
					return;
				}
				$pathway->addItem(JText::_('RSE_BC_REPEAT'), '');
				
			} break;
			
			case 'map':
				if($rseventsConfig['locations.gmaps'] == 1 && !empty($rseventsConfig['locations.gMaps.key']))
				{
					JHTML::script('maps?file=api&amp;v&amp;sensor=false=2&amp;key='.$rseventsConfig['locations.gMaps.key'],'http://maps.google.com/',false);
					$this->assignRef('data',$this->get('MapEvents'));
				}
			break;
			
		}
		parent::display($tpl);
	}
	
	function getPhotos($idExtra, $extraValue)
	{
		//get the config
		$rseventsConfig = rseventsHelper::getConfig();
		
		if($rseventsConfig['events.extras.flickr'])
		{
			//Get rid of the trailing slash
			$extraValue = trim($extraValue);
			$data = explode('/',$extraValue);
			$latest = strlen($extraValue)-1;
			if($extraValue[$latest] == '/') $extraValue = substr($extraValue,0,$latest);
			
			//Get the photosetid
			$photosetid = end(explode('/',$extraValue));
	
			//Get the username
			$usernameid = $data[4];
			
			//Get the api key
			$api_key = $rseventsConfig['flikr.key'];
			
			//Get from rseventsConfig the number of photos
			$photos = $rseventsConfig['flikr.num.photos'];
			if($photos == 0 || $photos == '') $photos = '3';
			
			//Load photos TODO (get xml)
			$xml = new JSimpleXML();
			$file = "http://api.flickr.com/services/rest/?method=flickr.photosets.getPhotos&api_key=" . $api_key . "&photoset_id=" . $photosetid . "&per_page=" . $photos . "&page=1";
			
			//Try getting the xml
			$xml_string = rseventsHelper::fopen($file);
			
			if($xml_string)
			{
				$xml->loadString($xml_string);
				//if the user doesnt input the flickr api key
				
				if (isset($xml->document->err[0]) && $xml->document->err[0]->attributes('code') == 100)
				{
					JError::raiseNotice(200,$xml->document->err[0]->attributes('msg'));
					return '';
				}
				
				if($rseventsConfig['flikr.key'] != '')
				{	
					//Get the total number of photos
					$total = $xml->document->photoset[0]->attributes('total');
					
					$result = '';
					for ($k = 0; $k < $photos; $k++) 
					{
						if (empty($xml->document->photoset[0]->photo[$k])) continue;
						$photo = $xml->document->photoset[0]->photo[$k];
						$id = $photo->attributes('id');
						if (!empty($id))
						{
							$result .= '<li><a href="http://www.flickr.com/photos/'.$usernameid.'/'.$photo->attributes('id').'" target="_blank">
									<img src="http://farm'.$photo->attributes('farm').'.static.flickr.com/'.$photo->attributes('server').'/'.$photo->attributes('id').'_'.$photo->attributes('secret').'_s.jpg">
								</a></li>';
						}
					}
					$result .= '<li><a href="'.rseventsHelper::route('index.php?option=com_rsevents&view=events&layout=album&cid='.$idExtra,false).'" target="_blank">'.JText::_('RSE_MORE').'</a></li>';

					return $result;
				}
			}
			else{
				return JText::_('RSE_EXTRA_FLICKR_FOPEN_ERROR');
			}
		}
		return '';		
	}
	

	function rsform($formId)
	{
		if(file_exists(JPATH_SITE.DS.'components'.DS.'com_rsform'.DS.'rsform.php'))
		{
			$lang = JFactory::getLanguage();
			$lang->load('com_rsform',JPATH_SITE);
			require_once(JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_rsform'.DS.'helpers'.DS.'rsform.php');
			$output = RSFormProHelper::displayForm($formId);
		} else $output = '';

		return $output;
	}

	function close()
	{
		$config = rseventsHelper::getConfig();
		
		if (!$config['modal.type'])
			$close = 'window.parent.jQuery.colorbox.close();';
		else 
		{
			if (rseventsHelper::is16())
				$close = 'window.parent.SqueezeBox.close();';
			else $close = "window.parent.document.getElementById('sbox-window').close();";
		}
		
		return $close;
	}

	function showSearch()
	{
		$mainframe =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		
		// Get the page/component configuration
		$params = &$mainframe->getParams();
		
		//search variables
		$show_search = $params->get('enablesearch',0);
		$show_categ = $params->get('showcateg',0);
		$show_loc = $params->get('showloc',0);
		$filter = JRequest::getVar('rse_filter','','request');
		$category_filter 	= JRequest::getVar('cat_filter','','request');
		$location_filter 	= JRequest::getVar('loc_filter','','request');
		
		if ($show_search == 0) return '';
		
		//get categories for the category filter
		$default = JHTML::_('select.option',  '0', JText::_( 'RSE_EVENT_SELECT_CATEGORY' ), 'value', 'text' );
		$categories = rseventsHelper::getCategories('cat_filter','class="inputbox" size="1"',$category_filter,$default);
		
		//get locations fot the location filter
		$db->setQuery("SELECT IdLocation, LocationName  FROM #__rsevents_locations");
		$loclist[]         = JHTML::_('select.option',  '0', JText::_( 'RSE_EVENT_SELECT_LOCATION' ), 'IdLocation', 'LocationName' );
		$loclist         = array_merge( $loclist, $db->loadObjectList() );
		$locations      = JHTML::_('select.genericlist', $loclist, 'loc_filter', 'size="1"','IdLocation', 'LocationName', $location_filter  );
		
		$html = '';
		
		if ($show_search == 1) 
		{
			$html .='
				<div style="text-align:center;">
				<form method="post" action="">
				<input type="text" id="rse_filter" name="rse_filter" onclick="this.select();" value="'.htmlentities($filter, ENT_COMPAT, 'utf-8').'"/>'; 
		if ($show_categ == 1)
			$html .= ' '.$categories;
		if ($show_loc == 1) 
			$html .= ' '.$locations;
			
			$html .= '<button type="submit">'.JText::_('RSE_SEARCH').'</button>
					</form>
					</div><br/>';
		}
		
		return $html;
	}

}