<?php
/**
* @version 1.2.0
* @package RSEvents! 1.2.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' ); 
jimport( 'joomla.application.component.view');

class rseventsViewlocations extends JView
{
	function display($tpl = null)
	{
		$db = & JFactory::getDBO();
		$user = & JFactory::getUser();
		$mainframe =& JFactory::getApplication();
		$rseventsConfig = rseventsHelper::getConfig();
		$this->assignRef('rseventsConfig',$rseventsConfig);
		$pathway 	=& $mainframe->getPathWay();
		$editor		=& JFactory::getEditor();
		$document	=& JFactory::getDocument();
		$this->assignRef('editor',$editor);
		
		$menus = &JSite::getMenu();
		$menu  = $menus->getActive();
		
		if (rseventsHelper::is16())
			$groups = JAccess::getGroupsByUser($user->id);
		
		//get page parameters
		$parameters = clone($mainframe->getParams('com_rsevents'));
		$this->assignRef('parameters', $parameters);
		
		if (rseventsHelper::is16())
		{
			if ($this->parameters->get('menu-meta_description'))
				$document->setDescription($this->parameters->get('menu-meta_description'));

			if ($this->parameters->get('menu-meta_keywords'))
				$document->setMetadata('keywords', $this->parameters->get('menu-meta_keywords'));

			if ($this->parameters->get('robots'))
				$document->setMetadata('robots', $this->parameters->get('robots'));
		}
		
		
		$layout=JRequest::getVar('layout','','request');
		switch($layout)
		{
			default:
			{				
				if (!$menu)
					$pathway->addItem(JText::_('RSE_BC_LISTLOCATIONS'), '');
				$data		= $this->get('data');
				$pagination	= $this->get('pagination');
				
				//get permission for creating a new location
				$permissions = rseventsModelEvents::getPermissions();
				
				$this->assignRef('data',$data);
				$this->assignRef('pagination',$pagination);
				$this->assignRef('permissions',$permissions);
			} break;
			
			case 'addeditlocation':
			{
				$cid = JRequest::getInt('cid',0);
				$isModal = JRequest::getVar('tmpl') == 'component';
				$this->assignRef('ismodal',$isModal);
				
				//get permission for creating a new location
				$permissions = rseventsModelEvents::getPermissions();
				
				$canedit = isset($permissions['enableEditLocation']) ? $permissions['enableEditLocation'] : 0;
				$cancreate = isset($permissions['allowLocations']) ? $permissions['allowLocations'] : 0;
				
				
				if ($cid && !$canedit && (rseventsHelper::is16() ? !in_array(8,$groups) : $user->usertype != 'Super Administrator'))
					$mainframe->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=locations',false),JText::_('RSE_LOCATION_NO_PERMISSION_EDIT'));
				
				if($cancreate || $user->usertype == "Super Administrator" || (rseventsHelper::is16() && in_array(8,$groups)) || $canedit)
				{
					$location = $this->get('Location');
					$this->assignRef('data',$location);
				} else $mainframe->redirect(rseventsHelper::route('index.php?option=com_rsevents&view=locations',false),JText::_('RSE_LOCATION_NO_PERMISSION'));
				$pathway->addItem(JText::_('RSE_BC_ADDESITLOCATION'), '');
			} break;
			
			case 'show':
			{
				//get permission for creating a new location
				$permissions = rseventsModelEvents::getPermissions();
				
				//load the location details
				$data = $this->get('Location');
				$this->assignRef('data',$data);	
				$pathway->addItem($data->LocationName, '');
			
				//load the google map
				$directions = $rseventsConfig['locations.directions'];
				if($rseventsConfig['locations.gmaps']) $map = eventsHelper::getMap($data->IdLocation,$directions); else $map = '';
				$this->assignRef('map',$map);
				$this->assignRef('permissions',$permissions);
			} break;
			
			case 'refreshlocations':
				$db->setQuery("SELECT IdLocation, LocationName FROM #__rsevents_locations WHERE published = 1 ORDER BY ordering");
				$locations = $db->loadObjectList();
				$loc_str = array();
				if(!empty($locations))
					foreach($locations as $locationObj)
						$loc_str[] = $locationObj->IdLocation.'|'.$locationObj->LocationName;
				echo implode("\n",$loc_str);
				exit();
			break;
		}		
		parent::display($tpl);
	}
}